package com.mobilegame.dominoes.Actor;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.utils.Align;
import com.mobilegame.dominoes.assets.Assets;

/**
 * Created by Doodle on 2021/2/7.
 */

public class AddPointActor extends Group {
    private Label pointLabel;
    private Image bgImage;
    public static final int YELLOW = 0;
    public static final int GREEN = 1;
    public final Color yellowColor = new Color(192 / 255f, 96 / 255f, 39 / 255f, 1);
    public final Color greenColor = new Color(9 / 255f, 123 / 255f, 49 / 255f, 1);

    public Color labelColor = Color.WHITE;

    public AddPointActor() {
        bgImage = new Image(new TextureRegion(new Texture("image/qiu2.png")));
        addActor(bgImage);
        setSize(bgImage.getWidth(), bgImage.getHeight());

        Label.LabelStyle labelStyle = new Label.LabelStyle();
        labelStyle.font = Assets.instance.fonts[2];

        pointLabel = new Label("0", labelStyle);
        pointLabel.setAlignment(Align.center);
        pointLabel.setPosition(getWidth() / 2f, getHeight() / 2f, Align.center);
        pointLabel.setFontScale(0.8f);
        addActor(pointLabel);
    }

    public AddPointActor(int color, boolean isBig) {
        TextureRegion bgRegion = null;
        float fontScale = 1;
        if (color == YELLOW) {
            if (isBig) {
                bgRegion = new TextureRegion(new Texture("image/qiu2.png"));

            } else {
                bgRegion = new TextureRegion(new Texture("image/qiu2.png"));
                setScale(0.7f);
                fontScale = 1.2f;
            }
            labelColor = yellowColor;
        } else if (color == GREEN) {
            if (isBig) {
                bgRegion = new TextureRegion(new Texture("image/qiu1.png"));

            } else {
                bgRegion = new TextureRegion(new Texture("image/qiu1.png"));
                setScale(0.7f);
                fontScale = 1.2f;
            }
            labelColor = greenColor;
        }
        bgRegion.getTexture().setFilter(Texture.TextureFilter.Linear, Texture.TextureFilter.Linear);
        setSize(bgRegion.getRegionWidth(), bgRegion.getRegionHeight());
        this.bgImage = new Image(bgRegion);
        addActor(bgImage);

        Label.LabelStyle labelStyle = new Label.LabelStyle();
        labelStyle.font = Assets.instance.fonts[2];

        pointLabel = new Label("0", labelStyle);
        pointLabel.setColor(labelColor);
        pointLabel.setAlignment(Align.center);
        pointLabel.setPosition(getWidth() / 2f, getHeight() / 2f, Align.center);
        pointLabel.setFontScale(fontScale);
        addActor(pointLabel);
    }

    public void setPoint(String point) {
        pointLabel.setText(point);
    }

    public void setBgColor(Color color) {
        bgImage.setColor(color);
    }
}
