package com.mobilegame.dominoes.Actor;

import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.graphics.glutils.ShaderProgram;
import com.badlogic.gdx.math.Interpolation;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.actions.Actions;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.badlogic.gdx.utils.Align;
import com.mobilegame.dominoes.DominoGame;
import com.mobilegame.dominoes.assets.Assets;

/**
 * Created by Doodle on 2021/3/2.
 */

public class FlipDominoActor extends Group {
    Image afterImage;
    Image middleImage;
    Group beforeGroup;

    float afterX, afterY;
    float middleX, middleY;
    float beforeX, beforeY;

    boolean isShader = true;

    public FlipDominoActor(int[] values) {
        TextureRegion beforeTexture = Assets.dominoes.findRegion(DominoGame.dominoeName + "board-dominoes");
        TextureRegion afterTexture = Assets.dominoes.findRegion(DominoGame.dominoeName + "back");
        TextureRegion middleTexture = Assets.dominoes.findRegion(DominoGame.dominoeName + "middle");
        setSize(89, 182);

        middleImage = new Image(middleTexture);
        middleImage.setSize(89, 182);
        middleX = middleImage.getX();
        middleY = middleImage.getY();
        addActor(middleImage);

        afterImage = new Image(afterTexture);
        afterImage.setSize(89, 176);
        afterImage.setPosition(getWidth() / 2f, getHeight(), Align.top);
        afterX = afterImage.getX();
        afterY = afterImage.getY();
        addActor(afterImage);

        Image beforeImage = new Image(beforeTexture);
        beforeImage.setSize(89, 176);

        beforeGroup = new Group(){
            @Override
            public void draw(Batch batch, float parentAlpha) {
                ShaderProgram spp = batch.getShader();
                if (isShader) {
                    batch.setShader(DominoGame.sp);
                }
                super.draw(batch, parentAlpha);
                batch.setShader(spp);
            }
        };
        beforeGroup.setSize(beforeImage.getWidth(), beforeImage.getHeight());
        beforeGroup.setPosition(getWidth() / 2f, getHeight(), Align.top);
        beforeGroup.addActor(beforeImage);

        beforeX = beforeGroup.getX();
        beforeY = beforeGroup.getY();
        beforeGroup.setVisible(false);

        float h = beforeGroup.getHeight() / 2f;
        if (values[0] != 0) {
            Image points = new Image(Assets.dominoes.findRegion(DominoGame.dominoeName + "point-" + values[0]));
            points.setSize(60, 60);
            points.setPosition(
                    (beforeGroup.getWidth() - points.getWidth()) / 2f,
                    (h - points.getHeight()) / 2f + h
            );
            beforeGroup.addActor(points);
        }

        if (values[1] != 0) {
            Image points = new Image(Assets.dominoes.findRegion(DominoGame.dominoeName + "point-" + values[1]));
            points.setSize(60, 60);
            points.setPosition(
                    (beforeGroup.getWidth() - points.getWidth()) / 2f,
                    (h - points.getHeight()) / 2f
            );
            beforeGroup.addActor(points);
        }
        addActor(beforeGroup);

//        Actor a = new Actor();
//        a.setPosition(-200, -300);
//        a.debug();
//        a.setSize(100, 100);
//        addActor(a);
//        a.clearListeners();
//        a.addListener(new ClickListener() {
//            @Override
//            public void clicked(InputEvent event, float x, float y) {
//                setFlipAnimation(new Runnable() {
//                    @Override
//                    public void run() {
//
//                    }
//                });
//            }
//        });

//        Actor b = new Actor();
//        b.debug();
//        b.setSize(5, 200);
//        b.setPosition(middleImage.getX(Align.center), middleImage.getY(Align.center), Align.center);
//        addActor(b);
    }

    float scaleTime = 0.4f;

    //动画1
//    afterImage.setPosition(afterX, afterY);
//        afterImage.setOrigin(Align.right);
//        afterImage.setVisible(true);
//        afterImage.setScale(1);
//        afterImage.clearActions();
//        afterImage.addAction(
//                Actions.sequence(
//                Actions.delay(0.3333f * scaleTime),             //0.3333f
//            Actions.scaleTo(0.514f, 1, 0.06667f * scaleTime),//0.4f
//            Actions.scaleTo(0.017f, 1, 0.1f * scaleTime),   //0.5f
//            Actions.delay(0.0333f * scaleTime, Actions.hide()),//0.5333
//            Actions.delay(0.1f * scaleTime),//0.5667
//            Actions.delay(0.1f * scaleTime), //0.6667
//            Actions.delay(0.1666f * scaleTime), //0.8333
//            Actions.delay(0.3667f * scaleTime)//1.2
//            )
//            );
//
//        middleImage.setPosition(middleX, middleY);
//        middleImage.setOrigin(Align.right);
//        middleImage.clearActions();
//        middleImage.addAction(
//                Actions.sequence(
//                Actions.delay(0.3333f * scaleTime),             //0.3333f
//            Actions.scaleTo(0.71f, 1, 0.06667f * scaleTime),//0.4f
//            Actions.scaleTo(0.203f, 1, 0.1f * scaleTime),   //0.5f
//            Actions.delay(0.0333f * scaleTime),             //0.5333
//            Actions.parallel(
//            Actions.sequence(
//            Actions.scaleTo(0.164f, 1, 0.0334f * scaleTime), //0.5667
//            Actions.parallel(
//            Actions.scaleTo(0.633f, 1, 0.1f * scaleTime) //0.6667
//            , Actions.moveBy(-4.31f, 0, 0.1f * scaleTime)
//            ),
//            Actions.parallel(
//            Actions.scaleTo(1, 1, 0.1666f * scaleTime) //0.8333
//            , Actions.moveBy(-9.33f, 0, 0.1666f * scaleTime)
//            )
//            ),
//            Actions.moveBy(13.28f, 0, 0.0334f * scaleTime)
//            ),
//            Actions.delay(0.3667f)//1.2
//            )
//            );
//
//        beforeImage.setPosition(beforeX, beforeY);
//        beforeImage.setOrigin(Align.right);
//        beforeImage.setScale(0.017f, 1);
//        beforeImage.setVisible(false);
//        beforeImage.clearActions();
//        beforeImage.addAction(
//                Actions.sequence(
//                Actions.delay(0.3333f * scaleTime),             //0.3333f
//            Actions.delay(0.06667f * scaleTime),//0.4f
//            Actions.delay(0.1f * scaleTime),   //0.5f
//            Actions.delay(0.0333f * scaleTime, Actions.show()),//0.5333
//            Actions.parallel(
//            Actions.sequence(
//            Actions.parallel(
//            Actions.scaleTo(0.055f, 1, 0.0334f * scaleTime) //0.5667
//            , Actions.moveBy(-14, 0, 0.0334f * scaleTime)
//            ),
//            Actions.scaleTo(0.534f, 1, 0.1f * scaleTime), //0.6667
//            Actions.scaleTo(1, 1, 0.1666f * scaleTime) //0.8333
//            ),
//            Actions.moveBy(13.28f, 0, 0.0334f * scaleTime)
//            ),
//            Actions.delay(0.3667f * scaleTime)//1.2
//            )
//            );

    public void setFlipAnimation(Runnable runnable) {
        float middleOffsetX = middleImage.getWidth() / 2f;
        afterImage.setPosition(afterX, afterY);
        afterImage.setOrigin(Align.right);
        afterImage.setVisible(true);
        afterImage.setScale(1);
        afterImage.clearActions();
        afterImage.addAction(
                Actions.sequence(
                        Actions.delay(0.3333f * scaleTime),                                         //0.3333f
                        Actions.parallel(
                                Actions.sequence(
                                        Actions.scaleTo(0.514f, 1, 0.06667f * scaleTime),           //0.4f
                                        Actions.scaleTo(0.017f, 1, 0.1f * scaleTime)                //0.5f
                                ),
                                Actions.moveBy(-middleOffsetX, 0, 0.16667f * scaleTime)
                        ),
                        Actions.delay(0.0333f * scaleTime, Actions.hide()),                         //0.5333
                        Actions.delay(0.1f * scaleTime),                                            //0.5667
                        Actions.delay(0.1f * scaleTime),                                            //0.6667
                        Actions.delay(0.1666f * scaleTime),                                         //0.8333
                        Actions.delay(0.3667f * scaleTime)                                          //1.2

                ));

        middleImage.setPosition(middleX, middleY);
        middleImage.setOrigin(Align.right);
        middleImage.clearActions();
        middleImage.addAction(
                Actions.sequence(
                        Actions.delay(0.3333f * scaleTime),                                         //0.3333f
                        Actions.parallel(
                                Actions.sequence(
                                        Actions.scaleTo(0.71f, 1, 0.06667f * scaleTime),            //0.4f
                                        Actions.scaleTo(0.203f, 1, 0.1f * scaleTime)                //0.5f
                                ),
                                Actions.moveBy(-middleOffsetX, 0, 0.16667f * scaleTime)
                        ),
                        Actions.delay(0.0333f * scaleTime),                                         //0.5333
                        Actions.parallel(
                                Actions.sequence(
                                        Actions.scaleTo(0.164f, 1, 0.0334f * scaleTime),            //0.5667
                                        Actions.parallel(
                                                Actions.scaleTo(0.633f, 1, 0.1f * scaleTime)        //0.6667
                                                , Actions.moveBy(-4.31f, 0, 0.1f * scaleTime)
                                        ),
                                        Actions.parallel(
                                                Actions.scaleTo(1, 1, 0.1666f * scaleTime)          //0.8333
                                                , Actions.moveBy(-9.33f, 0, 0.1666f * scaleTime)
                                        )
                                ),
                                Actions.moveBy(13.28f, 0, 0.0334f * scaleTime),
                                Actions.moveBy(middleOffsetX, 0, 0.3f * scaleTime)
                        ),
                        Actions.delay(0.3667f)                                                      //1.2
                )
        );

        beforeGroup.setPosition(beforeX, beforeY);
        beforeGroup.setOrigin(Align.right);
        beforeGroup.setScale(0.017f, 1);
        beforeGroup.setVisible(false);
        beforeGroup.clearActions();
        beforeGroup.addAction(
                Actions.sequence(
                        Actions.delay(0.3333f * scaleTime),                                         //0.3333f
                        Actions.parallel(
                                Actions.sequence(
                                        Actions.delay(0.06667f * scaleTime),                        //0.4f
                                        Actions.delay(0.1f * scaleTime)                             //0.5f
                                ),
                                Actions.moveBy(-middleOffsetX, 0, 0.16667f * scaleTime)
                        ),
                        Actions.delay(0.0333f * scaleTime, Actions.show()),                         //0.5333
                        Actions.parallel(
                                Actions.sequence(
                                        Actions.scaleTo(0.055f, 1, 0.0334f * scaleTime),            //0.5667
                                        Actions.scaleTo(0.534f, 1, 0.1f * scaleTime),               //0.6667
                                        Actions.scaleTo(1, 1, 0.1666f * scaleTime)                  //0.8333
                                ),
                                Actions.moveBy(middleOffsetX, 0, 0.33f * scaleTime)
                        ),
                        Actions.delay(0.3667f * scaleTime)                                          //1.2
                )
        );

        setOrigin(Align.center);
        setScale(1, 1);
        clearActions();
        addAction(
                Actions.sequence(
                        Actions.delay(0.3333f * scaleTime),
                        Actions.scaleTo(1.1f, 1.1f, 0.16667f * scaleTime),
                        Actions.delay(0.0333f * scaleTime),
                        Actions.scaleTo(1, 1, 0.3f * scaleTime),
                        Actions.run(runnable)
                )
        );


    }

    public void setMoveAnimation(float startX, float startY, float endX, float endY) {
        setPosition(startX, startY);
        clearActions();
        addAction(
                Actions.moveTo(endX, endY, 0.8f, Interpolation.sineOut)
        );
    }
}
