package com.mobilegame.dominoes.Actor;

import com.badlogic.gdx.scenes.scene2d.actions.TemporalAction;
import com.badlogic.gdx.utils.Align;

/**
 * Created by Doodle on 2021/2/23.
 */

public class MoveToEastInBackAction extends TemporalAction {
    private float startX, startY;
    private float endX, endY;
    private int alignment = Align.bottomLeft;
    private float c1 = 1.70158f;

    protected void begin() {
        startX = target.getX(alignment);
        startY = target.getY(alignment);
    }

    @Override
    protected void update(float percent) {
        float x = startX + (endX - startX) * percent;
        float y = getEastInBackY(x);
        target.setPosition(x, y, alignment);
    }

    private float getEastInBackY(float a) {
        float r = (c1 + 1) * a * a * a - c1 * a * a;
        return r;
    }

    public void reset() {
        super.reset();
        alignment = Align.bottomLeft;
    }

    public void setPosition(float x, float y) {
        endX = x;
        endY = y;
    }

    public void setPosition(float x, float y, int alignment) {
        endX = x;
        endY = y;
        this.alignment = alignment;
    }

    public float getX() {
        return endX;
    }

    public void setX(float x) {
        endX = x;
    }

    public float getY() {
        return endY;
    }

    public void setY(float y) {
        endY = y;
    }

    public int getAlignment() {
        return alignment;
    }

    public void setAlignment(int alignment) {
        this.alignment = alignment;
    }
}
