package com.mobilegame.dominoes.Animation;

/**
 * Created by Doodle on 2021/2/5.
 */

public abstract class AnimationBase {
    AnimationManager animationManager;
    Runnable runnable;

    public AnimationBase(AnimationManager animationManager) {
        this.animationManager = animationManager;

        runnable = new Runnable() {
            @Override
            public void run() {
                animationComplete();
            }
        };
    }

    public void animationComplete() {
        animationFinish();
        animationManager.finish();
    }

    public abstract void animationStart();

    public abstract void animationFinish();

    public abstract void animationMidStart();
}
