package com.mobilegame.dominoes.Animation;

import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.Stage;
import com.badlogic.gdx.scenes.scene2d.actions.Actions;

/**
 * Created by Doodle on 2021/2/5.
 */

public class AnimationDelay extends AnimationBase {
    private float delay;
    private Actor a;

    public AnimationDelay(AnimationManager animationManager, float delay, Stage stage) {
        super(animationManager);
        this.delay = delay;
        Actor a = new Actor();
        stage.addActor(a);
    }

    @Override
    public void animationStart() {
        a.clearActions();
        a.addAction(
                Actions.sequence(
                        Actions.delay(delay),
                        Actions.run(runnable),
                        Actions.removeActor()
                )
        );
    }

    @Override
    public void animationFinish() {
        if (a != null) {
            a.remove();
            a = null;
        }
    }

    @Override
    public void animationMidStart() {

    }
}
