package com.mobilegame.dominoes.Animation;

import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.utils.ClickListener;
import com.badlogic.gdx.utils.Array;
import com.mobilegame.dominoes.assets.Configuration;

/**
 * Created by Doodle on 2021/2/5.
 */

public class AnimationManager {
    public Array<AnimationBase> animationArrays = new Array<>();

    public Actor clickActor;
    private boolean isTouch1 = true;
    private boolean isTouch2 = true;

    public void addAnimation(AnimationBase animationInterface) {
        if (animationInterface != null) {
            animationArrays.add(animationInterface);
        }
    }

    public void startAnimation() {
        if (animationArrays.size < 1) return;
        animationArrays.get(0).animationStart();
    }

    public void finish() {
        if (animationArrays.size > 0) {
            animationArrays.removeIndex(0);
            if (animationArrays.size > 0) {
                startAnimation();
            }
        }
    }

    public void clearAnimation(boolean isMidStart) {
        if (animationArrays.size > 0) {
            if(isMidStart) {
                animationArrays.get(0).animationMidStart();
            }
            animationArrays.get(0).animationFinish();
            animationArrays.removeIndex(0);
        }
    }

    public Actor getClickActor() {
        if (clickActor == null) {
            clickActor = new Actor();
            clickActor.setPosition(-Configuration.widthOffset / 2f, -Configuration.heightOffset / 2f);
            clickActor.setSize(Configuration.width, Configuration.height);
            clickActor.clearListeners();
            clickActor.addListener(new ClickListener() {
                @Override
                public void clicked(InputEvent event, float x, float y) {
                    if (isTouch2 && FinishAnimation3.isComputerHandFinishAddAnimations) {
                        clearAnimation(false);
                        isTouch2 = false;
                    } else if (isTouch1) {
                        clearAnimation(true);
                        clearAnimation(true);
                        if (animationArrays.size > 0) {
                            animationArrays.get(0).animationMidStart();
                        }
                        isTouch1 = false;
                    }
                }
            });
        }
        return clickActor;
    }

    public void computerHandFinishAddAnimationClick() {

    }
}
