package com.mobilegame.dominoes.Animation;

import com.badlogic.gdx.math.Interpolation;
import com.badlogic.gdx.scenes.scene2d.Stage;
import com.badlogic.gdx.scenes.scene2d.actions.Actions;
import com.badlogic.gdx.utils.Align;
import com.mobilegame.dominoes.Actor.FinishActor;
import com.mobilegame.dominoes.assets.Configuration;

/**
 * Created by Doodle on 2021/2/5.
 */

public class FinishAnimation1 extends AnimationBase {
    private FinishActor finishActor;


    public FinishAnimation1(AnimationManager animationManager, Stage stage, int index) {
        super(animationManager);
        finishActor = new FinishActor(index);
        finishActor.setPosition(360, Configuration.height / 2f + 75 - Configuration.heightOffset / 2f, Align.center);
        stage.addActor(finishActor);
    }

    @Override
    public void animationStart() {
//        int index = DominoGame.bgNum - 10;
//        if (index < 0) {
//            index = 0;
//        } else if (index > 5) {
//            index = 5;
//        }
//        finishActor.guangBGImage.setAnimation(bgColor[index], false);

        finishActor.clearActions();
        finishActor.setScale(0);
        finishActor.addAction(
                Actions.sequence(
                        Actions.sequence(
                                Actions.delay(0.8f),
                                Actions.scaleTo(2.5f, 2.5f, 0.2333f, Interpolation.sineOut),
                                Actions.scaleTo(1, 1, 0.3333f, Interpolation.sineIn),
                                Actions.delay(1.5f, Actions.hide()),
                                Actions.run(runnable),
                                Actions.removeActor()
                        )
                )
        );
    }

    @Override
    public void animationFinish() {
        if (finishActor != null) {
            finishActor.remove();
            finishActor = null;
        }
    }

    @Override
    public void animationMidStart() {

    }
}
