
package com.mobilegame.dominoes;

import com.badlogic.gdx.*;
import com.badlogic.gdx.graphics.GL20;
import com.badlogic.gdx.graphics.Pixmap;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.BitmapFont;
import com.badlogic.gdx.graphics.g2d.CpuPolygonSpriteBatch;
import com.badlogic.gdx.graphics.g2d.TextureAtlas;
import com.badlogic.gdx.graphics.glutils.FrameBuffer;
import com.badlogic.gdx.graphics.glutils.ShaderProgram;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.badlogic.gdx.utils.Align;
import com.badlogic.gdx.utils.Json;
import com.badlogic.gdx.utils.Timer;
import com.badlogic.gdx.utils.viewport.*;
import com.esotericsoftware.spine.SkeletonData;
import com.esotericsoftware.spine.SkeletonJson;
import com.esotericsoftware.spine.SkeletonRenderer;
import com.esotericsoftware.spine.attachments.AtlasAttachmentLoader;
import com.mobilegame.dominoes.assets.Assets;
import com.mobilegame.dominoes.assets.Configuration;
import com.mobilegame.dominoes.audio.AudioManager;
import com.mobilegame.dominoes.audio.AudioProcess;
import com.mobilegame.dominoes.data.Classes.Design;
import com.mobilegame.dominoes.data.DiamondDataUtil;
import com.mobilegame.dominoes.data.FileUtil;
import com.mobilegame.dominoes.data.SettingDataUtil;
import com.mobilegame.dominoes.flurry.ABTestManager;
import com.mobilegame.dominoes.flurry.DeltaDNAManager;
import com.mobilegame.dominoes.flurry.FlurryManager;
import com.mobilegame.dominoes.handles.GameConfig;
import com.mobilegame.dominoes.objects.MainHelpNew;
import com.mobilegame.dominoes.screens.BaseScreen;
import com.mobilegame.dominoes.screens.GameScreen;
import com.mobilegame.dominoes.screens.GameScreenD;
import com.mobilegame.dominoes.screens.GameScreenInterface;
import com.mobilegame.dominoes.screens.LoadingScreenNew;
import com.mobilegame.dominoes.screens.MenuScreenNew;
import com.mobilegame.dominoes.spine.MAtlasAttachmentLoader;
import com.mobilegame.dominoes.utils.LUncaughtExceptionHandler;
import com.mobilegame.dominoes.utils.LayerUtils;
import com.mobilegame.dominoes.utils.LeagueUtil;
import com.mobilegame.dominoes.utils.Log;
import com.spine.MySpineActor;

import org.freyja.libgdx.cocostudio.ui.CocoStudioUIEditor;
import org.freyja.libgdx.cocostudio.ui.parser.group.CCScene;

import java.util.Date;
import java.util.HashMap;

public class DominoGame extends Game {
    private static Viewport viewport;
    private static InputMultiplexer inputMultiplexer;
    private static FrameBuffer frameBuffer;
    private static Batch batch;
    private static CocoStudioUIEditor cocoStudioUIEditor;
    private static Json json;
    public static LauncherListener launcherListener;
    private static SkeletonRenderer skeletonRenderer;
    private static SkeletonJson skeletonBinary;
    private static boolean isTimeRight;
    private Class preScreen;
    private boolean autoPauseInput = false;

    //    public static MenuScreen menuScreen;
    public static MenuScreenNew menuScreenNew;
    public static GameScreenInterface gameScreen;
    //    public static LoadingScreen loadingScreen;
    public static LoadingScreenNew loadingScreenNew;
    public static String dominoeName = "white-";
    public static int bgNum = 10;

    //    public static MainHelp mainHelp;
    public static MainHelpNew mainHelpNew;
    private MySpineActor dominoSpineActor;
    private Image Actionlayer;
    private Group dominoAnimationGroup;
    public static boolean isAction;

//    public static LeagueMain leagueMain;
//    public static LeagueEnd leagueEnd;

    public static DoodleHelper doodleHelper;

    public static boolean isMenuScreen;

    public static boolean isDelay;
    public static float delayTime;
    public static float AdTime;
    public static float dominoesScale;
    public static float playTime;
    public static float rateTime;
    public static float nextTime;
    public static float deltaTime;
    public static boolean isAd;
    public static boolean showIns = false;
    public static boolean isRate;
    public static boolean isBoneyard;
    public static boolean isShowEnd;

    public static long time;
    public static long timeDelta;
    public static AdsType adsType;

    public static ShaderProgram sp;

    public DominoGame(LauncherListener launcherListener, DoodleHelper doodleHelper) {
        this.launcherListener = launcherListener;
        this.doodleHelper = doodleHelper;
        isDelay = false;
    }

    @Override
    public void create() {
        sp = new ShaderProgram(Gdx.files.internal("shaders/s1.vert"), Gdx.files.internal("shaders/s1.frag"));
        Thread.setDefaultUncaughtExceptionHandler(new LUncaughtExceptionHandler());
        Configuration.prepare();
        DiamondDataUtil.prepare();
//        FileUtil.prepare();
        AudioProcess.prepare();
        setLandscape();

        isAd = !FileUtil.isnewPlayer();
        isRate = false;
        showIns = false;
        playTime = 0;
        nextTime = -5;
        Assets.prepare();

        inputMultiplexer = new InputMultiplexer();

//        float worldWidth = Constant.VIEWPORT_WIDTH;
//        float worldHeight = Gdx.graphics.getHeight() * worldWidth * 1f / Gdx.graphics.getWidth();
//        viewport = new ExtendViewport(worldWidth, worldHeight);
//        viewport.setWorldSize(worldWidth, worldHeight);

        //修改游戏视口
        viewport = new ExtendViewport(720, 1280);
        Configuration.screen_width = Gdx.graphics.getWidth();
        Configuration.screen_height = Gdx.graphics.getHeight();
        viewport.update(Configuration.screen_width, Configuration.screen_height, true);
//
        Configuration.width = (int) viewport.getWorldWidth();
        Configuration.height = (int) viewport.getWorldHeight();
        Configuration.widthOffset = Configuration.width - 720;
        Configuration.heightOffset = Configuration.height - 1280;

        Gdx.input.setCatchBackKey(true);
        Gdx.input.setInputProcessor(inputMultiplexer);

        float worldWidth = 720;
        float worldHeight = Gdx.graphics.getHeight() * worldWidth / Gdx.graphics.getWidth();

        if (worldHeight <= 1280) {
            dominoesScale = 1f;
        } else {
            dominoesScale = worldHeight / 1280f;
        }

        loadingScreenNew = new LoadingScreenNew(this);

        if (FileUtil.isFirstLogin) {
            GameConfig.initGameSetting();
        } else {
            GameConfig.loadGameSetting();
        }

        timeDelta = 0;
        GameConfig.uTime = 0;
        FlurryManager.flurryLog_Step(1);
        setScreen(loadingScreenNew);
        doodleHelper.LoadingTime();

        DeltaDNAManager.restart();

        dominoAnimationGroup = new Group();

        Actionlayer = LayerUtils.createLayer(0.90f);
        Actionlayer.setVisible(false);
        dominoAnimationGroup.addActor(Actionlayer);

        SkeletonJson sJsonAct;
        SkeletonData skeletonDataLoading;
        sJsonAct = new SkeletonJson(new AtlasAttachmentLoader(Assets.dominoes));
        skeletonDataLoading = sJsonAct.readSkeletonData(Gdx.files.internal("animation/dominoes.json"));
        dominoSpineActor = new MySpineActor(new SkeletonRenderer(), skeletonDataLoading);
        dominoSpineActor.setPosition(360, 640, Align.center);
        dominoAnimationGroup.addActor(dominoSpineActor);

    }

    public void loadingOver() {

//        mainHelp = new MainHelp(parseScene("ui/objects/help_main.json"), this, new MainHelp.MainHelpListener() {
//            @Override
//            public void startGame() {
//                if (DominoGame.deltaTime - DominoGame.nextTime < 2) {
//                    return;
//                }
//                DominoGame.nextTime = DominoGame.deltaTime;
////                menuScreen.showAction();
//                menuScreenNew.showAction();
//                GameConfig.isLeague = false;
//                Timer.instance().scheduleTask(new Timer.Task() {
//                    @Override
//                    public void run() {
//                        gotoGameScreen();
//                    }
//                }, 0.9f);
//
//
//                GameConfig.refreshDataForNewGame();
//                if (GameConfig.gameType == 0) {
//                    FlurryManager.flurryLog_draw_round_start();
//                    FlurryManager.flurryLog_draw_game_start();
//                } else if (GameConfig.gameType == 1) {
//                    FlurryManager.flurryLog_block_round_start();
//                    FlurryManager.flurryLog_block_game_start();
//                } else if (GameConfig.gameType == 2) {
//                    FlurryManager.flurryLog_allfive_round_start();
//                    FlurryManager.flurryLog_allfive_game_start();
//                }
//            }
//        });

        mainHelpNew = new MainHelpNew(parseScene("ui/objects/mainHelpNew.json"), this, new MainHelpNew.MainHelpListener() {
            @Override
            public void startGame() {
                if (DominoGame.deltaTime - DominoGame.nextTime < 2) {
                    return;
                }
                DominoGame.nextTime = DominoGame.deltaTime;
                menuScreenNew.showAction();
                GameConfig.isLeague = false;
                Group an = showDominoSpineActor(new Runnable() {
                    @Override
                    public void run() {
                        gotoGameScreen();
                    }
                });
                mainHelpNew.addActor(an);

                GameConfig.refreshDataForNewGame();
                if (GameConfig.gameType == 0) {
                    FlurryManager.flurryLog_draw_round_start();
                    FlurryManager.flurryLog_draw_game_start();
                } else if (GameConfig.gameType == 1) {
                    FlurryManager.flurryLog_block_round_start();
                    FlurryManager.flurryLog_block_game_start();
                } else if (GameConfig.gameType == 2) {
                    FlurryManager.flurryLog_allfive_round_start();
                    FlurryManager.flurryLog_allfive_game_start();
                }
            }
        });
//
//        leagueMain = new LeagueMain(parseScene("ui/objects/league_main.json"), new LeagueMain.LeagueListener() {
//            @Override
//            public void startGame() {
//                GameConfig.isLeague = true;
//                GameConfig.targetPoints = 100;
//                gotoGameScreen();
//                gameScreen.showAction();
//            }
//
//            @Override
//            public void close() {
//                menuScreenNew.closeLeague();
//            }
//
//            @Override
//            public void claim() {
//
//            }
//
//            @Override
//            public void showInfo() {
//                menuScreenNew.showLeagueInfoDialog();
//            }
//
//            @Override
//            public void showGameInfo() {
//                menuScreenNew.showInfoDialog();
//            }
//        });

//        leagueEnd = new LeagueEnd(parseScene("ui/objects/league_end.json"), new LeagueMain.LeagueListener() {
//            @Override
//            public void startGame() {
//
//            }
//
//            @Override
//            public void close() {
//                menuScreenNew.closeLeague();
//            }
//
//            @Override
//            public void claim() {
//
//            }
//
//            @Override
//            public void showInfo() {
//
//            }
//
//            @Override
//            public void showGameInfo() {
//
//            }
//        });

        gotoMenuScreen();
    }


    public void setLandscape() {
        launcherListener.setOrientation(SettingDataUtil.getOrientation());
    }


    @Override
    public void render() {
        Gdx.gl.glClearColor(0F, 0F, 0F, 1f);
        if (Configuration.poor) {
            Gdx.gl.glClear(GL20.GL_COLOR_BUFFER_BIT);
        } else {
            Gdx.gl.glClear(GL20.GL_COLOR_BUFFER_BIT | GL20.GL_DEPTH_BUFFER_BIT | (Gdx.graphics.getBufferFormat().coverageSampling ? GL20.GL_COVERAGE_BUFFER_BIT_NV : 0));
        }
        super.render();
//        if(isDelay){
//            delayTime+=Gdx.graphics.getDeltaTime();
//            if(delayTime > 3){
//                Gdx.app.log("deltaTime",""+delayTime);
//                playNext();
//            }
//        }
        AudioProcess.update();

    }

    public static Viewport getViewport() {
        return viewport;
    }


    public static void pauseInputProcessor() {
        Gdx.input.setInputProcessor(null);
    }

    public static void clearInputProcessor() {
        Gdx.app.postRunnable(new Runnable() {
            @Override
            public void run() {
                inputMultiplexer.clear();
            }
        });
    }

    public static void addInputProcessor(InputProcessor inputProcessor) {
        inputMultiplexer.addProcessor(inputProcessor);
    }

    public static void resumeInputProcessor() {
        Gdx.input.setInputProcessor(inputMultiplexer);
    }

    public static FrameBuffer getFrameBuffer() {
        if (Configuration.poor) return null;
        if (frameBuffer == null) {
//            Log.log("HelloZombie", "getFrameBuffer()---> new frame buffer");
            frameBuffer = new FrameBuffer(Pixmap.Format.RGBA8888, (int) Configuration.width, (int) Configuration.height, false);
        }
        return frameBuffer;
    }

    public static Batch getBatch() {
        if (batch == null) {
            batch = new CpuPolygonSpriteBatch();
            //   batch = new PolygonSpriteBatch();
        }
        return batch;
    }

    public static SkeletonRenderer getSkeletonRenderer() {
        if (skeletonRenderer == null) {
            skeletonRenderer = new SkeletonRenderer();
        }
        return skeletonRenderer;
    }

    public static SkeletonJson getSkeletonBinary() {
        if (skeletonBinary == null) {
            skeletonBinary = new SkeletonJson(new MAtlasAttachmentLoader(Assets.instance.newUI));
        }
        return skeletonBinary;
    }

    public void update() {
        Screen screen = getScreen();
        if (screen != null) {
            ((BaseScreen) screen).update();
        }
    }

    public static Json getJson() {
        if (json == null) {
            json = new Json();
        }
        return json;
    }

    @Override
    public void pause() {
        Log.log("DominoGame", "pause()");
        super.pause();
        if (frameBuffer != null) {
            frameBuffer.dispose();
            frameBuffer = null;
        }
        Configuration.saveData();
        if (Gdx.input.getInputProcessor() != null) {
            pauseInputProcessor();
            autoPauseInput = true;
        } else {
            autoPauseInput = false;
        }
    }

    @Override
    public void resume() {
        Log.log("DominoGame", "resume()");
        super.resume();
        CheckTime();
        if (autoPauseInput) {
            resumeInputProcessor();
        }
    }

    @Override
    public void setScreen(Screen screen) {
        inputMultiplexer.clear();
        if (getScreen() != null) {
            preScreen = getScreen().getClass();
        }
        super.setScreen(screen);
        Configuration.saveData();
        update();
    }

    public Class getPreScreen() {
        return preScreen;
    }

    public static CocoStudioUIEditor getCocoStudioUIEditor() {
        if (cocoStudioUIEditor == null) {
            HashMap<String, TextureAtlas> set = new HashMap<>();
//            set.put("ui", Assets.instance.ui);
            set.put("design", Assets.instance.design);
            set.put("main", Assets.instance.main);
            set.put("newUI", Assets.instance.newUI);
            set.put("bgUI1", Assets.instance.bgUI1);
            set.put("bgUI2", Assets.instance.bgUI2);
            set.put("tip_allfive1N", Assets.instance.allfiveTip);
            HashMap<String, BitmapFont> fonts = new HashMap<String, BitmapFont>();
            for (int i = 0; i < Assets.instance.fonts.length; i++) {
                fonts.put("font/" + Assets.FONT_NAME[i], Assets.instance.fonts[i]);
            }
            cocoStudioUIEditor = new CocoStudioUIEditor(null, fonts, null, set);
            cocoStudioUIEditor.setDirName("ui/");
        }
        return cocoStudioUIEditor;
    }

    @Override
    public void dispose() {
        Log.log("DominoGame", "dispose()");


        if (batch != null) {
            batch.dispose();
            batch = null;
        }
        if (frameBuffer != null) {
            frameBuffer.dispose();
            frameBuffer = null;
        }

        if (screen != null) {
            screen.dispose();
        }

        if (sp != null) {
            sp.dispose();
        }
    }

    public static Group parseScene(String name) {
        getCocoStudioUIEditor();
        return CCScene.parse(cocoStudioUIEditor, name);
    }

    @Override
    public void resize(int width, int height) {
        Configuration.screen_width = width;
        Configuration.screen_height = height;
        viewport.update(Configuration.screen_width, Configuration.screen_height, true);
        Configuration.width = (int) viewport.getWorldWidth();
        Configuration.height = (int) viewport.getWorldHeight();
        Configuration.screen_width = width;
        Configuration.screen_height = height;
        Configuration.widthOffset = Configuration.width - 720;
        Configuration.heightOffset = Configuration.height - 1280;

        if (mainHelpNew != null) {
            mainHelpNew.resize((int) Configuration.width, (int) Configuration.height);
        }

        super.resize((int) Configuration.width, (int) Configuration.height);
    }

    public void gotoGameScreen() {

//        leagueMain.isShow = false;
//        leagueEnd.isShow = false;

        isMenuScreen = false;
        if (gameScreen != null) {
            ((BaseScreen) gameScreen).dispose();
        }

        if (ABTestManager.currentTest == ABTestManager.D) {
            gameScreen = new GameScreenD(this);
        } else {
            gameScreen = new GameScreen(this);
        }

        setScreen(((BaseScreen) gameScreen));
    }


    public void gotoMenuScreen() {
//        leagueMain.isShow = false;
//        leagueEnd.isShow = false;
        isMenuScreen = true;
        isRate = false;
//        if (menuScreen != null) {
//            menuScreen.dispose();
//        }
//        menuScreen = new MenuScreen(this);
//        setScreen(menuScreen);
        if (menuScreenNew != null) {
            menuScreenNew.dispose();
        }
        menuScreenNew = new MenuScreenNew(this);
        setScreen(menuScreenNew);
    }

    public static void showBg(int m) {

        if (gameScreen != null)
            gameScreen.showBg(m);
        bgNum = m;
        refreshDesignDialog();
    }

    public static void showDominoes(String str) {

        DominoGame.dominoeName = str;

        if (!isMenuScreen) {
            gameScreen.showDominoes();
        }

        refreshDesignDialog();

    }

    public static void showAdsDialog() {

        if (isMenuScreen) {
            menuScreenNew.showAdsDialog();
        }

    }

    public static void showUnlockDialgo(Design design) {

        if (isMenuScreen) {
            menuScreenNew.showUnlock(design);
        } else {
            gameScreen.showUnlock(design);
        }
    }

    public static void refreshDesignDialog() {

        if (isMenuScreen) {
//            menuScreen.refreshDesignDialog();
            menuScreenNew.refreshDesignDialog();
        } else {
            gameScreen.refreshDesignDialog();
        }
    }

    public static void playNext() {
        if (isDelay) {
            isDelay = false;
            AudioManager.playMusic();
        } else {
            isDelay = true;
            delayTime = 0;
        }
    }

    public static void Rate() {

        doodleHelper.goToRate();
        FileUtil.hasRate();

    }

    public static void upDateNum() {
//        if (menuScreen != null) {
//            menuScreen.updateLabel();
//        }
//        if (leagueMain != null) {
//            leagueMain.update();
//            leagueEnd.update();
//        }

    }

    public static void addCoinAni() {
//        if (menuScreen != null) {
//            menuScreen.showCoinAction();
//        }
    }
//
//    public static void addStarAni(){
//        if(menuScreen!=null){
//            menuScreen.showStarAction();
//        }
//    }

    public static void CheckTime() {

        time = doodleHelper.getTime();
        Gdx.app.log("DoodleTimeGet", time + "");
        if (time == -1) {
            doodleHelper.LoadingTime();
            Timer.instance().scheduleTask(new Timer.Task() {
                @Override
                public void run() {
                    CheckTime();
                }
            }, 5);
        } else {
            Date date = new Date();
            timeDelta = time - date.getTime();
        }
    }

    public static Date getTime() {

//        Date date = new Date();
//        long x = date.getTime() ;
        return new Date();
    }

    public void adsFinished() {

        Gdx.app.log("yxk", "adsFinish");

        FlurryManager.flurryLog_Video_succeed();
        if (adsType == AdsType.Shop) {
            FlurryManager.flurryLog_Video_succeed_pop();
            int[] coin = {30, 40, 50, 80};
            LeagueUtil.addCoins(coin[FileUtil.getAdsNum()]);
            FileUtil.addAdsNum();
            if (FileUtil.getAdsNum() == 1)
                LeagueUtil.saveAdsTime();
//            leagueMain.update();

        } else {
            FlurryManager.flurryLog_Video_succeed_jiesuan();
            LeagueUtil.addCoins(50);
        }

    }

    public static void showLeague() {
//        menuScreen.closeLeague();
//        menuScreen.showLeague();
    }

    public Group showDominoSpineActor(final Runnable runnable) {
        Actionlayer.setVisible(true);
        dominoSpineActor.setVisible(true);
        dominoSpineActor.setAnimation("1", true);
        Timer.instance().scheduleTask(new Timer.Task() {
            @Override
            public void run() {
                if (runnable != null) {
                    runnable.run();
                }
            }
        }, 0.9f);
        return dominoAnimationGroup;
    }

    public void hideSpineActor() {
        isAction = false;
        dominoSpineActor.setVisible(false);
        Actionlayer.setVisible(false);
    }

    public Group hideDominoSpineActor() {
        dominoSpineActor.setVisible(true);
        Actionlayer.setVisible(true);

        isAction = true;
        Timer.instance().scheduleTask(new Timer.Task() {
            @Override
            public void run() {
                hideSpineActor();
            }
        }, 0.7f);
        return dominoAnimationGroup;
    }

    public enum AdsType {
        Shop,
        Claim
    }
}