package com.mobilegame.dominoes.GameFunction;

import com.badlogic.gdx.utils.Array;
import com.mobilegame.dominoes.handles.DominoManager;
import com.mobilegame.dominoes.screens.GameScreen;

/**
 * Created by Doodle on 2020/12/17.
 */

public class GetScore {
    final static int player = 0;
    final static int complete = 1;
    boolean isFinish = false;
    int[] completeIds = {5, 24, 23, 14, 8, 11, 18};
    int[] playerIds = {21, 22, 25, 26, 16, 15, 12};

    int startPeople = player;

    GameScreen gameScreen;
    DominaStartStruct dominaStartStruct = new DominaStartStruct();


    public GetScore(GameScreen gameScreen) {
        this.gameScreen = gameScreen;

        start(completeIds, playerIds, null, 0, new Array<Integer>());

        for (DominoStruct a : dominaStartStruct.dominoStructs) {
            showDemo(a);
            System.out.println("*******************************************************************");
        }
    }

    public void start(int[] completes, int[] players, DominoStruct dominoStruct, int pIndex, Array<Integer> pas) {
        if (completes.length == 0 || players.length == 0) {
            return;
        }

        if (startPeople == player) {
            for (int i = 0; i < players.length; ++i) {
                int id = players[i];
                DominoManager currentD = gameScreen.dominoManagers[id];

                if (dominoStruct == null) {
                    DominoStruct ds = new DominoStruct(id, currentD.values[0], currentD.values[1]);
                    dominaStartStruct.addDominoStruct(ds);

                    startPeople = complete;
                    isFinish = false;

                    setArrayID(pas, pIndex, id);
                    start(completes, arrayRemove(players, id), ds, ++pIndex, pas);
                } else {
                    int left = currentD.values[0];
                    int right = currentD.values[1];

                    if (dominoStruct.leftValue != -1) {
                        if (dominoStruct.leftValue == left) {
                            DominoStruct cd = new DominoStruct(id, -1, right);
                            dominoStruct.lefts.add(cd);
//                            dominoStruct.leftValue = -1;

                            startPeople = complete;
                            isFinish = false;

                            setArrayID(pas, pIndex, id);
                            start(completes, arrayRemove(players, id), cd, ++pIndex, pas);
                        }

                        if (left != right) {
                            if (dominoStruct.leftValue == right) {
                                DominoStruct cd = new DominoStruct(id, left, -1);
                                dominoStruct.lefts.add(cd);
//                            dominoStruct.leftValue = -1;

                                startPeople = complete;
                                isFinish = false;

                                setArrayID(pas, pIndex, id);
                                start(completes, arrayRemove(players, id), cd, ++pIndex, pas);
                            }
                        }
                    }

                    if (dominoStruct.rightValue != -1) {
                        if (dominoStruct.rightValue == left) {
                            DominoStruct cd = new DominoStruct(id, -1, right);
                            dominoStruct.rights.add(cd);
//                            dominoStruct.rightValue = -1;

                            startPeople = complete;
                            isFinish = false;

                            setArrayID(pas, pIndex, id);
                            start(completes, arrayRemove(players, id), cd, ++pIndex, pas);
                        }

                        if (left != right) {
                            if (dominoStruct.rightValue == right) {
                                DominoStruct cd = new DominoStruct(id, left, -1);
                                dominoStruct.rights.add(cd);
//                            dominoStruct.rightValue = -1;

                                startPeople = complete;
                                isFinish = false;

                                setArrayID(pas, pIndex, id);
                                start(completes, arrayRemove(players, id), cd, ++pIndex, pas);
                            }
                        }
                    }
                }
            }

            if (isFinish) {

                return;
            }
            startPeople = complete;
            isFinish = true;

            start(completes, players, dominoStruct, pIndex, pas);

        } else if (startPeople == complete) {

            for (int i = 0; i < completes.length; ++i) {
                int id = completes[i];
                DominoManager currentD = gameScreen.dominoManagers[id];

                if (dominoStruct == null) {
                    DominoStruct ds = new DominoStruct(id, currentD.values[0], currentD.values[1]);
                    dominaStartStruct.addDominoStruct(ds);

                    startPeople = player;
                    isFinish = false;

                    setArrayID(pas, pIndex, id);
                    start(arrayRemove(completes, id), players, ds, ++pIndex, pas);
                } else {
                    int left = currentD.values[0];
                    int right = currentD.values[1];

                    if (dominoStruct.leftValue != -1) {
                        if (dominoStruct.leftValue == left) {
                            DominoStruct cd = new DominoStruct(id, -1, right);
                            dominoStruct.lefts.add(cd);
//                            dominoStruct.leftValue = -1;

                            startPeople = player;
                            isFinish = false;

                            setArrayID(pas, pIndex, id);
                            start(arrayRemove(completes, id), players, cd, ++pIndex, pas);
                        }

                        if (left != right) {
                            if (dominoStruct.leftValue == right) {
                                DominoStruct cd = new DominoStruct(id, left, -1);
                                dominoStruct.lefts.add(cd);
//                            dominoStruct.leftValue = -1;

                                startPeople = player;
                                isFinish = false;

                                setArrayID(pas, pIndex, id);
                                start(arrayRemove(completes, id), players, cd, ++pIndex, pas);
                            }
                        }
                    }

                    if (dominoStruct.rightValue != -1) {
                        if (dominoStruct.rightValue == left) {
                            DominoStruct cd = new DominoStruct(id, -1, right);
                            dominoStruct.rights.add(cd);
//                            dominoStruct.rightValue = -1;

                            startPeople = player;
                            isFinish = false;

                            setArrayID(pas, pIndex, id);
                            start(arrayRemove(completes, id), players, cd, ++pIndex, pas);
                        }

                        if (left != right) {
                            if (dominoStruct.rightValue == right) {
                                DominoStruct cd = new DominoStruct(id, left, -1);
                                dominoStruct.rights.add(cd);
//                            dominoStruct.rightValue = -1;

                                startPeople = player;
                                isFinish = false;

                                setArrayID(pas, pIndex, id);
                                start(arrayRemove(completes, id), players, cd, ++pIndex, pas);
                            }
                        }
                    }
                }
            }

            if (isFinish) {
                return;
            }
            startPeople = player;
            isFinish = true;
            start(completes, players, dominoStruct, pIndex, pas);
        }
    }

    private void setArrayID(Array<Integer> pas, int index, int id) {
        if (index < pas.size) {
            pas.set(index, id);
        } else {
            pas.add(id);
        }
    }

//    public void start(int cIndex, int pIndex, DominoStruct dominoStruct) {
//        if (completeIds.length == cIndex || playerIds.length == pIndex) return;
//        if (startPeople == player) {
//
//            for (; pIndex < playerIds.length; ++pIndex) {
//                int id = playerIds[pIndex];
//                DominoManager currentD = gameScreen.dominoManagers[id];
//
//                if (dominoStruct == null) {
//                    DominoStruct ds = new DominoStruct(id, currentD.values[0], currentD.values[1]);
//                    dominaStartStruct.addDominoStruct(ds);
//
//                    startPeople = complete;
//                    start(cIndex, pIndex, ds);
//                } else {
//                    int left = currentD.values[0];
//                    int right = currentD.values[1];
//
//                    if (dominoStruct.leftValue != -1) {
//                        if (dominoStruct.leftValue == left) {
//                            DominoStruct cd = new DominoStruct(id, -1, right);
//                            dominoStruct.lefts.add(cd);
//                            dominoStruct.leftValue = -1;
//
//                            startPeople = complete;
//                            start(cIndex, pIndex, cd);
//                        }
//
//                        if (dominoStruct.leftValue == right) {
//                            DominoStruct cd = new DominoStruct(id, left, -1);
//                            dominoStruct.lefts.add(cd);
//                            dominoStruct.leftValue = -1;
//
//                            startPeople = complete;
//                            start(cIndex, pIndex, cd);
//                        }
//                    }
//
//                    if (dominoStruct.rightValue != -1) {
//                        if (dominoStruct.rightValue == left) {
//                            DominoStruct cd = new DominoStruct(id, -1, right);
//                            dominoStruct.rights.add(cd);
//                            dominoStruct.rightValue = -1;
//
//                            startPeople = complete;
//                            start(cIndex, pIndex, cd);
//                        }
//
//                        if (dominoStruct.rightValue == right) {
//                            DominoStruct cd = new DominoStruct(id, left, -1);
//                            dominoStruct.rights.add(cd);
//                            dominoStruct.rightValue = -1;
//
//                            startPeople = complete;
//                            start(cIndex, pIndex, cd);
//                        }
//
//                    }
//                }
//            }
//            startPeople = complete;
//            start(cIndex, pIndex, dominoStruct);
//        } else if (startPeople == complete) {
//            for (; cIndex < completeIds.length; ++cIndex) {
//                int id = completeIds[cIndex];
//                DominoManager currentD = gameScreen.dominoManagers[id];
//
//                if (dominoStruct == null) {
//                    DominoStruct ds = new DominoStruct(id, currentD.values[0], currentD.values[1]);
//                    dominaStartStruct.addDominoStruct(ds);
//
//                    startPeople = player;
//                    start(cIndex, pIndex, ds);
//                } else {
//                    int left = currentD.values[0];
//                    int right = currentD.values[1];
//
//                    if (dominoStruct.leftValue != -1) {
//                        if (dominoStruct.leftValue == left) {
//                            DominoStruct cd = new DominoStruct(id, -1, right);
//                            dominoStruct.lefts.add(cd);
//                            dominoStruct.leftValue = -1;
//
//                            startPeople = player;
//                            start(cIndex, pIndex, cd);
//                        }
//
//                        if (dominoStruct.leftValue == right) {
//                            DominoStruct cd = new DominoStruct(id, left, -1);
//                            dominoStruct.lefts.add(cd);
//                            dominoStruct.leftValue = -1;
//
//                            startPeople = player;
//                            start(cIndex, pIndex, cd);
//                        }
//
//                    }
//
//                    if (dominoStruct.rightValue != -1) {
//                        if (dominoStruct.rightValue == left) {
//                            DominoStruct cd = new DominoStruct(id, -1, right);
//                            dominoStruct.rights.add(cd);
//                            dominoStruct.rightValue = -1;
//
//                            startPeople = player;
//                            start(cIndex, pIndex, cd);
//                        }
//
//                        if (dominoStruct.rightValue == right) {
//                            DominoStruct cd = new DominoStruct(id, left, -1);
//                            dominoStruct.rights.add(cd);
//                            dominoStruct.rightValue = -1;
//
//                            startPeople = player;
//                            start(cIndex, pIndex, cd);
//                        }
//
//                    }
//                }
//            }
//            startPeople = player;
//            start(cIndex, pIndex, dominoStruct);
//        }
//    }

    Array<Array<DominoStruct>> paas = new Array<>();

    public void showDemo(DominoStruct root) {
        Array<DominoStruct> a = new Array<>();
        a.add(root);
        paas.add(a);
        System.out.print(" root: " + root.id);

        boolean isFinish = false;

        while (!isFinish) {
            Array<DominoStruct> k = new Array<>();
            System.out.println();
            System.out.println("1111111111111111111111111111111111111");
            for (DominoStruct ds : a) {
                isFinish = true;
                if (ds.lefts.size != 0 || ds.rights.size != 0) {
                    isFinish = false;
                    if (ds.id < 0) continue;

                    k.add(new DominoStruct(-2, -1, -1));
                    System.out.print(" left " + ds.id + ": ");
                    for (DominoStruct ds2 : ds.lefts) {
                        k.add(ds2);
                        System.out.print(ds2.id + "  ");
                    }
                    k.add(new DominoStruct(-3, -1, -1));
                    System.out.print(" right " + ds.id + ": ");
                    for (DominoStruct ds2 : ds.rights) {
                        k.add(ds2);
                        System.out.print(ds2.id + "  ");
                    }
                    paas.add(k);
                }
            }
            a = paas.peek();
        }
        System.out.println("\n" +
                "&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&");
    }

    private int[] arrayRemove(int[] array, int value) {
        int num = 0;
        for (int a : array) {
            if (a != value) {
                num++;
            }
        }
        int[] cs = new int[num];
        int i = 0;
        for (int a : array) {
            if (a != value) {
                cs[i] = a;
                i++;
            }
        }
        return cs;
    }

    public class DominoStruct {
        public int id;        //骨牌id
        public int leftValue;
        public int rightValue;

        public Array<DominoStruct> lefts = new Array<>(1);
        public Array<DominoStruct> rights = new Array<>(1);

        public DominoStruct(int id, int leftValue, int rightValue) {
            this.id = id;
            this.leftValue = leftValue;
            this.rightValue = rightValue;
        }
    }

    public class DominaStartStruct {
        public Array<DominoStruct> dominoStructs = new Array<DominoStruct>(7);

        public void addDominoStruct(DominoStruct dominoStruct) {
            dominoStructs.add(dominoStruct);
        }
    }

}
