package com.mobilegame.dominoes.GameFunction;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.files.FileHandle;
import com.badlogic.gdx.graphics.Pixmap;
import com.badlogic.gdx.graphics.PixmapIO;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.NinePatch;
import com.badlogic.gdx.graphics.g2d.TextureAtlas;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.graphics.glutils.FrameBuffer;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.utils.BufferUtils;
import com.badlogic.gdx.utils.ScreenUtils;
import com.mobilegame.dominoes.DominoGame;

import java.io.File;

/**
 * Created by Doodle on 2021/1/21.
 */

public class RoundedRectangle extends Actor {
    TextureAtlas textureAtlas;
    TextureRegion dominoesBg;
    TextureRegion dominoesShader;
    TextureRegion dominoesBgShader;
    TextureRegion tr;
    NinePatch dominoesBgN;
    NinePatch dominoesShaderN;
    NinePatch dominoesBgShaderN;
    FrameBuffer roundFrameBuffer;
    float dsx, dsy, dbx, dby;

    Texture texture;

    public RoundedRectangle(TextureAtlas textureAtlas, Batch batch) {
        this.textureAtlas = textureAtlas;

        dominoesBg = textureAtlas.findRegion(DominoGame.dominoeName + "board-dominoes");
        dominoesBgN = new NinePatch(dominoesBg, 20, 20, 20, 20);
        dominoesShader = textureAtlas.findRegion(DominoGame.dominoeName + "button");
        dominoesShaderN = new NinePatch(dominoesShader, 20, 20, 2, 2);
        Texture bgs = new Texture(Gdx.files.internal("image/maskSm.png"), Pixmap.Format.RGBA8888, false);
        bgs.setFilter(Texture.TextureFilter.Linear, Texture.TextureFilter.Linear);
        tr = textureAtlas.findRegion("mask");
        dominoesBgShader = new TextureRegion(bgs);//textureAtlas.findRegion("mask");
        dominoesBgShaderN = new NinePatch(dominoesBgShader, 2, 2, 2, 2);

        roundFrameBuffer = new FrameBuffer(Pixmap.Format.RGB888, 720, 1280, false);
        roundFrameBuffer.begin();
        batch.begin();
        dominoesShaderN.draw(batch, dsx, dsy, dominoesShader.getRegionWidth(), dominoesShader.getRegionHeight());
        dominoesBgN.draw(batch, dbx, dby, dominoesBg.getRegionWidth(), dominoesBg.getRegionHeight());
        batch.end();
        roundFrameBuffer.end();

        texture = new Texture("image/mask.png");
    }

    @Override
    public void setPosition(float x, float y) {
        super.setPosition(x, y);
        dsx = x;
        dsy = y;
        dbx = dsx;
        dby = dsy + 6;
    }

    private int num;

    @Override
    public void draw(Batch batch, float parentAlpha) {
//        batch.draw(dominoesShader, dsx, dsy);
//        batch.draw(dominoesBg, dbx, dby);
//        SpriteBatch
        batch.draw(roundFrameBuffer.getColorBufferTexture(), 0, 0);

//        batch.end();
//        batch.begin();
////        Color oldColor = batch.getColor();
////        batch.setColor(1, 1, 1, 0.6f);
//        batch.enableBlending();
////        batch.draw(dominoesBgShader, dsx, dsy);
//        batch.setBlendFunction(GL20.GL_ZERO, GL20.GL_ONE_MINUS_SRC_ALPHA);
//        dominoesBgShaderN.draw(batch, dsx, dsy, tr.getRegionWidth(), tr.getRegionHeight());
//
//        batch.enableBlending();
//        batch.setBlendFunction(GL20.GL_SRC_ALPHA, GL20.GL_ONE_MINUS_SRC_ALPHA);
//
//        batch.draw(texture, 200, 640);
//        batch.setColor(oldColor);

//        if (num >= 0) {
//            num++;
//            if (num > 10) {
//                takeScreen();
//                num = -1;
//            }
//        }
    }

    private void takeScreen() {
        byte[] pixels = ScreenUtils.getFrameBufferPixels(0, 0, Gdx.graphics.getBackBufferWidth(), Gdx.graphics.getBackBufferHeight(), true);
        Pixmap pixmap = new Pixmap(Gdx.graphics.getBackBufferWidth(), Gdx.graphics.getBackBufferHeight(), Pixmap.Format.RGBA8888);
        BufferUtils.copy(pixels, 0, pixmap.getPixels(), pixels.length);
        File file = new File("");
        String path = file.getAbsolutePath() + File.separator + "mypixmap.png";
        FileHandle fileHandle = new FileHandle(path);
        System.out.println("ccccccccccccccccccccccccccccccccc: " + fileHandle.path() + "  " + path);
        PixmapIO.writePNG(fileHandle, pixmap);
        pixmap.dispose();
    }
}
