package com.mobilegame.dominoes.GameFunction;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.Pixmap;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.graphics.g2d.NinePatch;
import com.badlogic.gdx.graphics.g2d.TextureAtlas;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.graphics.glutils.FrameBuffer;
import com.badlogic.gdx.graphics.glutils.ShaderProgram;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.mobilegame.dominoes.DominoGame;

/**
 * Created by Doodle on 2021/1/21.
 */

public class RoundedRectangleShader extends Group {
    TextureAtlas textureAtlas;
    TextureRegion dominoesBg;
    TextureRegion dominoesShader;
    TextureRegion dominoesBgShader;
    TextureRegion tr;
    NinePatch dominoesBgN;
    NinePatch dominoesShaderN;
    NinePatch dominoesBgShaderN;
    FrameBuffer roundFrameBuffer;
    float dsx, dsy, dbx, dby;

    ShaderProgram sp;

    public RoundedRectangleShader(TextureAtlas textureAtlas) {
        this.textureAtlas = textureAtlas;

        sp=new ShaderProgram(Gdx.files.internal("shaders/s1.vert"),Gdx.files.internal("shaders/s1.frag"));

        dominoesBg = textureAtlas.findRegion(DominoGame.dominoeName + "board-dominoes");
        dominoesBgN = new NinePatch(dominoesBg, 20, 20, 20, 20);
        dominoesShader = textureAtlas.findRegion(DominoGame.dominoeName + "button");
        dominoesShaderN = new NinePatch(dominoesShader, 20, 20, 2, 2);
        Texture bgs = new Texture(Gdx.files.internal("image/maskSm.png"), Pixmap.Format.RGBA8888, false);
        bgs.setFilter(Texture.TextureFilter.Linear, Texture.TextureFilter.Linear);
        tr = textureAtlas.findRegion("mask");
        dominoesBgShader = new TextureRegion(bgs);//textureAtlas.findRegion("mask");
        dominoesBgShaderN = new NinePatch(dominoesBgShader, 2, 2, 2, 2);

        Image f1=new Image(dominoesShaderN);
        f1.setY(-6);
        f1.setSize(dominoesBg.getRegionWidth(),dominoesBg.getRegionHeight());
        addActor(f1);

        addActor(new Image(dominoesBgN){
            @Override
            public void draw(Batch batch, float parentAlpha) {
                ShaderProgram spp=batch.getShader();
                batch.setShader(sp);
                super.draw(batch, parentAlpha);
                batch.setShader(spp);
            }
        });
    }

//    @Override
//    public void setPosition(float x, float y) {
//        super.setPosition(x, y);
//        dsx = x;
//        dsy = y;
//        dbx = dsx;
//        dby = dsy + 6;
//    }

//    @Override
//    public void draw(Batch batch, float parentAlpha) {
////        batch.draw(dominoesShader, dsx, dsy);
////        batch.draw(dominoesBg, dbx, dby);
////        SpriteBatch
//        dominoesShaderN.draw(batch, dsx, dsy, dominoesShader.getRegionWidth(), dominoesShader.getRegionHeight());
//        dominoesBgN.draw(batch, dbx, dby, dominoesBg.getRegionWidth(), dominoesBg.getRegionHeight());
//        batch.end();
//        batch.begin();
////        Color oldColor = batch.getColor();
////        batch.setColor(1, 1, 1, 0.6f);
//        batch.enableBlending();
//        batch.setBlendFunctionSeparate(GL20.GL_SRC_ALPHA, GL20.GL_ONE_MINUS_SRC_ALPHA, GL20.GL_ZERO, GL20.GL_ZERO);
////        batch.draw(dominoesBgShader, dsx, dsy);
//        dominoesBgShaderN.draw(batch, dsx, dsy, tr.getRegionWidth(), tr.getRegionHeight());
//
//        batch.enableBlending();
//        batch.setBlendFunctionSeparate(GL20.GL_SRC_ALPHA, GL20.GL_ONE_MINUS_SRC_ALPHA, GL20.GL_SRC_ALPHA, GL20.GL_ONE_MINUS_SRC_ALPHA);
////        batch.setColor(oldColor);
//    }


    @Override
    public void draw(Batch batch, float parentAlpha) {
        super.draw(batch, parentAlpha);
    }
}
