package com.mobilegame.dominoes.assets;

import com.badlogic.gdx.assets.AssetManager;
import com.badlogic.gdx.assets.loaders.resolvers.LocalFileHandleResolver;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.BitmapFont;
import com.badlogic.gdx.graphics.g2d.TextureAtlas;
import com.mobilegame.dominoes.data.Classes.Csv;
import com.mobilegame.dominoes.data.GameDataCsv;
import com.mobilegame.dominoes.loader.CocosUILoader;
import com.mobilegame.dominoes.loader.texture.MiniTextureAtlasLoader;
import com.mobilegame.dominoes.loader.texture.MiniTextureLoader;
import com.mobilegame.dominoes.objects.TipConfig;
import com.mobilegame.dominoes.utils.Log;
import com.qs.ui.ManagerUIEditor;
import com.qs.ui.loader.ManagerUILoader;
import com.qs.ui.plist.PlistAtlas;
import com.qs.ui.plist.PlistAtlasLoader;

import org.freyja.libgdx.cocostudio.ui.model.CCExport;

public class Assets {
    private static Csv csv;
    public static TextureAtlas newUI;
    public static TextureAtlas allfiveTip;
    public static TextureAtlas bgUI1;
    public static TextureAtlas bgUI2;
    public static TextureAtlas guide;
    public static TextureAtlas design;
    public static TextureAtlas tips;
    public static TextureAtlas kuang;
    public static TextureAtlas main;
    public static TextureAtlas dominoes;
    public static TextureAtlas pifu;
    public static TextureAtlas coins;
    public static TextureAtlas star;
    public static TextureAtlas congratulations;
    public static TextureAtlas designAnimation;
    public ManagerUILoader.ManagerUIParameter managerUIParameter;
    public PlistAtlas plistAtlas;
    public AssetManager assetManager;
    public AssetManager assetManagerLoading;
    public AssetManager assetManagerLocal;
    public static String[] FONT_NAME = {
//            "openSans_bold.fnt",
//            "openSans_bold_shadow.fnt",
//            "openSans_shadow.fnt",
//            "browaub.fnt",
//            "gold_40.fnt",
//            "brow38.fnt",
//            "bold.fnt",
            "OPENSANS.fnt",
            "OPENSANS_BOLD.fnt",
            "OPENSANS_EXTRABOLD.fnt",
            "OPENSANS_SEMIBOLD.fnt"

//            "shadowWord_30.fnt",
//            "shadowWord_60.fnt",
//            "OpenSans-Extrabold_42_1.fnt"
    };
    public BitmapFont[] fonts = new BitmapFont[FONT_NAME.length];
    public static Assets instance;

    private Assets() {
        assetManager = new AssetManager();
        assetManagerLoading = new AssetManager();
        assetManager.setLoader(CCExport.class, new CocosUILoader(assetManager.getFileHandleResolver()));
        assetManagerLoading.setLoader(CCExport.class, new CocosUILoader(assetManagerLoading.getFileHandleResolver()));
        assetManagerLocal = new AssetManager(new LocalFileHandleResolver());
    }

    public static void prepare() {
        instance = new Assets();
        instance.init();
//        instance.assetManagerLoading.load("image/loading.atlas", TextureAtlas.class);
        instance.assetManagerLoading.load("image/designAnimation.atlas", TextureAtlas.class);
        instance.assetManagerLoading.load("image/dominoes.atlas", TextureAtlas.class);
//        instance.assetManagerLoading.load("image/ui.atlas", TextureAtlas.class);
        instance.assetManagerLoading.load("image/newUI.atlas", TextureAtlas.class);
        instance.assetManagerLoading.load("image/bgUI1.atlas", TextureAtlas.class);
        instance.assetManagerLoading.load("image/bgUI2.atlas", TextureAtlas.class);
        instance.assetManagerLoading.load("image/tip_allfive1N.atlas", TextureAtlas.class);
        instance.assetManagerLoading.finishLoading();
        dominoes = instance.assetManagerLoading.get("image/dominoes.atlas", TextureAtlas.class);
//        loading = instance.assetManagerLoading.get("image/loading.atlas", TextureAtlas.class);
//        ui = instance.assetManagerLoading.get("image/ui.atlas", TextureAtlas.class);
        newUI = instance.assetManagerLoading.get("image/newUI.atlas", TextureAtlas.class);
        allfiveTip = instance.assetManagerLoading.get("image/tip_allfive1N.atlas", TextureAtlas.class);
        bgUI1 = instance.assetManagerLoading.get("image/bgUI1.atlas", TextureAtlas.class);
        bgUI2 = instance.assetManagerLoading.get("image/bgUI2.atlas", TextureAtlas.class);
        designAnimation = instance.assetManagerLoading.get("image/designAnimation.atlas", TextureAtlas.class);

    }

    private void init() {
        assetManager.setLoader(ManagerUIEditor.class, new ManagerUILoader(assetManager.getFileHandleResolver()));
        assetManager.setLoader(PlistAtlas.class, new PlistAtlasLoader(assetManager.getFileHandleResolver()));
        if (Configuration.poor) {
            assetManager.setLoader(Texture.class, new MiniTextureLoader(assetManager.getFileHandleResolver()));
            assetManager.setLoader(TextureAtlas.class, new MiniTextureAtlasLoader(assetManager.getFileHandleResolver()));

        }
    }

    public void load() {
//        assetManager.load("image/ui.atlas", TextureAtlas.class);
//        assetManager.load("image/laoren.atlas", TextureAtlas.class);
        assetManager.load("image/design.atlas", TextureAtlas.class);
        assetManager.load("image/main.atlas", TextureAtlas.class);
        assetManager.load("image/dominoes.atlas", TextureAtlas.class);
        assetManager.load("image/pifu.atlas", TextureAtlas.class);
//        assetManager.load("image/coins.atlas", TextureAtlas.class);
//        assetManager.load("image/fanbei.atlas", TextureAtlas.class);
        assetManager.load("image/jinbi_fk.atlas", TextureAtlas.class);
        assetManager.load("image/xx_fk.atlas", TextureAtlas.class);
        assetManager.load("image/jiesuan.atlas", TextureAtlas.class);
        assetManager.load("image/tips.atlas", TextureAtlas.class);
        assetManager.load("image/kuang.atlas", TextureAtlas.class);
        assetManager.load("image/guide.atlas", TextureAtlas.class);
        for (int i = 0; i < fonts.length; i++) {
            assetManager.load("font/" + FONT_NAME[i], BitmapFont.class);
        }
//        assetManager.load("ui/game.json", CCExport.class);
        assetManager.load("ui/menuNew.json", CCExport.class);
        assetManager.load("ui/gameNew.json", CCExport.class);
        assetManager.load("ui/gameNew3.json", CCExport.class);

        String[] names = {"draw", "block", "allfive"};

        LoadCsv();

    }

    public static void LoadCsv() {
        if (csv == null) {
            csv = new Csv();
            GameDataCsv.Load(csv);
        }
    }


    public void loadSync() {
        load();
        assetManager.finishLoading();

    }

    public void loadFinish() {

//        loading = assetManagerLoading.get("image/loading.atlas", TextureAtlas.class);
//        laoren = assetManager.get("image/laoren.atlas", TextureAtlas.class);
        kuang = assetManager.get("image/kuang.atlas", TextureAtlas.class);
        pifu = assetManager.get("image/pifu.atlas", TextureAtlas.class);
//        scale = assetManager.get("image/fanbei.atlas", TextureAtlas.class);
        coins = assetManager.get("image/jinbi_fk.atlas", TextureAtlas.class);
//        coinsTurn = assetManager.get("image/coins.atlas", TextureAtlas.class);
        star = assetManager.get("image/xx_fk.atlas", TextureAtlas.class);

        congratulations = assetManager.get("image/jiesuan.atlas", TextureAtlas.class);
        tips = assetManager.get("image/tips.atlas", TextureAtlas.class);
        guide = assetManager.get("image/guide.atlas", TextureAtlas.class);
        design = assetManager.get("image/design.atlas", TextureAtlas.class);
        main = assetManager.get("image/main.atlas", TextureAtlas.class);
        dominoes = assetManager.get("image/dominoes.atlas", TextureAtlas.class);
//        ui = instance.assetManager.get("image/ui.atlas", TextureAtlas.class);
//        loading = assetManager.get(  "image/loading.atlas", TextureAtlas.class);
        for (int i = 0; i < fonts.length; i++) {
            fonts[i] = assetManager.get("font/" + FONT_NAME[i]);
            fonts[i].getRegion().getTexture().setFilter(Texture.TextureFilter.Linear, Texture.TextureFilter.Linear);
        }

        TipConfig.init();
    }


    public static void dispose() {
        Log.log("Assets", "dispose");
//        instance.assetManagerLocal.dispose();
//        instance.assetManager.dispose();
//        instance.assetManager = null;
//        instance.assetManagerLocal = null;
//        instance = null;
    }


}
