package com.mobilegame.dominoes.assets;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Preferences;
import com.mobilegame.dominoes.constants.Constant;
import com.mobilegame.dominoes.data.*;
import com.mobilegame.dominoes.utils.Log;
import com.mobilegame.dominoes.data.SettingDataUtil;

import java.text.DecimalFormat;

public class Configuration {
    private static Preferences preferences;
    public static boolean unlock = false;
    public static boolean debug = false;
    public static boolean poor = false;
    public static String device_name = "";
    public static float width;
    public static float height;
    public static float gameScale;
    public static int screen_width = Constant.VIEWPORT_WIDTH;
    public static int screen_height = Constant.VIEWPORT_HEIGHT;
    public static int numSamples = 4;
    public static int availableMem;
    public static DecimalFormat numType = new DecimalFormat("#,###");
    public static int APILevel;
    public static boolean changed;
    public static float widthOffset = 0;
    public static float heightOffset = 0;
    public static int ABType = 1;        //ABTest
    public static void init_device() {
        if (screen_width * screen_height < 800 * 480 ||
                "DROID X2".equals(device_name) ||
                "MT25i".equals(device_name)) {
            poor = true;
        } else {
            poor = false;
        }
    }

    public static void prepare() {
        SettingDataUtil.prepare();
        preferences = Gdx.app.getPreferences("game_data");
        if (Gdx.gl20 == null) {
            poor = true;
            Log.log("Configuration","gl20 == null ");
        }
        changed = false;
    }



    public static void saveData() {
        SettingDataUtil.flush();
        preferences.flush();
    }

    public static void resetData() {
        SettingDataUtil.reset();
        saveData();
    }

}
