package com.mobilegame.dominoes.data;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Preferences;
import com.mobilegame.dominoes.audio.AudioManager;
import com.mobilegame.dominoes.dialogs.DesignDialogNew;
import com.mobilegame.dominoes.flurry.FlurryManager;

/**
 * Created by qwe on 2020/1/6.
 * 骨牌有关数据的类
 */

public class DiamondDataUtil {
    private static Preferences preferences;
    private static boolean prepared = false;

    private static final String num = "Number";         //当前钻石数
    private static final String Totalnum = "TNumber";   //游戏总钻石数
    private static final String Design = "Design";      //
    private static final String DesignInUse = "DesignInUse";

    private static final String DesignNameDominoes = "DesignNameDominoes";
    private static final String DesignNameBg = "DesignNameBg";

    public static void prepare() {
        if(preferences == null){
            preferences = Gdx.app.getPreferences("diamond_data");
        }
        prepared = true;
    }

    public static int getDiamondNum(){
        if(!prepared){
            prepare();
        }
        return preferences.getInteger(num);
    }
    public static int getDiamondTotal(){
        if(!prepared){
            prepare();
        }
        return preferences.getInteger(Totalnum);
    }

    //添加钻石
    public static void addDiamondNum(int m){
        if(!prepared){
            prepare();
        }
        FlurryManager.flurryLog_diamond_get();

        int x = getDiamondNum();
        x+=m;
        preferences.putInteger(num,x);
        int y = getDiamondTotal();
        y+=m;
        preferences.putInteger(Totalnum,y);
        preferences.flush();
    }

    public static boolean usdDiamond(int m){
        if(!prepared){
            prepare();
        }

        int x = getDiamondNum();
        if( x < m ){
            return false;
        }
        else {
            for (int i = 0;i< m ;i++){
                FlurryManager.flurryLog_diamond_use();
            }

            x -= m;
            preferences.putInteger(num,x);
            preferences.flush();
            return true;
        }
    }

    public static void unlockDesign(int id){

        preferences.putBoolean(Design+"_"+id,true);
        preferences.flush();
    }

    public static boolean isUnlockDesign(int id){
        return  preferences.getBoolean(Design+"_"+id);
    }

    public static void useDesign(int id, DesignDialogNew.DesignType designType){

        AudioManager.PlaySound(AudioManager.AudioType.change_dec);
        preferences.putInteger(DesignInUse+designType,id);
        preferences.flush();
    }

    public static int getUseDesign(DesignDialogNew.DesignType designType){

        if(preferences.getInteger(DesignInUse+designType) != 0){
            return  preferences.getInteger(DesignInUse+designType);
        }

        else {
            if(designType == DesignDialogNew.DesignType.dominoes){
                return 1;
            }
            else {
                return 10;
            }
        }

    }


}
