package com.mobilegame.dominoes.data;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Preferences;
import com.mobilegame.dominoes.flurry.ABTestManager;
import com.mobilegame.dominoes.flurry.FlurryManager;
import com.mobilegame.dominoes.handles.GameConfig;
import com.mobilegame.dominoes.utils.ABTestUtil;

import java.util.Calendar;

/**
 * Created by qwe on 2020/3/10.
 */

public class FileUtil {

    private static Preferences preferences;
    private static final String Dominoes = "DominoesGame";
    private static final String hasLogin = "hasLogin";
    private static final String hasRate = "hasRate";
    private static final String SaveData = "SaveData";
    private static final String NewPlay = "NewPlay";
    private static final String PlayTime = "PlayTime";
    private static final String RateTime = "RateTime";
    private static final String IS_TUTOR_FINISHED = "isTUtorFinished";
    private static final String IS_TUTOR = "IS_TUTOr";
    private static final String WinGame = "WinGame";
    private static final String FirstMode = "FirstMode";
    private static final String PlayWinNum = "PlayWinNum";


    public static boolean isFirstLogin;
    public static boolean isFirstRound;
    public static boolean isFirstGame;
    public static boolean isSecondRound;
    public static boolean isSave[] = new boolean[3];

    public static boolean[] isStep = new boolean[14];


    public static void prepare() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
//        preferences.clear();

        if (preferences.getBoolean(hasLogin)) {
            isFirstLogin = false;
        } else {
            isFirstLogin = true;
            preferences.putBoolean(hasLogin, true);
            preferences.flush();
        }

        for (int i = 0; i < 3; i++) {
            isSave[i] = preferences.getBoolean(SaveData + i, false);
        }
    }

    public static void hasRate() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        preferences.putBoolean(hasRate, true);
        preferences.flush();
    }

    public static boolean isRate() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        return preferences.getBoolean(hasRate, false);
    }

    public static void saveData(int a) {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }

        preferences.putBoolean(SaveData + a, true);
        preferences.flush();

        isSave[a] = true;
    }

    public static void clearSaveData(int a) {
        isSave[a] = false;
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        preferences.putBoolean("endAGame", true);
        preferences.putBoolean(SaveData + a, false);
        preferences.flush();

    }

    public static boolean isFinishGame() {

        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        return preferences.getBoolean("endAGame", false);
    }

    public static void putTime() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        int n = preferences.getInteger(PlayTime);
        n++;
        preferences.putInteger(PlayTime, n);
        preferences.flush();
    }


    public static void putRateTime() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        int n = preferences.getInteger(RateTime);
        n++;
        preferences.putInteger(RateTime, n);
        preferences.flush();
    }

    public static void clearRateTime() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }

        preferences.putInteger(RateTime, 0);
        preferences.flush();
    }

    public static int getTime() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        return preferences.getInteger(PlayTime);
    }

    public static int getRateTime() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        return preferences.getInteger(RateTime, 0);
    }

    public static void moreThan15Minutes() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        preferences.putBoolean(NewPlay, false);
        preferences.flush();
    }

    public static boolean isnewPlayer() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }

        if (!isFirstLogin) {
            return false;
        }
        return preferences.getBoolean(NewPlay, true);

    }

    public static void gameEnd() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        int n = preferences.getInteger("gameEnd", 0);
        n++;
        preferences.putInteger("gameEnd", n);
    }


    public static void savePauseTime() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        Calendar c = Calendar.getInstance();

        int n = c.MINUTE + c.HOUR * 60 + c.DAY_OF_MONTH * 60 * 24;

        preferences.putInteger("pauseTime", n);
    }

    public static boolean isLongTimePause() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        Calendar c = Calendar.getInstance();

        int n = c.MINUTE + c.HOUR * 60 + c.DAY_OF_MONTH * 60 * 24;
        int m = preferences.getInteger("pauseTime", 100000);

        return (n - m) > 20;
    }

    public static int gameEndNumber() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        return preferences.getInteger("gameEnd", 0);

    }

    public static void setPlayWinNum() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        int num = getPlayWinNum();
        preferences.putInteger(PlayWinNum, num + 1);
        preferences.flush();
    }

    public static int getPlayWinNum() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        return preferences.getInteger(PlayWinNum, 0);
    }


    public static boolean isView() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        return preferences.getBoolean("View", false);

    }

    public static void setView() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        preferences.putBoolean("View", true);

    }

    public static boolean isUnlock() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        return preferences.getBoolean("unlock", false);

    }

    public static void setUnlock() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        preferences.putBoolean("unlock", true);

    }


    public static void setLoading() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        preferences.putBoolean("loading", true);

    }

    public static void setLoadingEnd() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        preferences.putBoolean("loadingEnd", true);

    }


    public static boolean isLoading() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        return preferences.getBoolean("loading", false);

    }

    public static boolean isLoadingEnd() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        return preferences.getBoolean("loadingEnd", false);

    }

    public static int getCurrentTest() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        return preferences.getInteger("CURRENTTEST", ABTestManager.A);
    }

    public static void saveCurrentTest(int currentTest) {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        preferences.putInteger("CURRENTTEST", currentTest);
        preferences.flush();
    }

    public static boolean getIsTutorFinished(int id) {
        return true;
//        if(!getIsTuor())
//            return true;
////        if(ABTestUtil.isABTestA)
////            return true;
//
//        if(preferences == null){
//            preferences = Gdx.app.getPreferences(Dominoes);
//        }
//        return preferences.getBoolean(IS_TUTOR_FINISHED + id, false);
    }

    public static void setIsTutorFinished(int id) {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        preferences.putBoolean(IS_TUTOR_FINISHED + id, true);
        preferences.flush();
    }

    public static void setIsTuor(boolean b) {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        preferences.putBoolean(IS_TUTOR, b);
        preferences.flush();
    }

    public static boolean getIsTuor() {
//        if(ABTestUtil.isABTestA){
//            return true;
//        }
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        return preferences.getBoolean(IS_TUTOR, true);
    }

    public static void setWinNum(int gameType) {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        int x = preferences.getInteger(WinGame + gameType, 0);
        x++;
        preferences.putInteger(WinGame + gameType, x);
        preferences.flush();
    }

    public static int getWinNum(int gameType) {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        return preferences.getInteger(WinGame + gameType, 0);
    }

    public static void setGameType(int m) {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        preferences.putInteger("Type", m);
        preferences.flush();
    }

    public static int getGameType() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        return preferences.getInteger("Type", 2);
    }

    public static void setGameHard(int m) {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        preferences.putInteger("Hard", m);
        preferences.flush();
    }


    public static int getGameHard() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        return preferences.getInteger("Hard", 0);
    }


    public static void setGameSocre(int m) {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        preferences.putInteger("Score", m);
        preferences.flush();
    }

    public static int getGameSocre() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        return preferences.getInteger("Score", 1);
    }

    public static void setHelp(int type) {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        preferences.putBoolean("ShowHelp" + type, true);
        preferences.flush();
    }


    public static boolean getHelp(int type) {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        return preferences.getBoolean("ShowHelp" + type, false);

    }

    public static void saveFirstMode(int gameMode) {

        if (!preferences.getBoolean("FirstModeIsSave", false)) {
            preferences.putBoolean("FirstModeIsSave", true);
            preferences.putInteger(FirstMode, gameMode);
            preferences.flush();
        }
    }

    public static int getFirstMode() {
        return preferences.getInteger(FirstMode);
    }

    public static void saveFirstFinish(int gameMode, int handCount) {

        if (!preferences.getBoolean("FirstFinish", false)) {

            preferences.putBoolean("FirstFinish", true);
            preferences.flush();


            FlurryManager.flurryLog_firstGameDetails_amount(gameMode, handCount);

        }

    }

    public static void saveFirstRoundFinish(int gameMode, boolean isWin) {

        if (!preferences.getBoolean("FirstRoundFinish", false)) {

            preferences.putBoolean("FirstRoundFinish", true);
            preferences.flush();

            FlurryManager.flurryLog_finishRoundFirst(gameMode, isWin);
        }

    }

    public static boolean isFirstGame() {
        return !preferences.getBoolean("FirstFinish", false);
    }

    public static boolean isFirstRound() {
        return !preferences.getBoolean("FirstRoundFinish", false);
    }

    public static void checkFirstGame() {

        isFirstGame = preferences.getBoolean("isFirstGame", true);

    }

    public static void FinishGame() {
        preferences.putBoolean("isFirstGame", false);
        preferences.flush();
    }

    public static void checkFirstRound() {

        isFirstRound = preferences.getBoolean("FirstRound", true);
        preferences.putBoolean("FirstRound", false);
        preferences.flush();
    }

    public static void checkSecondRound() {

        if (!isFirstRound) {
            isSecondRound = preferences.getBoolean("isSecondRound", true);
            preferences.putBoolean("isSecondRound", false);
            preferences.flush();
        } else {
            isSecondRound = false;
        }

    }

    public static int[] gameNum = new int[]{0, 0, 0};

    public static void AddNum(int gameMode) {
        if (isFirstLogin) //判断是否是第一次登陆
            gameNum[gameMode] += 1;
    }

    public static int getAdsNum() {
        return preferences.getInteger("ADs", 0);
    }

    public static void addAdsNum() {

        int m = getAdsNum();
        m++;
        preferences.putInteger("ADs", m);
        preferences.flush();
    }

    public static void clearAdsNum() {

        preferences.putInteger("ADs", 0);
        preferences.flush();
    }

    public static boolean isFirstAllFive() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        boolean a = preferences.getBoolean("FIRSTALLFIVE", true);
        if (a) {
            preferences.putBoolean("FIRSTALLFIVE", false);
            preferences.flush();
        }
        return a;
    }

    public static boolean isFirstDraw() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        boolean a = preferences.getBoolean("FIRSTDRAW", true);
        if (a) {
            preferences.putBoolean("FIRSTDRAW", false);
            preferences.flush();
        }
        return a;
    }

    public static boolean isFirstBlock() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        boolean a = preferences.getBoolean("FIRSTBLOCK", true);
        if (a) {
            preferences.putBoolean("FIRSTBLOCK", false);
            preferences.flush();
        }
        return a;
    }

    //////////////////////////////DNA////////////////////////////////
    public static void savePlayID(int playID) {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        if (playID > 1000000) {
            String ids = getPlayIDN();
            if (ids == null) {
                savePlayIDN("a");
            } else {
                savePlayIDN(ids + "a");
            }
            playID = 0;
        }
        preferences.putInteger("DNAPLAYID", playID);
        preferences.flush();
    }

    private static void savePlayIDN(String string) {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        preferences.putString("DNAPLAYIDN", string);
    }

    private static String getPlayIDN() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        return preferences.getString("DNAPLAYIDN", null);
    }

    public static int getPlayID() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        return preferences.getInteger("DNAPLAYID", 0);
    }

    public static String getRPlayID() {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }
        String ids = getPlayIDN();
        int id = getPlayID();
        if (ids == null) {
            return id + "";
        } else {
            return ids + id;
        }
    }

    public static String mainpageSetting = "DNA1";

    public static String mainpageDesign = "DNA2";

    public static String mainpagePlay = "DNA3";

    public static String mainSettingMusic = "DNA4";

    public static String mainSettingSound = "DNA5";

    public static String skinTileDomino = "DNADOMINO";

    public static String skinTileBackGround = "DNABACKGROUND";

    public static String unlockOk = "DNA6";

    public static String menupageDraw = "DNA7";

    public static String menupageBlock = "DNA8";

    public static String menupageAllFive = "DNA9";

    public static String menupageScore100 = "DNA10";

    public static String menupageScore150 = "DNA11";

    public static String menupageScore200 = "DNA12";

    public static String menupageDifficultEasy = "DNA13";

    public static String menupageDifficultNormal = "DNA14";

    public static String menupageDifficultHard = "DNA15";

    public static String menupageStartNew = "DNA16";

    public static String tableSetting = "DNA17";

    public static String tableDesign = "DNA18";

    public static String roundEndNext = "DNA19";

    public static String playEndStartNew = "DNA20";

    public static String playEndHome = "DNA21";

    public static String playEndViewScore = "DNA22";

    public static String gameSettingMusic = "DNA23";

    public static String gameSettingSound = "DNA24";

    public static String gameSettingHelp = "DNA25";

    public static String gameSettingRestart = "DNA26";

    public static String gameSettingHome = "DNA27";

    public static void saveIsFirstButton(String buttonName, boolean isFirstMainSetting) {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }

        preferences.putBoolean(buttonName, isFirstMainSetting);
        preferences.flush();
    }

    public static boolean getIsFirstButton(String buttonName) {
        if (preferences == null) {
            preferences = Gdx.app.getPreferences(Dominoes);
        }

        return preferences.getBoolean(buttonName, true);
    }
}
