package com.mobilegame.dominoes.dialogs;

import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.utils.Align;
import com.mobilegame.dominoes.DominoGame;
import com.mobilegame.dominoes.data.FileUtil;
import com.mobilegame.dominoes.flurry.FlurryManager;
import com.mobilegame.dominoes.utils.LeagueUtil;
import com.mobilegame.dominoes.utils.listener.ButtonListener2;

/**
 * Created by qwe on 2020/10/28.
 */

public class AdsDialog extends BaseDialog {


    public AdsDialog(String name) {
        super(name);

        Group ads = group.findActor("btn_ads");
        ads.setOrigin(Align.center);
        ads .addListener(
                new ButtonListener2(){
                    @Override
                    public void clicked(InputEvent event, float x, float y) {
                        super.clicked(event, x, y);
                        if(FileUtil.getAdsNum() == 4){
                            return;
                        }

                        if(DominoGame.launcherListener.isRewardAdReady()){
                            DominoGame.adsType = DominoGame.AdsType.Shop;
                            DominoGame.launcherListener.showRewardAd();
                            FlurryManager.flurryLog_Video_click_pop();
                            close();
                        }
                        else {

                        }
                    }
                }
        );
    }

    @Override
    public void update() {
        super.update();

        String x = LeagueUtil.checkAdsTime();
        Label label = group.findActor("timeNum");
        if(FileUtil.getAdsNum() >= 4 || !DominoGame.launcherListener.isRewardAdReady()){
            group.findActor("unclicked").setVisible(true);

        }
        if(x.length() > 3){
            label.setText(x);
        }
        else {
            label.setText("00m00s");
            LeagueUtil.clearAdsTime();
            setProcess();
        }
    }

    @Override
    protected void show() {
        super.show();
        setProcess();
        group.findActor("unclicked").setVisible(!DominoGame.launcherListener.isRewardAdReady());
    }

    public void setProcess(){

        int process = FileUtil.getAdsNum();
        Image pro = group.findActor("process");
        pro.setVisible(true);

        if(process  == 4){
            pro.setWidth( 400 );
        }
        else if (process == 0){
            pro.setVisible(false);
        }
        else {
            pro.setWidth((process-1)*140+40);
        }

        for (int i = 1;i<=4;i++){
            if(i>process){
                group.findActor("finish"+i).setVisible(false);
            }
            else {
                group.findActor("finish"+i).setVisible(true);
            }
        }



    }


}
