package com.mobilegame.dominoes.dialogs;

import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.scenes.scene2d.ui.ScrollPane;
import com.badlogic.gdx.utils.Align;
import com.mobilegame.dominoes.assets.Configuration;
import com.mobilegame.dominoes.handles.GameConfig;
import com.mobilegame.dominoes.objects.TipConfig;

/**
 * Created by qwe on 2020/1/14.
 */

public class InfoDialog extends BaseDialog {
    private String[] names = {"DRAW", "BLOCK", "ALL FIVES"};
    private Group table;
    private float height = 0;

    private ScrollPane pane;

    public InfoDialog(String name) {
        super(name);

        table = new Group();
        pane = new ScrollPane(table);

        height = 0;

        if (GameConfig.gameType != GameConfig.ALL_FIVES_TYPE) {
            height = 130;
        }

        if (Configuration.height < 1080) {
            height += 200;
        }

        group.setHeight(group.getHeight() - height);
        group.setTouchable(Touchable.enabled);

        pane.setScrollingDisabled(true, false);
        pane.setCancelTouchFocus(false);
        pane.setSmoothScrolling(true);
        pane.toFront();
        pane.setScrollbarsOnTop(true);

        Label label = group.findActor("titleLabel");
        label.setText(names[GameConfig.gameType]);

        Actor close = group.findActor("btn_close");
        closeArea.setY(close.getY());

        pane.layout();

        group.addActor(pane);
    }

    public void showPane() {
        Actor bg = group.findActor("bg");
        pane.setSize(640, 655);
        pane.setPosition(360, bg.getY() + 78, Align.bottom);

        table.clear();
        table.addActor(TipConfig.info[GameConfig.gameType]);

        table.setSize(pane.getWidth(), TipConfig.info[GameConfig.gameType].getHeight());
        TipConfig.info[GameConfig.gameType].setX(table.getWidth() / 2, Align.center);

        pane.layout();
    }

}
