package com.mobilegame.dominoes.dialogs;

import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.utils.Align;
import com.mobilegame.dominoes.DominoGame;
import com.mobilegame.dominoes.utils.LeagueUtil;
import com.mobilegame.dominoes.utils.listener.ButtonListener2;

/**
 * Created by qwe on 2020/11/3.
 */

public class NameDialog extends BaseDialog {

    private Actor buttonCancel;
    private Actor buttonConfirm;
    private Actor buttonReroll;
    private Label nickNameL;

    private String nickName;

    public NameDialog(String name) {
        super(name);

        buttonCancel = group.findActor("btn_cancel");
        buttonConfirm = group.findActor("btn_confirm");
        buttonReroll = group.findActor("btn_reroll");
        nickNameL = group.findActor("nickName");

        buttonCancel.setOrigin(Align.center);
        buttonCancel.addListener(new ButtonListener2(){
            @Override
            public void clicked(InputEvent event, float x, float y) {
                super.clicked(event, x, y);
                close();

            }
        });

        buttonConfirm.setOrigin(Align.center);
        buttonConfirm.addListener(new ButtonListener2(){
            @Override
            public void clicked(InputEvent event, float x, float y) {
                super.clicked(event, x, y);
                Confirm();
                close();
            }
        });

        buttonReroll.setOrigin(Align.center);
        buttonReroll.addListener(new ButtonListener2(){
            @Override
            public void clicked(InputEvent event, float x, float y) {
                super.clicked(event, x, y);
                reRoll();

            }
        });
    }

    @Override
    protected void show() {
        super.show();
        nickName = LeagueUtil.user.getName();
        showNickName();

    }

    @Override
    public void close() {
        super.close();
        DominoGame.upDateNum();
    }

    public void showNickName(){
        nickNameL.setText(nickName);
    }

    public void reRoll(){
        nickName = LeagueUtil.reRollName();
        showNickName();
    }

    public void Confirm(){
        LeagueUtil.saveUserName(nickName);
    }
}
