package com.mobilegame.dominoes.dialogs;

import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.badlogic.gdx.scenes.scene2d.actions.Actions;
import com.badlogic.gdx.utils.Align;
import com.mobilegame.dominoes.utils.listener.ButtonListener2;

/**
 * Created by qwe on 2020/3/11.
 */

public class RateDialog extends  BaseDialog {
    private RateListener listener;

    private Actor[] stars;
    public RateDialog(String name) {
        super(name);
        group.setTouchable(Touchable.enabled);
        initButtons();
        stars = new Actor[5];
        for (int i = 0;i < stars.length;i++){
            stars[i] = group.findActor("star"+i);
        }
    }

    public void setListener(RateListener listener) {
        this.listener = listener;
    }

    private void initButtons(){
        Actor btn = group.findActor("btn_later",Touchable.enabled);
        if(btn!=null){
            btn.addListener(new ButtonListener2(){
                @Override
                public void clicked(InputEvent event, float x, float y) {
                    super.clicked(event, x, y);
                    if(listener!=null){
                        listener.later();
                    }
                }
            });
        }

        btn = group.findActor("btn_rate",Touchable.enabled);
        if(btn!=null){
            btn.addListener(new ButtonListener2(){
                @Override
                public void clicked(InputEvent event, float x, float y) {
                    super.clicked(event, x, y);
                    if(listener!=null){
                        listener.rate();
                    }
                }
            });
        }

    }

    @Override
    public void close() {
        if(listener!=null){
            listener.later();
        }
    }


    @Override
    protected void show() {
        super.show();

        for (int i = 0;i < stars.length;i++){

            float delayTime = 0.8f +  (i+1)/2 * 0.1f;
            stars[i].setOrigin(Align.center);
            stars[i].addAction(
                    Actions.sequence(
                            Actions.delay(delayTime),
                            Actions.scaleTo(0.5f,0.5f,0.3f),
                            Actions.scaleTo(1.4f,1.4f,0.3f),
                            Actions.scaleTo(0.9f,0.9f,0.3f),
                            Actions.scaleTo(1,1,0.3f)
                    )
            );
        }

        Actor btn = group.findActor("btn_later",Touchable.enabled);
        if(btn!=null){
            btn.setOrigin(Align.center);
            btn.setScale(0.6f);
            btn.addAction(
                    Actions.sequence(
                            Actions.scaleTo(1.1f,1.1f,0.3f),
                            Actions.scaleTo(1.0f,1.0f,0.1f)

                    )
            );
        }

        btn = group.findActor("btn_rate",Touchable.enabled);
        if(btn!=null){
            btn.setOrigin(Align.center);
            btn.setScale(0.6f);
            btn.addAction(
                    Actions.sequence(
                            Actions.scaleTo(1.1f,1.1f,0.3f),
                            Actions.scaleTo(1.0f,1.0f,0.1f)

                    )
            );
        }
    }

    public void closeRate(){
        super.close();
    }

    public interface RateListener {
        void rate();
        void later();

    }
}
