package com.mobilegame.dominoes.dialogs;

import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.badlogic.gdx.scenes.scene2d.ui.ScrollPane;
import com.badlogic.gdx.scenes.scene2d.ui.Table;
import com.badlogic.gdx.utils.Align;
import com.mobilegame.dominoes.assets.Assets;
import com.mobilegame.dominoes.handles.GameConfig;
import com.mobilegame.dominoes.objects.ScoreItem;

/**
 * Created by qwe on 2020/10/27.
 * 显示分数
 */

public class ScoreViewDialog extends BaseDialog {
    private final float lineHeight = 80;

    public ScoreViewDialog(String name) {
        super(name);
        initData();
    }

    private void initData() {
        Actor closeButton = group.findActor("btn_close");
//        closeButton.setVisible(false);

        Group table = new Group();
        table.setWidth(639);
        ScrollPane pane = new ScrollPane(table);
        group.addActorAfter(closeButton, pane);
        TextureRegion lineTexture = Assets.newUI.findRegion("scoreLine");

//        Label.LabelStyle style = new Label.LabelStyle();
//        style.font  = Assets.instance.fonts[2];
//        style.fontColor = Color.BLACK;
//
//        Label label = new Label(""+GameConfig.scores.size(), style);
//        label.setPosition(360, 640);
//        group.addActor(label);

        float y = 0;
        Table b = new ScoreItem(GameConfig.scores.size(), "Total score :", "" + GameConfig.points[0], "" + GameConfig.points[1], true);
        b.setPosition(319.5f, y, Align.bottom);
        table.addActor(b);
        y += lineHeight;

        int playPoint = 0;
        int compPoint = 0;
        for (int i = 1; i < GameConfig.scores.size(); ++i) {
            playPoint += GameConfig.scores.get(i - 1)[0];
            compPoint += GameConfig.scores.get(i - 1)[1];
        }

        for (int i = GameConfig.scores.size(); i > 0; i--) {
            Image line = new Image(lineTexture);
            line.setPosition(319.5f, y, Align.center);
            y += line.getHeight();
            table.addActor(line);

            Table a;
            if (i != GameConfig.scores.size()) {
                a = new ScoreItem(i, "Round " + i + " :", "+" + GameConfig.scores.get(i - 1)[0], "+" + GameConfig.scores.get(i - 1)[1], false);
            } else {
                a = new ScoreItem(i, "Round " + i + " :", "+" + (GameConfig.points[0] - playPoint), "+" + (GameConfig.points[1] - compPoint), false);
            }
            a.setPosition(319.5f, y, Align.bottom);
            y += lineHeight;
            table.addActor(a);
        }
//***************************************ceshiyongli******************
//        for (int i = 20; i > 0; i--) {
//            Image line = new Image(lineTexture);
//            line.setPosition(319.5f, y, Align.center);
//            y += line.getHeight();
//            table.addActor(line);
//
//            Table a;
//            if (i != GameConfig.scores.size()) {
//                a = new com.mobilegame.dominoes.objects.ScoreItem(i, "Round " + i + " :", "+" + 20, "+" + 20, false);
//            } else {
//                a = new com.mobilegame.dominoes.objects.ScoreItem(i, "Round " + i + " :", "+" + 2, "+" + 2, false);
//            }
//            a.setPosition(319.5f, y, Align.bottom);
//            y += lineHeight;
//            table.addActor(a);
//        }
//*****************************************************************
        table.setHeight(y);

        Actor bg = group.findActor("zu_74");
        float height = 500;
        if (height > table.getHeight() + 10) {
            height = table.getHeight() + 10;
        }
        pane.setSize(639, height);
        pane.setPosition(360, bg.getY(Align.top) - 140, Align.top);
    }

//    private void initData() {
//        Actor closeButton = group.findActor("btn_close");
//        Table table = new Table();
//        ScrollPane pane = new ScrollPane(table);
//        group.addActorAfter(closeButton, pane);
//        TextureRegion lineTexture = Assets.newUI.findRegion("scoreLine");
//        int playPoint = 0;
//        int compPoint = 0;
//        for (int i = 1; i <= GameConfig.scores.size(); i++) {
//            if (i != GameConfig.scores.size()) {
//                playPoint += GameConfig.scores.get(i - 1)[0];
//                compPoint += GameConfig.scores.get(i - 1)[1];
//                table.add(new ScoreItem(i, "Round " + i + " :", "+" + GameConfig.scores.get(i - 1)[0], "+" + GameConfig.scores.get(i - 1)[1], false)).height(80);
//            } else {
//                table.add(new ScoreItem(i, "Round " + i + " :", "+" + (GameConfig.points[0] - playPoint), "+" + (GameConfig.points[1] - compPoint), false)).height(80);
//            }
//            table.row();
//            table.add(new Image(lineTexture));
//            table.row();
//        }
//
//        table.add(new ScoreItem(GameConfig.scores.size(), "Total score :", "" + GameConfig.points[0], "" + GameConfig.points[1], true)).height(80);
//        table.row();
////        //****************** 测试使用,可以修改i<=num,为几层 ******************
////        for (int i = 1; i <= 0; i++) {
////            table.add(new ScoreItem(i, "Round " + i + " :", "+" + 100, "+" + 100, false)).height(80);
////            table.row();
////            table.add(new Image(lineTexture));
////            table.row();
////        }
////
////        table.add(new ScoreItem(GameConfig.scores.size(), "Total score :", "" + 200, "" + 200, true)).height(80);
////        table.row();
////        //********************************************************************
//
//        Actor bg = group.findActor("zu_74");
//        float height = 500;
//        if (height > table.getPrefHeight() + 10) {
//            height = table.getPrefHeight() + 10;
//        }
//        pane.setSize(639, height);
//        pane.setPosition(360, bg.getY(Align.top) - 140, Align.top);
//    }

//    public class ScoreItem extends Table {
//        Label[] labels = new Label[3];
//
//        public ScoreItem(int id, String tag, String score1, String score2, boolean isEnd) {
//            setSize(474, 80);
//            Label.LabelStyle style = new Label.LabelStyle();
//            style.font = Assets.instance.fonts[0];
//
//            Label.LabelStyle style1 = new Label.LabelStyle();
//            style1.font = Assets.instance.fonts[2];
//            if (isEnd) {
//                labels[0] = new Label("test", style);
//                labels[1] = new Label("test", style1);
//                labels[2] = new Label("test", style1);
//                labels[1].setColor(Colors.wordGreen);
//                labels[2].setColor(Colors.wordYellow);
//            } else {
//                labels[0] = new Label("test", style);
//                labels[1] = new Label("test", style);
//                labels[2] = new Label("test", style);
//                labels[1].setColor(Color.WHITE);
//                labels[2].setColor(Color.WHITE);
//            }
//            labels[0].setFontScale(0.6f);
//            labels[1].setFontScale(0.8f);
//            labels[2].setFontScale(0.8f);
//
//            float tableBlockWidth = 148;
//            for (int i = 0; i < 3; i++) {
////                labels[i].setWidth(tableBlockWidth);
////                labels[i].setAlignment(Align.center);
//                if (i == 0) {
//                    add(labels[0]).width(tableBlockWidth).height(40).padLeft(20);
//                } else if (i == 1) {
//                    labels[1].setAlignment(Align.center);
//                    add(labels[1]).width(tableBlockWidth).height(40).spaceLeft(14);
//                } else {
//                    labels[2].setAlignment(Align.center);
//                    add(labels[2]).width(tableBlockWidth).height(40).spaceLeft(40);
//                }
//            }
//
//            labels[0].setText(tag);
//            labels[1].setText(score1);
//            labels[2].setText(score2);
//        }
//    }
}
