package com.mobilegame.dominoes.dialogs;

import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.badlogic.gdx.scenes.scene2d.actions.Actions;

/**
 * Created by Doodle on 2021/3/18.
 */

public class TipTwoPageDialog extends TipBaseDialog {
    Actor ps1, ps2;
    Actor pl1, pl2;

    public TipTwoPageDialog(String name) {
        super(name);
    }

    @Override
    protected void initPagesGroup() {
        pageSize = 2;

        ps1 = group.findActor("PS1");
        ps2 = group.findActor("PS2");
        pl1 = group.findActor("PL1");
        pl2 = group.findActor("PL2");

        Group p1 = group.findActor("allfive1", Touchable.disabled);
        Group p2 = group.findActor("allfive2", Touchable.disabled);

        groupX = p1.getX();
        groupY = p1.getY();
        groupW = p1.getWidth();
        groupH = p1.getHeight();

        pagesGroup = new Group() {
            @Override
            public void draw(Batch batch, float parentAlpha) {
                batch.flush();
                clipBegin(groupX, groupY, groupW, pagesGroup.getHeight());
                super.draw(batch, parentAlpha);
                batch.flush();
                clipEnd();
            }
        };

        pagesGroup.setSize(groupW * 2, groupH);
        pagesGroup.setPosition(groupX, groupY);

        p1.setPosition(0, 0);
        pagesGroup.addActor(p1);
        p2.setPosition(groupW, 0);
        pagesGroup.addActor(p2);

        group.addActorAt(1, pagesGroup);

        pagesGroup.clearListeners();
        pagesGroup.addListener(getMoveClick());
    }

    @Override
    protected void showPageSign(int page) {
        if (page == 1) {
            ps1.setVisible(false);
            pl1.setVisible(true);
            ps2.setVisible(true);
            pl2.setVisible(false);

            left.setVisible(false);
            right.setVisible(true);
        } else if (page == 2) {
            ps1.setVisible(true);
            pl1.setVisible(false);
            ps2.setVisible(false);
            pl2.setVisible(true);

            left.setVisible(true);
            right.setVisible(false);
        }
    }

    @Override
    protected void showPage(int page) {
        pagesGroup.clearActions();
        if (page == 1) {
            pagesGroup.addAction(
                    Actions.moveTo(groupX, groupY, 0.2f)
            );
        } else if (page == 2) {
            pagesGroup.addAction(
                    Actions.moveTo(groupX - groupW, groupY, 0.2f)
            );
        }
    }
}
