package com.mobilegame.dominoes.dialogs;

import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.utils.Align;
import com.badlogic.gdx.utils.Timer;
import com.mobilegame.dominoes.flurry.FlurryManager;
import com.mobilegame.dominoes.utils.listener.ButtonListener2;

/**
 * Created by qwe on 2020/6/8.
 */

public class TutoDialog extends  BaseDialog{
    private TutoListener listener;
    public TutoDialog(String name) {
        super(name);
        initButtons();
    }

    public void setListener(TutoListener listener) {
        this.listener = listener;
    }

    private void initButtons(){
        Actor btn = group.findActor("btn_yes", Touchable.enabled);
        if(btn!=null){
            btn.addListener(new ButtonListener2(){
                @Override
                public void clicked(InputEvent event, float x, float y) {
                    super.clicked(event, x, y);
                    if(listener!=null){
                        listener.yes();
                    }
                    FlurryManager.flurryLog_tuto(true);
                    close();
                }
            });
        }

        btn = group.findActor("btn_no",Touchable.enabled);
        if(btn!=null){
            btn.addListener(new ButtonListener2(){
                @Override
                public void clicked(InputEvent event, float x, float y) {
                    super.clicked(event, x, y);
                    if(listener!=null){
                        listener.no();
                    }
                    FlurryManager.flurryLog_tuto(false);
                    close();
                }
            });
        }

    }

    public void noChoose(){
        group.findActor("btn_no",Touchable.enabled).setVisible(false);
        group.findActor("btn_yes").setX(320, Align.center);
        Label label = group.findActor("yes");
        label.setText("Go!");
    }


    @Override
    public void close() {
        super.close();
//        Timer.instance().scheduleTask(new Timer.Task() {
//            @Override
//            public void run() {
                listener.close();
//            }
//        },0.01f);

    }

    public interface TutoListener {
        void yes();
        void no();
        void close();

    }
}
