package com.mobilegame.dominoes.flurry;

import com.badlogic.gdx.utils.Array;
import com.mobilegame.dominoes.DominoGame;
import com.mobilegame.dominoes.data.FileUtil;
import com.mobilegame.dominoes.handles.GameConfig;

/**
 * Created by Doodle on 2020/12/31.
 */

public class DeltaDNAManager {
    public static boolean isDebug = false;
    public static int sessionIndex = 1;
    public static int lastReslut;
    public static int roundNum;
    public static float winNum;
    public static long startPlayTime;
    public static long startRoundTime;
    public static int rankDraw;

    public static int userdominoNum = 0;
    public static int computerdominoNum = 0;

    public static void addPlayStarted(String playId, int gameType, GameConfig.HardLevel hardLevel) {
        addPlayStarted(playId, getGameMode(gameType), getGameDifficult(hardLevel), sessionIndex, getResult(lastReslut));
    }

    public static void addPlayStarted(String playId, String modeId, String difficult, int rankInsession, String resultLastplay) {
        DominoGame.doodleHelper.addPlayStarted(playId, modeId, difficult, rankInsession, resultLastplay);
    }

    public static void addPlayCompleted(String playId, int gameType, GameConfig.HardLevel hardLevel, float timeUser, int result) {
        addPlayCompleted(playId, getGameMode(gameType), getGameDifficult(hardLevel), sessionIndex, roundNum, timeUser, getResult(result));
    }

    public static void addPlayCompleted(String playId, String modeId, String difficult, int rankInsession, int roundAmount, float timeUser, String result) {
        if (isDebug) {
            System.out.println("playID: " + playId + " gameType: " + modeId + " hardLevel: " + difficult + " sessionIndex: " + rankInsession + " roundNum: " + roundAmount + " timeUser: " + timeUser + " result: " + result);
        } else {
            DominoGame.doodleHelper.addPlayCompleted(playId, modeId, difficult, rankInsession, roundAmount, timeUser, result);
        }
    }

    public static void addRoundStarted(String playID, int gameType, String roundID, int rankInplay, int resultLastround, String handUser, String handComputer) {
        addRoundStarted(playID, getGameMode(gameType), roundID, rankInplay, getResult(resultLastround), handUser, handComputer);
    }

    public static void addRoundStarted(String playId, String modeId, String roundId, int rankInplay, String resultLastround, String handUser, String handComputer) {
        if (isDebug) {
            System.out.println("playID: " + playId + " gameType: " + modeId + " roundID: " + roundId + " rankInplay: " + rankInplay + " resultLastround: " + resultLastround + " handUser: " + handUser + " handComputer: " + handComputer);
        } else {
            DominoGame.doodleHelper.addRoundStarted(playId, modeId, roundId, getGameDifficult(GameConfig.hardLevel), rankInplay, resultLastround, handUser, handComputer);
        }
    }

    public static void addRoundCompleted(String playID, int gameType, String roundID, int rankInplay, int result,
                                         int addUser, int addComputer, int scoreUser, int scoreComputer, float timeUsed,
                                         String firstPlayer, String tilesPlay, String tilesDraw) {
        addRoundCompleted(playID, getGameMode(gameType), roundID, rankInplay, getResult(result), addUser, addComputer, scoreUser, scoreComputer, timeUsed,
                firstPlayer, tilesPlay, tilesDraw);
    }

    public static void addRoundCompleted(String playId, String modeId, String roundId, int rankInplay, String resultRound,
                                         int addUser, int addComputer, int scoreUser, int scoreComputer, float timeUsed,
                                         String firstPlayer, String tilesPlay, String tilesDraw) {
        if (isDebug) {
            System.out.println("playID: " + playId + " gameType: " + modeId + " roundID: " + roundId + " rankInplay: " + rankInplay + " result: " + resultRound + " addUser: " + addUser + " addComputer: " + addComputer + " scoreUser: " + scoreUser + " scoreComplete: " + scoreComputer + " timeUsed: " + timeUsed + " firstPlayer: " + firstPlayer + " tilesPlay: " + tilesPlay + " tilesPlay: " + tilesPlay + " tilesDraw: " + tilesDraw);
        } else {
            DominoGame.doodleHelper.addRoundCompleted(playId, modeId, roundId, getGameDifficult(GameConfig.hardLevel), rankInplay, resultRound,
                    addUser, addComputer, scoreUser, scoreComputer, timeUsed, firstPlayer, tilesPlay, tilesDraw);
        }
    }

    public static void addSkinUsed(String skinType, String skinID, boolean ifNew, int diamondNum) {
        if (isDebug) {
            System.out.println("skinType: " + skinType + " skinID: " + skinID + " ifNew: " + ifNew + " diamondNum: " + diamondNum);
        } else {
            DominoGame.doodleHelper.addSkinUsed(skinType, skinID, ifNew, diamondNum);
        }
    }

    public static void addUiInteraction(String UILocation, String UIType, String UIName, String name) {
        boolean isFirst = false;
        if (FileUtil.getIsFirstButton(name)) {
            isFirst = true;
            FileUtil.saveIsFirstButton(name, false);
        }

        if (isDebug) {
            System.out.println("uiLocation: " + UILocation + " uiType: " + UIType + " uiName: " + UIName + " isFirst: " + isFirst);
        } else {
            DominoGame.doodleHelper.addUiInteraction(UILocation, UIType, UIName, isFirst);
        }
    }

    public static void addTilesPlay(String player, String modeId, String roundId, int rankPlay, String idPlay,
                                    String linkID, int scoreInround, int choiceNum) {
//        if (isDebug) {
//            System.out.println("player: " + player + " mode: " + modeId + " roundID: " + roundId + " rankPlay: " + rankPlay + " idPlay: " + idPlay + " linkID: " + linkID + " scoreInround: " + scoreInround + " choiceNum: " + choiceNum);
//        } else {
//            DominoGame.doodleHelper.addTilesPlay(player, modeId, roundId, rankPlay, idPlay, linkID, scoreInround, choiceNum);
//        }
    }

    public static void addTilesPlay(String player, int mode, String roundID, int rankPlay, int idPlay,
                                    int linkID, int scoreInround, int choiceNum) {
        addTilesPlay(player, getGameMode(mode), roundID, rankPlay, idPlay + "", linkID + "", scoreInround, choiceNum);
    }

    public static void addTilesDraw(String roundID, String idDraw, int rankDraw, String drawer, boolean ifPlay) {
        if (isDebug) {
            System.out.println("roundID: " + roundID + " idDraw: " + idDraw + " rankDraw: " + rankDraw + " drawer: " + drawer + " ifPlay: " + ifPlay);
        } else {
            DominoGame.doodleHelper.addTilesDraw(roundID, idDraw, rankDraw, drawer, ifPlay);
        }
    }

//    public static void addAdShow(String adStatus) {
//        if (isDebug) {
//            System.out.println("adStatus: " + adStatus);
//        } else {
//            String[] key = {"adstatus"};
//            String[] value = {adStatus};
//            DominoGame.doodleHelper.addParam("adShow", key, value);
//        }
//    }

    private static String getGameMode(int mode) {
        if (mode == GameConfig.DRAW_TYPE) {
            return "draw_type";
        } else if (mode == GameConfig.BLOCK_TYPE) {
            return "block_type";
        } else if (mode == GameConfig.ALL_FIVES_TYPE) {
            return "all_fives_types";
        } else {
            return "error";
        }
    }

    private static String getGameDifficult(GameConfig.HardLevel diff) {
        if (diff == GameConfig.HardLevel.Easy) {
            return "easy";
        } else if (diff == GameConfig.HardLevel.Normal) {
            return "normal";
        } else if (diff == GameConfig.HardLevel.Hard) {
            return "hard";
        } else {
            return "error";
        }
    }

    private static String getResult(int win) {
        if (win == 1) {
            return "win";
        } else if (win == 2) {
            return "lose";
        } else {
            return "NULL";
        }
    }

    public static String getHandString(Array<Integer> hands) {
        if (hands == null || hands.size == 0) return null;

        StringBuffer stringBuffer = new StringBuffer();
        for (int i = 0, j = hands.size; i < j; ++i) {
            stringBuffer.append(hands.get(i) + ",");
        }
        return stringBuffer.toString();
    }

    public static void restart() {
        sessionIndex = 1;
        lastReslut = 0;
    }
}
