package com.mobilegame.dominoes.flurry;

import com.badlogic.gdx.Gdx;
import com.mobilegame.dominoes.DominoGame;
import com.mobilegame.dominoes.data.FileUtil;
import com.mobilegame.dominoes.handles.GameConfig;
import com.mobilegame.dominoes.utils.ABTestUtil;
import com.mobilegame.dominoes.utils.PlayControler;

public class FlurryManager {

    public static boolean isShowLog = true;

    public static String DRAW = "Draw";
    public static String BLOCK = "Block";
    public static String ALLFIVE = "Allfive";
    public static String League = "League";

    public static String ROUND = "_ROUND";
    public static String GAME = "_GAME";
    public static String DESIGN = "Design";
    public static String PLAYTIME = "PlayTime";
    public static String ADS = "Ads";

    public static String CLICK = "Click";
    public static String STEP = "STEP_Tutorial";

    public static String Subrace = "Subrace";
    public static String Race = "Race";
    public static String First = "First";
    public static String Unlock = "Unlock";
    public static String View = "View";
    public static String Start = "Start";
    public static String Finish = "Finish";
    public static String Result = "Result";
    public static String Pips = "Pips";
    public static String Cleanpips = "Cleanpips";

    public static String Duser = "design_user";
    public static String Dapply = "design_apply";


    public static void flurryLog(String info, String paraName, String paraValue) {

        if(  DominoGame.doodleHelper != null){
            DominoGame.doodleHelper.flurry(info, paraName, paraValue);
            Gdx.app.log("flurry",info + " : " + paraName + "　: " + paraValue);
        }
        else {
//            Gdx.app.log("flurry","wrong");
        }

    }

    public static void flurryLog_design_unlock() {
        flurryLog(DESIGN,Dapply , "design_unlock_f");
    }
    public static void flurryLog_design_switch() {

        flurryLog(DESIGN,Dapply , "design_switch");

    }

    public static void flurryLog_design_unlock_f(int designId) {

        flurryLog(DESIGN,"design_unlock_f", ""+designId);

    }
    public static void flurryLog_design_view() {

        if(!FileUtil.isView())
            flurryLog(DESIGN,Duser , "design_view");
        FileUtil.setView();
    }

    public static void flurryLog_design_unlock_u() {

        if(!FileUtil.isUnlock())
            flurryLog(DESIGN,Duser , "design_unlock_u");
        FileUtil.setUnlock();
    }

    public static String[] hard = {"easy_","random_","hard_"};
    public static String[] mode = {"darw","block","allfive"};

    public static void flurryLogs_win_path(int num ,int modeNum) {

        String str = num+"";
        if(num > 10){
            str = "more than 10";
        }

        flurryLog("Win_Path",mode[modeNum]+"_Win" , str);
    }

    public static void flurryLogs_finish_path(int num ,int modeNum) {

        String str = num+"";
        if(num > 15){
            str = "more than 15";
        }

        flurryLog("Path",mode[modeNum]+"_Path" , str);
    }


    public static void flurryLog_draw_round_start() {
        flurryLog(DRAW,ROUND+"S/F" , Start);
    }
    public static void flurryLog_draw_round_finish() {
        flurryLog(DRAW,ROUND +"S/F", Finish);
    }
    public static void flurryLog_draw_round_result(boolean isWin) {
        flurryLog(DRAW,ROUND+Result , ""+isWin);
//        if(!ABTestUtil.isABTestA){
//            flurryLog(DRAW,hard[FileUtil.getGameHard()]+ROUND+Result , ""+isWin);
//        }
    }
    public static void flurryLog_draw_round_result(boolean isWin,int aimode) {
        flurryLog(DRAW,ROUND+Result+"_"+aimode , ""+isWin);
    }
    public static void flurryLog_draw_game_start() {
        flurryLog(DRAW,GAME+"S/F" , Start);
    }
    public static void flurryLog_draw_game_start(int aimode) {
        flurryLog(DRAW,GAME+"S/F"+"_"+aimode , Start);
    }
    public static void flurryLog_draw_game_finish() {
        flurryLog(DRAW,GAME+"S/F" , Finish);
    }
    public static void flurryLog_draw_game_finish(int aimode) {
        flurryLog(DRAW,GAME+"S/F"+"_"+aimode , Finish);
    }
    public static void flurryLog_draw_game_cleanpips(boolean isClean) {
        flurryLog(DRAW,Cleanpips , ""+isClean);
//        if(!ABTestUtil.isABTestA)
//            flurryLog(DRAW,Cleanpips , hard[FileUtil.getGameHard()]+isClean);
    }
    public static void flurryLog_draw_game_result(boolean isWin,int aimode) {
        flurryLog(DRAW,GAME +Result, ""+isWin);
        flurryLog(DRAW,GAME +Result+"_"+aimode, ""+isWin);
//        if(!ABTestUtil.isABTestA){
//            flurryLog(DRAW,hard[FileUtil.getGameHard()]+GAME +Result , ""+isWin);
//        }
    }

    public static void flurryLog_draw_pips_board(int num) {
        flurryLog(DRAW,Pips+ "board", ""+num);
    }

    public static void flurryLog_draw_pips_hand(int num) {
        flurryLog(DRAW,Pips +"hand"  , ""+num);
    }
    public static void flurryLog_draw_round_score_dif(int num) {
        flurryLog(DRAW,"score_dif" , ""+num);
//        if(!ABTestUtil.isABTestA){
//            flurryLog(DRAW,hard[FileUtil.getGameHard()]+"score_dif" , ""+num);
//        }
    }
    public static void flurryLog_draw_round_score_dif_ai(int num,int aimode) {
        flurryLog(DRAW,"score_dif"+aimode , ""+num);
    }
    public static void flurryLog_draw_round_per_game(int num) {
        flurryLog(DRAW,"per_game" , ""+num);
    }
    public static void flurryLog_draw_round_per_game(int num,int aimode) {
        flurryLog(DRAW,"per_game" + "_" + aimode, ""+num);
    }
    public static void flurryLog_draw_round_per_game_Diamond(int num,int diamond) {
        flurryLog(DRAW,"per_game" + "_diamond_" + diamond, ""+num);
    }



    public static void flurryLog_block_round_start() {
        flurryLog(BLOCK,ROUND+"S/F" , Start);
    }

    public static void flurryLog_block_round_finish() {
        flurryLog(BLOCK,ROUND +"S/F", Finish);
    }
    public static void flurryLog_block_round_result(boolean isWin) {
        flurryLog(BLOCK,ROUND+Result , ""+isWin);
//        if(!ABTestUtil.isABTestA){
//            flurryLog(BLOCK,hard[FileUtil.getGameHard()]+ROUND+Result , ""+isWin);
//        }
    }
    public static void flurryLog_block_round_result(boolean isWin,int aimode) {
        flurryLog(BLOCK,ROUND+Result+"_"+aimode , ""+isWin);


    }
    public static void flurryLog_block_round_score_dif_ai(int num,int aimode) {
        flurryLog(BLOCK,"score_dif"+aimode , ""+num);
    }
    public static void flurryLog_block_game_cleanpips(boolean isClean) {
        flurryLog(BLOCK,Cleanpips , ""+isClean);
//        if(!ABTestUtil.isABTestA)
//            flurryLog(BLOCK,Cleanpips , hard[FileUtil.getGameHard()]+isClean);
    }
    public static void flurryLog_block_game_start() {
        flurryLog(BLOCK,GAME+"S/F" , Start);
    }
    public static void flurryLog_block_game_finish() {
        flurryLog(BLOCK,GAME +"S/F", Finish);
    }
    public static void flurryLog_block_game_result(boolean isWin) {
        flurryLog(BLOCK,GAME+Result , ""+isWin);
//        if(!ABTestUtil.isABTestA){
//            flurryLog(BLOCK,hard[FileUtil.getGameHard()]+GAME +Result , ""+isWin);
//        }
    }
    public static void flurryLog_block_round_score_dif(int num) {
        flurryLog(BLOCK,"score_dif" , ""+num);
//        if(!ABTestUtil.isABTestA){
//            flurryLog(BLOCK,hard[FileUtil.getGameHard()]+"score_dif" , ""+num);
//        }
    }

    public static void flurryLog_allfive_round_start() {
        flurryLog(ALLFIVE,ROUND +"S/F", Start);
    }
    public static void flurryLog_allfive_round_finish() {
        flurryLog(ALLFIVE,ROUND+"S/F" , Finish);
    }
    public static void flurryLog_allfive_round_result(boolean isWin,int aimode) {
        flurryLog(ALLFIVE,ROUND+Result+"_"+aimode , ""+isWin);
    }
    public static void flurryLog_allfive_game_cleanpips(boolean isClean) {
        flurryLog(ALLFIVE,Cleanpips , ""+isClean);
        flurryLog(ALLFIVE,Cleanpips , hard[FileUtil.getGameHard()]+isClean);
    }
    public static void flurryLog_allfive_round_result(boolean isWin) {
        flurryLog(ALLFIVE,ROUND+Result , ""+isWin);
//        if(!ABTestUtil.isABTestA){
//            flurryLog(ALLFIVE,hard[FileUtil.getGameHard()]+ROUND+Result , ""+isWin);
//        }
    }
    public static void flurryLog_allfive_round_score_dif(int num) {
        flurryLog(ALLFIVE,"score_dif" , ""+num);
//        if(!ABTestUtil.isABTestA){
//            flurryLog(ALLFIVE,hard[FileUtil.getGameHard()]+"score_dif" , ""+num);
//        }
    }

    public static void flurryLog_allfive_add_score(boolean isScore) {

//        if(!ABTestUtil.isABTestA){
//            flurryLog(ALLFIVE,hard[FileUtil.getGameHard()]+"add_score" , "tap");
//            if(isScore)
//                flurryLog(ALLFIVE,hard[FileUtil.getGameHard()]+"add_score" , ""+isScore);
//        }
    }

    public static void flurryLog_allfive_round_score_dif_ai(int num,int aimode) {
        flurryLog(ALLFIVE,"score_dif"+aimode , ""+num);
    }
    public static void flurryLog_allfive_round_num(int allfiveNum) {
        flurryLog(ALLFIVE,ROUND+"_AllfiveTimes" , ""+allfiveNum);
    }
    public static void flurryLog_allfive_game_start() {
        flurryLog(ALLFIVE,GAME +"S/F", Start);
    }
    public static void flurryLog_allfive_game_finish() {
        flurryLog(ALLFIVE,GAME +"S/F", Finish);
    }
    public static void flurryLog_allfive_game_result(boolean isWin) {
        flurryLog(ALLFIVE,GAME +Result, ""+isWin);
//        if(!ABTestUtil.isABTestA){
//            flurryLog(ALLFIVE,hard[FileUtil.getGameHard()]+GAME +Result , ""+isWin);
//        }
    }

    public static void flurryLog_PlayTime_first(int gameMode,int time) {
        flurryLog(PLAYTIME,First+gameMode , ":"+time);
    }

    public static void flurryLog_PlayTime(int gameMode,int time) {
        flurryLog(PLAYTIME,gameMode+"_c" , ":"+time);
    }

    public static void flurryLog_PlayTime_firstBase(int time) {
        flurryLog(PLAYTIME,First , ":"+time);
    }

    public static void flurryLog_PlayTime_subrace(int gameMode,int time) {
        flurryLog(PLAYTIME,Subrace+gameMode , ":"+time);
    }

    public static void flurryLog_PlayTime_race(int gameMode,int time) {
        flurryLog(PLAYTIME,Race+gameMode , ":"+time);
    }

    public static void flurryLog_Ads() {
        flurryLog(ADS,"screen" ,"succeed" );
    }

    public static void flurryLog_Ads_apply() {
        flurryLog(ADS,"screen" ,"apply" );
    }

    public static void flurryLog_Click(int gamaType,int click) {
        flurryLog(CLICK,CLICK+gamaType , ""+click);
        flurryLog(CLICK,CLICK , ""+click);
    }
    public static void flurryLog_Click(int click) {
        flurryLog(CLICK,CLICK, ""+click);
    }

    public static void flurryLog_ClickStartGametype(int gametype) {
        flurryLog(CLICK,CLICK+"Start", ""+gametype);
    }

    public static void flurryLog_ClickPlayTypeGametype(int gametype) {
        flurryLog(CLICK,CLICK+"PlayType", ""+gametype);
    }

    public static void flurryLog_ClickpipsGametype(int gametype) {
        flurryLog(CLICK,CLICK+"pips", ""+gametype);
    }

    public static void flurryLog_Clicknew() {
        flurryLog(CLICK,CLICK+"score", ""+GameConfig.targetPoints);
        flurryLog(CLICK,CLICK+"mode", ""+GameConfig.gameType);
        flurryLog(CLICK,CLICK+"difficulty", ""+GameConfig.hardLevel);
    }

    public static void flurryLog_loadingStart() {

        if(!FileUtil.isLoading()){
            flurryLog("loading","first_loading_start", "start");
            FileUtil.setLoading();
        }

    }

    public static void flurryLog_loadingEnd() {

        if(FileUtil.isLoadingEnd()){
            flurryLog("loading","first_loading_start", "end");
            FileUtil.setLoadingEnd();

        }

    }

    public static void  flurryLog_diamond_get(){
        flurryLog("Diamond","Diamond" , "get");
    }
    public static void  flurryLog_diamond_use(){
        flurryLog("Diamond","Diamond" , "use");
    }

    public static void flurryLog_Step(int step) {

        if(FileUtil.isFirstLogin && !FileUtil.isStep[step]){
            flurryLog(STEP,STEP , ""+step);
        }
        FileUtil.isStep[step] = true;

    }

    public static void flurryLog_tuto(boolean b) {
        flurryLog("Tuto","Tuto"  , ""+ b);

    }

    static String[] modeName = new String[]{"Draw","Block","Allfive"};

    public static void flurryLog_finishGameFirst(int gameMode,int handCount) {

        String str = handCount+"";
        if(handCount > 15){
            str = "more than 15";
        }
        flurryLog("Round_per_load","total"  , str);
        flurryLog("Round_per_load",modeName[gameMode]  , str);

    }

    public static void flurryLog_finishGameFirstMode(int gameMode,int handCount) {

        String str = handCount+"";
        if(handCount > 15){
            str = "more than 15";
        }
        flurryLog(firstGame+modeName[gameMode],"round_amount"  , str);

    }

    public static void flurryLog_finishRoundFirst(int gameMode,boolean isWin) {

        String str;
        if(isWin){
            str = "win";
        }
        else {
            str = "lose";

        }
        flurryLog("Result_first_game","total"  , str);
        flurryLog("Result_first_game",modeName[gameMode]  , str);

    }
    public static String firstGame = "first_game_";

    public static void flurryLog_firstGameDetails_Start(int gameMode,int handCount ) {

        if(handCount <= 2){
            flurryLog(firstGame+modeName[gameMode],"round_in_game"  , "round_"+handCount+"_start");
        }


    }

    public static void flurryLog_firstGameDetails_back(int gameMode,int handCount ) {

        if(handCount <= 2){
            flurryLog(firstGame+modeName[gameMode],"round_in_game"  , "round_"+handCount+"_back");
        }

    }

    public static void flurryLog_firstGameDetails_amount(int gameMode,int handCount ) {

        String str  = handCount+"";
        if(handCount > 15){
            str = "more than 15";
        }

        flurryLog(firstGame+modeName[gameMode],"Round_amount"  , str);


    }

    public static void flurryLog_firstGameDetails_EndRound(int gameMode,int handCount,boolean isWin ) {

        String str;
        if(isWin){
            str = "win";
        }
        else {
            str = "lose";

        }
        if(handCount <= 2){
            flurryLog(firstGame+modeName[gameMode],"round_in_game"  , "round_"+handCount+"_"+str);
        }


    }

    public static void flurryLog_levelGameFirst( ) {

        int total = 0;

        for (int i = 0;i < 3;i++){
            total += FileUtil.gameNum[i];
            String str = FileUtil.gameNum[i]+"";
            if(FileUtil.gameNum[i] > 15){
                str = "more than 15";
            }
            flurryLog("Round_per_load",modeName[i]  , str);
        }
        String str = total+"";
        if(total > 15){
            str = "more than 15";
        }
        flurryLog("Round_per_load","total"  , str);

    }

    public static void flurryLog_total_turn(int round,int turn) {

        flurryLog("Allfive_first_design","total_turn_"+round  , ""+turn);

    }


    public static void flurryLog_design_path(int round,int type,int ID) {

        if(type==4){
            flurryLog("Allfive_first_design","round_"+round+"_path_"+type  , "others");
            PlayControler.isStartUse = false;
        }else {
            flurryLog("Allfive_first_design","round_"+round+"_path_"+type  , ""+ID);
        }

    }

    public static void flurryLog_option(int round,int type,int ID,int turn) {


        if(round==1){
            flurryLog("Allfive_first_design","round_"+round+"_option"  , ""+type);

        }else {
            if(ID!=-1){
                flurryLog("Allfive_first_design","round_"+round+"_option"  , ""+ID);
            }
            else {
                flurryLog("Allfive_first_design","round_"+round+"_option"  , "others"+turn);
            }

        }

    }

    public static void flurryLog_Gameamount(int m){
        flurryLog(League,"Round_amount"  , ""+m);
    }

    public static void flurryLog_Playeamount(int time){
        flurryLog(League,"Player_amount"  , ""+time);
    }

    public static void flurryLog_league_round_result(boolean isWin){

        String str;
        if(isWin){
            str = "win";
        }
        else {
            str = "lose";
        }
        flurryLog(League,"round_result"  , ""+str);
    }


    public static void flurryLog_league_game_result(boolean isWin){

        String str;
        if(isWin){
            str = "win";
        }
        else {
            str = "lose";
        }
        flurryLog(League,"game_result"  , ""+str);
    }

    public static void flurryLog_score_league(int m){
        flurryLog(League,"score_league"  , ""+(m/300));
    }

    public static void flurryLog_Video_click(){
        flurryLog(ADS,"Video"  , "click");
    }

    public static void flurryLog_Video_click_pop(){
        flurryLog(ADS,"Video"  , "popup_click");
    }

    public static void flurryLog_Video_click_jiesuan(){
        flurryLog(ADS,"Video"  , "jiesuan_click");
    }


    public static void flurryLog_Video_succeed(){
        flurryLog(ADS,"Video"  , "succeed");
    }

    public static void flurryLog_Video_succeed_pop(){
        flurryLog(ADS,"Video"  , "popup_succeed");
    }

    public static void flurryLog_Video_succeed_jiesuan(){
        flurryLog(ADS,"Video"  , "jiesuan_succeed");
    }

    public static void flurryLog_league_rankLeague(int rank){
        flurryLog(League,"Rank_league"  , ""+rank);
    }


}
