package com.mobilegame.dominoes.handles;

import com.mobilegame.dominoes.DominoGame;
import com.mobilegame.dominoes.data.FileUtil;

import java.util.ArrayList;
import java.util.Random;

public class GameConfig {
    public final static int DRAW_TYPE = 0;
    public final static int BLOCK_TYPE = 1;
    public final static int ALL_FIVES_TYPE = 2;

    public static int playerCount = 2;  //玩家数量
    public static int gameType = ALL_FIVES_TYPE;
    public static boolean UseAi = true;
    public static int playerTurn = 0;
    public static boolean loadData;
    public static int handCount = 1;                           //标记第几回合
    public static int PauseCount = 0;
    public static int targetPoints;                            //目标分数
    public static boolean isPause = false;
    public static boolean gameEnded;
    public static float aniTime = 0.3f;
    public static int[] points = new int[2];
    public static int[] toPoints = new int[2];
    public static ArrayList<int[]> scores = new ArrayList<>();
    public static int AiMode = 1;
    public static HardLevel hardLevel = HardLevel.Easy;
    public static int RoundMode = 1;
    public static int AllfiveNum = 0; //allfive得分的次数

    public static float roundTime;
    public static float gameTime;
    public static float uTime;
    public static float firstTime = 0;
    public static float firstTimeTotal = 0;

    public static int roundFLurry;
    public static int gameFLurry;
    public static int firstFLurry;
    public static int uTimeFLurry;
    public static int firstFLurryTotal;

    public static int roundNum = 0;
    public static boolean isLeague;          //是否是联赛


    public static void refreshDataForNewGame() {
//        DominoGame.scores.clear();
        scores.clear();
        handCount = 1;
        gameEnded = false;
        points[0] = 0;
        points[1] = 0;
        aniTime = 0.5F;

        roundTime = 0;
        roundFLurry = 0;
        gameTime = 0;
        gameFLurry = 0;
        DominoGame.isBoneyard = false;
    }

    public static void calculateAimode() {

        int x = FileUtil.getWinNum(gameType);
        if (x < 3) {
            AiMode = 1;
        } else if (x < 7) {
            AiMode = 2;
        } else {
            AiMode = 3;
        }

    }

    public static void calculateRoundmode() {
        int x = new Random().nextInt(100);
        if (x < 50) {
            RoundMode = 2;
        } else {
            RoundMode = 0;
        }
    }

    public enum HardLevel {
        Easy,
        Normal,
        Hard
    }

    public static void initGameSetting() {
        setGameHard(0);
        setGameSocre(1);
        setGameType(2);
    }

    public static void loadGameSetting() {
        setGameHard(FileUtil.getGameHard());
        setGameSocre(FileUtil.getGameSocre());
        setGameType(FileUtil.getGameType());
    }

    public static void setGameHard(int m) {
        FileUtil.setGameHard(m);
        if (m == 0) {
            hardLevel = HardLevel.Easy;
        } else if (m == 1) {
            hardLevel = HardLevel.Normal;
        } else {
            hardLevel = HardLevel.Hard;
        }
    }

    public static void setGameType(int m) {
        FileUtil.setGameType(m);
        gameType = m;
    }

    public static void setGameSocre(int m) {

        FileUtil.setGameSocre(m);
        if (m == 0) {
            targetPoints = 100;
        } else if (m == 1) {
            targetPoints = 150;
        } else {
            targetPoints = 200;
        }
//        Gdx.app.log("yxk",m+":"+targetPoints);
    }
}
