package com.mobilegame.dominoes.loader;

import com.badlogic.gdx.assets.AssetDescriptor;
import com.badlogic.gdx.assets.AssetLoaderParameters;
import com.badlogic.gdx.assets.AssetManager;
import com.badlogic.gdx.assets.loaders.AsynchronousAssetLoader;
import com.badlogic.gdx.assets.loaders.FileHandleResolver;
import com.badlogic.gdx.files.FileHandle;
import com.badlogic.gdx.utils.Array;
import com.badlogic.gdx.utils.Json;
import org.freyja.libgdx.cocostudio.ui.model.*;

public class CocosUILoader extends AsynchronousAssetLoader<CCExport,CocosUILoader.CCExportParameter> {

    private CCExport ccExport;
    public CocosUILoader(FileHandleResolver resolver) {
        super(resolver);
    }

    @Override
    public void loadAsync(AssetManager manager, String fileName, FileHandle file, CCExportParameter parameter) {
        String json = file.readString("utf-8");
        Json jj = new Json();
        jj.addClassTag(CCData.class.getName(),CCData.class);
        jj.addClassTag(GameProjectData.class.getName(),GameProjectData.class);
        jj.addClassTag(CColor.class.getName(),CColor.class);
        jj.addClassTag(FileData.class.getName(),FileData.class);
        jj.setIgnoreUnknownFields(true);
        ccExport = jj.fromJson(CCExport.class, json);
    }

    @Override
    public CCExport loadSync(AssetManager manager, String fileName, FileHandle file, CCExportParameter parameter) {
        return ccExport;
    }

    @Override
    public Array<AssetDescriptor> getDependencies(String fileName, FileHandle file, CCExportParameter parameter) {
        return null;
    }

    static public class CCExportParameter extends AssetLoaderParameters<CCExport>{

    }
}
