package com.mobilegame.dominoes.objects;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.g2d.NinePatch;
import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.scenes.scene2d.utils.ClickListener;
import com.badlogic.gdx.utils.Align;
import com.badlogic.gdx.utils.ArrayMap;
import com.mobilegame.dominoes.assets.Assets;

/**
 * Created by qwe on 2020/7/22.
 */

public class ChooseGroup extends Group {

    private Image bg;
    private Image[] buttonSelected = new Image[3];
    private Group[] button = new Group[3];
    private Image[] buttonbg = new Image[3];
    private Label name;
    private Label[] buttonLable = new Label[3];
    private float stratY[] = new float[3];
    private float setY[] = new float[3];

    public ChooseGroup(String nameStr, String[] buttonWords, final ChooseListener chooseListener) {

        setSize(700,124);
        bg = new Image(new NinePatch(Assets.dominoes.findRegion("button_Options"),20,20,20,20));
        bg.setSize(getWidth(),getHeight());

        Label.LabelStyle style1 = new Label.LabelStyle();
        style1.font  = Assets.instance.fonts[2];
        style1.fontColor = Color.WHITE;

        Label.LabelStyle style2 = new Label.LabelStyle();
        style2.font  = Assets.instance.fonts[0];
        style2.fontColor = Color.WHITE;

        name = new Label(nameStr,style2);

        addActor(bg);
        addActor(name);
        name.setPosition(80,65,Align.center);
        name.setFontScale(0.8f);

        for (int i = 0;i < 3;i++){
            button[i] = new Group();
            buttonSelected[i] = new Image(new NinePatch(Assets.dominoes.findRegion("button_Selected"),20,20,20,20));
            buttonbg[i] = new Image(new NinePatch(Assets.dominoes.findRegion("button_Options"),20,20,20,20));
            buttonbg[i].setSize(164,78);
            buttonSelected[i].setSize(156,74);
            button[i].setSize(164,78);
            button[i].setPosition(
                    150+i*(164+14),
                    22
            );
            buttonSelected[i].setPosition(4,5);
            buttonLable[i] = new Label(buttonWords[i],style1);
            buttonLable[i].setOrigin(Align.center);
            buttonLable[i].setFontScale(0.8f);
            buttonLable[i].setPosition(
                     82 - buttonLable[i].getPrefWidth()/2,
                    39 - buttonLable[i].getPrefHeight()/2
            );
            stratY[i] =  buttonLable[i].getY();
            setY[i] = stratY[i]+3;

            button[i].addActor(buttonbg[i]);
            button[i].addActor(buttonSelected[i]);
            button[i].addActor(buttonLable[i]);
            addActor(button[i]);
            final int finalI = i;
            button[i].addListener(new ClickListener( ){
                @Override
                public void clicked(InputEvent event, float x, float y) {
                    super.clicked(event, x, y);
                    choose(finalI);
                    chooseListener.click(finalI);
                }
            });

        }


    }

    public void choose(int i){
        for (int m = 0;m < 3;m++){
            if (m == i){
                buttonSelected[m].setVisible(true);
            }
            else {
                buttonSelected[m].setVisible(false);
            }
            buttonLable[m].setY(stratY[m]);
        }
        buttonLable[i].setY(setY[i]);


    }



    public interface ChooseListener{

        void click(int m);

    }

}
