package com.mobilegame.dominoes.objects;

import com.badlogic.gdx.graphics.g2d.NinePatch;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.badlogic.gdx.utils.Align;
import com.mobilegame.dominoes.DominoGame;
import com.mobilegame.dominoes.assets.Assets;

/**
 * Created by Doodle on 2021/2/24.
 */

public class HandShowDomioCard extends Group implements DominoCardBase {

    public HandShowDomioCard(int[] values) {
        Image bgShader = new Image(
                new NinePatch(
                        Assets.instance.dominoes.findRegion(DominoGame.dominoeName + "button"), 30, 30, 0, 0)
        );
        addActor(bgShader);

        Image bg = new Image(
                new NinePatch(
                        Assets.instance.dominoes.createSprite(DominoGame.dominoeName + "board-dominoes1")
                )
        );

        bg.setSize(253.5f * DominoGame.dominoesScale, 127.5f * DominoGame.dominoesScale);
        setSize(bg.getWidth(), bg.getHeight());
        addActor(bg);

        bgShader.setSize(127.5f * DominoGame.dominoesScale, 30 * DominoGame.dominoesScale);
        bgShader.setOrigin(Align.center);
        bgShader.setRotation(90);
        bgShader.setPosition(bg.getX()+ bg.getWidth() - 5f * DominoGame.dominoesScale, bg.getY() + bg.getHeight() / 2, Align.center);

        Image[] points = new Image[2];
        for (int i = 0; i < 2; ++i) {
            if (values[i] == 0)
                continue;
            if (values[i] != 0) {
                points[i] = new Image(Assets.instance.dominoes.createSprite(DominoGame.dominoeName + "point-" + values[i]));
                points[i].setSize(90 * DominoGame.dominoesScale, 90 * DominoGame.dominoesScale);
                points[i].setOrigin(Align.center);
                points[i].setRotation(90);
                points[i].setVisible(true);
            }
            points[i].setOrigin(Align.center);
            addActor(points[i]);
        }

        if (points[0] != null) {
            points[0].setPosition(getWidth() / 4, getHeight() / 2, Align.center);
        }
        if (points[1] != null) {
            points[1].setPosition(getWidth() / 4 * 3, getHeight() / 2, Align.center);
        }
        setOrigin(getWidth() / 4F, getHeight() / 2);
    }

    @Override
    public void gray(boolean set) {

    }
}
