package com.mobilegame.dominoes.objects;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.badlogic.gdx.scenes.scene2d.actions.Actions;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.scenes.scene2d.ui.ScrollPane;
import com.badlogic.gdx.utils.Align;
import com.badlogic.gdx.utils.Timer;
import com.mobilegame.dominoes.DominoGame;
import com.mobilegame.dominoes.assets.Configuration;
import com.mobilegame.dominoes.flurry.FlurryManager;
import com.mobilegame.dominoes.handles.GameConfig;
import com.mobilegame.dominoes.utils.LeagueUtil;
import com.mobilegame.dominoes.utils.Player;
import com.mobilegame.dominoes.utils.StringUtil;
import com.mobilegame.dominoes.utils.listener.ButtonListener2;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;


/**
 * Created by qwe on 2020/10/26.
 */

public class LeagueMain extends Group {

    public Group root;

    public ArrayList<PlayerInfo> playerInfoList = new ArrayList<PlayerInfo>();

    public Group table ;
    public ScrollPane pane ;
    public Actor back;

    private Group freeHeart;
    private Label freeHeartclock;
    private Group buttonStart;
    private Image buttonLeft;
    private Image buttonRight;
    private Label clock;

    private Actor[] Types;
    private String[] names = {"Draw", "Block", "Allfive"};

    private int type;
    private Vector2 typePosition;
    public LeagueListener listener;

    public boolean isShow;
    public boolean isAction;

    float checkPointTime = 0;
    float playerY;

    float changeX = 1;
    float changeY = 0;


    public LeagueMain(Group root,LeagueListener leagueListener) {

        this.listener = leagueListener;
        this.root = root;
        addActor(root);
        init();
    }

    private void init() {

        table = new Group();
        pane = new ScrollPane(table);
        isAction = false;


        back = root.findActor("btn_back");
        freeHeart = root.findActor("freeHeart");
        freeHeartclock = root.findActor("freeHeartclockLabel");

        back.setTouchable(Touchable.enabled);
        back.addListener(new ButtonListener2() {
            @Override
            public void clicked(InputEvent event, float x, float y) {
                super.clicked(event, x, y);
                close();
            }
        });

        changePositon(back);

        Group title = root.findActor("title");
        changePositon(title);
        changePositon(root.findActor("tip_icon_2"));

        Group maptitle = root.findActor("maptitle");
        changePositon(maptitle);
        maptitle.setY(maptitle.getY()-10);

        Actor rankBg =  root.findActor("rank");
        changeHeight(rankBg);

        Actor Bg =  root.findActor("bg");
        changeHeight(Bg);


        pane.setSize(
                root.findActor("rank").getWidth(),
                root.findActor("rank").getHeight()-130
        );
        pane.setPosition(
                root.findActor("rank").getX(Align.center),
                root.findActor("rank").getY(Align.center) - 30,
                Align.center);

        clock = root.findActor("BitmapFontLabel_9");
        changePositon(clock);

        initButton();
        root.addActor(pane);
        root.findActor("tip").toFront();

    }

    private void initButton(){

        Gdx.app.log("yxk","initTypes");
        Types  = new Actor[names.length];
        for (int i = 0;i < names.length;i++ ){
            Types[i] =  root.findActor(names[i]);
        }
        typePosition = new Vector2(Types[2].getX(),Types[2].getY());

        buttonLeft = root.findActor("left");

        buttonLeft.setTouchable(Touchable.enabled);
        buttonLeft.addListener(new ButtonListener2() {
            @Override
            public void clicked(InputEvent event, float x, float y) {
                super.clicked(event, x, y);
                if(isAction)
                    return;
                isAction = true;


                for (int i = 0;i < names.length;i++ ){
                        Types[i].setPosition(typePosition.x+400,typePosition.y);
                        Types[i].setVisible(true);
                }

                Types[type].addAction(
                        Actions.sequence(
                                Actions.moveTo(typePosition.x,typePosition.y,0.01f),
                                Actions.moveTo(typePosition.x-400,typePosition.y,0.5f)
                        )
                );
                changeType(1);
                Types[type].addAction(
                        Actions.sequence(
                                Actions.moveTo(typePosition.x+400,typePosition.y,0.01f),
                                Actions.moveTo(typePosition.x,typePosition.y,0.5f),
                                Actions.run(new Runnable() {
                                    @Override
                                    public void run() {
                                        isAction = false;
                                        initType();
                                    }
                                })
                        )
                );

            }
        });

        buttonRight = root.findActor("right");

        buttonRight.setTouchable(Touchable.enabled);
        buttonRight.addListener(new ButtonListener2() {
            @Override
            public void clicked(InputEvent event, float x, float y) {
                super.clicked(event, x, y);
                if(isAction)
                    return;
                isAction = true;

                for (int i = 0;i < names.length;i++ ){
                    Types[i].setPosition(typePosition.x+400,typePosition.y);
                    Types[i].setVisible(true);
                }

                Types[type].addAction(
                        Actions.sequence(
                                Actions.moveTo(typePosition.x,typePosition.y,0.01f),
                                Actions.moveTo(typePosition.x+400,typePosition.y,0.5f)
                        )
                );
                changeType(2);
                Types[type].addAction(
                        Actions.sequence(
                                Actions.moveTo(typePosition.x-400,typePosition.y,0.01f),
                                Actions.moveTo(typePosition.x,typePosition.y,0.5f),
                                Actions.run(new Runnable() {
                                    @Override
                                    public void run() {
                                        isAction = false;
                                        initType();
                                    }
                                })
                        )
                );
            }
        });

        buttonStart = root.findActor("btn_new");
        buttonStart.setTouchable(Touchable.enabled);
        buttonStart.addListener(new ButtonListener2() {
            @Override
            public void clicked(InputEvent event, float x, float y) {
                super.clicked(event, x, y);
//                LeagueUtil.JoinLeague();
                if(LeagueUtil.getLife() >= 1){
                    FlurryManager.flurryLog_Step(12);
                    LeagueUtil.addLife(-1);
                    listener.startGame();
                }
                else if(LeagueUtil.getCoins() >= 20){
                    LeagueUtil.addCoins(-20);
                    listener.startGame();
                }
                else {
                    DominoGame.showAdsDialog();
                }


            }
        });

        Image buttonGameInfo = root.findActor("btn_info");

        buttonGameInfo.setTouchable(Touchable.enabled);
        buttonGameInfo.addListener(new ButtonListener2() {
            @Override
            public void clicked(InputEvent event, float x, float y) {
                super.clicked(event, x, y);
                listener.showGameInfo();
            }
        });

        Image buttonLeagueInfo = root.findActor("tip_icon_2");

        buttonLeagueInfo.setTouchable(Touchable.enabled);
        buttonLeagueInfo.addListener(new ButtonListener2() {
            @Override
            public void clicked(InputEvent event, float x, float y) {
                super.clicked(event, x, y);
                listener.showInfo();
            }
        });

    }

    public void close() {

        changeX = -1;
        addAction(Actions.sequence(
                Actions.moveTo(changeX * Configuration.width,changeY * Configuration.height,0.3f),
//                Actions.fadeOut(0.3f),
                Actions.run(new Runnable() {
                    @Override
                    public void run() {
                        setVisible(false);
                        isShow = false;
                        listener.close();
                    }
                })
        ));

    }

    public void update(){

        playerInfoList.clear();
        table.clear();

        while (LeagueUtil.players.size() < 1 ){
            LeagueUtil.loadPlayer();
        }

        Gdx.app.log("yxkupdate",""+LeagueUtil.players.size());

        float playerInfoHeight = 0;

        for (Player player: LeagueUtil.players){
            PlayerInfo playerInfo = new PlayerInfo(player);
            playerInfoHeight = playerInfo.getHeight();
            playerInfo.upDate();
            playerInfoList.add(playerInfo);
        }

        table.setSize(
                pane.getWidth(),
                playerInfoList.size()*playerInfoHeight
        );
        Collections.sort(playerInfoList,new Comparator<PlayerInfo>() {

            @Override
            public int compare(PlayerInfo playerInfo, PlayerInfo t1) {

                int diff = playerInfo.rank - t1.rank;
                if (diff > 0) {
                    return -1;
                }else if (diff < 0) {
                    return 1;
                }
                return 0; //相等为0
            }
        });

        float posY = 0;
        for (PlayerInfo playerInfo : playerInfoList){

            table.addActor(playerInfo);

            playerInfo.setX(pane.getWidth()/2,Align.center);
            playerInfo.setY(posY);
            posY+=playerInfo.getHeight();
            if(playerInfo.player.getId() == 99){
                playerY = playerInfo.getHeight() * ( 25 - playerInfo.player.getRank()) ;
            }

        }

        root.findActor("tip").toFront();

        Group heart = root.findActor("useHeart");
        Actor coins = root.findActor("coins");
        Actor unclicker = root.findActor("free_coins");

        unclicker.setVisible(false);
        heart.setVisible(false);
        coins.setVisible(false);

        if(LeagueUtil.getLife() >= 1){
            heart.setVisible(true);
        }
        else if(LeagueUtil.getCoins() >= 20){
            coins.setVisible(true);
        }else {
            unclicker.setVisible(true);
        }
    }

    public void changeType(int m){
        type+=m;
        type = type%3;
        LeagueUtil.setGameType(type);
        GameConfig.setGameType(type);

    }

    public void changePositon(Actor actor){
        float changeY = actor.getY();
        changeY += Configuration.heightOffset ;
        actor.setY(changeY);

    }

    public void changeHeight(Actor actor){

        float changeY = actor.getHeight();
        changeY += Configuration.heightOffset;
        actor.setHeight(changeY);

    }



    public void show(){
        if(isShow)
            return;

        boolean isShowTip = LeagueUtil.ShowLeague();

        root.findActor("tip").setVisible(isShowTip);
        root.findActor("tip").setY(root.findActor("rank").getY());
        update();

        if(!isShowTip){

            pane.scrollTo(0,playerY - pane.getHeight()/2,pane.getWidth(),pane.getHeight());
        }

        isShow = true;
        type = LeagueUtil.getGameType();
        GameConfig.setGameType(type);

        initType();
        Types[type].setPosition(typePosition.x,typePosition.y);

        setVisible(true);

        Timer.instance().scheduleTask(new Timer.Task() {
            @Override
            public void run() {
                if(LeagueUtil.getCoins() < 20 && LeagueUtil.getLife() < 1 && isShow && DominoGame.launcherListener.isRewardAdReady()){
                    DominoGame.showAdsDialog();
                }
            }
        },0.5f);

        changeX = 1;
        changeY = 0;

        addAction(Actions.sequence(
                Actions.moveTo(changeX * Configuration.width,changeY * Configuration.height,0.01f),
                Actions.fadeIn(0.01f),
                Actions.moveTo(0,0,0.3f)
        ));

        float backX = back.getX();
        back.setX(backX+100);
        back.addAction(Actions.sequence(
                Actions.delay(0.3f),
                Actions.moveTo(backX,back.getY(),0.1f)
        ));


    }

    private void initType() {
        for (int i = 0;i < names.length;i++ ){
            Types[i].setVisible(false);
        }
        Types[type].setVisible(true);
    }


    public interface LeagueListener {
        void startGame();
        void close();
        void claim();
        void showInfo();
        void showGameInfo();

    }

    @Override
    public void act(float delta) {

        super.act(delta);
        checkPointTime+=delta;
        if(checkPointTime>45){
//            Gdx.app.log("yxk","checkPoints");
            LeagueUtil.CheckPoint();
//            DominoGame.leagueMain.update();
            checkPointTime = 0;
        }

        clock.setText("Time left for league: "+StringUtil.getTimeLable(LeagueUtil.checkSeconds()));

        if(LeagueUtil.FreeHeartStartTime.length() > 1){
            freeHeart.setVisible(true);
            freeHeartclock.setText(LeagueUtil.checkHeartTime());
        }
        else {
            freeHeart.setVisible(false);
        }

        if(isShow && LeagueUtil.CheckIsShowEnd()){
            setVisible(false);
            isShow = false;
            listener.close();
            DominoGame.showLeague();
        }


    }
}
