package com.mobilegame.dominoes.objects;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.utils.Align;
import com.mobilegame.dominoes.assets.Assets;

/**
 * Created by Doodle on 2021/2/4.
 */

public class NewPointLabel extends Group {
    Label label;
    Group labelGroup;
    Image imageBg;

    public NewPointLabel(float width, float height, boolean isLabel) {
//        imageBg = new Image();
        imageBg = new Image(Assets.dominoes.findRegion("connectBg"));
        imageBg.setSize(width, height);
        imageBg.setOrigin(Align.center);
        addActor(imageBg);

        if (isLabel) {
            label = new Label("5", getLabelStyle());
            label.setAlignment(Align.center);
            label.setFontScale(1.5f);
            labelGroup = new Group(); //为了反转
            labelGroup.setSize(label.getWidth(), label.getHeight());
            labelGroup.setPosition(imageBg.getX(Align.center), imageBg.getY(Align.center), Align.center);
            labelGroup.setOrigin(Align.center);
            labelGroup.addActor(label);

            addActor(labelGroup);
        }
        setSize(imageBg.getWidth(), imageBg.getHeight());
        setOrigin(Align.center);
    }

//    public void setImageBgAlpha(float alpha) {
////        Color c = imageBg.getColor();
////        this.alpha = alpha;
////        c.a = alpha;
////        imageBg.setColor(c);
//    }

    public void setImageBgFar(boolean isFar) {
        Color oldColor = imageBg.getColor();
        if (isFar) {
            oldColor.a = 0.6f;
        } else {
            oldColor.a = 1f;
        }
        imageBg.setColor(oldColor);
    }

    protected Label.LabelStyle getLabelStyle() {
        Label.LabelStyle style = new Label.LabelStyle();
        style.font = Assets.instance.fonts[2];
        return style;
    }

    public void setColor(boolean isGreen) {
        if (isGreen) {
            imageBg.setColor(new Color(0x8AFD65ff));
            if (label != null) {
                label.setColor(9 / 255f, 123 / 255f, 49 / 255f, 1);
            }

        } else {
            imageBg.setColor(new Color(0xFFF0A1ff));
            if (label != null) {
                label.setColor(206 / 255f, 114 / 255f, 59 / 255f, 1);
            }
        }
//        setImageBgAlpha(alpha);
    }

    public void setPoint(int point) {
        if (label != null) {
            label.setText("" + point);
        }
    }

    public void setLabelRotation(float rotation) {
        if (labelGroup != null) {
            labelGroup.setRotation(rotation);
        }
    }

    public void setBgRotation(float rotation) {
        imageBg.setRotation(rotation);
    }
}
