package com.mobilegame.dominoes.objects;

import com.badlogic.gdx.graphics.g2d.NinePatch;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.utils.Align;
import com.mobilegame.dominoes.assets.Assets;
import com.mobilegame.dominoes.utils.LeagueUtil;
import com.mobilegame.dominoes.utils.Player;

import java.util.Iterator;

/**
 * Created by qwe on 2020/10/26.
 */

class PlayerInfo extends Group{

    Player player;

    int rank;

    Image hearI;
    Image coinI;


    Label rankLabel;
    Label name;
    Label heart;
    Label coins;

    Label points;
    
    Image bg;

    public PlayerInfo(Player player) {
        this.player = player;
        init();
    }

    private void init() {
        if(player.getId()<99){
            bg = new Image(new NinePatch( Assets.instance.newUI.findRegion("pointBg"),20,20,20,20));
            bg.setSize(655,67);
        }else {
            bg = new Image(new NinePatch( Assets.instance.main.findRegion("ziji_button"),20,20,20,20));
            bg.setSize(655,67);
        }

        setSize(655,87);
        bg.setY(18);

        Label.LabelStyle style1 = new Label.LabelStyle();
        style1.font = Assets.instance.fonts[0];

        Label.LabelStyle style2 = new Label.LabelStyle();
        style2.font = Assets.instance.fonts[2];

        rankLabel = new Label("test",style2);
        name = new Label("test",style1);
        name.setFontScale(0.9f);
        heart = new Label("test",style1);
        heart.setFontScale(1.2f);
        coins = new Label("test",style1);
        coins.setFontScale(1.2f);

        points = new Label("test",style2);

        hearI = new Image(new NinePatch(Assets.main.findRegion("heart")));
        hearI.setSize(42,38.7f);
        coinI = new Image(new NinePatch(Assets.main.findRegion("coin")));
        coinI.setSize(38,39);

        rankLabel.setPosition(
                35,
                (getHeight() + 20)/2 -1,
                Align.center
        );

        name.setPosition(
                90,
                (getHeight() + 20)/2 -1 ,
                Align.center
        );

        hearI.setPosition(
                288,
                (getHeight() + 20)/2 - 3,
                Align.center
        );

        heart.setPosition(
                hearI.getX()+72,
                (getHeight() + 20)/2 -1 ,
                Align.center
        );
        coinI.setPosition(
                hearI.getX()+96,
                (getHeight() + 20)/2 - 5,
                Align.center
        );

        coins.setPosition(
                hearI.getX()+147,
                (getHeight() + 20)/2 -1,
                Align.center
        );

        points.setPosition(
                595,
                (getHeight() + 20)/2 -1,
                Align.center
        );

        addActor(bg);
        addActor(rankLabel);
        addActor(name);
        addActor(heart);
        addActor(coins);
        addActor(points);

        addActor(hearI);
        addActor(coinI);

    }

    public void upDate(){

        rank = 1;
        name.setText(player.getName());

        Iterator<Player> iterator =  LeagueUtil.players.iterator();
        while(iterator.hasNext()){
            Player player1 = iterator.next();
            if(player1.getScore()>player.getScore() ){
                rank++;
            }
            else if(player1.getScore() == player.getScore()){
                if(player1.getId() > player.getId()){
                    rank++;
                }
            }
        }

        rankLabel.setText(rank+"");

        if(rank <= LeagueUtil.heartNum.length){
            heart.setText(LeagueUtil.heartNum[rank-1]+"");
        }
        else {
            heart.setVisible(false);
            hearI.setVisible(false);
        }

        if(rank <= LeagueUtil.coinNum.length){
            coins.setText(LeagueUtil.coinNum[rank-1]+"");
        }
        else {
            coins.setVisible(false);
            coinI.setVisible(false);
        }


        points.setText(player.getScore()+"");

        rankLabel.setAlignment(Align.center);
        points.setAlignment(Align.center);
        coins.setAlignment(Align.left);

        player.setRank(rank);
        
    }
}
