package com.mobilegame.dominoes.objects;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.g2d.NinePatch;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.utils.Align;
import com.mobilegame.dominoes.assets.Assets;

public class PointLabel extends Group {

    Label label;
    Image image;
    Image image2;
    public PointLabel(){

        image = new Image(new NinePatch(Assets.instance.newUI.findRegion("c1")));
        image2 = new Image(new NinePatch(Assets.instance.newUI.findRegion("button_tip_green")));

        setSize(140,140);
        addActor(image);
        addActor(image2);
        image2.setPosition(getWidth()/2,getHeight()/2,Align.center);
        image.setPosition(getWidth()/2,getHeight()/2,Align.center);
        Label.LabelStyle style = new Label.LabelStyle();
        style.font = Assets.instance.fonts[2];
        label = new Label("5",style);
        addActor(label);
        label.setAlignment(Align.center);
        label.setFontScale(1.4f);
        label.setPosition(image.getX(Align.center),image.getY(Align.center),Align.center);
        label.setColor(new Color(0xffe700ff));
    }

    public void setPoint(int point){
        if(point > 10){
            label.setFontScale(1.4f);
        }
        else {
            label.setFontScale(1.8f);
        }
        label.setText(""+point);

        image.setVisible(point%5 != 0 ||  point == 0);
        image2.setVisible(!image.isVisible());

        if(image.isVisible())
            label.setColor(new Color(0xffe700ff));
        else
            label.setColor(new Color(0x16f52dff));
//        label.setPosition(image.getX(Align.center),image.getY(Align.center),Align.center);
    }
}
