package com.mobilegame.dominoes.objects;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.scenes.scene2d.ui.Table;
import com.badlogic.gdx.utils.Align;
import com.mobilegame.dominoes.assets.Assets;
import com.mobilegame.dominoes.assets.Colors;

/**
 * Created by Doodle on 2021/2/25.
 */

public class ScoreItem extends Table {
    Label[] labels = new Label[3];

    public ScoreItem(int id, String tag, String score1, String score2, boolean isEnd) {
        setSize(474, 80);
        Label.LabelStyle style = new Label.LabelStyle();
        style.font = Assets.instance.fonts[0];

        Label.LabelStyle style1 = new Label.LabelStyle();
        style1.font = Assets.instance.fonts[2];
        if (isEnd) {
            labels[0] = new Label("test", style);
            labels[1] = new Label("test", style1);
            labels[2] = new Label("test", style1);
            labels[1].setColor(Colors.wordGreen);
            labels[2].setColor(Colors.wordYellow);
        } else {
            labels[0] = new Label("test", style);
            labels[1] = new Label("test", style);
            labels[2] = new Label("test", style);
            labels[1].setColor(Color.WHITE);
            labels[2].setColor(Color.WHITE);
        }
        labels[0].setFontScale(0.6f);
        labels[1].setFontScale(0.8f);
        labels[2].setFontScale(0.8f);

        float tableBlockWidth = 148;
        for (int i = 0; i < 3; i++) {
//                labels[i].setWidth(tableBlockWidth);
//                labels[i].setAlignment(Align.center);
            if (i == 0) {
                add(labels[0]).width(tableBlockWidth).height(40).padLeft(20);
            } else if (i == 1) {
                labels[1].setAlignment(Align.center);
                add(labels[1]).width(tableBlockWidth).height(40).spaceLeft(14);
            } else {
                labels[2].setAlignment(Align.center);
                add(labels[2]).width(tableBlockWidth).height(40).spaceLeft(40);
            }
        }

        labels[0].setText(tag);
        labels[1].setText(score1);
        labels[2].setText(score2);
    }
}
