package com.mobilegame.dominoes.screens;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.math.Interpolation;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.badlogic.gdx.scenes.scene2d.actions.Actions;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.utils.Align;
import com.badlogic.gdx.utils.Timer;
import com.esotericsoftware.spine.SkeletonData;
import com.esotericsoftware.spine.SkeletonJson;
import com.esotericsoftware.spine.SkeletonRenderer;
import com.esotericsoftware.spine.attachments.AtlasAttachmentLoader;
import com.mobilegame.dominoes.DominoGame;
import com.mobilegame.dominoes.assets.Assets;
import com.mobilegame.dominoes.assets.Configuration;
import com.mobilegame.dominoes.constants.Constant;
import com.mobilegame.dominoes.data.Classes.Design;
import com.mobilegame.dominoes.data.DiamondDataUtil;
import com.mobilegame.dominoes.data.FileUtil;
import com.mobilegame.dominoes.data.SettingDataUtil;
import com.mobilegame.dominoes.dialogs.AdsDialog;
import com.mobilegame.dominoes.dialogs.DesignDialogNew;
import com.mobilegame.dominoes.dialogs.InfoDialog;
import com.mobilegame.dominoes.dialogs.LeagueInfoDialog;
import com.mobilegame.dominoes.dialogs.NoInternetDialog;
import com.mobilegame.dominoes.dialogs.SettingDialogNew;
import com.mobilegame.dominoes.dialogs.UnlockDialog;
import com.mobilegame.dominoes.flurry.ABTestManager;
import com.mobilegame.dominoes.flurry.DeltaDNAManager;
import com.mobilegame.dominoes.flurry.FlurryManager;
import com.mobilegame.dominoes.handles.GameConfig;
import com.mobilegame.dominoes.utils.ABTestUtil;
import com.mobilegame.dominoes.utils.LeagueUtil;
import com.mobilegame.dominoes.utils.listener.ButtonListener2;
import com.spine.MySpineActor;

import org.freyja.libgdx.cocostudio.ui.model.CCExport;

/**
 * Created by Doodle on 2021/1/7.
 */

public class MenuScreenNew extends BaseScreen {
    Group scene;
    private DesignDialogNew designDialog;
    private Actor bgActor;
    private Actor quanActor;
    private MySpineActor dominoActor;
    private Actor logoActor;
    private Actor setting;
    private Actor design;
    private Actor playButton;
    private Actor designClickActor;
    private Actor settingClickActor;

    private float oldSettingX, oldSettingY;
    private float oldDesignX, oldDesignY;

    public MenuScreenNew(DominoGame game) {
        super(game);
        init();

        ABTestManager.currentTest = FileUtil.getCurrentTest();

//        Label.LabelStyle style = new Label.LabelStyle();
//        style.font = Assets.instance.fonts[2];
//        style.fontColor = Color.RED;
//        final Label label = new Label(ABTestUtil.getVersion(), style);
//        label.setAlignment(Align.center);
//        stage.addActor(label);
//        label.setPosition(360, 100, Align.center);


//        Actor tes1 = new Actor();
//        tes1.debug();
//        tes1.setSize(100, 100);
//        tes1.setOrigin(Align.center);
//        tes1.setPosition(360, 640, Align.center);
//        stage.addActor(tes1);
//
//        tes1.addListener(new ClickListener() {
//            @Override
//            public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
//                Actor a = event.getTarget();
//                a.setScale(0.8f);
//                return super.touchDown(event, x, y, pointer, button);
//            }
//
//            @Override
//            public void touchUp(InputEvent event, float x, float y, int pointer, int button) {
//                super.touchUp(event, x, y, pointer, button);
//                Actor a = event.getTarget();
//                a.setScale(1);
//            }
//
//            @Override
//            public void clicked(InputEvent event, float x, float y) {
//                ABTestManager.currentTest = ABTestManager.B;
//                label.setText("ifDelhandtip");
//            }
//        });
//
//        Actor tes2 = new Actor();
//        tes2.debug();
//        tes2.setSize(100, 100);
//        tes2.setOrigin(Align.center);
//        tes2.setPosition(360, 800, Align.center);
//
//        stage.addActor(tes2);
//
//        tes2.addListener(new ClickListener() {
//            @Override
//            public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
//                Actor a = event.getTarget();
//                a.setScale(0.8f);
//                return super.touchDown(event, x, y, pointer, button);
//            }
//
//            @Override
//            public void touchUp(InputEvent event, float x, float y, int pointer, int button) {
//                super.touchUp(event, x, y, pointer, button);
//                Actor a = event.getTarget();
//                a.setScale(1);
//            }
//
//            @Override
//            public void clicked(InputEvent event, float x, float y) {
//                ABTestManager.currentTest = ABTestManager.C;
//                label.setText("ifDelendtip");
//            }
//        });
//
//        Actor tes3 = new Actor();
//        tes3.debug();
//        tes3.setSize(100, 100);
//        tes3.setOrigin(Align.center);
//        tes3.setPosition(360, 960, Align.center);
//        stage.addActor(tes3);
//        tes3.clearListeners();
//        tes3.addListener(new ClickListener() {
//            @Override
//            public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
//                Actor a = event.getTarget();
//                a.setScale(0.8f);
//                return super.touchDown(event, x, y, pointer, button);
//            }
//
//            @Override
//            public void touchUp(InputEvent event, float x, float y, int pointer, int button) {
//                super.touchUp(event, x, y, pointer, button);
//                Actor a = event.getTarget();
//                a.setScale(1);
//            }
//
//            @Override
//            public void clicked(InputEvent event, float x, float y) {
//                ABTestManager.currentTest = ABTestManager.D;
//                label.setText("ifDelanimation");
//            }
//        });
//
//        Actor tes4 = new Actor();
//        tes4.debug();
//        tes4.setSize(100, 100);
//        tes4.setOrigin(Align.center);
//        tes4.setPosition(360, 1120, Align.center);
//        stage.addActor(tes4);
//
//        tes4.addListener(new ClickListener() {
//            @Override
//            public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
//                Actor a = event.getTarget();
//                a.setScale(0.8f);
//                return super.touchDown(event, x, y, pointer, button);
//            }
//
//            @Override
//            public void touchUp(InputEvent event, float x, float y, int pointer, int button) {
//                super.touchUp(event, x, y, pointer, button);
//                Actor a = event.getTarget();
//                a.setScale(1);
//            }
//
//            @Override
//            public void clicked(InputEvent event, float x, float y) {
//                ABTestManager.currentTest = ABTestManager.A;
//                label.setText("1.2.5");
//            }
//        });

//        String string = "\"ifChangeUI\":true,\"ddnaIsPersistent\":false";
//        string = string.substring(1, string.length() - 1);
//        System.out.println("cccccccccccccccccccccccccccccccc: " + string);
//        if (string.contains("ifChangeUI")) {
//            System.out.println("1111111111111111111111111111111111111111");
//        } else if (string.contains("ifAddhandtip")) {
//            System.out.println("2222222222222222222222222222222222222222");
//        } else if (string.contains("ifAddendtip")) {
//            System.out.println("3333333333333333333333333333333333333333");
//        } else if (string.contains("ifAddanimation")) {
//            System.out.println("4444444444444444444444444444444444444444");
//        } else {
//            System.out.println("5555555555555555555555555555555555555555");
//        }
        //添加钻石
//        DiamondDataUtil.addDiamondNum(1000);
//
//        FlipDominoActor flipDominoActor = new FlipDominoActor(new int[]{1, 3});
//        flipDominoActor.setPosition(360, 540);
//        stage.addActor(flipDominoActor);

//        DominoCardPlayer2 dominoCardPlayer2 = new DominoCardPlayer2(5, new int[]{1, 3}, null);
//        dominoCardPlayer2.setPosition(400, 540);
//        dominoCardPlayer2.debug();
//        stage.addActor(dominoCardPlayer2);
//        System.out.println("cccccccccccccccc: " + dominoCardPlayer2.getWidth() + "    " + dominoCardPlayer2.getHeight() + "   " + dominoCardPlayer2.getScaleX() + "   " + dominoCardPlayer2.getScaleY());

//        TipThreePageDialog aftd =  showDialog(TipThreePageDialog.class, "ui/objects/tip_allfiveN.json");
//        TipTwoPageDialog aftd =  showDialog(TipTwoPageDialog.class, "ui/objects/tip_blockN.json");
//        aftd.setGroup(stage.getRoot());
    }

    private String getABTestString() {
       if (ABTestManager.currentTest == ABTestManager.B) {
            return "ifDelhandtip";
        } else if (ABTestManager.currentTest == ABTestManager.C) {
            return "ifDelendtip";
        } else if (ABTestManager.currentTest == ABTestManager.D) {
           return "ifDelanimation";
        }
        return "1.2.5";
    }

    private void init() {
        CCExport export = Assets.instance.assetManager.get("ui/menuNew.json");
        scene = game.getCocoStudioUIEditor().createGroup(export);

        SkeletonJson sJsonAct;
        SkeletonData skeletonDataLoading;
        sJsonAct = new SkeletonJson(new AtlasAttachmentLoader(Assets.instance.newUI));
        skeletonDataLoading = sJsonAct.readSkeletonData(Gdx.files.internal("animation/shouye_pai.json"));
        dominoActor = new MySpineActor(new SkeletonRenderer(), skeletonDataLoading);
        dominoActor.setAnimation("animation", false);
        scene.addActor(dominoActor);

        bgActor = scene.findActor("bg");
        quanActor = scene.findActor("menuBg_2");
        logoActor = scene.findActor("logo");
        setting = scene.findActor("btn_setting", Touchable.disabled);
        oldSettingX = setting.getX();
        oldSettingY = setting.getY();

        design = scene.findActor("btn_design", Touchable.disabled);
        oldDesignX = design.getX();
        oldDesignY = design.getY();

        scene.setTransform(false);
        scene.setTouchable(Touchable.enabled);

        Actor titleActor = scene.findActor("logo");
        titleActor.setVisible(false);
        titleActor.clearActions();
        titleActor.addAction(
                Actions.sequence(
                        Actions.delay(0.1667f, Actions.show()),
                        Actions.scaleTo(1.2f, 1.2f, 0.3f, Interpolation.sineOut),
                        Actions.scaleTo(1, 1, 0.3667f, Interpolation.sineIn)
                )
        );

        designClickActor = new Actor() {
            @Override
            public void setScale(float scaleX, float scaleY) {
                super.setScale(scaleX, scaleY);
                design.setScale(scaleX, scaleY);
            }
        };

        designClickActor.setTouchable(Touchable.enabled);
        designClickActor.setSize(design.getWidth() + 30, design.getHeight() + 30);
        scene.addActor(designClickActor);
        designClickActor.addListener(new ButtonListener2() {
            @Override
            public void clicked(InputEvent event, float x, float y) {
                super.clicked(event, x, y);
//                if (tutorManager != null) {
//                    tutorManager.hide();
//                    scene.findActor("btn_design").clearActions();
//                    scene.findActor("btn_design").addAction(Actions.scaleTo(1, 1, 0.01f));
//                }
                designDialog = showDialog(DesignDialogNew.class, "ui/objects/designNew.json");
                designDialog.addListenr();

                //////////////////////////// DNA ////////////////////////////////
                DeltaDNAManager.addUiInteraction("mainPage", "button", "design", FileUtil.mainpageDesign);
                /////////////////////////////////////////////////////////////////
            }
        });
        design.setScale(0.416f);
        design.clearActions();
        design.addAction(
                Actions.sequence(
                        Actions.delay(0.0333f),
                        Actions.scaleTo(1.2f, 1.2f, 0.3333f, Interpolation.sineOut),
                        Actions.scaleTo(1, 1, 0.4f, Interpolation.sineIn)
                )
        );

        settingClickActor = new Actor() {
            @Override
            public void setScale(float scaleX, float scaleY) {
                super.setScale(scaleX, scaleY);
                setting.setScale(scaleX, scaleY);
            }
        };
        settingClickActor.setTouchable(Touchable.enabled);
        settingClickActor.setSize(setting.getWidth() + 30, setting.getHeight() + 30);
        scene.addActor(settingClickActor);

        setting.toFront();
        settingClickActor.addListener(new ButtonListener2() {
            @Override
            public void clicked(InputEvent event, float x, float y) {
                super.clicked(event, x, y);
                showDialog(SettingDialogNew.class, "ui/objects/setting_menuNew.json");

                //////////////////////////// DNA ////////////////////////////////
                DeltaDNAManager.addUiInteraction("mainPage", "button", "setting", FileUtil.mainpageSetting);
                /////////////////////////////////////////////////////////////////
            }
        });
        setting.setScale(0.416f);
        setting.clearActions();
        setting.addAction(
                Actions.sequence(
                        Actions.delay(0.0333f),
                        Actions.scaleTo(1.2f, 1.2f, 0.3333f, Interpolation.sineOut),
                        Actions.scaleTo(1, 1, 0.4f, Interpolation.sineIn)
                )
        );

        playButton = scene.findActor("button_play", Touchable.enabled);
        stage.addActor(scene);

        playButton.setOrigin(Align.center);
        playButton.addListener(new ButtonListener2() {
            @Override
            public void clicked(InputEvent event, float x, float y) {
                super.clicked(event, x, y);
                if (DominoGame.mainHelpNew.isShow()) {//DominoGame.mainHelpNew.isShow() || DominoGame.leagueMain.isShow || DominoGame.leagueEnd.isShow
                    return;
                }
                FlurryManager.flurryLog_Step(4);
                if (!FileUtil.getIsTutorFinished(1)) {
                    return;
                } else {
                    GameConfig.refreshDataForNewGame();
                    DominoGame.mainHelpNew.show();
                }
                //////////////////////////// DNA ////////////////////////////////
                DeltaDNAManager.addUiInteraction("mainPage", "button", "play", FileUtil.mainpagePlay);
                /////////////////////////////////////////////////////////////////
            }
        });
        playButton.setVisible(false);
        playButton.setScale(0.416f);
        playButton.clearActions();
        playButton.addAction(
                Actions.sequence(
                        Actions.delay(0.3f, Actions.show()),
                        Actions.scaleTo(1.2f, 1.2f, 0.28f, Interpolation.sineOut),
                        Actions.scaleTo(1, 1, 0.4333f, Interpolation.sineIn)
                )
        );

        stage.addActor(DominoGame.mainHelpNew);
        DominoGame.mainHelpNew.setVisible(false);
    }

    @Override
    public void show() {
        super.show();
//        Assets.instance.assetManager.load("particles/lizi", ParticleEffect.class);
        SettingDataUtil.setExitScreen(Constant.MENUSCREEN);

        scene.setTransform(false);
        scene.setTouchable(Touchable.childrenOnly);
        GameConfig.refreshDataForNewGame();

        Timer.instance().scheduleTask(new Timer.Task() {
            @Override
            public void run() {
                showTutoDialog();
            }
        }, 0.3f);

        GameConfig.uTime = 0;
        GameConfig.uTimeFLurry = 0;
        resize((int) Configuration.width, (int) Configuration.height);
    }

    @Override
    public void resize(int width, int height) {
        super.resize(width, height);

        float offsetWidth = Configuration.widthOffset / 2f;
        float offsetHeight = Configuration.heightOffset / 2f;

        //顶端两个按钮的适配
        setting.setPosition(oldSettingX - offsetWidth, oldSettingY + offsetHeight);
        design.setPosition(oldDesignX + offsetWidth, oldDesignY + offsetHeight);
        designClickActor.setPosition(design.getX(Align.center), design.getY(Align.center), Align.center);
        settingClickActor.setPosition(setting.getX(Align.center), setting.getY(Align.center), Align.center);

        float scale = Configuration.height / 1280f;
        //骨牌动画适配
        dominoActor.setPosition(360, scale * 779 - offsetHeight, Align.bottom);

        quanActor.setPosition(360, dominoActor.getY() - 195, Align.bottom);
        //底端按钮适配
        playButton.setPosition(360, scale * 387 - offsetHeight, Align.bottom);

        logoActor.setPosition(360, scale * 627 - offsetHeight, Align.bottom);

        bgActor.setSize(Configuration.width, Configuration.height);
        bgActor.setPosition(-offsetWidth, -offsetHeight);
    }

    @Override
    protected boolean back() {
//        if (tutorManager != null) {
//            if (!tutorManager.isHide())
//                return false;
//        }

        boolean flag = super.back();

        if (flag) {
            if (false) { //DominoGame.leagueMain.isShow
//                DominoGame.leagueMain.close();
            } else if (DominoGame.mainHelpNew.isShow()) {
                DominoGame.mainHelpNew.close();
            } else {
                if (FileUtil.isFirstLogin) {
                    FlurryManager.flurryLog_levelGameFirst();
                }
                Gdx.app.exit();
                System.exit(0);
            }

        }
        return false;
    }

    public void addTutorDesign() {
        if (FileUtil.getIsTutorFinished(8)) {
            return;
        }
//        tutorManager = new TutorManager(stage, 8);
//        Vector2 pos = tutorManager.showActionActor(scene.findActor("btn_design"));
//        tutorManager.addoldMan(600, pos.y - 200);
//        tutorManager.addWord(100, pos.y - 200, "Try to unlock a\nnew design now!", 500, 160);
//
//        tutorManager.bg.addListener(new ClickListener() {
//            @Override
//            public void clicked(InputEvent event, float x, float y) {
//                super.clicked(event, x, y);
//                tutorManager.hide();
//            }
//        });

    }

    private void showTutoDialog() {
        if (FileUtil.getIsTutorFinished(1)) {
            if (DiamondDataUtil.getDiamondNum() > 0) {
                addTutorDesign();
            }
            return;

        }

//        tutorManager = new TutorManager(stage, false, 13);
//        tutorManager.addoldMan(600, Configuration.height - 600);
//        tutorManager.addWord(100, Configuration.height - 600, "Welcome to Dominoes!\nDo you need a tutorial?", 500, 160);
    }

    public void showNeterrorDialog() {
        NoInternetDialog dialog = showDialog(NoInternetDialog.class, "ui/objects/noInternet.json");
    }

    @Override
    public void render(float delta) {
        super.render(delta);

        if (!game.doodleHelper.isConnected() && dialogs.size() < 1) {  //!game.doodleHelper.isConnected() && (DominoGame.leagueMain.isShow || DominoGame.leagueEnd.isShow) && dialogs.size() < 1
//            if (DominoGame.leagueMain.isShow) {
//                DominoGame.leagueMain.close();
//            } else if (DominoGame.leagueEnd.isShow) {
//                DominoGame.leagueEnd.close();
//            }
            showNeterrorDialog();
        }
    }

    public void closeLeague() {
        setting.setVisible(true);
        scene.findActor("heart_6").setVisible(false);
        scene.findActor("change").setVisible(true);
        updateLabel();
    }

    public void showInfoDialog() {
        InfoDialog dialog = showDialog(InfoDialog.class, "ui/objects/tip_main.json");
        dialog.showPane();
    }

    public void showLeagueInfoDialog() {
        LeagueInfoDialog dialog = showDialog(LeagueInfoDialog.class, "ui/objects/league_info.json");
    }

    public void refreshDesignDialog() {
        if (designDialog != null) {
            designDialog.refresh();
        }
    }

    public void updateLabel() {
        Label name = scene.findActor("name");
        Label coin = scene.findActor("coin");

        name.setAlignment(Align.center);
        if (false) { //DominoGame.leagueEnd.isShow || DominoGame.leagueMain.isShow
            name.setText(LeagueUtil.getLife() + "");
            name.setFontScale(1.1f);
            name.setX(320);
        } else {
            name.setText(LeagueUtil.user.getName());
            name.setFontScale(0.7f);
            name.setX(304);
        }

        coin.setText(LeagueUtil.getCoins() + "");
    }

    public void showAdsDialog() {
        showDialog(AdsDialog.class, "ui/objects/ads.json");
    }

    public void showUnlock(Design design) {
        UnlockDialog unlockDialog = showDialog(UnlockDialog.class, "ui/objects/unlockNew.json");
        unlockDialog.setDesign(design);
    }
}
