package com.mobilegame.dominoes.utils;

import com.badlogic.gdx.files.FileHandle;
import com.badlogic.gdx.utils.ArrayMap;
import com.badlogic.gdx.utils.Json;
import com.badlogic.gdx.utils.ObjectMap;
import com.mobilegame.dominoes.utils.json.PythonDict;

import java.io.File;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Iterator;

public class AnimationProcess {

    public static void main(String[] args) {
        changePngName();
//        changeAnimation();
    }

    private static void changeAnimation() {
        String name = "zombie2";
        File jsonFile = new File("android/assets/animations/" + name + ".json");
        File imageFile = new File("Assets/pic/" + name);
        if (!imageFile.exists()) return;
        File[] images = imageFile.listFiles();
        Json json = new Json();
        PythonDict root = json.fromJson(PythonDict.class, new FileHandle(jsonFile).readString());
        PythonDict skins = (PythonDict) root.get("skins");
        ArrayMap.Keys<String> keys = skins.keys();
        Iterator<String> iterator = keys.iterator();

        while (iterator.hasNext()) {
            processSkin((PythonDict) skins.get(iterator.next()), name, images);
        }
        System.out.println("ssss");
        try {
            FileWriter fileWriter = new FileWriter(jsonFile);
            PrintWriter printWriter = new PrintWriter(fileWriter);
            printWriter.write(json.toJson(root));
            fileWriter.close();
            printWriter.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private static void processSkin(PythonDict skins, String name, File[] images) {
        ArrayMap.Keys<String> keys = skins.keys();
        Iterator<String> iterator = keys.iterator();

        while (iterator.hasNext()) {
            PythonDict skin = (PythonDict) skins.get(iterator.next());
            Iterator<ObjectMap.Entry<String, Object>> iterator1 = skin.iterator();
            PythonDict temp = new PythonDict();
            while (iterator1.hasNext()) {
                ObjectMap.Entry<String, Object> entry = iterator1.next();
                iterator1.remove();
                if (checkImage(name, entry.key, images)) {
                    temp.put(name + "_" + entry.key, entry.value);
                } else {
                    temp.put(entry.key, entry.value);
                }
            }
            Iterator<ObjectMap.Entry<String, Object>> iterator2 = temp.iterator();
            skin.clear();
            while (iterator2.hasNext()) {
                ObjectMap.Entry<String, Object> entry = iterator2.next();
                skin.put(entry.key, entry.value);
            }
        }
        System.out.println("x");
    }


    private static boolean checkImage(String name, String key, File[] images) {
        boolean changed = false;
        for (int i = 0; i < images.length; i++) {
            File file = images[i];
            String fileNameTemp = file.getName();
            if (!fileNameTemp.endsWith(".png")) continue;
            String fileName = fileNameTemp.substring(0, fileNameTemp.length() - 4);
            if (fileName.equals(key)) {
                if (fileName.startsWith(name + "_")) return false;
                else {
                    File tempFile = new File(file.getParent() + "/" + name + "_" + key + ".png");
                    file.renameTo(tempFile);
                    System.out.println(file.getName());
                    changed = true;
                    break;
                }
            } else {
                continue;
            }
        }
        System.out.println(changed);
        return changed;
    }


    private static void changePngName() {
        String name = "zombie2";
        File imageFile = new File("Assets/pic/" + name);
        if (!imageFile.exists()) return;
        File[] images = imageFile.listFiles();
        for (int i = 0; i < images.length; i++) {
            File file = images[i];
            String fileNameTemp = file.getName();
            if (!fileNameTemp.endsWith(".png")) continue;
            if (fileNameTemp.startsWith(name + "_")) continue;
            File tempFile = new File(file.getParent() + "/" + name + "_" + fileNameTemp);
            file.renameTo(tempFile);
        }
    }
}
