package com.mobilegame.dominoes.utils;

import com.badlogic.gdx.Application;
import com.badlogic.gdx.Gdx;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by Doodle on 2018/11/14.
 */

public class FlurryUtils {
    private static FlurryListener listener;

    public static interface FlurryListener {
        public void logEvent(String e, Map<String, String> map);
    }

    private static void f(String k, String v, String e) {
        if (Gdx.app.getType() == Application.ApplicationType.Android) {
            Map<String, String> m = new HashMap<String, String>(1);
            m.put(k, v);
            if (listener != null) {
                listener.logEvent(e, m);
            }
        }
    }

    public static void setLiterer(FlurryListener literer) {
        FlurryUtils.listener = literer;
    }

    private static void Level(String k, int level) {
        f(k, "level _ " + level, "Level");
    }

    private static void View(String k, String v) {
        f(k, v, "View");
    }

    private static void Two_Player(String k, String v) {
        f(k, v, "Tow_Player");
    }

    private static void Theme(String k, String v) {
        f(k, v, "Theme");
    }
    private static void Daily(String k, String v) {
        f(k, v, "Daily");
    }


    public static void level_Start(int level) {
        Level("level_start", level);
    }

    public static void level_video_ads(int level) {
        Level("level_video_ads", level);
    }

    public static void level_Win(int level) {
        Level("level_win", level);
    }

    public static void level_Hint(int level) {
        Level("level_hint", level);
    }

    public static void level_Lose(int level) {
        Level("level_lose", level);
    }
    public static void level_Draw(int level) {
        Level("level_draw", level);
    }

    public static void level_FirstStart(int level) {
        //关卡id（胜利）
        Level("level_FirstStart", level);
    }

    public static void level_FirstWin(int level) {
        Level("level_FirstWin", level);
    }

    public static void theme_Use(int id){
        Theme("theme_use","theme_"+id);
    }
    public static void theme_3D(){
        Theme("theme_orientation","theme_3D");
    }
    public static void theme_2D(){
        Theme("theme_orientation","theme_2D");
    }

    public static void daily_FirstStart(){
        Daily("daily_FirstStart","daily_FirstStart");
    }
    public static void daily_FirstWin(){
        Daily("daily_FirstWin","daily_FirstWin");
    }


    public static void two_Player(){
        Two_Player("two_player","two_player");
    }

    public static void Ads_show(){
        View("Ads_show","Ads_show");
    }

}
