package com.mobilegame.dominoes.utils;

import com.badlogic.gdx.graphics.g2d.NinePatch;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.badlogic.gdx.scenes.scene2d.utils.NinePatchDrawable;
import com.badlogic.gdx.utils.Align;
import com.mobilegame.dominoes.assets.Assets;
import com.mobilegame.dominoes.assets.Configuration;

public class LayerUtils {
    public static Image createLayer() {
        return createLayer(0.75F);
    }

    public static Image createLayer(float alpha) {
        TextureRegion region = Assets.instance.newUI.findRegion("white");
        NinePatch patch = new NinePatch(region, 2, 2, 2, 2);
        NinePatchDrawable drawable = new NinePatchDrawable(patch);
        Image image = new Image(drawable);
        image.setSize(Configuration.width, Configuration.height);
        image.setPosition(360, 640, Align.center);
        image.setColor(0, 0, 0, alpha);
        return image;
    }

//    public static Image createColorBoard(Color color){
//        TextureRegion region = Assets.instance.ui.findRegion("white");
//        NinePatch patch = new NinePatch(region,2,2,2,2);
//        NinePatchDrawable drawable = new NinePatchDrawable(patch);
//        Image image = new Image(drawable);
//        image.setSize(Configuration.width,Configuration.height);
//        image.setPosition(0,0);
//        image.setColor(color);
//        return image;
//    }
//    public static NinePatch createLayerNinePatch(float alpha){
//        TextureRegion region = Assets.instance.ui.findRegion("white");
//        NinePatch patch = new NinePatch(region,2,2,2,2);
//        return patch;
//    }
}
