package com.mobilegame.dominoes.utils;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Preferences;
import com.badlogic.gdx.utils.Timer;
import com.mobilegame.dominoes.DominoGame;
import com.mobilegame.dominoes.data.FileUtil;
import com.mobilegame.dominoes.flurry.FlurryManager;
import com.mobilegame.dominoes.handles.GameConfig;


import java.io.File;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.Iterator;
import java.util.Random;

/**
 * Created by qwe on 2020/10/14.
 * 排行榜
 */

public class LeagueUtil {


    public static float ScoreScale;

    public static Player user;

    public static ArrayList<Player> players = new ArrayList<>();
    public static ArrayList<String> noun = new ArrayList<>();
    public static ArrayList<String> adj = new ArrayList<>();

    private static final String FILE_NAME = "LeagueUtil";
    private static final String PlayerName = "PlayerName";
    private static final String PlayerAct = "PlayerAct";
    private static final String PlayerCheckList = "PlayerCheckList";
    private static final String PlayerChecked = "PlayerChecked";
    private static final String PlayerScore = "PlayerScore";
    private static final String LeaguelID = "LeaguelID";

    private static final String UserName = "UserName";
    private static final String UserPoint = "UserPoint";
    private static final String HeartFreeTime = "HeartFreeTime";

    private static final String Life = "Life";
    private static final String Coins = "Coins";
    private static final String Level = "Level";
    private static final String Stars = "Stars";
    private static final String roundNum = "roundNum";
    private static Preferences prefs;

    private static int[] startTime = {0,3,6,9,12,15,18,21};
    public static int[] scale = {10,13,15,18,20,22,30};

    public static int[] heartNum = {3,2,1};
    public static int[] coinNum = {160,120,80,60,40,40,40,40,20,20,20,20,20,20,20,20};
    public static int[] starNum = {40,20,15,10,5,5,5,5,5,5,5};
    public static String LeaguelIDT = "";
    public static String  NowTime;

    public static String  FreeHeartStartTime;

    public static SimpleDateFormat sdf =new SimpleDateFormat("yyyy/MM/dd HH:mm:ss" );

    public static void init(){

        readName();

        setPrefs();
        CheckUser();
        CheckNowTime();

        if(FileUtil.isFirstLogin){
            addCoins(120);
            addLife(3);
        }
        setLevel(0);
        LoadFreeHeartTime();
        LeaguelIDT = prefs.getString(LeaguelID," ");
    }

    private static void readName() {
        String nouns = Gdx.files.internal("data/Noun.txt").readString();
        String adjs = Gdx.files.internal("data/Adj.txt").readString();

        String[] allNoun = nouns.trim().replaceAll("\r", "").split("\n");
        String[] allAdj = adjs.trim().replaceAll("\r", "").split("\n");
        Collections.addAll(noun, allNoun);
        Collections.addAll(adj, allAdj);
    }

    public static void CheckNowTime(){

        Date date = DominoGame.getTime();
        String str = sdf.format(date);

        int[] now = StringUtil.getDateNum(str);
        int checkHour = 0;
        for (int i = 0;i < startTime.length ;i ++){
            if(now[3]>=startTime[i]){
                checkHour = startTime[i];
            }
        }
        NowTime = ""+now[0]+"/"+now[1]+"/"+now[2]+" "+checkHour+":"+0+":"+0;
    }

    public static void setLevel(int m) {


        prefs.putInteger(Level, m);
        prefs.flush();

    }

    public static void addLevel(){
        int m =  prefs.getInteger(Level);
        m++;
        if(m > 2){
            m = 2;
        }
        setLevel(m);

    }

    public static void lessLevel(){
        int m =  prefs.getInteger(Level);
        int x = prefs.getInteger(Level+"Get");
        if(m == 1){

            x++;

            if(x == 3){
                x = 0;
                m --;
            }
            prefs.putInteger(Level+"Get",x);
        }
        else {
            m--;
        }


        if(m < 0){
            m = 0;
        }
        setLevel(m);
    }


    public static GameConfig.HardLevel getLevel() {

        int m =  prefs.getInteger(Level);
        GameConfig.HardLevel hardLevel;

        if(m == 0){
            hardLevel = GameConfig.HardLevel.Easy;
        }else if(m == 1) {
            hardLevel = GameConfig.HardLevel.Normal;
        }
        else {
            hardLevel = GameConfig.HardLevel.Hard;
        }
        return hardLevel;
    }

    public static void setPrefs() {
        if(prefs == null)
            prefs = Gdx.app.getPreferences(FILE_NAME);
    }

    public static int LeagueMin(){


        int min = 0;
        Date date = DominoGame.getTime();
        String str = sdf.format(date);
        int[] now = StringUtil.getDateNum(str);

        int[] startLeague = StringUtil.getDateNum(NowTime);
        min+=now[4]+(now[3] - startLeague[3])*60;

        return min;
    }

    public static boolean ShowLeague(){

        Date date = DominoGame.getTime();
        String str = sdf.format(date);

        Gdx.app.log("yxkLeagueTime",str);
        Gdx.app.log("yxkLeagueTime",LeaguelIDT);
        int[] now = StringUtil.getDateNum(str);
        int checkHour = 0;

        for (int i = 0;i < startTime.length ;i ++){
            if(now[3]>=startTime[i]){
                checkHour = startTime[i];
            }
        }
        String oldName = LeaguelIDT;
        String newName = ""+now[0]+"/"+now[1]+"/"+now[2]+" "+checkHour+":"+0+":"+0;
        Gdx.app.log("yxkLeagueTime",newName);

        if(oldName.equals(newName)){
            loadPlayer();
            CheckPoint();
            return false;
        }else{
            CreateShowPlayer();
            return true;
        }


    }

    private static void CreateShowPlayer() {
        int waitPlayerNum = MyRandom.getInstance().nextInt(4)+3;
        players.clear();

        for (int i = 0;i < 25;i++){
            String name = adj.remove(MyRandom.getInstance().nextInt(adj.size())) + " "+noun.remove(MyRandom.getInstance().nextInt(noun.size()));
            Player player = new Player(name,i,waitPlayerNum);
            Random r = new Random();
            player.score =  r.nextInt(500);
            players.add(player);
        }
        readName();

    }


    public static void JoinLeague(){

//        if(ABTestUtil.isABTestA)
//            return;

//        Date date = DominoGame.getTime();
//        String str = sdf.format(date);
//
//        Gdx.app.log("yxkLeagueTime",str);
//        Gdx.app.log("yxkLeagueTime",LeaguelIDT);
//        int[] now = StringUtil.getDateNum(str);
//        int checkHour = 0;
//
//        for (int i = 0;i < startTime.length ;i ++){
//            if(now[3]>=startTime[i]){
//                checkHour = startTime[i];
//            }
//        }
//        String oldName = LeaguelIDT;
//        String newName = ""+now[0]+"/"+now[1]+"/"+now[2]+" "+checkHour+":"+0+":"+0;
//        Gdx.app.log("yxkLeagueTime",newName);
//        if(oldName.equals(newName)){
//            loadPlayer();
//            CheckPoint();
//        }else{
//
//            FlurryManager.flurryLog_Playeamount(checkHour);
//            StartNewLeaguel(newName);
//            CheckPoint();
//
//        }

    }

    public static boolean CheckIsShowEnd(){
        CheckNowTime();
        return (LeaguelIDT.length() > 3 && !LeaguelIDT.equals(NowTime))  ;

    }

    public static void EndLeague(){

        LeaguelIDT = "";

        clearRonudNum();
        prefs.putString(LeaguelID," ");
        prefs.flush();

        if(FreeHeartStartTime.length() > 1){
            endFreeHeart();
        }

    }

    public static void StartNewLeaguel(String leagueName){


        Gdx.app.log("yxkNewLeague", leagueName);
        if(prefs == null){
            setPrefs();
        }

        creatUiPlayer();
        LeaguelIDT = leagueName;
        prefs.putString(LeaguelID, leagueName);
        prefs.flush();
    }

    public static void CheckUser(){

        if(prefs == null){
            setPrefs();
        }

        if(user == null){
            String userName = prefs.getString(UserName);
            if(userName.length() < 3){
                userName = adj.remove(MyRandom.getInstance().nextInt(adj.size())) + " "+noun.remove(MyRandom.getInstance().nextInt(noun.size()));
                prefs.putString(UserName,userName);
                prefs.flush();
            }
            user = new Player(userName,99,0);
        }

        Gdx.app.log("yxkName",user.name);

    }

    public static void upDateUser(int scrore){

        if(CheckIsShowEnd())
            return;
        user.score = scrore;
        prefs.putInteger(UserPoint,scrore);
        prefs.flush();
    }

    public static void creatUiPlayer(){

        if(prefs == null){
            setPrefs();
        }
        CheckUser();
        user.score = 0;
        players.add(user);
        upDateUser(0);

        int waitPlayerNum = MyRandom.getInstance().nextInt(4)+3;
        players.clear();
        for (int i = 0;i < 24;i++){

            String name = adj.remove(MyRandom.getInstance().nextInt(adj.size())) + " "+noun.remove(MyRandom.getInstance().nextInt(noun.size()));
            Player player = new Player(name,i,waitPlayerNum);

            players.add(player);
            prefs.putString(PlayerName+i,name);
            prefs.putInteger(PlayerAct+i, player.addScoreTime.size());
            for (int m = 0; m < player.addScoreTime.size() ;m++){
                prefs.putFloat(i+PlayerCheckList+m,player.addScoreTime.get(m));
            }
            prefs.putInteger(PlayerScore+i, 0);
            prefs.putInteger(PlayerChecked+i, 0);

        }
        prefs.flush();
        readName();

    }

    public static void loadPlayer(){
        user.score =  prefs.getInteger(UserPoint,0);
        players.clear();
        players.add(user);
        for (int i = 0;i < 24;i++){

            String name;
            int score;
            ArrayList<Float> addScoreTime = new ArrayList<>();
            int checked;

            name = prefs.getString(PlayerName+i);
            int size = prefs.getInteger(PlayerAct+i);
            for (int m = 0; m < size ;m++){
                float x = prefs.getFloat(i+PlayerCheckList+m);
                addScoreTime.add(x);
            }
            score = prefs.getInteger(PlayerScore+i, 0);
            checked = prefs.getInteger(PlayerChecked+i, 0);

            Player player = new Player(i,name,score,addScoreTime,checked);

            players.add(player);
        }
    }

    public static void SavePlayerChange(int id,int score,int checked){
        prefs.putInteger(PlayerScore+id, score);
        prefs.putInteger(PlayerChecked+id, checked);
        prefs.flush();
    }


    public static void CheckPoint() {
        String str = sdf.format(new Date());

        int[] now = StringUtil.getDateNum(str);
        int checkHour = 0;

        for (int i = 0;i < startTime.length ;i ++){
            if(now[3]>=startTime[i]){
                checkHour = startTime[i];
            }
        }

        Gdx.app.log("yxkPlayer",LeaguelIDT);
        String oldName = LeaguelIDT;
        String newName = ""+now[0]+"/"+now[1]+"/"+now[2]+" "+checkHour+":"+0+":"+0;
        Gdx.app.log("yxkPlayer",newName);

        if(oldName.equals(newName)){
            Iterator<Player> iterator = players.iterator();
            while(iterator.hasNext()){
                Player player = iterator.next();
                player.CheckPoints();
            }

        }


    }

    public static int CreateScore() {

        Random random = new Random();

        int score;
        boolean isWin = random.nextInt(100) > 35;
        boolean isAllfive = random.nextInt(100) > 25;

        int scaleIndex;

        int randomForScale = random.nextInt(100);
        int randomForScore = random.nextInt(100);
        if( randomForScale <= 4){
            scaleIndex = 0;
        }
        else {
            scaleIndex = (randomForScale-4)/16 +1;
        }

        if(isWin && !isAllfive){
            if(randomForScore < 20){
                score = 100 + random.nextInt(20);
            }
            else if (randomForScore < 35){
                score = 120 + random.nextInt(10);
            }
            else if (randomForScore < 75){
                score = 130 + random.nextInt(20);
            }
            else if (randomForScore < 95){
                score = 150 + random.nextInt(20);
            }
            else {
                score = 170 + random.nextInt(10);
            }
        }else if(isWin){
            if(randomForScore < 10){
                score = 100 ;
            }
            else if (randomForScore < 40){
                score = 105 + random.nextInt(5);
            }
            else if (randomForScore < 60){
                score = 115;
            }
            else if (randomForScore < 90){
                score = 120 + random.nextInt(5);
            }
            else {
                score = 130;
            }
        }else {
            score = randomForScore;
        }

        if(isAllfive){
            score = allfiveScore(score);
        }

       int m = score ;

        return m;
    }

    private static int allfiveScore(int n){
        int x;

        int a = n%5;
        int b = n/5;

        if(a>=3){
            b++;
        }
        x = b*5;

        return x;

    }

    public static void setGameType(int m){
        setPrefs();
        prefs.putInteger("Type" , m);
        prefs.flush();
    }
    public static int getGameType(){
        setPrefs();
        return prefs.getInteger("Type",2 );
    }

    public static void addCoins(int m){

        setPrefs();
        int x = getCoins();
        x+=m;
        prefs.putInteger(Coins, x);
        prefs.flush();

        if(m > 0){
            DominoGame.addCoinAni();
            Timer.instance().scheduleTask(new Timer.Task() {
                @Override
                public void run() {
                    DominoGame.upDateNum();
                }
            },0.6f);
        }
        else {
            DominoGame.upDateNum();
        }


        if(m < 0 && getLife() < 1 && getCoins() < 20){
            checkTheFreeHeart();
        }
    }
    public static int getCoins(){
        setPrefs();
        return prefs.getInteger(Coins,0 );
    }

    public static void addLife(int m){
        setPrefs();
        int x = getLife();
        x+=m;
        prefs.putInteger(Life, x);
        prefs.flush();

        DominoGame.upDateNum();
        if(m < 0 && getLife() < 1 && getCoins() < 20){
            checkTheFreeHeart();
        }
    }
    public static int getLife(){
        setPrefs();
        return prefs.getInteger(Life,0 );
    }

//    public static void addStars(int m){
//        setPrefs();
//        int x = getStars();
//        x+=m;
//        prefs.putInteger(Stars, x);
//        prefs.flush();
//        DominoGame.upDateNum();
//        DominoGame.addStarAni();
//    }
    public static int getStars(){
        setPrefs();
        return prefs.getInteger(Stars,0 );
    }


    public static int checkSeconds(){


        Date date = DominoGame.getTime();
        String str = sdf.format(date);
        int[] now = StringUtil.getDateNum(str);

        int[] old = StringUtil.getDateNum(NowTime);

        int ans = 3*3600 - (now[5]+(now[4]*60)+(now[3] - old[3])*3600);

        if(ans>0 && ans < 3*3600)
            return ans;
        else{
            CheckNowTime();
            old = StringUtil.getDateNum(NowTime);
            ans = 3*3600 - (now[5]+(now[4]*60)+(now[3] - old[3])*3600);
            return ans;
        }

    }


    public static void saveAdsTime(){
        Date date = DominoGame.getTime();
        String adstime = sdf.format(date);
        prefs.putString("ADsTime",adstime);
        prefs.flush();
    }

    public static String checkAdsTime(){

        Date date = DominoGame.getTime();
        String now = sdf.format(date);
        String Start = prefs.getString("ADsTime");
        if(Start.length() < 3){
            return "";
        }

        int[] a = StringUtil.getDateNum(now);
        int[] b = StringUtil.getDateNum(Start);

        if(a[3] < b[3]){
            a[3] += 24;
        }

        int m = 120*60 - (a[3]-b[3])*60*60 - (a[4]-b[4])*60 - (a[5] - b[5]);
        if(m < 0){
            return "";
        }
        else
            return m/60+"m"+m%60+"s";
    }

    public static void clearAdsTime(){
        FileUtil.clearAdsNum();
        prefs.putString("ADsTime","");

    }

    public static int getRonudNum(){
        return prefs.getInteger(roundNum,0);
    }

    public static void addRonudNum(){
        int x =  getRonudNum();
        x++;
        prefs.putInteger(roundNum,x);
        prefs.flush();

    }

    public static void clearRonudNum(){

        prefs.putInteger(roundNum,0);
        prefs.flush();

    }

    public static void saveUserName(String name){

        user.name = name;
        prefs.putString(UserName,name);
        prefs.flush();


    }

    public static String reRollName(){


        String name = adj.get(MyRandom.getInstance().nextInt(adj.size())) + " "+noun.get(MyRandom.getInstance().nextInt(noun.size()));
        return name;
    }

    public static void checkTheFreeHeart(){

        if(FreeHeartStartTime.length() < 1){
            startFreeHeart();
        }

    }

    public static String checkHeartTime(){

        Date date = DominoGame.getTime();
        String now = sdf.format(date);
        String Start = FreeHeartStartTime;
        if(Start.length() < 3){
            return "";
        }

        int[] a = StringUtil.getDateNum(now);
        int[] b = StringUtil.getDateNum(Start);

        if(a[2]!=b[2] || a[0] != b[0] || a[1] != b[1]){
            a[3] += 24;
        }


        int m = 15*60 - (a[3]-b[3])*60*60 - (a[4]-b[4])*60 - (a[5] - b[5]);
        if(m < 0){
            endFreeHeart();
            return "";
        }
        else
            return m/60+"m"+m%60+"s";
    }

    public static void startFreeHeart(){

        Date date = DominoGame.getTime();
        String str = sdf.format(date);
        SetFreeHeartTime(str);
    }

    public static void endFreeHeart(){

        addLife(1);
        SetFreeHeartTime("");
    }

    public static void SetFreeHeartTime(String time){

        setPrefs();
        prefs.putString(HeartFreeTime,time);
        FreeHeartStartTime = time;
        prefs.flush();
    }

    public static void LoadFreeHeartTime(){
        setPrefs();
        FreeHeartStartTime = prefs.getString(HeartFreeTime);
    }

}
