package com.mobilegame.dominoes.utils;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.glutils.ShaderProgram;

public class ShaderUtil {
    private static ShaderProgram outlineShader;
    private static ShaderProgram smoothShader;

    public static ShaderProgram getOutlineShader() {
        if (outlineShader == null) {
 //           ShaderProgram.pedantic = false;
            outlineShader = initProgram("shaders/outline.vertex", "shaders/outline.frag");
        }
        return outlineShader;
    }

    public static ShaderProgram getSmoothShader() {
        if (smoothShader == null) {
            //           ShaderProgram.pedantic = false;
            smoothShader = initProgram("shaders/smooth.vertex", "shaders/smooth.frag");
        }
        return smoothShader;
    }

    public static ShaderProgram getFboShader() {
        if (smoothShader == null) {
            //           ShaderProgram.pedantic = false;
            smoothShader = initProgram("shaders/smooth.vertex", "shaders/tattoo2drawincover.fp");
        }
        return smoothShader;
    }

    private static ShaderProgram initProgram(String vetexFileName, String fragFileName) {
        ShaderProgram program = new ShaderProgram(Gdx.files.internal(vetexFileName), Gdx.files.internal(fragFileName));
        return program;
    }
}
