package com.mobilegame.dominoes.utils.downloader;

import com.badlogic.gdx.utils.Array;

public interface Downloader {

    public void download(DownLoadInfo info);

    public void download(Array<DownLoadInfo> infos);

    public static class DownLoadInfo{
        public String URL;
        public boolean external;
        public String path;
        public DownloadListener listener;
        public float totalBytes;
        public float soFarBytes;

        public static DownLoadInfo getInstance(String URL,String path,boolean external,DownloadListener listener){
            DownLoadInfo info = new DownLoadInfo();
            info.URL = URL;
            info.path = path;
            info.external = external;
            info.listener = listener;
            return info;
        }

        public String getFileName(){
            String[] strs = path.split("/");
            if(strs!=null){
                return strs[strs.length-1];
            }
            return null;
        }

        public float getPercent() {
            if(totalBytes == 0) return 0;
            return soFarBytes/totalBytes;
        }
    }

}
