package com.mobilegame.dominoes.utils.listener;

import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.Event;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.actions.Actions;

/**
 * Created by lilexiang on 17-2-14.
 */
public class ButtonListener extends LClickListener {
    float scaleOriginX;
    float scaleOriginY;
    private Actor activeActor;

    public ButtonListener() {
        super();
    }

    public ButtonListener(Actor actor) {
        this.activeActor = actor;
    }

    protected void touched(InputEvent event) {
        isTouched = true;
        Actor target = getTarget(event);
        if(target!=null){
            scaleOriginX = target.getScaleX();
            scaleOriginY = target.getScaleY();
            target.addAction(Actions.scaleTo(scaleOriginX * 0.95F,scaleOriginY * 0.95F,0.1F));
        }
    }

    private Actor getTarget(Event event){
        if(activeActor!=null) return activeActor;
        else return event.getListenerActor();
    }


    public boolean release(Event event) {
        boolean flag = super.release(event);
        if (flag) {
            Actor target = getTarget(event);
            if(target!=null) {
                target.getActions().clear();
                target.setScale(scaleOriginX,scaleOriginY);
            }
            return true;
        }
        return false;
    }


}