package com.mobilegame.dominoes.utils.listener;

import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.actions.Actions;
import com.mobilegame.dominoes.audio.AudioManager;

/**
 * Created by qwe on 2020/10/27.
 */

public class ButtonListener3  extends MClickListener {
    private boolean ownTarget;
    private Actor target;
    float startY ;
    float startX ;
    private float scaleOriginX, scaleOriginY;
    private boolean release = true;
    boolean effect = true;

    public ButtonListener3(Actor target) {
        this.target = target;
        ownTarget = false;
    }

    public ButtonListener3() {
        ownTarget = false;
    }

    public ButtonListener3(boolean effect){
        this.effect = effect;
    }

    @Override
    public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
        boolean flag = super.touchDown(event, x, y, pointer, button);
        AudioManager.PlaySound(AudioManager.AudioType.button);

        if (!ownTarget) {
            target = event.getListenerActor();
            startY = target.getY();
            startX = target.getX();

        }
        if (target != null) {
            release = false;
            target.addAction(Actions.moveBy(0, -5, 0.1F));
        }


        return flag;
    }

    @Override
    public void touchUp(InputEvent event, float x, float y, int pointer, int button) {
        super.touchUp(event, x, y, pointer, button);
        if(!release) {
            release();
        }
    }

    @Override
    public void invalidateTapSquare() {
        super.invalidateTapSquare();
        if(!release) {
            release();
        }
    }

    protected void release() {
        if(!effect) return;
        release = true;
        if (target != null) {
            target.addAction(Actions.moveBy(0, 5, 0.1F));
        }
        if (!ownTarget) {
            target = null;
        }
    }

    public Actor getTarget() {
        return target;
    }
}

