package com.mobilegame.dominoes.utils.listener;

import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.actions.Actions;

/**
 * Created by qwe on 2020/2/21.
 */

public class ButtonListenrNoSound extends MClickListener {
    private boolean ownTarget;
    private Actor target;
    private float scaleOriginX, scaleOriginY;
    private boolean release = true;
    boolean effect = true;

    public ButtonListenrNoSound(Actor target) {
        this.target = target;
        ownTarget = false;
    }

    public ButtonListenrNoSound() {
        ownTarget = false;
    }

    public ButtonListenrNoSound(boolean effect){
        this.effect = effect;
    }

    @Override
    public boolean touchDown(InputEvent event, float x, float y, int pointer, int button) {
        boolean flag = super.touchDown(event, x, y, pointer, button);
        if (flag && effect) {
            if (!ownTarget) {
                target = event.getListenerActor();
            }
            if (target != null) {
                release = false;
                scaleOriginX = target.getScaleX();
                scaleOriginY = target.getScaleY();
                target.addAction(Actions.scaleTo(scaleOriginX * 0.95F, scaleOriginY * 0.95F, 0.1F));
            }
        }
        return flag;
    }

    @Override
    public void touchUp(InputEvent event, float x, float y, int pointer, int button) {
        super.touchUp(event, x, y, pointer, button);
        if(!release) {
            release();
        }
    }

    @Override
    public void invalidateTapSquare() {
        super.invalidateTapSquare();
        if(!release) {
            release();
        }
    }

    protected void release() {
        if(!effect) return;
        release = true;
        if (target != null) {
            target.getActions().clear();
            target.setScale(scaleOriginX, scaleOriginY);
        }
        if (!ownTarget) {
            target = null;
        }
    }

    public Actor getTarget() {
        return target;
    }
}
