package com.spine;

import com.badlogic.gdx.scenes.scene2d.Group;
import com.esotericsoftware.spine.AnimationState;
import com.esotericsoftware.spine.Skeleton;
import com.esotericsoftware.spine.SkeletonData;
import com.esotericsoftware.spine.SkeletonRenderer;

public class MySpineGroup extends Group {

    protected MySpineActor actor;

    public MySpineGroup(SkeletonRenderer renderer, Skeleton skeleton, AnimationState state) {
        this.actor = new MySpineActor(renderer, skeleton, state);
        this.addActor(actor);
    }

    public MySpineGroup(SkeletonRenderer renderer, SkeletonData data) {
        this.actor = new MySpineActor(renderer, data);
        this.addActor(actor);
    }

    public MySpineGroup(SkeletonRenderer renderer2, MySpineStatus mysp1) {
        this.actor = new MySpineActor(renderer2, mysp1);
        this.addActor(actor);
    }

    public SkeletonRenderer getRenderer() {
        return actor.getRenderer();
    }

    public void setRenderer(SkeletonRenderer renderer) {
        this.actor.setRenderer(renderer);
    }

    public Skeleton getSkeleton() {
        return actor.getSkeleton();
    }

    public void setSkeleton(Skeleton skeleton) {
        actor.setSkeleton(skeleton);
    }

    public AnimationState getAnimationState() {
        return actor.getAnimationState();
    }

    public void setAnimation(String animation) {
        this.actor.setAnimation(animation, true, 0);
    }

    public void setAnimation(String animation, boolean loop) {
        this.actor.setAnimation(animation, loop, 0);
    }

    public void setAnimation(String animation, boolean loop, int trackIndex) {
        this.actor.setAnimation(animation, loop, trackIndex);
    }

    public void setAnimationState(AnimationState state) {
        this.actor.setAnimationState(state);
    }

    public void setClip(boolean b) {
        this.actor.setClip(b);
    }
}
