package com.mobilegame.dominoes.screens;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.files.FileHandle;
import com.badlogic.gdx.graphics.g2d.NinePatch;
import com.badlogic.gdx.math.Interpolation;
import com.badlogic.gdx.math.MathUtils;
import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.InputEvent;
import com.badlogic.gdx.scenes.scene2d.Touchable;
import com.badlogic.gdx.scenes.scene2d.actions.Actions;
import com.badlogic.gdx.scenes.scene2d.actions.SequenceAction;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.scenes.scene2d.utils.ClickListener;
import com.badlogic.gdx.utils.*;
import com.mobilegame.dominoes.Actor.FinishActor;
import com.mobilegame.dominoes.Actor.FlipDominoActor;
import com.mobilegame.dominoes.Actor.PointActor;
import com.mobilegame.dominoes.Animation.AnimationManager;
import com.mobilegame.dominoes.Animation.FinishAnimation2;
import com.mobilegame.dominoes.Animation.FinishAnimation3;
import com.mobilegame.dominoes.Animation.FinishAnimation1;
import com.mobilegame.dominoes.Animation.StartGameAnimation;
import com.mobilegame.dominoes.DNAManage.DNATilesPlay;
import com.mobilegame.dominoes.DNAManage.DnaTilesDraw;
import com.mobilegame.dominoes.DominoGame;
import com.mobilegame.dominoes.GameFunction.DominoNumber;
import com.mobilegame.dominoes.assets.Assets;
import com.mobilegame.dominoes.assets.Configuration;
import com.mobilegame.dominoes.audio.AudioManager;
import com.mobilegame.dominoes.constants.Constant;
import com.mobilegame.dominoes.data.Classes.Design;
import com.mobilegame.dominoes.data.DiamondDataUtil;
import com.mobilegame.dominoes.data.FileUtil;
import com.mobilegame.dominoes.data.GameDataCsv;
import com.mobilegame.dominoes.dialogs.*;
import com.mobilegame.dominoes.dialogs.BoneYard;
import com.mobilegame.dominoes.flurry.DeltaDNAManager;
import com.mobilegame.dominoes.flurry.FlurryManager;
import com.mobilegame.dominoes.handles.DominoManager;
import com.mobilegame.dominoes.handles.GameConfig;
import com.mobilegame.dominoes.handles.PlayerManager;
import com.mobilegame.dominoes.objects.Board;
import com.mobilegame.dominoes.objects.HandShowDomioCard;
import com.mobilegame.dominoes.objects.NewPointLabel;
import com.mobilegame.dominoes.utils.ABTestUtil;
import com.mobilegame.dominoes.utils.ConvertUtil;
import com.mobilegame.dominoes.utils.LeagueUtil;
import com.mobilegame.dominoes.utils.MyRandom;
import com.mobilegame.dominoes.utils.PlayControler;
import com.mobilegame.dominoes.utils.Vector2Int;
import com.mobilegame.dominoes.utils.json.PythonArray;
import com.mobilegame.dominoes.utils.json.PythonDict;
import com.mobilegame.dominoes.utils.listener.ButtonListener2;
import com.mobilegame.dominoes.dialogs.ScoreViewDialog;
import com.mobilegame.dominoes.dialogs.UnlockDialog;
import com.mobilegame.dominoes.objects.DominoCard;
import com.mobilegame.dominoes.objects.DominoCardBase;
import com.mobilegame.dominoes.objects.DominoCardCommon;
import com.mobilegame.dominoes.objects.DominoCardHalf;
import com.mobilegame.dominoes.objects.DominoCardPlayer2;

import org.freyja.libgdx.cocostudio.ui.model.CCExport;
import org.freyja.libgdx.cocostudio.ui.util.StringUtil;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.Iterator;
import java.util.Random;

/**
 * Created by lilexiang on 19-11-1.
 */

public class GameScreen extends BaseScreen implements GameScreenInterface {
    public DominoManager[] dominoManagers;     //保存28個骨牌信息
    private PlayerManager[] players;            //保存玩家信息(玩家, 电脑)
    IntArray boneYardDominoes = new IntArray(); //保存骨牌id, 长度为28
    private Group scene;
    private int startDominoCount = 7;           //开始骨牌数量
    private int pointsTarget;
    private int[] useNum;                       //端口的值
    private int[] useNumCard;                   //端口牌的id
    private boolean gameHasBoneYard;
    private boolean gameHasSpinner;             //判定是否有spinner
    private int playerTurn;                     //保存谁先出牌
    private ArrayMap<Integer, IntArray> possibleMoves = new ArrayMap<>();  //保存的是能够出牌的手牌 id(Integer) 和 用一个list(IntArray)保存所有能够连接的端点的骨牌id
    private IntArray layedIds = new IntArray();                            //出的牌id
    private int layedIncrementId;                                          //layedIds的长度
    private boolean spinnerPosed;                                          //spinner是否被摆放
    //计算是否用来缩放
    private int maxX;
    private int maxY;
    private Vector2Int minPoint;
    private Vector2Int maxPoint;
    //缩放比例
    private float boardRatio;
    private Board board;          //桌面group,控制缩放
    private Vector2 boardCenter;
    private Vector2 dominoSize;   //初始骨牌的大小
    private Vector2 boardSize;
    private Vector2 boardOriginSize;

    private Group[] playerPanels;     //保存手牌Actor
    private ArrayMap<Integer, Actor> dominoObjects = new ArrayMap<>();  //管理Acror
    private float[] boardScale = {1F, 1F};      //上下缩放区域的缩放比
    private BoneYard boneYard;
    private int closestMove;                    //离出牌近的牌的id
    private Label[] pointLabel = new Label[2];
    private Image[] processes;

    private boolean handEnded;                   //回合是否结束(一局结束)
    private boolean gameEnd;                     //大局结束
    private boolean noTouch;
    private boolean tutorSpinnerShow;
    //    private NewPointLabel[] allFiveText = new NewPointLabel[5];
    private DesignDialogNew designDialog;
    //    Label addPointLabel;
    private PointActor addPointLabel;
    int[] scores;

    private Label round;
    private Label roundTitle;
    private Group playerWord;
    private Label pWords;
    private Image pBg;
    private Group opponentWord;
    private Label oWords;
    private Image oBg;

    private Group titleActor;

    private Image[] topBgs;
    private Image[] middleBgs;
    private Image[] downBgs;

    private int board_id[];

    private ArrayList<DominoCard> dominoCards = new ArrayList<DominoCard>();

    private float delaytime = 0;
    private float boneYarddelaytime = 0;
    private boolean showYourTurn = false;
    private boolean showSpinner = false;
    private boolean isShowTimeAddPoint = false;
    private boolean isEnd = false;

    private float scale = 1;
//    public TutorManager tutorManager;

    //    public LeagueGameEndDialog leagueGameEndDialogdialog;
//    private FanbeiDialog fanbeiDialog;
    private DominoNumber dominoNumber;  //记牌器数据

    private Array<Integer> playHeadID = new Array<>();
    private Array<Integer> compHeadID = new Array<>();

    private DNATilesPlay dnaTilesPlay;
    private DnaTilesDraw dnaTilesDraw;
    int oldUserPoint = 0;
    int oldCompPoint = 0;

//    private IntArray canConnectId = new IntArray();

    public static boolean isAddPoint = false;

    private boolean isSpinner = false;

    private final float nextTurnDelayTime = 0.5f;

    private NewPointLabel firstPointLabel;

    private boolean isStartGame = false;

    public GameScreen(DominoGame game) {
        super(game);

        isAddPoint = false;

        TAG = "gameNew";
        //牌的大小
        scale = DominoGame.dominoesScale;
        tutorSpinnerShow = false;
        noTouch = true;
//        if (FileUtil.getPlayWinNum() > 4) {
//            dominoNumber = new DominoNumber();
//        }

        dnaTilesPlay = new DNATilesPlay();
        dnaTilesDraw = new DnaTilesDraw();
        init();
    }

    @Override
    public void show() {
        //教程
//        if (tutorManager != null) {
//            tutorManager.hide();
//        }
        boardSize.set(boardOriginSize.x, boardOriginSize.y);
        boardRatio = boardSize.x / boardSize.y;
        //初始化玩家区域
        initPlayerBoards();
        //出牌放到排面
        layDominoOnBoard(false);
        adjustBoard(false);
        //更换皮肤
        showBg(DominoGame.bgNum);

//        //进入游戏界面动画
//        stage.addActor(Actionlayer);
//        if (mySpineActor != null) {
//            stage.addActor(mySpineActor);
//            mySpineActor.setAnimation("2", true);
//        }
//        Actionlayer.setVisible(true);
//
//        isAction = true;
//        Timer.instance().scheduleTask(new Timer.Task() {
//            @Override
//            public void run() {
//                isAction = false;
//                Actionlayer.setVisible(false);
//                mySpineActor.setVisible(false);
//            }
//        }, 0.7f);

        Group g = game.hideDominoSpineActor();
        stage.addActor(g);
        super.show();
    }

    private void init() {
        initUI();
        initButtons();
    }

    float boardC;

    private void initUI() {
        CCExport export = Assets.instance.assetManager.get("ui/gameNew3.json");

        scene = game.getCocoStudioUIEditor().createGroup(export);
        stage.addActor(scene);
        titleActor = scene.findActor("title_panel");
        titleActor.moveBy(0, Configuration.heightOffset / 2f);

        Actor topBgActor = scene.findActor("top_bg");
        topBgActor.setWidth(Configuration.width);
        topBgActor.setX(360, Align.center);
        Actor middleActor = scene.findActor("middle_bg", Touchable.disabled);

        Actor downActor = scene.findActor("down_bg");
        downActor.setSize(Configuration.width, downActor.getHeight() + 20);
        downActor.setX(360, Align.center);
        downActor.moveBy(0, -Configuration.heightOffset / 2f);

        float middleHeight = Configuration.height - topBgActor.getHeight() - downActor.getHeight() + 2;
        float middleWidth = middleActor.getWidth();

        if (middleHeight > middleActor.getHeight()) {
            middleWidth = middleWidth / middleActor.getHeight() * middleHeight;
        }
        middleActor.setSize(Configuration.width, middleHeight);
        middleActor.setPosition(360, downActor.getY(Align.top) - 1, Align.bottom);

        float middleBgW = middleWidth;
        float middleBgH = middleHeight;
        if (Configuration.width / Configuration.height > 720 / 1280f) {
            middleBgH = middleBgH / middleBgW * Configuration.width;
            middleBgW = Configuration.width;
        }

        topBgs = new Image[GameDataCsv.getDesignBgSize()];
        middleBgs = new Image[GameDataCsv.getDesignBgSize()];
        downBgs = new Image[GameDataCsv.getDesignBgSize()];
        board_id = new int[GameDataCsv.getDesignBgSize()];
        int n = 0;
        for (int i = 1; i <= GameDataCsv.getDesignSize(); i++) {
            Design design = GameDataCsv.getDesign(i);
            if (design.type.contains("background")) {
                //大背景
                board_id[n] = design.ID;
                topBgs[n] = new Image(new NinePatch(Assets.instance.design.findRegion(design.Topic_name + "up"), 0, 0, 2, 3));
                topBgs[n].setSize(Configuration.width, topBgActor.getHeight());
                topBgs[n].setPosition(topBgActor.getX(), topBgActor.getY());
                topBgs[n].setVisible(false);

                middleBgs[n] = new Image(new NinePatch(Assets.instance.design.findRegion(design.Topic_name + "middle")));
                middleBgs[n].setSize(middleBgW, middleBgH);
                middleBgs[n].setPosition(middleActor.getX(Align.center), middleActor.getY(Align.center), Align.center);
                middleBgs[n].setVisible(false);

                downBgs[n] = new Image(new NinePatch(Assets.instance.design.findRegion(design.Topic_name + "down"), 3, 3, 0, 0));
                downBgs[n].setSize(downActor.getWidth(), downActor.getHeight());
                downBgs[n].setPosition(downActor.getX(), downActor.getY());
                downBgs[n].setVisible(false);
                scene.addActorBefore(titleActor, middleBgs[n]);
                titleActor.addActorAfter(topBgActor, topBgs[n]);
                scene.addActor(downBgs[n]);
                n++;
            }
        }

        boardC = downBgs[0].getY(Align.top) + Configuration.height - topBgs[0].getHeight() - downBgs[0].getHeight();
        //进度条
        processes = new Image[GameConfig.playerCount];
        for (int i = 0; i < GameConfig.playerCount; i++) {
            processes[i] = scene.findActor("pro_" + i);
        }
        //分数
        for (int i = 0; i < pointLabel.length; i++) {
            pointLabel[i] = scene.findActor("point_" + i);
            pointLabel[i].setAlignment(Align.center);
            pointLabel[i].setText("" + GameConfig.points[i]);
            setProcess(false, false);
        }

        boardSize = new Vector2(Configuration.width - 10, middleActor.getHeight() - 50);
        boardOriginSize = new Vector2(boardSize);
        boardCenter = new Vector2(middleActor.getX(Align.center), middleActor.getY(Align.center));
        dominoSize = new Vector2(265f * scale, 130f * scale);

        board = new Board();
        board.setPosition(boardCenter.x, boardCenter.y);
//        scene.addActor(board);
        scene.addActorBefore(titleActor, board);

        boardRatio = boardSize.x / boardSize.y;
        DominoCardCommon.reset();

        round = scene.findActor("round_label");
        round.setY(titleActor.getY() - 76, Align.top);
        roundTitle = scene.findActor("round");
        round.setVisible(false);

        opponentWord = scene.findActor("opponent_words");
//        opponentWord.setPosition(360, titleActor.getY() - 76, Align.top);

        playerWord = scene.findActor("player_words");
        playerWord.setPosition(360, downActor.getY(Align.top) + 97, Align.bottom);

        oBg = opponentWord.findActor("wordoppobg");
        oWords = opponentWord.findActor("wordoppo");
        oWords.setOrigin(Align.center);

        pBg = playerWord.findActor("wordBg");
        pWords = playerWord.findActor("wordplayer");
        pWords.setOrigin(Align.center);

        scene.removeActor(opponentWord);
        scene.removeActor(playerWord);

        stage.addActor(opponentWord);
        stage.addActor(playerWord);

        //初始化字體
//        Label.LabelStyle labelStyle = new Label.LabelStyle();
//        labelStyle.font = Assets.instance.fonts[2];
//
//        addPointLabel = new Label("+10", labelStyle);
        addPointLabel = new PointActor(true);
        addPointLabel.setVisible(false);
//        addPointLabel.setFontScale(0.9f);
        stage.addActor(addPointLabel);

        opponentWord.addAction(Actions.fadeOut(0.01f));
        playerWord.addAction(Actions.fadeOut(0.01f));

        opponentWord.setY(titleActor.getY() - 76, Align.top);

        //如果是聯賽，將切換皮膚按鈕去掉
        if (GameConfig.isLeague) {
            scene.findActor("btn_info").setVisible(false);
        }

        if (dominoNumber != null) {
            Group dominoNumberGroup = dominoNumber.getShowGroup();
            dominoNumberGroup.setPosition(0, downActor.getY(Align.top) + 5);
            stage.addActor(dominoNumberGroup);
        }
    }

    //分数进度条
    private void setProcess(boolean isAnimation, boolean isDelay) {
        float processLength = 198;

        float player = (processLength) * (float) GameConfig.points[0] / (float) GameConfig.targetPoints;
        float ai = (processLength) * (float) GameConfig.points[1] / (float) GameConfig.targetPoints;


        if (ai > processLength) {
            ai = processLength;
        } else if (ai > 0 && ai <= 10) {
            ai = 10;
        }

        if (player > processLength) {
            player = processLength;
        } else if (player > 0 && player <= 10) {
            player = 10;
        }

        if (isAnimation) {
            processes[0].clearActions();
            processes[1].clearActions();

            processes[0].addAction(Actions.sizeTo(player, processes[0].getHeight(), 0.2f));
            processes[1].addAction(Actions.sizeTo(ai, processes[1].getHeight(), 0.2f));
        } else {
            processes[0].setWidth(player);
            processes[1].setWidth(ai);
        }

        processes[0].setVisible(player > 0);
        processes[1].setVisible(ai > 0);
    }

    private void initButtons() {
        //选择皮肤按钮
        final Actor designActor = scene.findActor("btn_info", Touchable.disabled);
        Actor designClickActor = new Actor() {
            @Override
            public void setScale(float scaleX, float scaleY) {
                super.setScale(scaleX, scaleY);
                designActor.setScale(scaleX, scaleY);
            }

            @Override
            public void setPosition(float x, float y) {
                super.setPosition(x, y);
                designActor.setPosition(x, y);
            }

            @Override
            public void setPosition(float x, float y, int alignment) {
                super.setPosition(x, y, alignment);
                designActor.setPosition(x, y, alignment);
            }
        };
        designClickActor.setTouchable(Touchable.enabled);
        designClickActor.setSize(designActor.getWidth() + 30, designActor.getHeight() + 30);
        designClickActor.setPosition(designActor.getX(Align.center) + Configuration.widthOffset / 2f, designActor.getY(Align.center), Align.center);
        titleActor.addActor(designClickActor);

        designClickActor.addListener(new ButtonListener2() {
            @Override
            public void clicked(InputEvent event, float x, float y) {
                super.clicked(event, x, y);
                //如果当前是电脑回合或玩家跳过回合
                if (playerTurn == 1 || players[playerTurn].hasPassed) {
                    return;
                }
//                if (tutorManager != null) {
//                    tutorManager.hide();
//                }
                FlurryManager.flurryLog_Click(6);
                FlurryManager.flurryLog_Click(6);
                //展示选择皮肤弹窗
                designDialog = showDialog(DesignDialogNew.class, "ui/objects/designNew.json");
                designDialog.addListenr();

                //////////////////////////// DNA ////////////////////////////////
                DeltaDNAManager.addUiInteraction("table", "button", "design", FileUtil.tableDesign);
                /////////////////////////////////////////////////////////////////
            }
        });
        //设置按钮
        final Actor settingActor = scene.findActor("btn_setting", Touchable.disabled);
        Actor settingClickActor = new Actor() {
            @Override
            public void setScale(float scaleX, float scaleY) {
                super.setScale(scaleX, scaleY);
                settingActor.setScale(scaleX, scaleY);
            }

            @Override
            public void setPosition(float x, float y) {
                super.setPosition(x, y);
                settingActor.setPosition(x, y);
            }

            @Override
            public void setPosition(float x, float y, int alignment) {
                super.setPosition(x, y, alignment);
                settingActor.setPosition(x, y, alignment);
            }
        };
        settingClickActor.setTouchable(Touchable.enabled);
        settingClickActor.setSize(settingActor.getWidth() + 30, settingActor.getHeight() + 30);
        settingClickActor.setPosition(settingActor.getX(Align.center) - Configuration.widthOffset / 2f, settingActor.getY(Align.center), Align.center);
        titleActor.addActor(settingClickActor);

        settingClickActor.addListener(new ButtonListener2() {
            @Override
            public void clicked(InputEvent event, float x, float y) {
                super.clicked(event, x, y);
                //如果是电脑回合或晚间跳过回合
                if (playerTurn == 1 || players[playerTurn].hasPassed) {
                    return;
                }
                saveGame();
                final SettingDialogNew dialog = showDialog(SettingDialogNew.class, "ui/objects/setting_gameNew.json");
//                PlayerWordsShow("The game is saved automatically.",true);
                dialog.setListener(new SettingDialogNew.SettingListener() {
                    //点击restar按钮
                    @Override
                    public void startNew() {
                        GameConfig.refreshDataForNewGame();
                        game.gotoGameScreen();
                    }

                    //点击home按钮
                    @Override
                    public void home() {
                        if ((FileUtil.isFirstRound && GameConfig.handCount == 1) || (FileUtil.isSecondRound && GameConfig.handCount == 2)) {
                            FlurryManager.flurryLog_firstGameDetails_back(GameConfig.gameType, GameConfig.handCount);
                        }
                        saveGame();
                        game.gotoMenuScreen();
                        if (!ABTestUtil.isABTestA) {
                            DominoGame.showLeague();
                        }
                    }

                    //帮助
                    @Override
                    public void openDesignDialog() {
                        showInfoDialog();
                    }

                });

                //////////////////////////// DNA ////////////////////////////////
                DeltaDNAManager.addUiInteraction("table", "button", "setting", FileUtil.tableSetting);
                /////////////////////////////////////////////////////////////////
            }
        });
    }


    @Override
    protected void start() {
        super.start();
        if (GameConfig.gameType == GameConfig.ALL_FIVES_TYPE) {
            if (FileUtil.isFirstAllFive()) {
                isStartGame = false;
                TipBaseDialog b = showDialog(TipThreePageDialog.class, "ui/objects/tip_allfiveN.json");
                b.setCloseFinish(new Runnable() {
                    @Override
                    public void run() {
                        gameStart();
                    }
                });
            } else {
                gameStart();
            }
        } else if (GameConfig.gameType == GameConfig.DRAW_TYPE) {
            if (FileUtil.isFirstDraw()) {
                isStartGame = false;
                TipBaseDialog b = showDialog(TipTwoPageDialog.class, "ui/objects/tip_drawN.json");
                b.setCloseFinish(new Runnable() {
                    @Override
                    public void run() {
                        gameStart();
                    }
                });
            } else {
                isStartGame = true;
                gameStart();
            }
        } else {
            if (FileUtil.isFirstBlock()) {
                isStartGame = false;
                TipBaseDialog b = showDialog(TipTwoPageDialog.class, "ui/objects/tip_blockN.json");
                b.setCloseFinish(new Runnable() {
                    @Override
                    public void run() {
                        gameStart();
                    }
                });
            } else {
                isStartGame = true;
                gameStart();
            }
        }
//        gameEnd = true;
//        endOfHand(1);
//        endOfGame();
//        showRateDialog();
//        GetScore2 getScore2 = new GetScore2(this);
//        showBoneYard();
//        showDialog(ScoreViewDialog.class, "ui/objects/score_viewNew.json");
    }

    private void gameStart() {

        DominoGame.isShowEnd = false;
        //初始化骨牌,設置骨牌id
        instantiateDominoes();

        //如果当前游戏类型为allfive
        if (GameConfig.gameType == GameConfig.ALL_FIVES_TYPE) {
            //端口的值
            useNum = new int[4];
            //端口骨牌id
            useNumCard = new int[4];
        } else {
            useNum = new int[2];
            useNumCard = new int[2];
        }
        //检查是否是第一回合
        FileUtil.checkFirstRound();
        //检查是否是第二回合
        FileUtil.checkSecondRound();

        if ((FileUtil.isFirstRound && GameConfig.handCount == 1) || (FileUtil.isSecondRound && GameConfig.handCount == 2)) {
            FileUtil.saveFirstMode(GameConfig.gameType);
            FlurryManager.flurryLog_firstGameDetails_Start(GameConfig.gameType, GameConfig.handCount);
        }

        PlayControler.checkIsUse();

        newGame();

        if (GameConfig.handCount == 1) {
            PlayerWordsShow("The player with the highest\ndouble domino plays first.");
            FlurryManager.flurryLog_draw_game_start(GameConfig.AiMode);
            GameConfig.calculateAimode();
        }
//        }

        for (int i = 0; i < useNum.length; i++) {
            //重置数据结构
            useNum[i] = -1;
            useNumCard[i] = -1;
        }
        //初始化分数数组
        scores = new int[GameConfig.playerCount];
        //
        round.setVisible(true);
        String Roundtext = StringUtil.createNumber(GameConfig.handCount);
        Roundtext = GameConfig.targetPoints + "";
        roundTitle.setText(Roundtext);
        round.setText("Round " + GameConfig.handCount);
        //
        GameConfig.AllfiveNum = 0;
//        if(GameConfig.points[0] - GameConfig.points[1] > 40 ){
//            GameConfig.UseAi = false ;
//        }
//        else if( GameConfig.points[0] - GameConfig.points[1] <= -30){
//            GameConfig.UseAi = true ;
//        }

        round.addAction(
                Actions.sequence(
                        Actions.fadeOut(1.8f)
                )
        );
        //刷新骨牌显示
        showDominoes();
        //初始化玩家区域
        initPlayerBoards();

        displayPlayerHands(false);

        showHelp();

        if (GameConfig.AiMode == 4) {
            GameConfig.calculateRoundmode();
        }
        if (dominoNumber != null) {
            dominoNumber.clearColor();
        }

        scene.findActor("btn_info").toFront();
        scene.findActor("btn_setting").toFront();

        for (int j = 0, m = players[0].dominoesInHand; j < m; j++) {
            //置灰操作
            ((DominoCardBase) dominoObjects.get(players[0].idsInHand.get(j))).gray(true);
        }
        AnimationManager am = new AnimationManager();
        am.addAnimation(new StartGameAnimation(am, playerPanels));
        am.startAnimation();
    }


    private void loadGame() {
        GameConfig.loadData = false;
        String str = Gdx.files.local("savegame_" + GameConfig.gameType).readString();
        PythonDict dict = DominoGame.getJson().fromJson(PythonDict.class, str);
        GameConfig.loadData = false;
        if (dict.get("playercount") != null) {
            GameConfig.playerCount = ConvertUtil.convertToInt(dict.get("playercount"));
        }
        instantiatePlayers();
        setRules();
        if (dict.get("handcount") != null) {
            GameConfig.handCount = ConvertUtil.convertToInt(dict.get("handcount"));
        }
        if (dict.get("you") != null) {
            GameConfig.points[0] = ConvertUtil.convertToInt(dict.get("you"));
        }
        if (dict.get("opponent") != null) {
            GameConfig.points[1] = ConvertUtil.convertToInt(dict.get("opponent"));
        }
        if (dict.get("turn") != null) {
            playerTurn = ConvertUtil.convertToInt(dict.get("turn"));
        }

        if (dict.get("scoresSize") != null) {
            int size = ConvertUtil.convertToInt(dict.get("scoresSize"));

            for (int i = 0; i < size; i++) {
                if (dict.get("scores" + i) != null) {
                    PythonArray scoresArray = dict.get("scores" + i, PythonArray.class);
                    int[] scores = new int[2];
                    scores[0] = ConvertUtil.convertToInt(scoresArray.items[0]);
                    scores[1] = ConvertUtil.convertToInt(scoresArray.items[1]);
                    GameConfig.scores.add(scores);
                }
            }
        }

        for (int i = 0; i < GameConfig.scores.size(); i++) {
            dict.put("scores" + i, GameConfig.scores.get(i));
        }
        if (dict.get("players") != null) {
            PythonArray laid = dict.get("laid", PythonArray.class);
            for (int i = 0; i < laid.size; i++) {
                PythonArray values = (PythonArray) laid.get(i);
                if (i == 0) {
                    layDomino(ConvertUtil.convertToInt(values.items[0]), -1);
                } else {
                    layDomino(ConvertUtil.convertToInt(values.items[0]), ConvertUtil.convertToInt(values.items[1]));
                }
                boneYardDominoes.removeValue(ConvertUtil.convertToInt(values.items[0]));
            }
            PythonArray playerArray = (PythonArray) dict.get("players");
            for (int i = 0; i < GameConfig.playerCount; i++) {
                PythonArray temp = (PythonArray) playerArray.get(i);
                for (int j = 0; j < temp.size; j++) {
                    instantiateDominoesInHand(ConvertUtil.convertToInt(temp.get(j)), i);
                }
            }
            instantiateBoneYard();
            layDominoOnBoard(true);
        } else {
            distributeStartDominoes();
        }

        for (int i = 0; i < pointLabel.length; i++) {
//            pointLabel[i] = findActor("point_" + i);
            pointLabel[i].setText("" + GameConfig.points[i]);
            setProcess(false, false);

        }
        Gdx.app.log("load", "dis");
        displayPlayerHands(false);
        nextTurn(false);
    }

    private void newGame() {
//        Gdx.app.log("yxkUse",""+PlayControler.isUse);

        //设置游戏规则
        setRules();
        //初始化玩家管理类
        instantiatePlayers();
        //初始化手牌,电脑手牌,牌池
        distributeStartDominoes();
        //设置手牌的位置信息(玩家,电脑)
        displayPlayerHands(false);

        //如果是第一把
        if (GameConfig.handCount == 1) {
            //获得谁先出牌, 保存在 playerTurn变量中
            decideWhichPlayerStarts();
            if (GameConfig.isLeague) {
                LeagueUtil.addRonudNum();
                FlurryManager.flurryLog_Gameamount(LeagueUtil.getRonudNum());
            }

            //////////////////////////////DNA///////////////////////////////
            DeltaDNAManager.roundNum = 0;
            DeltaDNAManager.winNum = 0;
            DeltaDNAManager.startPlayTime = 0;

            DeltaDNAManager.startRoundTime = DeltaDNAManager.startPlayTime = System.currentTimeMillis();
            FileUtil.savePlayID(FileUtil.getPlayID() + 1);
            String playID = FileUtil.getRPlayID();

            DeltaDNAManager.addPlayStarted(playID, GameConfig.gameType, GameConfig.hardLevel);
            /////////////////////////////////////////////////////////////////
        } else {
//            Random random = new Random();
//            playerTurn = random.nextInt(2);
            playerTurn = GameConfig.playerTurn;
        }

        isCanTouch = false;
        Actor a = new Actor();
        a.clearActions();
        a.addAction(
                Actions.sequence(
                        Actions.delay(1.5f),
                        Actions.run(new Runnable() {
                            @Override
                            public void run() {
                                nextTurn(false);
                                isCanTouch = true;
                                isStartGame = true;
                            }
                        }),
                        Actions.removeActor()
                )
        );
        stage.addActor(a);

        //////////////////////////////DNA////////////////////////////////
        DeltaDNAManager.rankDraw = 0;
        DeltaDNAManager.userdominoNum = 0;
        DeltaDNAManager.computerdominoNum = 0;

        DeltaDNAManager.startRoundTime = System.currentTimeMillis();
        DeltaDNAManager.roundNum++;
        String handUser = DeltaDNAManager.getHandString(playHeadID);
        String handComputer = DeltaDNAManager.getHandString(compHeadID);
        String playID = FileUtil.getRPlayID();
        DeltaDNAManager.addRoundStarted(playID, GameConfig.gameType, playID + "-" + DeltaDNAManager.roundNum, DeltaDNAManager.roundNum,
                DeltaDNAManager.lastReslut, handUser, handComputer);
        dnaTilesPlay.setFirstPlayer(playerTurn);

        oldUserPoint = GameConfig.points[0];
        oldCompPoint = GameConfig.points[1];
        //////////////////////////////////////////////////////////////////
    }

    //初始化玩家区域
    private void initPlayerBoards() {
        if (playerPanels == null) {
            playerPanels = new Group[GameConfig.playerCount];
        }
        for (int i = 0; i < GameConfig.playerCount; i++) {
            if (playerPanels[i] == null) {
                playerPanels[i] = new Group();
            }
            if (i == 0) {
                Actor playerBg = scene.findActor("player_bg");

                playerBg.setPosition(360, scene.findActor("down_bg").getY(Align.top) - 4, Align.top);
                playerPanels[i].setSize(Configuration.width, dominoSize.x / 1.5f / scale);
                playerPanels[i].setPosition(360, playerBg.getY(Align.center) - 4, Align.center);
                scene.addActor(playerPanels[i]);
            } else if (i == 1) {
                if (playerPanels[i].findActor("shadow2") != null) {
                    playerPanels[i].findActor("shadow1").remove();
                    playerPanels[i].findActor("shadow2").remove();
                }
                Image shadow1 = new Image(new NinePatch(Assets.newUI.findRegion("dominoBottom")));
                shadow1.setTouchable(Touchable.disabled);
                shadow1.setName("shadow1");
                shadow1.setWidth(Configuration.width / 0.6f);
                shadow1.setX(Configuration.width / 2, Align.center);
                shadow1.setY(42 - shadow1.getHeight());

                Image shadow2 = new Image(new NinePatch(Assets.newUI.findRegion("dominoUp")));
                shadow2.setTouchable(Touchable.disabled);
                shadow2.setName("shadow2");
                shadow2.setWidth(Configuration.width / 0.6f);
                shadow2.setX(Configuration.width / 2, Align.center);
                shadow2.setY(42 - shadow2.getHeight());

                shadow1.setVisible(false);
                shadow2.setVisible(false);
                playerPanels[i].addActor(shadow1);
                playerPanels[i].addActor(shadow2);

                Actor titlePanel = scene.findActor("title_panel");
                playerPanels[i].setSize(Configuration.width, 42);
                playerPanels[1].setPosition(360, titlePanel.getY() + 2, Align.top);
                playerPanels[i].setTouchable(Touchable.disabled);

                scene.addActorBefore(titlePanel, playerPanels[i]);
            }
            playerPanels[i].setOrigin(Align.top);
            playerPanels[i].setScale(boardScale[i]);
        }
    }

    //设定游戏规则
    private void setRules() {
        if (GameConfig.playerCount > 2) {
            startDominoCount = 5;
        }
        if (GameConfig.gameType == GameConfig.DRAW_TYPE) {
            pointsTarget = 100;  //默认分数
            gameHasBoneYard = true;  //是否有牌池
            gameHasSpinner = false;  //是否微调
        } else if (GameConfig.gameType == GameConfig.BLOCK_TYPE) {
            pointsTarget = 100;
            gameHasBoneYard = false;
            gameHasSpinner = false;

        } else if (GameConfig.gameType == GameConfig.ALL_FIVES_TYPE) {
            pointsTarget = 150;
            gameHasSpinner = true;
            gameHasBoneYard = true;
        }
        pointsTarget = GameConfig.targetPoints;    //将分数调整为选择的分数
    }

    //设置骨牌id,只在進入時調用,start函数中调用
    private void instantiateDominoes() {
        dominoManagers = new DominoManager[28];
        int num = 0;
        for (int i = 0; i <= 6; i++) {
            for (int j = i; j <= 6; j++) {
                DominoManager dominoManager = new DominoManager();
                dominoManager.dominoId = num;
                dominoManager.values[0] = i;
                dominoManager.values[1] = j;
                dominoManagers[num] = dominoManager;
                DominoCard card = new DominoCard(dominoManager.values);  //骨牌actor
                dominoManager.dominoBody = card;
                boneYardDominoes.add(num);
                num++;
            }
        }
    }

    //初始化playsmarage(游戏和电脑手牌数据)
    private void instantiatePlayers() {
        players = new PlayerManager[GameConfig.playerCount];
        for (int i = 0; i < players.length; i++) {
            players[i] = new PlayerManager(i);
        }
    }

//    boolean ceshi = false;

    //初始化手牌,电脑手牌,牌池牌
    private void distributeStartDominoes() {
        dominoObjects.clear();

//        int[] pickIds = {2, 1, 6, 27, 10, 24, 23, 25, 0, 11, 15, 3, 17, 16};
//        int[] pickIdsblock = {16, 18, 19, 10, 4, 17, 1, 25, 20, 9, 15, 2, 6, 7};
//        int[] pickIdsAllFive = {21, 14, 13, 11, 19, 10, 8, 27, 5, 20, 7, 22, 9, 26};
        int num = boneYardDominoes.size;    //28
        for (int i = 0; i < startDominoCount; i++) {
            for (int j = 0; j < players.length; j++) {
                int pickedId;
//               if(GameConfig.gameType == 2 && !FileUtil.getIsTutorFinished(10)){
//                        pickedId = pickIdsAllFive[i+j*7];
//                    }
//                else if(GameConfig.gameType == 1  && !FileUtil.getIsTutorFinished(5)) {
//                    pickedId = pickIdsblock[i+j*7];
//                }
//                else if(GameConfig.gameType == 0 && !FileUtil.getIsTutorFinished(5) ) {
//                    pickedId = pickIds[i+j*7];
//                }
//                else if(PlayControler.isUse){
//                   if(j < 1){
//                       pickedId = PlayControler.usersBone[i];
//                   }else {
//                       pickedId = PlayControler.uiBone[i];
//                   }
//
//               }
//               else {
                //从28个骨牌中随机一个骨牌
                pickedId = boneYardDominoes.get(MyRandom.getInstance().nextInt(num));
//                }
                if (j == 0) {
                    playHeadID.add(pickedId);
                } else {
//                    if (!ceshi) {
//                        pickedId = 0;
//                        ceshi = true;
//                    }
                    compHeadID.add(pickedId);
                }
//                pickedId = pickIds[i+j*7];
                instantiateDominoesInHand(pickedId, j);
                num--;

            }
        }
        instantiateBoneYard();
    }

    //玩家手牌显示(手牌的位置信息), 手牌改变就调用
//    private void displayPlayerHands() {
//        for (int i = 0; i < GameConfig.playerCount; i++) {
//            float offsetX = (Configuration.width - (dominoSize.y / 1.5f / scale + Constant.DOMINO_OFFSET) * players[i].dominoesInHand + Constant.DOMINO_OFFSET) / 2;
//            float offsetXplayer = (Configuration.width - (59 + Constant.DOMINO_OFFSET) * players[i].dominoesInHand + Constant.DOMINO_OFFSET) / 2;
//            for (int j = 0; j < players[i].dominoesInHand; j++) {
//                Actor card = dominoObjects.get(players[i].idsInHand.get(j));
//                if (card != null) {
//                    if (i == 1) {  //电脑
//                        card.setPosition(offsetXplayer + j * (59 + Constant.DOMINO_OFFSET), 0);
//                    } else {
//                        ((DominoCardPlayer2) card).changePosition(offsetX + j * (dominoSize.y / 1.5f / scale + Constant.DOMINO_OFFSET), 0);
//                    }
//
//                } else {
////                    System.out.println("displayPlayerHands card == null");
//                }
//            }
//            //玩家和电脑操作区域的放大缩小逻辑
//            if (i == 0) {
//                float scale = 7F / players[i].dominoesInHand < 1 ? boardScale[i] * 7 / players[i].dominoesInHand : boardScale[i];
//                playerPanels[i].setOrigin(Align.center);
//                playerPanels[i].setScale(scale);
//            } else {
//                float scale = 10f / players[i].dominoesInHand < 1 ? boardScale[i] * 10 / players[i].dominoesInHand : boardScale[i];
//                playerPanels[i].setScale(scale);
//            }
//        }
//    }

    private void displayComputerHands(boolean isAnimation, Runnable runnable) {
        float offsetX = (Configuration.width - (59 + Constant.DOMINO_OFFSET) * players[1].dominoesInHand + Constant.DOMINO_OFFSET) / 2;
        for (int j = 0, s = players[1].dominoesInHand; j < s; j++) {
            final Actor card = dominoObjects.get(players[1].idsInHand.get(j));
            if (card != null) {
                float x = offsetX + j * (59 + Constant.DOMINO_OFFSET);
                if (isAnimation) {
                    SequenceAction sequenceAction = Actions.sequence(Actions.moveTo(x, 0, 0.2f));
                    if (runnable != null) {
                        if (j == s - 1) {
                            sequenceAction.addAction(Actions.run(runnable));
                        }
                    }
                    card.addAction(sequenceAction);
                } else {
                    card.setPosition(offsetX + j * (59 + Constant.DOMINO_OFFSET), 0);
                }
            }
        }
        float scale = 10f / players[1].dominoesInHand < 1 ? boardScale[1] * 10 / players[1].dominoesInHand : boardScale[1];
        playerPanels[1].setScale(scale);
    }

    private void displayPeopleHands(boolean isAnimation, boolean isBoneYardAnimation, final Runnable runnable) {
        float offsetX = (Configuration.width - (dominoSize.y / 1.5f / scale + Constant.DOMINO_OFFSET) * players[0].dominoesInHand + Constant.DOMINO_OFFSET) / 2;
        for (int j = 0, s = players[0].dominoesInHand; j < s; j++) {
            final Actor card = dominoObjects.get(players[0].idsInHand.get(j));
            if (card != null) {
                final float x = offsetX + j * (dominoSize.y / 1.5f / scale + Constant.DOMINO_OFFSET);
                if (isAnimation) {
                    SequenceAction sequenceAction;
                    if (isBoneYardAnimation && j == s - 1) {
                        card.setPosition(x, 0);
                        card.setVisible(false);
                        sequenceAction = Actions.sequence(
//                                Actions.delay(0.2f),
//                                Actions.show()
                        );
                    } else {
                        sequenceAction = Actions.sequence(
                                Actions.moveTo(x, 0, 0.2f),
                                Actions.run(new Runnable() {
                                    @Override
                                    public void run() {
                                        ((DominoCardPlayer2) card).changePosition(x, 0);
                                    }
                                })
                        );
                    }

                    if (runnable != null) {
                        if (j == s - 1) {
                            sequenceAction.addAction(Actions.run(runnable));
                        }
                    }

                    card.addAction(sequenceAction);
                } else {
                    ((DominoCardPlayer2) card).changePosition(x, 0);
                }
            }
        }
        float scale = 7F / players[0].dominoesInHand < 1 ? boardScale[0] * 7 / players[0].dominoesInHand : boardScale[0];
        playerPanels[0].setOrigin(Align.center);
        playerPanels[0].setScale(scale);
    }

    private void displayPlayerHands(boolean isAnimation) {
//        for (int i = 0; i < GameConfig.playerCount; i++) {
//            float offsetX = (Configuration.width - (dominoSize.y / 1.5f / scale + Constant.DOMINO_OFFSET) * players[i].dominoesInHand + Constant.DOMINO_OFFSET) / 2;
//            float offsetXplayer = (Configuration.width - (59 + Constant.DOMINO_OFFSET) * players[i].dominoesInHand + Constant.DOMINO_OFFSET) / 2;
//            for (int j = 0; j < players[i].dominoesInHand; j++) {
//                final Actor card = dominoObjects.get(players[i].idsInHand.get(j));
//                if (card != null) {
//                    if (i == 1) {  //电脑
//                        float x = offsetXplayer + j * (59 + Constant.DOMINO_OFFSET);
//                        if (isAnimation) {
//                            card.addAction(
//                                    Actions.moveTo(x, 0, 0.2f)
//                            );
//                        } else {
//                            card.setPosition(offsetXplayer + j * (59 + Constant.DOMINO_OFFSET), 0);
//                        }
//                    } else {
//                        final float x = offsetX + j * (dominoSize.y / 1.5f / scale + Constant.DOMINO_OFFSET);
//                        if (isAnimation) {
//                            card.addAction(
//                                    Actions.sequence(
//                                            Actions.moveTo(x, 0, 0.2f),
//                                            Actions.run(new Runnable() {
//                                                @Override
//                                                public void run() {
//                                                    ((DominoCardPlayer2) card).changePosition(x, 0);
//                                                }
//                                            })
//                                    )
//                            );
//                        } else {
//                            ((DominoCardPlayer2) card).changePosition(offsetX + j * (dominoSize.y / 1.5f / scale + Constant.DOMINO_OFFSET), 0);
//                        }
//                    }
//                }
//            }
//            //玩家和电脑操作区域的放大缩小逻辑
//            if (i == 0) {
//                float scale = 7F / players[i].dominoesInHand < 1 ? boardScale[i] * 7 / players[i].dominoesInHand : boardScale[i];
//                playerPanels[i].setOrigin(Align.center);
//                playerPanels[i].setScale(scale);
//            } else {
//                float scale = 10f / players[i].dominoesInHand < 1 ? boardScale[i] * 10 / players[i].dominoesInHand : boardScale[i];
//                playerPanels[i].setScale(scale);
//            }
//        }

        displayComputerHands(isAnimation, null);
        displayPeopleHands(isAnimation, false, null);
    }

    //初始化牌池
    private void instantiateBoneYard() {
        int count = boneYardDominoes.size;
        int num = count;
        while (num > 1) {
            num--;
            //从剩下的牌堆中随机
            int index = MyRandom.getInstance().nextInt(num + 1);
            int value = boneYardDominoes.items[index];
            boneYardDominoes.items[index] = boneYardDominoes.items[num];
            boneYardDominoes.items[num] = value;
        }
        if (boneYard != null) {
            boneYard.remove();
            boneYard.clear();
        }

        boneYard = new BoneYard(boneYardDominoes, new BoneYard.BoneYardListener() {
            @Override
            public void selected(int id, Image image) {
                BoneYard.isSelect = false;

                int pickedId = id;
                boneYardDominoes.removeValue(pickedId);
                players[playerTurn].distributeDomino(pickedId);
                /*
                 * 分牌操作
                 *动画之类的
                 *
                 * */
                Actor card = null;
                switch (playerTurn) {
                    case 0:
                        card = new DominoCardPlayer2(pickedId, dominoManagers[pickedId].values, playerListener);

                        if (dominoNumber != null) {
                            dominoNumber.updateDemoNumber(dominoManagers, pickedId);
                        }

                        /////////////////////////// DNA ///////////////////////////////
                        int[] a = dominoManagers[pickedId].values;
                        boolean isConnect = false;
                        for (int i = 0; i < useNum.length; ++i) {
                            if (a[0] == useNum[i] || a[1] == useNum[i]) {
                                isConnect = true;
                                break;
                            }
                        }

                        DeltaDNAManager.rankDraw++;
//                        DeltaDNAManager.addTilesDraw(FileUtil.getRPlayID() + "-" + DeltaDNAManager.roundNum,
//                                pickedId + "", DeltaDNAManager.rankDraw, "play", isConnect);
                        dnaTilesDraw.addDnaDraw(pickedId, "user", isConnect);
                        ///////////////////////////////////////////////////////////////

                        break;
                    case 1:
                        card = new DominoCardHalf();
//                        card = new DominoCardPlayer(pickedId, dominoManagers[pickedId].values, playerListener);

                        break;
                }

                if (card != null) {
                    dominoObjects.put(pickedId, card);
                    playerPanels[playerTurn].addActor(card);
                    if (playerTurn == 1) {
                        playerPanels[playerTurn].findActor("shadow2").setZIndex(playerPanels[playerTurn].getChildren().size);
                    }
                }
                final FlipDominoActor flipActor = new FlipDominoActor(dominoManagers[pickedId].values);
                flipActor.setVisible(false);
                float scalex = image.getWidth() / flipActor.getWidth();
                flipActor.setScale(scalex, scalex);
                Vector2 imageP = new Vector2(image.getX(Align.center), image.getY(Align.center));
                image.getParent().localToStageCoordinates(imageP);

                flipActor.setPosition(imageP.x + playerPanels[playerTurn].getX(), imageP.y + playerPanels[playerTurn].getY(), Align.center);
                playerPanels[playerTurn].addActor(flipActor);

                final Actor finalCard = card;
                displayPeopleHands(true, true, new Runnable() {
                    @Override
                    public void run() {
                        flipActor.setVisible(true);
//                        float endScaleX = finalCard.getWidth() / flipActor.getWidth();
//                        float endScaleY = finalCard.getHeight() / flipActor.getHeight();
                        float x = finalCard.getX();
                        float y = finalCard.getY();

                        flipActor.clearActions();
                        flipActor.addAction(
                                Actions.sequence(
                                        Actions.parallel(
                                                Actions.scaleTo(1, 1, 0.2f),
                                                Actions.moveTo(x, y, 0.2f)
                                        )
                                        , Actions.run(new Runnable() {
                                            @Override
                                            public void run() {
                                                flipActor.setFlipAnimation(new Runnable() {
                                                    @Override
                                                    public void run() {
                                                        finalCard.setVisible(true);
                                                        flipActor.remove();
                                                        buildListOfPossibleMoves();
                                                        BoneYard.isSelect = true;
                                                        if (possibleMoves.size == 0 && boneYardDominoes.size > 0) {
                                                        } else {
                                                            boneYard.exitAction();
                                                            if (possibleMoves.size == 0) {
                                                                players[playerTurn].hasPassed = true;
                                                                nextTurn(true);
                                                            }
                                                        }
                                                    }
                                                });
                                            }
                                        })
                                )
                        );
                    }
                });
            }
        });
    }

    private DominoCard oldDC = null;

    //手牌交互逻辑
    DominoCardPlayer2.DominoCardPlayerListener playerListener = new DominoCardPlayer2.DominoCardPlayerListener() {
        public float oldTouchY;

        @Override
        public ArrayMap<Integer, Vector2> touchdown(int dominoId, int closestIndex) {
            noTouch = false;
            showYourTurn = true;
            showSpinner = false;
            //清除上下提示标识
            ClearWords();

            adjustBoard(true);

            closestMove = closestIndex;
            //判断当前点击的骨牌是否在能出骨牌容器中
            if (possibleMoves.containsKey(dominoId)) {

                Actor move = dominoObjects.get(dominoId);
                oldTouchY = move.getY();

                ArrayMap<Integer, Vector2> possiblePos = new ArrayMap<>();
                //获得该骨牌能够连接的端点list
                IntArray moves = possibleMoves.get(dominoId);
                for (int i = 0; i < moves.size; i++) {
                    int num = moves.get(i);
                    if (num != -1) {
                        DominoCard dc = dominoManagers[num].dominoBody;
                        dc.setNewPointLabelAlpha(GameConfig.gameType == GameConfig.ALL_FIVES_TYPE, true);

                        Vector2 vector2 = new Vector2(dominoManagers[num].dominoBody.getX(Align.center), dominoManagers[num].dominoBody.getY(Align.center));
                        possiblePos.put(moves.get(i), board.localToStageCoordinates(vector2));
                    } else {
                        possiblePos.put(-1, new Vector2(boardCenter));
                    }
                }
                highLightPossibleMoves(true, dominoId);
                highLightClosestMove(true, dominoId);
//                    closestMove = closestIndex;
//                }
                playerPanels[playerTurn].setZIndex(Integer.MAX_VALUE);


//                for (int i = 0; i < useNumCard.length; ++i) {
//                    int id = useNumCard[i];
//                    if (id != -1) {
//                        DominoManager dominoManager = dominoManagers[id];
//                        dominoManager.dominoBody.setHideLineLight(false);
//                    }
//                }
                clearLightHint();
                return possiblePos;
            }

            return null;
        }

        @Override
        public void touchDrag(int id, int closestIndex) {
//            if (tutorManager != null) {
//                tutorManager.hide();
//            }
//            Actor move = dominoObjects.get(id);
//            if (oldTouchY + 100 < move.getY()) {
//                for (int i = 0; i < arrays.size; ++i) {
//                    arrays.get(i).setNewPointLabelAlpha(1);
//                }
//            }

            if (closestIndex != closestMove) {
                closestMove = closestIndex;
                highLightClosestMove(true, id);
            }
        }

        @Override
        public void touchNoConnect() {
            showaa(false);
            if (firstPointLabel != null) {
                firstPointLabel.remove();
                firstPointLabel = null;
            }
        }

        @Override
        public void touchUp(Vector2 position, int id, int connectIndex) {
            highLightPossibleMoves(false, id);
            noTouch = true;
            FlurryManager.flurryLog_Click(GameConfig.gameType + 1, 3);
            FlurryManager.flurryLog_ClickpipsGametype(GameConfig.gameType + 1);
            board.stageToLocalCoordinates(position);
            dominoManagers[id].dominoBody.setPosition(position.x, position.y, Align.center);
            dominoManagers[id].dominoBody.setRotation(-90);
            int connectID = possibleMoves.get(id).get(connectIndex);
            int sumNum = 0;
            if (possibleMoves != null) {
                for (IntArray a : possibleMoves.values()) {
                    sumNum += a.size;
                }
            }
            //更新手牌结构
            layDomino(id, connectID);

            players[0].idsInHand.removeValue(id);
            players[0].dominoesInHand--;

            displayPlayerHands(true);

            Actor b = new Actor();
            stage.addActor(b);

            SequenceAction sequenceAction1 = Actions.sequence();
//            if (isShowTimeAddPoint) {
//                isShowTimeAddPoint = false;
//                sequenceAction1.addAction(Actions.delay(nextTurnDelayTime));
//            }

            sequenceAction1.addAction(Actions.delay(0.6f, Actions.run(new Runnable() {
                @Override
                public void run() {
                    if (GameConfig.gameType == GameConfig.ALL_FIVES_TYPE && calculateAllFivePoints(false, 0) > 0) {
                        displayAllFivePoints(isShowTimeAddPoint || isSpinner);
                        isShowTimeAddPoint = false;
                        isSpinner = false;
                    } else {
                        if (isSpinner) {
                            delayAnimation(new Runnable() {
                                @Override
                                public void run() {
                                    nextTurn(true);
                                }
                            });
                            isSpinner = false;
                        } else {
                            nextTurn(true);
                        }
                    }
                }
            })));

            sequenceAction1.addAction(Actions.removeActor());

            b.clearActions();
            b.addAction(sequenceAction1);

            dominoObjects.get(id).remove();

            layDominoOnBoard(true);

            setPlayerHandGray(true);

            ///////////////////////////////////////// DNA /////////////////////////////////
            int scoreN = -1;
            if (GameConfig.gameType == GameConfig.ALL_FIVES_TYPE) {
                int k = calculateAllFivePoints(true, connectID);
                if (k % 5 == 0) {
                    scoreN = k;
                }
            }

            DeltaDNAManager.userdominoNum++;
//            DeltaDNAManager.addTilesPlay("user", GameConfig.gameType, FileUtil.getRPlayID() + "-" + DeltaDNAManager.roundNum, DeltaDNAManager.userdominoNum, id,
//                    connectID, scoreN, connectNum);

            dnaTilesPlay.addTitleDate(id, connectID, scoreN, sumNum);
            ///////////////////////////////////////////////////////////////////////////////

            FlurryManager.flurryLog_Step(6);

            if (PlayControler.isUse) {

                if (PlayControler.Turn == 5 && PlayControler.type == 0) {
                    if (connectID == 2) {
                        PlayControler.uiConnect[0][6] = 16;
                    }

                }

                if (PlayControler.roundNum == 1) {
                    if (PlayControler.Turn == 3) {
                        if (id == 1 && PlayControler.type == 0) {
                            PlayControler.type = 1;
                        }
                    } else if (PlayControler.Turn == 4) {
                        if (id == 14 && PlayControler.type == 0) {
                            PlayControler.type = 2;
                        }

                    } else if (PlayControler.Turn == 5) {
                        if (id != 21 && PlayControler.type == 1) {
                            PlayControler.type = 3;
                            PlayControler.isUse = false;
                        }
                    }

                    FlurryManager.flurryLog_design_path(PlayControler.roundNum, PlayControler.type, id);

                    if (PlayControler.Turn == 5)
                        FlurryManager.flurryLog_option(PlayControler.roundNum, PlayControler.type, 0, 0);

                    PlayControler.Turn++;
                    FlurryManager.flurryLog_total_turn(PlayControler.roundNum, PlayControler.Turn);
                } else {
                    if (id != PlayControler.userPlay[PlayControler.type][PlayControler.Turn - 1]) {
                        PlayControler.isUse = false;
                        FlurryManager.flurryLog_option(PlayControler.roundNum, PlayControler.type, -1, PlayControler.Turn);
                    } else {
                        FlurryManager.flurryLog_option(PlayControler.roundNum, PlayControler.type, id, PlayControler.Turn);
                    }
                }

            } else if (PlayControler.isStartUse && PlayControler.roundNum == 1) {
                PlayControler.Turn++;
                FlurryManager.flurryLog_total_turn(PlayControler.roundNum, PlayControler.Turn);
            }
//            board.setZIndex(Integer.MAX_VALUE);

        }

        @Override
        public void release() {
            for (int i = 0; i < layedIds.size; i++) {
                DominoCard dominoCard = dominoManagers[layedIds.get(i)].dominoBody;
                dominoCard.highLight(-1);
                if (GameConfig.gameType == GameConfig.ALL_FIVES_TYPE) {
                    dominoCard.removeAllFiveAddPointAction();
                    dominoCard.removePointHint(true);
                } else {
                    dominoCard.removePointHint(false);
                }

                if (firstPointLabel != null) {
                    firstPointLabel.remove();
                    firstPointLabel = null;
                }
            }
//            if (GameConfig.gameType == GameConfig.ALL_FIVES_TYPE) {
//                for (int j = 0; j < allFiveText.length; j++) {
//                    if (allFiveText[j] != null) {
//                        allFiveText[j].remove();
//                    }
//                }
//            }
        }
    };

    private void getCanConnectPosition(int id, boolean isDelay) {
        DominoManager doubleDomino = dominoManagers[id];
        boolean[] isConnect = {false, false, true, true};
        if (doubleDomino.isDouble()) {
            Vector2Int middleP = middlePos(doubleDomino.bottomPos, doubleDomino.topPos);
            int direction = -1;   //up 1 down 2 left 3 right 4
            if (doubleDomino.bottomPos.x == doubleDomino.topPos.x) {
                if (doubleDomino.bottomPos.y < doubleDomino.topPos.y) {
                    direction = 1;
                } else {
                    direction = 2;
                }
            } else {
                if (doubleDomino.bottomPos.x < doubleDomino.topPos.x) {
                    direction = 4;
                } else {
                    direction = 3;
                }
            }

            if (doubleDomino.isSpinner) {
                isConnect[0] = true;
                isConnect[1] = true;
            }

            Iterator<IntMap.Entry<Integer>> iterator = doubleDomino.connectedDominoes.iterator();
            while (iterator.hasNext()) {
                IntMap.Entry<Integer> entry = iterator.next();
                int connectId = entry.key;
                Vector2Int middCP = middlePos(dominoManagers[connectId].bottomPos, dominoManagers[connectId].topPos);
                float w1 = middleP.x, w2 = middCP.x;
                float h1 = middleP.y, h2 = middCP.y;
                if (middCP.x != middleP.x && middCP.y != middleP.y) {
                    float w = Math.abs(middCP.x - middleP.x);
                    float h = Math.abs(middCP.y - middleP.y);
                    if (w > h) {
                        h2 = h1 = 0;
                    } else {
                        w2 = w1 = 0;
                    }
                }
                if (w2 > w1) {
                    if (direction == 1) {
                        isConnect[3] = false;
                    } else if (direction == 2) {
                        isConnect[2] = false;
                    } else if (direction == 3) {
                        isConnect[1] = false;
                    } else if (direction == 4) {
                        isConnect[0] = false;
                    }
                } else if (w2 < w1) {
                    if (direction == 1) {
                        isConnect[2] = false;
                    } else if (direction == 2) {
                        isConnect[3] = false;
                    } else if (direction == 3) {
                        isConnect[0] = false;
                    } else if (direction == 4) {
                        isConnect[1] = false;
                    }
                } else if (h2 > h1) {
                    if (direction == 1) {
                        isConnect[0] = false;
                    } else if (direction == 2) {
                        isConnect[1] = false;
                    } else if (direction == 3) {
                        isConnect[3] = false;
                    } else if (direction == 4) {
                        isConnect[2] = false;
                    }
                } else {
                    if (direction == 1) {
                        isConnect[1] = false;
                    } else if (direction == 2) {
                        isConnect[0] = false;
                    } else if (direction == 3) {
                        isConnect[2] = false;
                    } else if (direction == 4) {
                        isConnect[3] = false;
                    }
                }
            }
            addConnectId(id, isConnect[1], isConnect[0], isConnect[2], isConnect[3], isDelay);
        }
    }

    private Array<Integer> doubleIds = new Array<>(); //去重

    private void clearLightHint(){
        //清理手牌
        for (int i = 0; i < layedIds.size; ++i) {
            int id = layedIds.get(i);
            if (id != -1) {
                DominoManager dominoManager = dominoManagers[id];
                dominoManager.dominoBody.setHideLineLight(false);
            }
        }
    }

    private void showaa(boolean isDelay) {
        if (useNumCard == null) return;

        clearLightHint();
        doubleIds.clear();
        for (int i = 0; i < useNumCard.length; ++i) {
            int id = useNumCard[i];
            if (id != -1) {
                DominoManager dominoManager = dominoManagers[id];
                if (dominoManager.isDouble()) {
                    if (!doubleIds.contains(id, true)) {
                        doubleIds.add(id);
                    }
                } else {
                    boolean[] isConnect = {false, false, false, false};
                    if (useNum[i] == dominoManager.values[0]) {
                        isConnect[1] = true;
                    } else {
                        isConnect[0] = true;
                    }
                    addConnectId(id, isConnect[1], isConnect[0], false, false, isDelay);
                }
            }
        }

        for (int a : doubleIds) {
            getCanConnectPosition(a, isDelay);
        }
    }

    //初始化抽牌Actor,每次抽牌会生成一个新的actor, 骨牌id,
    private void instantiateDominoesInHand(int pickedId, int i) {

        boneYardDominoes.removeValue(pickedId);
        players[i].distributeDomino(pickedId);
        Actor card = null;
        switch (i) {
            case 0: //玩家
                card = new DominoCardPlayer2(pickedId, dominoManagers[pickedId].values, playerListener);
                //初始化记牌器逻辑
                if (dominoNumber != null) {
                    dominoNumber.updateDemoNumber(dominoManagers, pickedId);
                }

                break;
            case 1: //电脑
                card = new DominoCardHalf();
//                card = new DominoCardPlayer(pickedId, dominoManagers[pickedId].values, playerListener);
                break;
        }
        if (card != null) {
            dominoObjects.put(pickedId, card);
            playerPanels[i].addActor(card);
            if (i == 1) {
                playerPanels[i].findActor("shadow2").setZIndex(playerPanels[i].getChildren().size);
            }
        }
    }

    //决定谁先出牌
    private void decideWhichPlayerStarts() {
        int num = players[0].idsInHand.items[0];

        int[] dvalue = new int[2];
        dvalue[0] = 0;
        dvalue[1] = 0;
        boolean flag = dominoManagers[num].isDouble();
        //遍历玩家和电脑手牌
        for (int i = 0; i < GameConfig.playerCount; i++) {
            for (int j = 0; j < startDominoCount; j++) {
                int num2 = players[i].idsInHand.items[j];
                boolean flag2 = dominoManagers[num2].isDouble();
                //找最大值
                if (flag2 && dominoManagers[num2].values[0] > dvalue[i]) {
                    dvalue[i] = dominoManagers[num2].values[0];
                }
//                if ((flag && flag2 && dominoManagers[num2].values[0] > dominoManagers[num].values[0]) || !flag && !flag2 && dominoManagers[num2].values[0] + dominoManagers[num2].values[1] > dominoManagers[num].values[0] + dominoManagers[num].values[1]) {
//                    playerTurn = i;
//                    num = num2;
//                    flag = flag2;
//                }

            }
        }
        //如果相等,随机
        if (dvalue[0] == dvalue[1]) {
            Random random = new Random();
            playerTurn = random.nextInt(2);
        } else {
            playerTurn = dvalue[0] > dvalue[1] ? 0 : 1;
        }
//        Random random = new Random();
//        playerTurn = random.nextInt(2);
//        playerTurn = 0;
//        nextTurn(false);
    }

    boolean isnext = true;

    //切换回合
    private void nextTurn(boolean increment) {
        if (!isnext) return;
        showYourTurn = false;
        delaytime = 0;
        boneYarddelaytime = 0;
        DominoGame.isShowEnd = false;
        boolean flag = true;

        //判断上一回合是否还有手牌
        if (players[playerTurn].dominoesInHand > 0) {
            //判断当前牌局是否无法继续
            for (int i = 0; i < GameConfig.playerCount; i++) {
                if (!players[i].hasPassed) {
                    flag = false;
                    break;
                }
            }
        }

        //切换下一局谁出牌
        if (increment) {
            if (!FileUtil.getIsTutorFinished(5) && GameConfig.gameType != GameConfig.ALL_FIVES_TYPE) {
                addTutorFirstBone();
            }
            playerTurn++;
        }

//        if (layedIds.size > 0) {
//            playerTurn = 1;
//        }

        if (playerTurn == GameConfig.playerCount) {
            playerTurn = 0;
        }
        //判断是否跳出(true 玩家和电脑都无法继续)

        if (flag) {
            setPlayerHandGray(true);
            float y = scene.findActor("middle_bg", Touchable.disabled).getX(Align.center);

            if (players[0].hasPassed && players[1].hasPassed) {
                DominoGame.isShowEnd = true;
                PlayerWordsShow("Blocked! The player with the lightest hand\n(the number of dots on his dominoes)wins.");
                showYourTurn = true;
                final int winnerDate = getWinner(true);
                AnimationManager animationManager = new AnimationManager() {
//                    @Override
//                    public void computerHandFinishAddAnimationClick() {
//                        System.out.println("cccccccccccccccc00000000000000000004444: " + GameConfig.points[winnerDate] + "    " + GameConfig.toPoints[winnerDate]);
//                        if (!isEnd) {
//                            isEnd = true;
//                            GameConfig.points[winnerDate] = GameConfig.toPoints[winnerDate];
//                            pointLabel[winnerDate].setText(GameConfig.points[winnerDate] + "");
//                            setProcess(true, false);
//                            endOfHand(winnerDate);
//                        }
//                    }
                };

                animationManager.addAnimation(new FinishAnimation1(animationManager, stage, FinishActor.BLOCK_HINT));
                animationManager.addAnimation(new FinishAnimation2(animationManager, dominoManagers, layedIds, board));
                animationManager.addAnimation(new FinishAnimation3(animationManager, players, dominoObjects, dominoManagers, stage, processes, winnerDate) {
                    @Override
                    public void addPointFunc() {
                        GameConfig.points[winnerDate] = GameConfig.toPoints[winnerDate];
                        pointLabel[winnerDate].setText(GameConfig.points[winnerDate] + "");
                        setProcess(true, false);
                    }

                    @Override
                    public void animationFinish() {
                        super.animationFinish();
                        if (!isEnd) {
                            isEnd = true;
                            GameConfig.points[winnerDate] = GameConfig.toPoints[winnerDate];
                            endOfHand(winnerDate);
                        }
                    }
                });
                animationManager.startAnimation();

                Actor a = animationManager.getClickActor();
                stage.addActor(a);
            } else {
//                isCanTouch = false;
                final int winnerDate = getWinner(true);
                AnimationManager animationManager = new AnimationManager() {
//                    @Override
//                    public void computerHandFinishAddAnimationClick() {
//                        System.out.println("this is animations3click:  " + GameConfig.points[winnerDate] + "    " + GameConfig.toPoints[winnerDate] + "   " + isEnd);
//                        if (!isEnd) {
//                            isEnd = true;
//                            GameConfig.points[winnerDate] = GameConfig.toPoints[winnerDate];
//                            pointLabel[winnerDate].setText(GameConfig.points[winnerDate] + "");
//                            setProcess(true, false);
//                            endOfHand(winnerDate);
//                        }
//                    }
                };

                animationManager.addAnimation(new FinishAnimation1(animationManager, stage, FinishActor.DOMINO_HINT));
                animationManager.addAnimation(new FinishAnimation2(animationManager, dominoManagers, layedIds, board));
                animationManager.addAnimation(new FinishAnimation3(animationManager, players, dominoObjects, dominoManagers, stage, processes, winnerDate) {
                    @Override
                    public void addPointFunc() {
                        GameConfig.points[winnerDate] = GameConfig.toPoints[winnerDate];
                        pointLabel[winnerDate].setText(GameConfig.points[winnerDate] + "");
                        setProcess(true, false);
                    }

                    @Override
                    public void animationFinish() {
                        super.animationFinish();
                        if (!isEnd) {
                            isEnd = true;
                            GameConfig.points[winnerDate] = GameConfig.toPoints[winnerDate];
                            endOfHand(winnerDate);
                        }
                    }
                });
                animationManager.startAnimation();

                Actor a = animationManager.getClickActor();
                stage.addActor(a);
            }
            return;
        }

        //如果是电脑回合, 玩家手牌置灰
        if (playerTurn > 0) {
            setPlayerHandGray(true);
        }
        //
        buildListOfPossibleMoves();
        //如果没有能出的手牌
        if (possibleMoves.size == 0) {
            if (playerTurn == 0) {
                //允许从牌池中取牌,且牌池中有牌
                if (gameHasBoneYard && boneYardDominoes.size > 0) {
                    //opponentPickFromBoneYard();
                    PlayerWordsShow("No valid moves.\nYou have to pull from the boneyard.");
                    showYourTurn = true;
                    showBoneYard();
                    return;
                } else {
                    /*
                     * 文字信息
                     * */
                    players[0].hasPassed = true;
                    if (GameConfig.gameType == GameConfig.BLOCK_TYPE && !FileUtil.getIsTutorFinished(9))
                        addTutorBlock();
                    else {
                        //延迟下回合
                        delayThenPass();
                        PlayerWordsShow("No valid moves.\nYou have to skip your turn.");
                    }
                }
            } else if (gameHasBoneYard && boneYardDominoes.size > 0) { //如果不是玩家回合,且允许从牌池中取牌,且牌池中有牌
                //展示上提示文字
                OpponentWordWordsShow("Your opponent is unable to place a valid\ntile and has to pull from the boneyard.");
                //从牌池中抽牌(电脑从牌池中)
                opponentPickFromBoneYard();
            } else { //否则
                /*
                 * 文字信息
                 * */
                players[playerTurn].hasPassed = true;
                OpponentWordWordsShow("Your opponent has to skip his turn.");
                delayThenPass();
            }
        } else { //手牌中有能出的牌
            players[playerTurn].hasPassed = false;

            if (playerTurn > 0) { //是电脑出牌
                //模拟电脑思考时间, 里面有电脑出牌ai逻辑( playOpponent() )
                delayAndPlayOpponent();
            }
            //如果是玩家出牌
            if (playerTurn == 0) {
                if (FileUtil.isFinishGame() && !FileUtil.getIsTutorFinished(7)) {
                    addTutorHelp();
                }
//
//                Timer.instance().scheduleTask(new Timer.Task() {
//                    @Override
//                    public void run() {
//                        PlayerWordsShow("It's your turn!");
//                    }
//                }, 1F);

                /*
                 * 玩家出牌，显示提示之类的
                 * */
            }
        }
//
//        if (layedIds.size > 2) {
//            isnext = false;
//
//            playerTurn = 1;
////            setPlayerHandGray(true);
////            final Vector2Int winnerDate = getWinner();
////            AnimationManager animationManagera = new AnimationManager() {
////                @Override
////                public void finishHintANimationClick() {
////                    pointLabel[winnerDate.x].setText(GameConfig.points[winnerDate.x] + "");
////                    setProcess(false, false);
////                    endOfHand(winnerDate.x, winnerDate.y);
////                }
////
////                @Override
////                public void computerHandFinishAddAnimationClick() {
////                    pointLabel[winnerDate.x].setText(GameConfig.points[winnerDate.x] + "");
////                    setProcess(true, false);
////                    endOfHand(winnerDate.x, winnerDate.y);
////                }
////            };
////            Actor a = animationManagera.getClickActor();
////            stage.addActor(a);
////
////            animationManagera.addAnimation(new FinishHintAnimation(animationManagera, stage, 1));
////            animationManagera.addAnimation(new BoardDominoFinishAnimation(animationManagera, dominoManagers, layedIds, board));
////            animationManagera.addAnimation(new FinishAnimation3(animationManagera, players, dominoObjects, dominoManagers, stage, processes, 1));
//////            animationManagera.addAnimation(new RunFinishAnimation(animationManagera) {
////////                @Override
////////                public void animationStart() {
////////                    endOfHand();
////////                }
////////            });
////            animationManagera.startAnimation();
////            GameConfig.points[0] += 150;
////            pointLabel[0].setText(GameConfig.points[0] + "");
////            setProcess(false);
//        }
    }

    //延时跳过
    private void delayThenPass() {

        DominoGame.isShowEnd = true;

        Timer.instance().scheduleTask(new Timer.Task() {
            @Override
            public void run() {
                nextTurn(true);
            }
        }, 1.5F);
    }

    //模拟电脑出牌时间
    private void delayAndPlayOpponent() {
//        Timer.instance().scheduleTask(new Timer.Task() {
//            @Override
//            public void run() {
//
//            }
//        }, 0.8F);
        playOpponent();
    }

    private boolean isCanAddPoint(int touchedId) {
        IntArray moves = possibleMoves.get(touchedId);
        if (moves == null) return false;
        if (layedIds.size == 0) {
            int[] values = dominoManagers[touchedId].values;
            int point = values[0] + values[1];
            if (point != 0 && point % 5 == 0) {
                return true;
            }
        } else {
            for (int i = 0; i < moves.size; i++) {
                int possibleId = moves.get(i);
                if (possibleId == -1) {
                    continue;
                }
                int point = calculateAllFivePoints(true, possibleId);

                if (dominoManagers[touchedId].isDouble()) {
                    point += dominoManagers[touchedId].values[0] + dominoManagers[touchedId].values[1];
                    if (layedIds.size == 1 && !dominoManagers[layedIds.get(0)].isDouble()) {
                        point -= dominoManagers[touchedId].values[0];
                    }
                } else {
                    if (dominoManagers[possibleId].values[0] == dominoManagers[touchedId].values[1]
                            || dominoManagers[possibleId].values[1] == dominoManagers[touchedId].values[1]) {
                        point += dominoManagers[touchedId].values[0];
                        if (layedIds.size == 1 && !dominoManagers[layedIds.get(0)].isDouble()) {
                            point -= dominoManagers[touchedId].values[1];
                        }
                    } else {
                        point += dominoManagers[touchedId].values[1];
                        if (layedIds.size == 1 && !dominoManagers[layedIds.get(0)].isDouble()) {
                            point -= dominoManagers[touchedId].values[0];
                        }
                    }
                }
                if (point != 0 && point % 5 == 0) {
                    return true;
                }
            }
        }
        return false;
    }

    //创建可出牌列表,每回合开始前调用
    private void buildListOfPossibleMoves() {
        possibleMoves.clear();
        int count = layedIds.size;
        for (int i = 0; i < players[playerTurn].dominoesInHand; i++) {
            //获得当前手牌id
            int num = players[playerTurn].idsInHand.items[i];
            IntArray connectList = new IntArray(); //保存的是当前手牌能够连接的端点骨牌id
            //如果当前桌面上没有出过牌
            if (count == 0) {
                //设置list为-1
                connectList.add(-1);
            } else {
                //遍历出过的牌
                for (int j = 0; j < count; j++) {
                    //如果当前出过的牌是一个double(两端一样)
                    if (dominoManagers[layedIds.items[j]].isDouble()) {
                        //判断这个牌是一个spiner,且当前连接数小于4, 或 当前骨牌的连接数小于2
                        DominoManager dominoManager = dominoManagers[layedIds.items[j]];
                        if (((dominoManager.isSpinner && dominoManager.connectedCount < 4) || dominoManager.connectedCount < 2)
                                && (dominoManager.values[0] == dominoManagers[num].values[0] || dominoManager.values[0] == dominoManagers[num].values[1])) {
                            connectList.add(layedIds.items[j]);
                        }
                        //计算
//                        if(dominoManager.isSpinner){
//                            if(dominoManager.connectedCount)
//                        }
                    } else {
                        //不是端点
                        if (dominoManagers[layedIds.items[j]].connectedCount >= 2) {
                            continue;
                        } else {
                            for (int k = 0; k < 2; k++) {
                                if ((dominoManagers[layedIds.items[j]].values[k] == dominoManagers[num].values[0] || dominoManagers[layedIds.items[j]].values[k] == dominoManagers[num].values[1]) && !dominoManagers[layedIds.items[j]].connectedDominoes.containsValue(dominoManagers[layedIds.items[j]].values[k], true)) {
                                    connectList.add(layedIds.items[j]);
                                    break;
                                }
                            }
                        }
                    }
                }
            }
            if (connectList.size > 0) {
                if (!possibleMoves.containsKey(num)) {
                    possibleMoves.put(num, connectList);
                }
                if (playerTurn == 0) {
                    ((DominoCardBase) dominoObjects.get(num)).gray(false);
                    //把灰色的卡牌变亮
                }
            } else if (playerTurn == 0) {
                ((DominoCardBase) dominoObjects.get(num)).gray(true);
                //该卡牌没有合适的牌，置灰
            }

            if (GameConfig.gameType == GameConfig.ALL_FIVES_TYPE && playerTurn == 0) {
//                for (int k = 0; k < connectList.size; ++k) {
                if (isCanAddPoint(num)) {
                    ((DominoCardPlayer2) dominoObjects.get(num)).addAllfiveAddPointAction();
                } else {
                    ((DominoCardPlayer2) dominoObjects.get(num)).removeAllFiveAddPointAction();
                }
//                }
            }
        }

    }

    private void clearConnect() {

    }

    private void clearConnectList() {
//        for (int i = 0; i < canConnectId.size; ++i) {
//            int id = canConnectId.get(i);
//            if (id < 0) {
//                continue;
//            }
//            dominoManagers[id].dominoBody.setHideLineLight(false);
//        }
//        canConnectId.clear();
//        System.out.println("cccccccccccccccccccccccccccccccccccc2222222222222222222222222222222222");
//        for (int i = 0, s = layedIds.size; i < s; ++i) {
//            dominoManagers[layedIds.get(i)].dominoBody.setHideLineLight(false);
//        }
    }

    private void addConnectId(int id, boolean isTop, boolean isBottom, boolean isLeft, boolean isRight, boolean isDelay) {
        if (id < 0) return;
//        canConnectId.add(id);
        dominoManagers[id].dominoBody.setLineLightPosition(isTop, isBottom, isLeft, isRight, isDelay);
    }

    // 展示牌池
    private void showBoneYard() {
        if (tutorSpinnerShow) {
            DominoGame.isBoneyard = true;
            return;
        }

        if (dialogs.empty()) {
            boneYard.show(boneYardDominoes);
            stage.addActor(boneYard);
            boneYard.showAction();
            DominoGame.isBoneyard = false;
            addTutorDrawBone();
        }
//        else if(DominoGame.isBoneyard){
//            boneYard.show(boneYardDominoes);
//            stage.addActor(boneYard);
//            boneYard.showAction();
//            DominoGame.isBoneyard = false;
//        }
        else {
            DominoGame.isBoneyard = true;
        }
//        Timer.instance().scheduleTask(new Timer.Task() {
//            @Override
//            public void run() {
//                /*show message*/
//                //   System.out.println("opponentPickFromYard");
//            }
//        }, 0.5F);
//        Timer.instance().scheduleTask(new Timer.Task() {
//            @Override
//            public void run() {
//                if (possibleMoves.size == 0 && boneYardDominoes.size > 0) {
//                    int pickedId = boneYardDominoes.get(MyRandom.getInstance().nextInt(boneYardDominoes.size));
//                    boneYardDominoes.removeValue(pickedId);
//                    players[playerTurn].distributeDomino(pickedId);
//                    /*
//                     * 分牌操作
//                     *动画之类的
//                     *
//                     * */
//                    Actor card = null;
//                    switch (playerTurn) {
//                        case 0:
//                            card = new DominoCardPlayer(pickedId, dominoManagers[pickedId].values, playerListener);
//                            break;
//                        case 1:
//                            card = new DominoCardHalf();
//                            break;
//                    }
//                    if (card != null) {
//                        dominoObjects.put(pickedId, card);
//                        playerPanels[playerTurn].addActor(card);
//                    }
//                    displayPlayerHands();
//                    buildListOfPossibleMoves();
//
//                } else {
//                    this.cancel();
//                    if (possibleMoves.size == 0) {
//                        players[playerTurn].hasPassed = true;
//                        nextTurn(true);
//                        System.out.println("没有抽中合适的牌");
//                    } else {
//                        System.out.println("抽到了，请出牌");
////            players[playerTurn].hasPassed = false;
////            playOpponent();
//                    }
//                }
//            }
//        }, 0.5F, 0.5F, boneYardDominoes.size + 1);
    }

    //出牌 跟新数据结构
    private void layDomino(int id, int connectedId) {

        layedIds.add(id);
        Timer.instance().scheduleTask(new Timer.Task() {
            @Override
            public void run() {
                AudioManager.PlaySound(AudioManager.AudioType.draw);
            }
        }, GameConfig.aniTime - 0.15f);

        //如果桌面没有骨牌则都为-1
        if (connectedId == -1) {
            //标记当前打出的牌是第几号牌
            dominoManagers[id].layedId = 0;
            //当前牌的连接数为0
            dominoManagers[id].connectedCount = 0;
            //设置当前端点
            useNum[0] = dominoManagers[id].values[0];
            useNum[1] = dominoManagers[id].values[1];
            useNumCard[0] = id;
            useNumCard[1] = id;

        } else {
            layedIncrementId++;
            int layedId = layedIncrementId;

            dominoManagers[id].layedId = layedId;
            //设置当前牌的父节点
            dominoManagers[id].firstConnectedId = connectedId;
            int value = 0;
            if (dominoManagers[id].isDouble()) { //如果当前这个牌是double
                value = dominoManagers[id].values[0]; //获得牌上的数字
            } else {                             //当前打出的牌不是double类型
                if (dominoManagers[connectedId].isDouble()) {  //判断连接的牌是否是double类型
                    value = dominoManagers[connectedId].values[0];
                } else {
                    if (dominoManagers[connectedId].connectedDominoes.containsValue(dominoManagers[connectedId].values[0], true)) {
                        value = dominoManagers[connectedId].values[1];
                    } else {
                        if (dominoManagers[connectedId].connectedDominoes.containsValue(dominoManagers[connectedId].values[1], true)) {
                            value = dominoManagers[connectedId].values[0];
                        } else {
                            if (dominoManagers[connectedId].values[0] != dominoManagers[id].values[0] && dominoManagers[connectedId].values[0] != dominoManagers[id].values[1]) {
                                value = dominoManagers[connectedId].values[1];
                            } else {
                                value = dominoManagers[connectedId].values[0];
                            }
                        }
                    }
                }
            }
            //实际出牌的操作
            dominoManagers[connectedId].connectedDominoes.put(id, value);
            dominoManagers[id].connectedDominoes.put(connectedId, value);
            dominoManagers[id].connectedCount = 1;
            dominoManagers[connectedId].connectedCount++;

            for (int m = 0; m < useNumCard.length; m++) {
                if (connectedId == useNumCard[m]) {
                    if (useNum[m] == dominoManagers[id].values[0]) {
                        useNum[m] = dominoManagers[id].values[1];
                        useNumCard[m] = id;
                        m = 10;
                    } else if (useNum[m] == dominoManagers[id].values[1]) {
                        useNum[m] = dominoManagers[id].values[0];
                        useNumCard[m] = id;
                        m = 10;
                    }

                }
            }

        }

        if (gameHasSpinner && !spinnerPosed && dominoManagers[id].isDouble()) {
            dominoManagers[id].isSpinner = true;
            dominoManagers[id].dominoBody.setSpinner();
            spinnerPosed = true;
//            PlayerWordsShow("The first double placed is called the\nspinner. It can be connected from 4 sides.", true);
            PlayerWordsShow("The Spinner!\nYou can connect it from 4 sides.", true);
            addTutorSpinner();
            showSpinner = true;

            useNum[2] = dominoManagers[id].values[0];
            useNum[3] = dominoManagers[id].values[1];
            useNumCard[2] = id;
            useNumCard[3] = id;

//            System.out.println("set spinner " + dominoManagers[id]);
        }

        isSpinner = dominoManagers[id].isSpinner;

//        for (int m = 0;m < useNumCard.length;m ++){
//            Gdx.app.log("yxkplay","useNum"+m+":"+ useNum[m]);
//            Gdx.app.log("yxkplay","useNumCard"+m+":"+ useNumCard[m]);
//        }
    }

    //出牌放到排面,骨牌的变形逻辑
    private void layDominoOnBoard(boolean isHint) {
        int count = layedIds.size;
        maxX = MathUtils.ceil(count * 1.5F);
        if (maxX < 20) {
            maxX = 20;
        }
        if (maxX > 32) maxX = 32;
        maxY = MathUtils.round(maxX / boardRatio);
        minPoint = new Vector2Int();
        maxPoint = new Vector2Int();
        for (int i = 0; i < count; i++) {
            int num = layedIds.items[i];
            Vector2Int vector2Int;
            Vector2Int vector2Int2;
            //第一张牌的位置
            if (i == 0) {
                //第一张牌不是Double()牌
                if (!dominoManagers[num].isDouble()) {
                    vector2Int = new Vector2Int(-1, 0);//可以设想在四个格子里的坐标，格子的中间为0，0
                    vector2Int2 = new Vector2Int(1, 0);
                } else {
                    vector2Int = new Vector2Int(0, -1);
                    vector2Int2 = new Vector2Int(0, 1);
                    dominoManagers[num].initVec = new Vector2Int(2, 0);
                }
                updateMinPointMaxPoint(vector2Int);
                updateMinPointMaxPoint(vector2Int2);
            } else {
                //获得父节点id
                int firstConnectedId = dominoManagers[num].firstConnectedId;
                //获得连的值
                int connectValue = dominoManagers[num].connectedDominoes.get(firstConnectedId);
                //计算骨牌的真实长度
                Vector2Int vec = dominoManagers[firstConnectedId].topPos.sub(dominoManagers[firstConnectedId].bottomPos);
                //如果父节点是double()类型
                if (dominoManagers[firstConnectedId].isDouble()) {
                    //若父节点是spinner类型,
                    if (dominoManagers[firstConnectedId].isSpinner && dominoManagers[firstConnectedId].connectedSoFar > 1) {
                        if (dominoManagers[firstConnectedId].connectedSoFar == 2) {
                            vec = new Vector2Int(-dominoManagers[firstConnectedId].initVec.y, -dominoManagers[firstConnectedId].initVec.x);
                        } else {
                            vec = new Vector2Int(dominoManagers[firstConnectedId].initVec.y, dominoManagers[firstConnectedId].initVec.x);
                        }
                        vector2Int = middlePos(dominoManagers[firstConnectedId].bottomPos, dominoManagers[firstConnectedId].topPos).add(vec).add(vec.halfVec(vec));
                        updateMinPointMaxPoint(vector2Int);
                        vec = adjustVec(vec, vector2Int, 1, dominoManagers[num].isSpinner);
                        vector2Int2 = vector2Int.add(vec);
                        if (connectValue == dominoManagers[num].values[1]) {
                            Vector2Int temp = vector2Int;
                            vector2Int = vector2Int2;
                            vector2Int2 = temp;
                        }
                    } else {
                        Vector2Int vector2Int4 = dominoManagers[firstConnectedId].initVec;
                        //通过连接位置设置位置
                        if (dominoManagers[firstConnectedId].connectedSoFar == 1 && layedIds.items[0] == firstConnectedId) {
                            vector2Int4 = toNegative(vector2Int4);
                        }

                        vector2Int = middlePos(dominoManagers[firstConnectedId].bottomPos, dominoManagers[firstConnectedId].topPos).add(vector2Int4);
                        vector2Int2 = vector2Int4.add(vector2Int);
                        updateMinPointMaxPoint(vector2Int);
                        updateMinPointMaxPoint(vector2Int2);
                        if (connectValue == dominoManagers[num].values[1]) {
                            Vector2Int temp = vector2Int;
                            vector2Int = vector2Int2;
                            vector2Int2 = temp;
                        }
                    }
                    dominoManagers[firstConnectedId].connectedSoFar++;

                } else {
                    Vector2Int connectedPos = dominoManagers[firstConnectedId].topPos;
                    if (connectValue == dominoManagers[firstConnectedId].values[0]) {
                        vec = toNegative(vec);
                        connectedPos = dominoManagers[firstConnectedId].bottomPos;
                    }
                    if (dominoManagers[num].isDouble()) {
                        vec = adjustVec(vec, connectedPos, dominoManagers[num].connectedCount + 1, dominoManagers[num].isSpinner);
                        vector2Int2 = vec.add(connectedPos);
                        dominoManagers[num].initVec = vec;
                        vector2Int = new Vector2Int(vector2Int2);
                        if (vec.x == 0) {
                            vector2Int2.x--;
                            vector2Int.x++;
                        } else {
                            vector2Int2.y--;
                            vector2Int.y++;
                        }
                        updateMinPointMaxPoint(vector2Int);
                        updateMinPointMaxPoint(vector2Int2);
                    } else {
                        int multiplier = 1;
                        if (dominoManagers[num].connectedDominoes.size > 1) {
                            Iterator<IntMap.Entry<Integer>> iterator = dominoManagers[num].connectedDominoes.iterator();
                            while (iterator.hasNext()) {
                                IntMap.Entry<Integer> entry = iterator.next();
                                if (entry.key != firstConnectedId) {
                                    if (dominoManagers[entry.key].isSpinner) {
                                        multiplier = dominoManagers[entry.key].connectedDominoes.size + 3;
                                    } else if (dominoManagers[entry.key].isDouble()) {
                                        multiplier = dominoManagers[entry.key].connectedDominoes.size + 2;
                                    }
                                }
                            }
                        }
                        vec = adjustVec(vec, connectedPos, multiplier, dominoManagers[num].isSpinner);
                        vector2Int2 = connectedPos.add(vec);
                        vector2Int = vector2Int2.add(vec);
                        updateMinPointMaxPoint(vector2Int);
                        if (connectValue == dominoManagers[num].values[0]) {
                            Vector2Int temp = vector2Int;
                            vector2Int = vector2Int2;
                            vector2Int2 = temp;
                        }
                    }
                }
            }

            if (i == 0) {
                dominoManagers[num].connectedSoFar = 0;
            } else {
                dominoManagers[num].connectedSoFar = 1;
            }
            dominoManagers[num].bottomPos = vector2Int;
            dominoManagers[num].topPos = vector2Int2;
            dominoCards.add(dominoManagers[num].dominoBody);
        }

        if (dominoCards.size() > 0) {
            sortDomino(); //为了处理骨牌层级关系,视觉效果,g根据y坐标排序
            board.clear();
            for (int a = dominoCards.size() - 1; a >= 0; a--) {
                board.addActor(dominoCards.get(a));
            }
        }

        adjustBoard(false);

        clearConnectList();
        if (playerTurn == 1 && isHint) {

            showaa(true);
        }

        //为了解决出牌时翻牌牌处于牌的底层
        layDominoInItsCoordinates(layedIds);
    }

    private void sortDomino() {
        if (dominoCards.size() < 2) {
            return;
        }
        for (int i = 1; i < dominoCards.size() - 1; i++) {
            for (int j = 0; j < dominoCards.size() - i; j++) {
                if (dominoCards.get(j).getPositionY() >= dominoCards.get(j + 1).getPositionY()) {
                    DominoCard dominoCard = dominoCards.get(j);
                    dominoCards.remove(j);
                    dominoCards.add(j + 1, dominoCard);
                }
            }
        }
    }

    class SortByY implements Comparator {
        public int compare(Object o1, Object o2) {
            DominoCard s1 = (DominoCard) o1;
            DominoCard s2 = (DominoCard) o2;
            if (s1.getY() > s2.getY()) {
                return 1;
            } else if (s1.getY() < s2.getY()) {
                return -1;
            } else {
                if (s1.getX() >= s2.getX()) {
                    return 1;
                } else {
                    return -1;
                }
            }
        }
    }

    private void layDominoInItsCoordinates(IntArray layedIds) {
        for (int i = 0; i < layedIds.size; ++i) {
            int id = layedIds.items[i];
            int x = dominoManagers[id].bottomPos.x;
            int y = dominoManagers[id].bottomPos.y;
            int x2 = dominoManagers[id].topPos.x;
            int y2 = dominoManagers[id].topPos.y;
            float rotation = 0;
            if (x2 <= x) {
                if (x2 < x) {
                    rotation = 180f;
                } else if (y2 > y) {
                    rotation = -90f;
                } else {
                    rotation = 90f;
                }
            }
            if (i == layedIds.size - 1) {
                dominoManagers[id].dominoBody.updatePosition(x, y, rotation, new Runnable() {
                    @Override
                    public void run() {
                        if (dominoCards.size() > 0) {
                            sortDomino(); //为了处理骨牌层级关系,视觉效果,g根据y坐标排序
                            board.clear();
                            for (int a = dominoCards.size() - 1; a >= 0; a--) {
                                board.addActor(dominoCards.get(a));
                            }
                        }
                    }
                });
            } else {
                dominoManagers[id].dominoBody.updatePosition(x, y, rotation, null);
            }
        }
    }

    private void highLightClosestMove(boolean set, int touchedId) {
        IntArray temp = possibleMoves.get(touchedId);
        for (int i = 0; i < temp.size; i++) {
            int id = temp.get(i);
            if (id == -1) {
                continue;
            }

            boolean isLabel = GameConfig.gameType == GameConfig.ALL_FIVES_TYPE;
            if (set) {
                if (closestMove < 0 || closestMove == i) {
                    DominoCard dc = dominoManagers[id].dominoBody;
                    dc.highLight(DominoCardCommon.GREEN);
                    dc.setNewPointLabelAlpha(isLabel, false);
                    oldDC = dc;
                } else {
                    dominoManagers[id].dominoBody.highLight(DominoCardCommon.YELLOW);
                    dominoManagers[id].dominoBody.setNewPointLabelAlpha(isLabel, true);
                }
            } else {
                dominoManagers[i].dominoBody.highLight(-1);
            }
        }
    }

    private void highLightPossibleMoves(boolean set, int touchedId) {
        int num = 0;
        IntArray moves = possibleMoves.get(touchedId);
        if (moves == null) return;
        if (moves.size == 1 && moves.get(0) == -1) {
            setFirstPointShowPosition(touchedId, GameConfig.gameType == GameConfig.ALL_FIVES_TYPE);
            return;
        }
        for (int i = 0; i < moves.size; i++) {
            int possibleId = moves.get(i);
            if (possibleId == -1) {
                continue;
            }
            if (set) {
//                dominoManagers[possibleId].dominoBody.highLight(DominoCardCommon.GREEN);
                if (GameConfig.gameType != GameConfig.ALL_FIVES_TYPE) {
                    setPointShowPosition(0, touchedId, possibleId, false);
                    continue;
                }
                int point = calculateAllFivePoints(true, possibleId);

                if (dominoManagers[touchedId].isDouble()) {
                    point += dominoManagers[touchedId].values[0] + dominoManagers[touchedId].values[1];
                    if (layedIds.size == 1 && !dominoManagers[layedIds.get(0)].isDouble()) {
                        point -= dominoManagers[touchedId].values[0];
                    }
                } else {
//                    int num4 = dominoManagers[possibleId].values[0];
                    if (dominoManagers[possibleId].values[0] == dominoManagers[touchedId].values[1] || dominoManagers[possibleId].values[1] == dominoManagers[touchedId].values[1]) {
//                        num4 = dominoManagers[possibleId].values[1];
//                        Gdx.app.log("point2.1p",""+dominoManagers[possibleId].values[0]);

                        point += dominoManagers[touchedId].values[0];
                        if (layedIds.size == 1 && !dominoManagers[layedIds.get(0)].isDouble()) {
                            point -= dominoManagers[touchedId].values[1];
                        }
//                        Gdx.app.log("point2.1",""+point);
                    } else {
                        point += dominoManagers[touchedId].values[1];
                        if (layedIds.size == 1 && !dominoManagers[layedIds.get(0)].isDouble()) {
                            point -= dominoManagers[touchedId].values[0];
                        }
//                        Gdx.app.log("point2.2",""+point);
                    }
//                    point = dominoManagers[touchedId].values[0] != num4 ? point + dominoManagers[touchedId].values[0] : point + dominoManagers[touchedId].values[1];
                }
//                Gdx.app.log("point4",""+point);
//                if (point != 0) {
                float x = 0;
                float y = 0;
                DominoManager temp = dominoManagers[possibleId];
                if (temp.bottomPos.y == temp.topPos.y) {
                    x = (temp.topPos.x - temp.bottomPos.x) * 0.5F;
                    y = 2;
                } else if (temp.topPos.x >= 0 && !(temp.dominoBody.getX() < 140) || temp.dominoBody.getX() > 600) {
                    x = -2;
                    y = (temp.topPos.y - temp.bottomPos.y) * 0.5F;
                } else {
                    x = 2;
                    y = (temp.topPos.y - temp.bottomPos.y) * 0.5F;
                }
//                if (allFiveText[num] == null) {
//                    allFiveText[num] = new NewPointLabel();
//                }
//                allFiveText[num].setPoint(point);
//                board.addActor(allFiveText[num]);

                float allfiveX = dominoSize.x / 4 * x + temp.dominoBody.getX();

                float allfiveY = dominoSize.x / 4 * y + temp.dominoBody.getY();

                if (allfiveX + board.getX() > Configuration.width - 100) {
                    allfiveX -= dominoSize.x / 4;
                }

                if (point % 5 == 0) {
                    isAddPoint = true;
                    dominoManagers[possibleId].dominoBody.addAllfiveAddPointAction();
                }
//                allFiveText[num].setPosition(allfiveX, allfiveY);
                setPointShowPosition(point, touchedId, possibleId, true);

//                allFiveText[num].setOrigin(Align.center);
//                float allfiveTextScale;
//                if (board.getScaleX() < 0.5) {
//                    allfiveTextScale = 0.4f / board.getScaleX();
//                } else if (board.getScaleX() < 0.6) {
//                    allfiveTextScale = 0.5f / board.getScaleX();
//                } else {
//                    allfiveTextScale = 0.6f / board.getScaleX();
//                }
//
//                allFiveText[num].setScale(allfiveTextScale);


//                    if(board.getScaleX() < 0.5){
//
//                        float deltaY = 1/board.getScaleX()*1;
//
//                        allFiveText[num].setPosition(dominoSize.x / 4 * x + temp.dominoBody.getX() , dominoSize.x / 4 * y + temp.dominoBody.getY() + 1/board.getScaleX()*10 + deltaY);
//                    }
                num++;
//                }
//            } else {
//                dominoManagers[possibleId].dominoBody.highLight(-1);
//                if (GameConfig.gameType == 2) {
//                    for (int j = 0; j < allFiveText.length; j++) {
//                        if (allFiveText[j] != null) {
//                            allFiveText[j].remove();
//                        }
//                    }
//                }


            }
        }

    }

    private void setFirstPointShowPosition(int id, boolean isLabel) {
        DominoManager dominoManager = dominoManagers[id];
        int point = dominoManager.values[0] + dominoManager.values[1];
        if (firstPointLabel != null) {
            firstPointLabel.remove();
            firstPointLabel = null;
        }
        firstPointLabel = new NewPointLabel(253.5f * DominoGame.dominoesScale, 127.5f * DominoGame.dominoesScale, isLabel);
        if (point != 0 && point % 5 == 0 && GameConfig.gameType == GameConfig.ALL_FIVES_TYPE) {
            firstPointLabel.setColor(true);
        } else {
            firstPointLabel.setColor(false);
        }
        board.addActor(firstPointLabel);

        firstPointLabel.setOrigin(Align.center);
        firstPointLabel.setPosition(board.getWidth() / 2f, board.getHeight() / 2f, Align.center);

        if (dominoManager.isDouble()) {
            firstPointLabel.setRotation(-90);
            firstPointLabel.setLabelRotation(90);
        } else {
            firstPointLabel.setRotation(0);
            firstPointLabel.setLabelRotation(0);
        }

        firstPointLabel.setPoint(point);
    }

    private int getSpecileSpinnerDirection(int isSpinerId) {
        Vector2Int vec = new Vector2Int(-dominoManagers[isSpinerId].initVec.y, -dominoManagers[isSpinerId].initVec.x);
        Vector2Int cBottomPos = middlePos(dominoManagers[isSpinerId].bottomPos, dominoManagers[isSpinerId].topPos).add(vec).add(vec.halfVec(vec));
        updateMinPointMaxPoint(cBottomPos);
        vec = adjustVec(vec, cBottomPos, 1, false);
        Vector2Int cTopPos = cBottomPos.add(vec);
        Vector2Int temp = cBottomPos;
        cBottomPos = cTopPos;
        cTopPos = temp;

        Vector2Int cMiddlePos = middlePos(cBottomPos, cTopPos);

        DominoManager dm = dominoManagers[isSpinerId];
        Vector2Int bottomPos = dm.bottomPos;
        Vector2Int topPos = dm.topPos;

        Vector2Int middlePos = middlePos(bottomPos, topPos);

        int xs = Math.abs(middlePos.x - cMiddlePos.x);
        int ys = Math.abs(middlePos.y - cMiddlePos.y);
        if (xs > ys) {
            if (middlePos.x > cMiddlePos.x) {
                return 1;
            } else {
                return 0;
            }
        } else {
            if (middlePos.y > cMiddlePos.y) {
                return 3;
            } else {
                return 2;
            }
        }
    }

    private int setSpinnerDirection(int id) {
        DominoManager dominoManager = dominoManagers[id];
        Iterator<IntMap.Entry<Integer>> iterator = dominoManager.connectedDominoes.iterator();
        Vector2Int middleP = middlePos(dominoManager.bottomPos, dominoManager.topPos);
        boolean[] isConnnects = {false, false, false, false};

        while (iterator.hasNext()) {
            IntMap.Entry<Integer> entry = iterator.next();
            int connectId = entry.key;
            Vector2Int middCP = middlePos(dominoManagers[connectId].bottomPos, dominoManagers[connectId].topPos);
            float w1 = middleP.x, w2 = middCP.x;
            float h1 = middleP.y, h2 = middCP.y;
            if (middCP.x != middleP.x && middCP.y != middleP.y) {
                float w = Math.abs(middCP.x - middleP.x);
                float h = Math.abs(middCP.y - middleP.y);
                if (w > h) {
                    h2 = h1 = 0;
                } else {
                    w2 = w1 = 0;
                }
            }

            if (h1 == h2) {
                if (w1 > w2) {
                    isConnnects[1] = true;
                } else {
                    isConnnects[0] = true;
                }
            } else {
                if (h1 > h2) {
                    isConnnects[3] = true;
                } else {
                    isConnnects[2] = true;
                }
            }
        }

        if (dominoManager.topPos.x == dominoManager.bottomPos.x) { //上下
            if (!isConnnects[0]) {
                return 0;
            }

            if (!isConnnects[1]) {
                return 1;
            }

            if (dominoManager.isSpinner) {
                if (!isConnnects[2]) {
                    return 2;
                }

                if (!isConnnects[3]) {
                    return 3;
                }
            }
        } else if (dominoManager.topPos.y == dominoManager.bottomPos.y) {
            if (!isConnnects[2]) {
                return 2;
            }

            if (!isConnnects[3]) {
                return 3;
            }

            if (dominoManager.isSpinner) {
                if (!isConnnects[0]) {
                    return 0;
                }

                if (!isConnnects[1]) {
                    return 1;
                }
            }
        }
        return 0;
    }

    private void setPointShowPosition(int point, int touchId, int id, boolean isLabel) {
        DominoManager touchDominoManager = dominoManagers[touchId];
        DominoManager dominoManager = dominoManagers[id];
        Vector2Int topP = dominoManager.topPos;
        Vector2Int bottomP = dominoManager.bottomPos;
        DominoCard dActor = dominoManager.dominoBody;
        boolean isTouchDouble = touchDominoManager.isDouble();

        float rotation = -90;
        if (dominoManager.isDouble()) {
            int direction;
            if (dominoManager.isSpinner && dominoManager.connectedCount == 2) {
                direction = getSpecileSpinnerDirection(id);
            } else {
                direction = setSpinnerDirection(id);
            }

            if (topP.x == bottomP.x) {
                if (topP.y > bottomP.y) { //向上
                    rotation = -90;
                    if (direction == 0) {
                        dActor.addPointHint(point, 3, isTouchDouble, isLabel);
                        dActor.setPointLabelRotation(isLabel, rotation);
                    } else if (direction == 1) {
                        dActor.addPointHint(point, 2, isTouchDouble, isLabel);
                        dActor.setPointLabelRotation(isLabel, rotation);
                    } else if (direction == 2) {
                        dActor.addPointHint(point, 0, isTouchDouble, isLabel);
                        dActor.setPointLabelRotation(isLabel, rotation);
                    } else if (direction == 3) {
                        dActor.addPointHint(point, 1, isTouchDouble, isLabel);
                        dActor.setPointLabelRotation(isLabel, rotation);
                    }
                } else { //向下
                    rotation = 90;
                    if (direction == 0) {
                        dActor.addPointHint(point, 2, isTouchDouble, isLabel);
                        dActor.setPointLabelRotation(isLabel, rotation);
                    } else if (direction == 1) {
                        dActor.addPointHint(point, 3, isTouchDouble, isLabel);
                        dActor.setPointLabelRotation(isLabel, rotation);
                    } else if (direction == 2) {
                        dActor.addPointHint(point, 1, isTouchDouble, isLabel);
                        dActor.setPointLabelRotation(isLabel, rotation);
                    } else if (direction == 3) {
                        dActor.addPointHint(point, 0, isTouchDouble, isLabel);
                        dActor.setPointLabelRotation(isLabel, rotation);
                    }
                }
            } else {
                if (topP.x > bottomP.x) { //向右
                    rotation = 0;
                    if (direction == 0) {
                        dActor.addPointHint(point, 0, isTouchDouble, isLabel);
                        dActor.setPointLabelRotation(isLabel, rotation);
                    } else if (direction == 1) {
                        dActor.addPointHint(point, 1, isTouchDouble, isLabel);
                        dActor.setPointLabelRotation(isLabel, rotation);
                    } else if (direction == 2) {
                        dActor.addPointHint(point, 2, isTouchDouble, isLabel);
                        dActor.setPointLabelRotation(isLabel, rotation);
                    } else if (direction == 3) {
                        dActor.addPointHint(point, 3, isTouchDouble, isLabel);
                        dActor.setPointLabelRotation(isLabel, rotation);
                    }
                } else {  //向左
                    rotation = 180;
                    if (direction == 0) {
                        dActor.addPointHint(point, 1, isTouchDouble, isLabel);
                        dActor.setPointLabelRotation(isLabel, rotation);
                    } else if (direction == 1) {
                        dActor.addPointHint(point, 0, isTouchDouble, isLabel);
                        dActor.setPointLabelRotation(isLabel, rotation);
                    } else if (direction == 2) {
                        dActor.addPointHint(point, 3, isTouchDouble, isLabel);
                        dActor.setPointLabelRotation(isLabel, rotation);
                    } else if (direction == 3) {
                        dActor.addPointHint(point, 2, isTouchDouble, isLabel);
                        dActor.setPointLabelRotation(isLabel, rotation);
                    }
                }
            }
        } else {
            if (touchDominoManager.values[0] == dominoManager.values[0]
                    || touchDominoManager.values[1] == dominoManager.values[0]) {
                if (topP.x == bottomP.x) {
                    if (topP.y > bottomP.y) {
                        rotation = -90;
                    } else {
                        rotation = 90;
                    }
                    dActor.addPointHint(point, 1, isTouchDouble, isLabel);
                    dActor.setPointLabelRotation(isLabel, rotation);

                } else if (topP.y == bottomP.y) {
                    if (topP.x < bottomP.x) {
                        rotation = 180;
                    } else {
                        rotation = 0;
                    }
                    dActor.addPointHint(point, 1, isTouchDouble, isLabel);
                    dActor.setPointLabelRotation(isLabel, rotation);
                }
            } else {
                if (topP.x == bottomP.x) {
                    if (topP.y > bottomP.y) {
                        rotation = -90;
                    } else {
                        rotation = 90;
                    }
                    dActor.addPointHint(point, 0, isTouchDouble, isLabel);
                    dActor.setPointLabelRotation(isLabel, rotation);

                } else if (topP.y == bottomP.y) {

                    if (topP.x < bottomP.x) {
                        rotation = 180;
                    } else {
                        rotation = 0;
                    }
                    dActor.addPointHint(point, 0, isTouchDouble, isLabel);
                    dActor.setPointLabelRotation(isLabel, rotation);
                }
            }
        }
    }

//    private void setPointShowPosition(int point, int touchId, int id, boolean isLabel) {
//        DominoManager touchDominoManager = dominoManagers[touchId];
//        DominoManager dominoManager = dominoManagers[id];
//        Vector2Int topP = dominoManager.topPos;
//        Vector2Int bottomP = dominoManager.bottomPos;
//        DominoCard dActor = dominoManager.dominoBody;
//        boolean isTouchDouble = touchDominoManager.isDouble();
//
//        Iterator<IntMap.Entry<Integer>> iterator = dominoManager.connectedDominoes.iterator();
//        float rotation = -90;
//        if (dominoManager.isDouble()) {
//            Vector2Int middleP = middlePos(bottomP, topP);
//            boolean[] isConnnects = {true, true, false, false};
//            if (dominoManager.isSpinner) {
//                isConnnects[0] = false;
//                isConnnects[1] = false;
//            }
//            while (iterator.hasNext()) {
//                IntMap.Entry<Integer> entry = iterator.next();
//                int connectId = entry.key;
//                Vector2Int middCP = middlePos(dominoManagers[connectId].bottomPos, dominoManagers[connectId].topPos);
//
//                float w1 = middleP.x, w2 = middCP.x;
//                float h1 = middleP.y, h2 = middCP.y;
//                if (middCP.x != middleP.x && middCP.y != middleP.y) {
//                    float w = Math.abs(middCP.x - middleP.x);
//                    float h = Math.abs(middCP.y - middleP.y);
//                    if (w > h) {
//                        h2 = h1 = 0;
//                    } else {
//                        w2 = w1 = 0;
//                    }
//                }
//
//                if (topP.x == bottomP.x) {
//                    if (topP.y > bottomP.y) { //向上
//                        if (h1 == h2) {
//                            if (w1 > w2) {
//                                isConnnects[2] = true;
//                            } else {
//                                isConnnects[3] = true;
//                            }
//                        } else {
//                            if (h1 > h2) {
//                                isConnnects[1] = true;
//                            } else {
//                                isConnnects[0] = true;
//                            }
//                        }
//                        rotation = -90;
//                    } else { //向下
//                        if (h1 == h2) {
//                            if (w1 > w2) {
//                                isConnnects[3] = true;
//                            } else {
//                                isConnnects[2] = true;
//                            }
//                        } else {
//                            if (h1 > h2) {
//                                isConnnects[0] = true;
//                            } else {
//                                isConnnects[1] = true;
//                            }
//                        }
//                        rotation = 90;
//                    }
//                } else {
//                    if (topP.x > bottomP.x) { //向右
//                        if (h1 == h2) {
//                            if (w1 > w2) {
//                                isConnnects[1] = true;
//                            } else {
//                                isConnnects[0] = true;
//                            }
//                        } else {
//                            if (h1 > h2) {
//                                isConnnects[3] = true;
//                            } else {
//                                isConnnects[2] = true;
//                            }
//                        }
//                        rotation = 0;
//                    } else {  //向左
//                        if (h1 == h2) {
//                            if (w1 > w2) {
//                                isConnnects[0] = true;
//                            } else {
//                                isConnnects[1] = true;
//                            }
//                        } else {
//                            if (h1 > h2) {
//                                isConnnects[2] = true;
//                            } else {
//                                isConnnects[3] = true;
//                            }
//                        }
//                        rotation = 180;
//                    }
//                }
//            }
//
//            for (int i = 3; i >= 0; --i) {
//                if (!isConnnects[i]) {
//                    dActor.addPointHint(point, i, isTouchDouble, isLabel);
//                    dActor.setPointLabelRotation(isLabel, rotation);
//                    break;
//                }
//            }
//
//        } else {
//            if (touchDominoManager.values[0] == dominoManager.values[0]
//                    || touchDominoManager.values[1] == dominoManager.values[0]) {
//                if (topP.x == bottomP.x) {
//                    if (topP.y > bottomP.y) {
//                        rotation = -90;
//                    } else {
//                        rotation = 90;
//                    }
//                    dActor.addPointHint(point, 1, isTouchDouble, isLabel);
//                    dActor.setPointLabelRotation(isLabel, rotation);
//
//                } else if (topP.y == bottomP.y) {
//                    if (topP.x < bottomP.x) {
//                        rotation = 180;
//                    } else {
//                        rotation = 0;
//                    }
//                    dActor.addPointHint(point, 1, isTouchDouble, isLabel);
//                    dActor.setPointLabelRotation(isLabel, rotation);
//                }
//            } else {
//                if (topP.x == bottomP.x) {
//                    if (topP.y > bottomP.y) {
//                        rotation = -90;
//                    } else {
//                        rotation = 90;
//                    }
//                    dActor.addPointHint(point, 0, isTouchDouble, isLabel);
//                    dActor.setPointLabelRotation(isLabel, rotation);
//
//                } else if (topP.y == bottomP.y) {
//
//                    if (topP.x < bottomP.x) {
//                        rotation = 180;
//                    } else {
//                        rotation = 0;
//                    }
//                    dActor.addPointHint(point, 0, isTouchDouble, isLabel);
//                    dActor.setPointLabelRotation(isLabel, rotation);
//                }
//            }
//        }
//    }

//    private void setPointShowPosition(int point, int touchId, int id, boolean isLabel) {
//        DominoManager touchDominoManager = dominoManagers[touchId];
//        DominoManager dominoManager = dominoManagers[id];
//        Vector2Int topP = dominoManager.topPos;
//        Vector2Int bottomP = dominoManager.bottomPos;
//        DominoCard dActor = dominoManager.dominoBody;
//        boolean isTouchDouble = touchDominoManager.isDouble();
//
//        Iterator<IntMap.Entry<Integer>> iterator = dominoManager.connectedDominoes.iterator();
//        float rotation = -90;
//        if (dominoManager.isDouble()) {
//            Vector2Int middleP = middlePos(bottomP, topP);
//            boolean[] isConnnects = {false, false, false, false};
//            int direction = -1;
//            while (iterator.hasNext()) {
//                IntMap.Entry<Integer> entry = iterator.next();
//                int connectId = entry.key;
//                Vector2Int middCP = middlePos(dominoManagers[connectId].bottomPos, dominoManagers[connectId].topPos);
//
//                float w1 = middleP.x, w2 = middCP.x;
//                float h1 = middleP.y, h2 = middCP.y;
//                if (middCP.x != middleP.x && middCP.y != middleP.y) {
//                    float w = Math.abs(middCP.x - middleP.x);
//                    float h = Math.abs(middCP.y - middleP.y);
//                    if (w > h) {
//                        h2 = h1 = 0;
//                    } else {
//                        w2 = w1 = 0;
//                    }
//                }
//
//                if (topP.x == bottomP.x) {
//                    if (topP.y > bottomP.y) { //向上
//                        direction = 1;
//                        rotation = -90;
//                    } else {                  //向下
//                        direction = 2;
//                        rotation = 90;
//                    }
//                } else {
//                    if (topP.x > bottomP.x) { //向右
//                        direction = 3;
//                        rotation = 0;
//                    } else {                  //向左
//                        direction = 4;
//                        rotation = 180;
//                    }
//                }
//
//                if (h1 == h2) {
//                    if (w1 > w2) {
//                        isConnnects[1] = true;
//                    } else {
//                        isConnnects[0] = true;
//                    }
//                } else {
//                    if (h1 > h2) {
//                        isConnnects[3] = true;
//                    } else {
//                        isConnnects[2] = true;
//                    }
//                }
//            }
//
//            float center = (minPoint.x + maxPoint.x) / 2f;
//            if (direction == 1) {
//                if (!isConnnects[0]) {
//                    dActor.addPointHint(point, 3, isTouchDouble, isLabel);
//                } else if (!isConnnects[1]) {
//                    dActor.addPointHint(point, 2, isTouchDouble, isLabel);
//                } else {
//                    if (dominoManager.isSpinner) {
////                        if (!isConnnects[3]) {
////                            dActor.addPointHint(point, 1, isTouchDouble, isLabel);
////                        } else if (!isConnnects[2]) {
////                            dActor.addPointHint(point, 0, isTouchDouble, isLabel);
////                        }
//                        if (middleP.x < center) {   //左边
//                            if (!isConnnects[2]) {
//                                dActor.addPointHint(point, 0, isTouchDouble, isLabel);
//                            } else {
//                                dActor.addPointHint(point, 1, isTouchDouble, isLabel);
//                            }
//                        } else {               //右边
//                            if (!isConnnects[3]) {
//                                dActor.addPointHint(point, 1, isTouchDouble, isLabel);
//                            } else {
//                                dActor.addPointHint(point, 0, isTouchDouble, isLabel);
//                            }
//                        }
//                    }
//                }
//            } else if (direction == 2) {
//                if (!isConnnects[0]) {
//                    dActor.addPointHint(point, 2, isTouchDouble, isLabel);
//                } else if (!isConnnects[1]) {
//                    dActor.addPointHint(point, 3, isTouchDouble, isLabel);
//                } else {
//                    if (dominoManager.isSpinner) {
////                        if (!isConnnects[3]) {
////                            dActor.addPointHint(point, 0, isTouchDouble, isLabel);
////                        } else if (!isConnnects[2]) {
////                            dActor.addPointHint(point, 1, isTouchDouble, isLabel);
////                        }
//                        if (middleP.x < center) {   //左边
//                            if (!isConnnects[2]) {
//                                dActor.addPointHint(point, 1, isTouchDouble, isLabel);
//                            } else {
//                                dActor.addPointHint(point, 0, isTouchDouble, isLabel);
//                            }
//                        } else {               //右边
//                            if (!isConnnects[3]) {
//                                dActor.addPointHint(point, 0, isTouchDouble, isLabel);
//                            } else {
//                                dActor.addPointHint(point, 1, isTouchDouble, isLabel);
//                            }
//                        }
//                    }
//                }
//            } else if (direction == 3) {
//                if (!isConnnects[2]) {
//                    dActor.addPointHint(point, 2, isTouchDouble, isLabel);
//                } else if (!isConnnects[3]) {
//                    dActor.addPointHint(point, 3, isTouchDouble, isLabel);
//                } else {
//                    if (dominoManager.isSpinner) {
//                        if (middleP.x < center) {   //左边
//                            if (!isConnnects[1]) {
//                                dActor.addPointHint(point, 1, isTouchDouble, isLabel);
//                            } else {
//                                dActor.addPointHint(point, 0, isTouchDouble, isLabel);
//                            }
//                        } else {               //右边
//                            if (!isConnnects[0]) {
//                                dActor.addPointHint(point, 0, isTouchDouble, isLabel);
//                            } else {
//                                dActor.addPointHint(point, 1, isTouchDouble, isLabel);
//                            }
//                        }
//                    }
//                }
//            } else if (direction == 4) {
//                if (!isConnnects[2]) {
//                    dActor.addPointHint(point, 3, isTouchDouble, isLabel);
//                } else if (!isConnnects[3]) {
//                    dActor.addPointHint(point, 2, isTouchDouble, isLabel);
//                } else {
//                    if (dominoManager.isSpinner) {
//                        if (middleP.x < center) {   //左边
//                            if (!isConnnects[1]) {
//                                dActor.addPointHint(point, 0, isTouchDouble, isLabel);
//                            } else {
//                                dActor.addPointHint(point, 1, isTouchDouble, isLabel);
//                            }
//                        } else {               //右边
//                            if (!isConnnects[0]) {
//                                dActor.addPointHint(point, 1, isTouchDouble, isLabel);
//                            } else {
//                                dActor.addPointHint(point, 0, isTouchDouble, isLabel);
//                            }
//                        }
//                    }
//                }
//            }
//            dActor.setPointLabelRotation(isLabel, rotation);
//
//        } else {
//            if (touchDominoManager.values[0] == dominoManager.values[0]
//                    || touchDominoManager.values[1] == dominoManager.values[0]) {
//                if (topP.x == bottomP.x) {
//                    if (topP.y > bottomP.y) {
//                        rotation = -90;
//                    } else {
//                        rotation = 90;
//                    }
//                    dActor.addPointHint(point, 1, isTouchDouble, isLabel);
//                    dActor.setPointLabelRotation(isLabel, rotation);
//
//                } else if (topP.y == bottomP.y) {
//                    if (topP.x < bottomP.x) {
//                        rotation = 180;
//                    } else {
//                        rotation = 0;
//                    }
//                    dActor.addPointHint(point, 1, isTouchDouble, isLabel);
//                    dActor.setPointLabelRotation(isLabel, rotation);
//                }
//            } else {
//                if (topP.x == bottomP.x) {
//                    if (topP.y > bottomP.y) {
//                        rotation = -90;
//                    } else {
//                        rotation = 90;
//                    }
//                    dActor.addPointHint(point, 0, isTouchDouble, isLabel);
//                    dActor.setPointLabelRotation(isLabel, rotation);
//
//                } else if (topP.y == bottomP.y) {
//
//                    if (topP.x < bottomP.x) {
//                        rotation = 180;
//                    } else {
//                        rotation = 0;
//                    }
//                    dActor.addPointHint(point, 0, isTouchDouble, isLabel);
//                    dActor.setPointLabelRotation(isLabel, rotation);
//                }
//            }
//        }
//    }

    private Vector2Int middlePos(Vector2Int vec1, Vector2Int vec2) {
        return new Vector2Int(Math.round((float) (vec1.x + vec2.x) / 2f), Math.round((float) (vec1.y + vec2.y) / 2f));
    }

    // 结束小局
    private void endOfHand(int winnerPlayer) {
        //保存当前分
        GameConfig.scores.add(scores);
        //设置当前回合数
        GameConfig.roundNum++;

        FileUtil.AddNum(GameConfig.gameType);

        handEnded = true;

//        GameConfig.points[winnerPlayer] += getScore;

        //获胜得分
//        showPointAction(getScore,winnerPlayer);
//        scores[winnerPlayer] += getScore;
//        pointsTarget = 10;
        if (GameConfig.points[winnerPlayer] >= pointsTarget) {
            gameEnd = true;
        }

        boolean isWin = winnerPlayer == 0;

        if ((FileUtil.isFirstRound && GameConfig.handCount == 1) || (FileUtil.isSecondRound && GameConfig.handCount == 2)) {
            FlurryManager.flurryLog_firstGameDetails_EndRound(GameConfig.gameType, GameConfig.handCount, isWin);
        }
        FileUtil.saveFirstRoundFinish(GameConfig.gameType, isWin);

        int roundDif;
        int difScore = GameConfig.points[winnerPlayer];
        if (winnerPlayer != 0) {
            difScore *= -1;
        }

        if (difScore >= 20) {
            roundDif = 4;
        } else if (difScore >= 0) {
            roundDif = 3;
        } else if (difScore > -20) {
            roundDif = 2;
        } else {
            roundDif = 1;
        }

        float k1 = GameConfig.points[0] - GameConfig.points[1];
        float k2 = pointsTarget - GameConfig.points[0];
        float k3 = pointsTarget - GameConfig.points[1];

        int aiLevel = calculateAi(k1, k2, k3);
        boolean isclean = players[0].idsInHand.size == 0;

        if (GameConfig.gameType == GameConfig.DRAW_TYPE) {
            FlurryManager.flurryLog_draw_round_finish();
            FlurryManager.flurryLog_draw_round_result(isWin);
            FlurryManager.flurryLog_draw_round_result(isWin, aiLevel);
            FlurryManager.flurryLog_draw_game_cleanpips(isclean);
            FlurryManager.flurryLog_draw_pips_board(layedIds.size);
            FlurryManager.flurryLog_draw_pips_hand(28 - boneYardDominoes.size);
            FlurryManager.flurryLog_draw_round_score_dif(roundDif);
            FlurryManager.flurryLog_draw_round_score_dif_ai(roundDif, aiLevel);
        } else if (GameConfig.gameType == GameConfig.BLOCK_TYPE) {
            FlurryManager.flurryLog_block_round_result(isWin, aiLevel);
            FlurryManager.flurryLog_block_round_finish();
            FlurryManager.flurryLog_block_round_result(isWin);
            FlurryManager.flurryLog_block_round_score_dif_ai(roundDif, aiLevel);
            FlurryManager.flurryLog_block_game_cleanpips(isclean);
            FlurryManager.flurryLog_block_round_score_dif(roundDif);
        } else if (GameConfig.gameType == GameConfig.ALL_FIVES_TYPE) {
            FlurryManager.flurryLog_allfive_round_result(isWin, aiLevel);
            FlurryManager.flurryLog_allfive_round_finish();
            FlurryManager.flurryLog_allfive_round_result(isWin);
            FlurryManager.flurryLog_allfive_round_score_dif_ai(roundDif, aiLevel);
            FlurryManager.flurryLog_allfive_round_num(GameConfig.AllfiveNum);
            FlurryManager.flurryLog_allfive_game_cleanpips(isclean);
            FlurryManager.flurryLog_allfive_round_score_dif(roundDif);
        }

        if (GameConfig.isLeague) {
            FlurryManager.flurryLog_league_round_result(isWin);
        }

        FileUtil.checkFirstGame();


        GameConfig.playerTurn = winnerPlayer;
        if (GameConfig.gameType == GameConfig.ALL_FIVES_TYPE) {
            GameConfig.playerTurn = winnerPlayer;
        }

        showEndOfHandDialog(winnerPlayer);

        //////////////////////////////// DNA /////////////////////////////////
        int addUseri = GameConfig.points[0] - oldUserPoint;
        int addCompi = GameConfig.points[1] - oldCompPoint;

        float timeUsed = (System.currentTimeMillis() - DeltaDNAManager.startRoundTime) / 1000f;
        String playID = FileUtil.getRPlayID();

        DeltaDNAManager.addRoundCompleted(playID, GameConfig.gameType, playID + "-" + DeltaDNAManager.roundNum,
                DeltaDNAManager.roundNum, winnerPlayer + 1, addUseri, addCompi, GameConfig.points[0],
                GameConfig.points[1], timeUsed, dnaTilesPlay.getFirstPlayer(), dnaTilesPlay.getTitleDate(), dnaTilesDraw.getDates());
        if (winnerPlayer == 0) {
            DeltaDNAManager.winNum++;
        }
        /////////////////////////////////////////////////////////////////////////
    }

    //结束大局
    private void endOfGame() {
        saveGameGameEnd();
        //判断是否胜利
        boolean isWin = GameConfig.points[0] > GameConfig.points[1];
        //////////////////////////////// DNA /////////////////////////////////
        if (isWin) {
            DeltaDNAManager.winNum++;
        }
        float time = (System.currentTimeMillis() - DeltaDNAManager.startPlayTime) / 10000f;
        DeltaDNAManager.addPlayCompleted(FileUtil.getRPlayID(), GameConfig.gameType, GameConfig.hardLevel, time, isWin ? 1 : 2);
        //////////////////////////////////////////////////////////////////////

        FileUtil.FinishGame();
        if (isWin) {
            FileUtil.setWinNum(GameConfig.gameType);
            FlurryManager.flurryLogs_win_path(FileUtil.getWinNum(GameConfig.gameType), GameConfig.gameType);
            FileUtil.setPlayWinNum();
        }
        FlurryManager.flurryLogs_finish_path(FileUtil.getWinNum(GameConfig.gameType), GameConfig.gameType);
        FileUtil.saveFirstFinish(GameConfig.gameType, GameConfig.handCount);

        FileUtil.gameEnd();
        boolean isclean = players[0].idsInHand.size == 0;
        if (GameConfig.gameType == GameConfig.DRAW_TYPE) {
            FlurryManager.flurryLog_draw_game_finish();
            FlurryManager.flurryLog_draw_game_finish(GameConfig.AiMode);
            FlurryManager.flurryLog_draw_game_result(isWin, GameConfig.AiMode);
            FlurryManager.flurryLog_draw_round_per_game(GameConfig.handCount);
            FlurryManager.flurryLog_draw_round_per_game(GameConfig.handCount, GameConfig.AiMode);
            FlurryManager.flurryLog_draw_round_per_game_Diamond(GameConfig.handCount, DiamondDataUtil.getDiamondTotal());
        } else if (GameConfig.gameType == GameConfig.BLOCK_TYPE) {
            FlurryManager.flurryLog_block_game_finish();
            FlurryManager.flurryLog_block_game_result(isWin);
        } else if (GameConfig.gameType == GameConfig.ALL_FIVES_TYPE) {
            FlurryManager.flurryLog_allfive_game_finish();
            FlurryManager.flurryLog_allfive_game_result(isWin);
        }
        FlurryManager.flurryLog_Step(9);

        if (GameConfig.isLeague) {
            FlurryManager.flurryLog_league_game_result(isWin);
        }

//        Timer.instance().scheduleTask(new Timer.Task() {
//            @Override
//            public void run() {
        AudioManager.PlaySound(AudioManager.AudioType.gameEnd);

        if (GameConfig.isLeague) {
//            leagueGameEndDialogdialog = showDialog(LeagueGameEndDialog.class, "ui/objects/league_game_end.json");
//            leagueGameEndDialogdialog.setListener(
//                    new LeagueGameEndDialog.LegueGameEndListener() {
//                        @Override
//                        public void startNew() {
//                            game.gotoMenuScreen(
//                            );
//                            game.showLeague();
//                        }
//                    });
        } else {
            if (GameConfig.points[0] > GameConfig.points[1]) {
                DiamondDataUtil.addDiamondNum(1);
                GameConfig.handCount = 0;
            }

            if (DominoGame.isRate && !FileUtil.isRate() && isWin) {
                showRateDialog();
            }

            GameEndDialogNew dialog = showDialog(GameEndDialogNew.class, "ui/objects/game_endNew.json");
            dialog.setListener(new GameEndDialogNew.GameEndListener() {
                @Override
                public void startNew() {
//                if(DominoGame.isAd){
//                    showAds();
//                }
//                else {
                    FlurryManager.flurryLog_Step(10);
                    if (DominoGame.deltaTime - DominoGame.nextTime < 2) {
                        return;
                    }
                    DominoGame.nextTime = DominoGame.deltaTime;
                    GameConfig.handCount = 0;
                    continueTouched();
                    if (GameConfig.gameType == GameConfig.DRAW_TYPE) {
                        FlurryManager.flurryLog_draw_game_start();
                        FlurryManager.flurryLog_draw_game_start(GameConfig.AiMode);
                    } else if (GameConfig.gameType == GameConfig.BLOCK_TYPE) {
                        FlurryManager.flurryLog_block_game_start();
                    } else if (GameConfig.gameType == GameConfig.ALL_FIVES_TYPE) {
                        FlurryManager.flurryLog_allfive_game_start();
                    }
                    FlurryManager.flurryLog_Click(GameConfig.gameType + 1, 5);
//                }
//                if(!ABTestUtil.isABTestA){
//                    FlurryManager.flurryLog_Clicknew();
//                }

                    ///////////////////////////DNA///////////////////////////
                    DeltaDNAManager.sessionIndex++;

                }

                //home按钮
                @Override
                public void home() {
//                 if(DominoGame.isAd){
//                     showAds();
//                 }
//                 else {
                    game.gotoMenuScreen();
                    FlurryManager.flurryLog_Click(8);
//                 }

                }

                //查分按钮
                @Override
                public void scoreView() {
//                if(DominoGame.isAd){
//                    showAds();
//                }
//                else {
                    showDialog(ScoreViewDialog.class, "ui/objects/score_viewNew.json");
                    FlurryManager.flurryLog_Click(7);
//                }

                }
            });
        }

//            }
//        },0.5F);
    }

    private int getWinner(boolean isAddHandPoint) {
        int[] points = new int[GameConfig.playerCount];
        int[] minId = new int[GameConfig.playerCount];
        int[] minDominoes = new int[GameConfig.playerCount];
        for (int i = 0; i < GameConfig.playerCount; i++) {
            minId[i] = 100;
            minDominoes[i] = 100;
            for (int j = 0; j < players[i].dominoesInHand; j++) {
                DominoManager temp = dominoManagers[players[i].idsInHand.get(j)];
                points[i] += temp.values[0] + temp.values[1];

                int id = temp.dominoId;
                int dominoes = temp.values[0] + temp.values[1];

                if (id < minId[i]) {
                    minId[i] = id;
                }
                if (dominoes < minDominoes[i]) {
                    minDominoes[i] = dominoes;
                }
            }
        }
        //判断谁赢
        int winnerPlayer;
        if (points[0] != points[1]) {
            winnerPlayer = points[0] < points[1] ? 0 : 1;
        } else if (points[0] == 0) {
            winnerPlayer = players[0].dominoesInHand < players[1].dominoesInHand ? 0 : 1;
        } else if (minDominoes[0] != minDominoes[1]) {
            winnerPlayer = minDominoes[0] < minDominoes[1] ? 0 : 1;
        } else {
            winnerPlayer = minId[0] < minId[1] ? 0 : 1;
        }

        GameConfig.toPoints[winnerPlayer] = GameConfig.points[winnerPlayer];

        if (isAddHandPoint) {
            int p0 = points[0];
            int p1 = points[1];
            if (GameConfig.gameType == GameConfig.ALL_FIVES_TYPE) {
                p0 = allfiveScore(p0);
                p1 = allfiveScore(p1);
            }
            scores[0] = scores[0] + p1;
            scores[1] = scores[1] + p0;
            if (winnerPlayer == 0) {
                GameConfig.toPoints[winnerPlayer] += p1;
            } else {
                GameConfig.toPoints[winnerPlayer] += p0;
            }
        }

        return winnerPlayer;
    }

    //下一局
    private void continueTouched() {

        GameConfig.handCount++;
        showAction();
        Group an = game.showDominoSpineActor(new Runnable() {
            @Override
            public void run() {
                game.gotoGameScreen();
                game.hideSpineActor();
            }
        });
        stage.addActor(an);

//        Timer.instance().scheduleTask(new Timer.Task() {
//            @Override
//            public void run() {
//                game.gotoGameScreen();
//            }
//        }, 0.9f);

        if (GameConfig.gameType == GameConfig.DRAW_TYPE) {
            FlurryManager.flurryLog_draw_round_start();
        } else if (GameConfig.gameType == GameConfig.BLOCK_TYPE) {
            FlurryManager.flurryLog_block_round_start();
        } else if (GameConfig.gameType == GameConfig.ALL_FIVES_TYPE) {
            FlurryManager.flurryLog_allfive_round_start();
        }


    }

    private void showEndOfHandDialog(final int winner) {
        DominoGame.isShowEnd = true;
        saveGame();
        GameConfig.roundTime = 0;
        GameConfig.roundFLurry = 0;

        FlurryManager.flurryLog_Step(7);

//        if(winner == 0){
//            LeagueUtil.addLevel();
//        }
//        else {
//            LeagueUtil.lessLevel();
//        }

        Timer.instance().scheduleTask(new Timer.Task() {
            @Override
            public void run() {
                isCanTouch = true;

                for (int i = 0; i < pointLabel.length; i++) {
//                    pointLabel[i] = findActor("point_" + i);
                    pointLabel[i].setText("" + GameConfig.points[i]);
                    setProcess(false, false);
                }

                String jsonPath;
                if (gameEnd) {
                    jsonPath = "ui/objects/hand_endGameNew.json";
                } else {
                    jsonPath = "ui/objects/hand_endNew.json";
                }

                AudioManager.PlaySound(AudioManager.AudioType.handEnd);
                HandEndDialogNew dialog = showDialog(HandEndDialogNew.class, jsonPath);
                addTutorScore();
                dialog.setData(players, dominoManagers, winner, gameEnd);
                dialog.setListener(new HandEndListener() {
                    @Override
                    public void next() {
//                        if (tutorManager != null)
//                            tutorManager.hide();
                        if (DominoGame.deltaTime - DominoGame.nextTime < 2)
                            return;
                        DominoGame.nextTime = DominoGame.deltaTime;
                        FlurryManager.flurryLog_Step(8);
                        FlurryManager.flurryLog_Click(GameConfig.gameType + 1, 4);
//                        if (DominoGame.isRate && !FileUtil.isRate()) {
//                            showRateDialog();
//                        } else {
//                            continueTouched();
//                        }
                        continueTouched();
                    }

                    @Override
                    public void ok() {
//                        if (tutorManager != null)
//                            tutorManager.hide();
                        endOfGame();
                    }
                });
            }
        }, 0.5F);
    }

    private void showRateDialog() {

        DominoGame.isRate = false;
        DominoGame.isAd = false;
        DominoGame.rateTime = 0;
        DominoGame.AdTime = 0;
        FileUtil.clearRateTime();

        Timer.instance().scheduleTask(new Timer.Task() {
            @Override
            public void run() {
                final RateDialog dialog = showDialog(RateDialog.class, "ui/objects/rateNew.json");
                dialog.setListener(new RateDialog.RateListener() {
                    @Override
                    public void rate() {
                        dialog.closeRate();
//                        continueTouched();

                        Timer.instance().scheduleTask(new Timer.Task() {
                            @Override
                            public void run() {
                                DominoGame.Rate();
                            }
                        }, 0.5F);

                    }

                    @Override
                    public void later() {
                        dialog.closeRate();
//                        continueTouched();
                    }
                });
            }
        }, 0.5F);
    }


    private boolean isTooFar(int min, int max, int d) {
        return Math.abs(min) + Math.abs(max) > d;
    }

    /*
     *
     *
     *
     *
     *
     * adjustVec
     * */
    //翻转逻辑
    private Vector2Int adjustVec(Vector2Int vec, Vector2Int startPos, int multiplier, boolean isDouble) {
        if (isDouble) {
            return vec;
        }
        Vector2Int vector2Int = new Vector2Int(startPos.x + vec.x * multiplier, startPos.y + vec.y * multiplier);
        if ((vector2Int.x < minPoint.x && isTooFar(vector2Int.x, maxPoint.x, maxX))
                || (vector2Int.x > maxPoint.x && isTooFar(minPoint.x, vector2Int.x, maxX))
                || (vector2Int.y < minPoint.y && isTooFar(vector2Int.y, maxPoint.y, maxY))
                || (vector2Int.y > maxPoint.y && isTooFar(minPoint.y, vector2Int.y, maxY))) {
            if (vec.y == 0) { //水平方向
                if ((startPos.y > 0 && vec.x < 0) || (startPos.y < 0 && vec.x > 0)) {
                    return new Vector2Int(0, vec.x);
                }
                return new Vector2Int(0, -vec.x);
            }
            //竖直方向
            if ((startPos.x > 0 && vec.y > 0) || (startPos.x < 0 && vec.y < 0)) {
                return new Vector2Int(-vec.y, 0);
            }
            return new Vector2Int(vec.y, 0);
        }
        if ((-minPoint.y + maxPoint.y) > maxY) {
//            System.out.println("");
        }
        return vec;
    }

    private Vector2Int toNegative(Vector2Int vec) {
        return new Vector2Int(-vec.x, -vec.y);
    }

    private void updateMinPointMaxPoint(Vector2Int point) {
        minPoint.x = Math.min(point.x, minPoint.x);
        minPoint.y = Math.min(point.y, minPoint.y);
        maxPoint.x = Math.max(point.x, maxPoint.x);
        maxPoint.y = Math.max(point.y, maxPoint.y);
    }

    private void adjustBoard(boolean isShowEdge) {
        //count出的牌的长度
        int count = layedIds.size;
        for (int i = 0; i < count; i++) {
            DominoManager manager = dominoManagers[layedIds.get(i)];
            updateMinPointMaxPoint(manager.bottomPos);
            updateMinPointMaxPoint(manager.topPos);
        }

        float centerX = (minPoint.x + maxPoint.x) / 2F;
        float centerY = (minPoint.y + maxPoint.y) / 2F;
        System.out.println("cccccccccccccc: minPoint.x: " + minPoint.x + " minPoint.y: " + minPoint.y
                + " maxPoint.x: " + maxPoint.x + " maxPoint.y: " + maxPoint.y);

        float boardOffsetX = centerX * dominoSize.x / 4;
        float boardOffsetY = centerY * dominoSize.x / 4;
        float originX = board.getOriginX();
        float originY = board.getOriginY();
        float sourceX = board.getX();
        float sourceY = board.getY();
        board.setOrigin(boardOffsetX, boardOffsetY);
        board.setPosition(sourceX - (boardOffsetX - originX) * (1 - board.getScaleX()),
                sourceY - (boardOffsetY - originY) * (1 - board.getScaleY()));
        float targetX = boardCenter.x - boardOffsetX;
        float targetY = boardCenter.y - boardOffsetY;
        float time = GameConfig.aniTime * 1.5f + 0.1F;
        float temp = (boardSize.x - 100) / dominoSize.x * 4;

        if (boardSize.x > boardSize.y) {
            temp = (boardSize.y - 100) / dominoSize.x * 4;
        }

        float scaleX = isShowEdge ? (temp / (maxPoint.x - minPoint.x + 8)) : (temp / (maxPoint.x - minPoint.x + 2));
//        if (scaleX > 1F) scaleX = 1F;

        temp = (boardSize.y - 100) / dominoSize.x * 4;
        float scaleY = isShowEdge ? temp / (maxPoint.y - minPoint.y + 8) : temp / (maxPoint.y - minPoint.y + 2);
//        if (scaleY > 1) scaleY = 1;

        float scale = Math.min(scaleX, scaleY);
        Configuration.gameScale = scale;
//        board.setPosition(targetX,targetY);
//        board.setScale(scale);

        System.out.println("scale  x=" + scaleX + " y=" + scaleY + " maxX:" + maxX + " maxY:" + maxY + " maxP:" + maxPoint + " minP:" + minPoint);

        if (scale < 0.5) {
            scale *= 1.1;
        }
        if (scale > 0.8f)
            scale = 0.8f;
        board.getActions().clear();
        board.addAction(Actions.moveTo(targetX, targetY, isShowEdge ? time * 0.6f : time, Interpolation.pow4Out));
        board.addAction(Actions.scaleTo(scale, scale, isShowEdge ? time * 0.6f : time, Interpolation.pow4Out));
    }

    //对手出牌
    Label abtest1;
    Label abtest2;
    Label abtest3;
    Label abtest4;
    Label abtest5;
    Label abtest6;
    Label abtest7;

    private void playOpponent() {
        //电脑出牌逻辑
        int num = 0;
        int connectNum = -1;
        int cardLength = 100;

        int[][] cardInfo = new int[cardLength][4];
        int n = 0;

        Iterator<ObjectMap.Entry<Integer, IntArray>> iterator = possibleMoves.iterator();
        //如果牌桌上已经出牌了
        if (
//                GameConfig.gameType == 0 &&
                GameConfig.UseAi && layedIds.size >= 1) {
            while (iterator.hasNext()) {
                ObjectMap.Entry<Integer, IntArray> map = iterator.next();
//
//                if(ABTestUtil.isABTestA){
//                    cardInfo[n][1] = (dominoManagers[map.key].values[0] + dominoManagers[map.key].values[1])*-1;
//                    cardInfo[n][2] = -12;
//                    int count = layedIds.size;
//                    int connectInt = -1;
//
//                    for (int j = 0; j < count; j++) {
//                        if ( dominoManagers[layedIds.items[j]].connectedCount < 2) {
//                            if(dominoManagers[map.key].values[0] ==  dominoManagers[layedIds.items[j]].values[0] || dominoManagers[map.key].values[1] ==  dominoManagers[layedIds.items[j]].values[0]){
//                                connectInt = dominoManagers[layedIds.items[j]].values[1];
//                                break;
//                            }
//                            else {
//                                if(dominoManagers[map.key].values[0] ==  dominoManagers[layedIds.items[j]].values[1] ||dominoManagers[map.key].values[1] == dominoManagers[layedIds.items[j]].values[1]){
//                                    connectInt = dominoManagers[layedIds.items[j]].values[0];
//                                    break;
//                                }
//                            }
//                        }
//                    }
//
//                    int playerSize = players[0].dominoesInHand;
//                    for (int j = 0; j < playerSize; j++) {
//                        if(dominoManagers[players[0].idsInHand.get(j)].values[0] == connectInt || dominoManagers[players[0].idsInHand.get(j)].values[1] == connectInt ){
//                            int canusePoint =  dominoManagers[players[0].idsInHand.get(j)].values[0] + dominoManagers[players[0].idsInHand.get(j)].values[1];
//                            if(cardInfo[n][2] < canusePoint){
//                                cardInfo[n][2]  = canusePoint;
//                            }
//                        }
//                    }
//
//                    cardInfo[n][2] = 0;
//                    cardInfo[n][3] = possibleMoves.get(map.key).items[0];
//                }
//                else {
                for (int m = 0; m < possibleMoves.get(map.key).size; m++) {
                    cardInfo[n][0] = map.key;                                             // 牌id
                    cardInfo[n][1] = aiNum(map.key, possibleMoves.get(map.key).items[m]);  //赋值分数
                    cardInfo[n][2] = 0;  //暂时启用
//                        if(cardInfo[n][1] > 0){
//                            cardInfo[n][2] = 0;
//                        }
//                        else {
//                            cardInfo[n][2] = boneNum(map.key,possibleMoves.get(map.key).items[m]);;
//                        }
                    cardInfo[n][3] = possibleMoves.get(map.key).items[m]; //记录连接怕的id
                    n++;
                }
//                }
            }

            //排序 (根据赋值分进行从小到大的排序)
            for (int i = 1; i < n; i++) {
                for (int j = 0; j < n - i; j++) {
                    if (cardInfo[j][1] + cardInfo[j][2] > cardInfo[j + 1][1] + cardInfo[j + 1][2]) {
                        int[] ex = cardInfo[j];
                        cardInfo[j] = cardInfo[j + 1];
                        cardInfo[j + 1] = ex;
                    }
                }
            }

            Random random = new Random();

            int sum = 0;
            for (int i = 1; i <= n; i++) {
                sum += i;
            }
            int rNum = random.nextInt(sum);

            sum = 0;

            float k1 = GameConfig.points[0] - GameConfig.points[1]; //玩家得分减电脑得分
            float k2 = pointsTarget - GameConfig.points[0];         //目标分减玩家当前得分
            float k3 = pointsTarget - GameConfig.points[1];         //目标分减电脑当前得分

            int aiLevel = calculateAi(k1, k2, k3);

            if (aiLevel == 1) {   //随机出一张牌
                Gdx.app.log("yxk", "random");
                int x = random.nextInt(n);
                num = cardInfo[x][0];
                connectNum = cardInfo[x][3];
            } else if (aiLevel == 2) {   //取赋值分最小的牌
                Gdx.app.log("yxk", "hard");
                num = cardInfo[0][0];
                connectNum = cardInfo[0][3];
//                    for(int i = 1;i <= n;i++ ){
//                        sum+=i;
//                        if(sum >= rNum){
//                            num = cardInfo[n-i][0];
//                        }
//                    }
            } else if (aiLevel == 3) { //取赋值分最大的牌
                Gdx.app.log("yxk", "veryEasy");
                num = cardInfo[n - 1][0];

                connectNum = cardInfo[n - 1][3];
            } else {
                Gdx.app.log("yxk", "easy");
                for (int i = 1; i <= n; i++) {
                    sum += i;
                    if (sum >= rNum) {
                        num = cardInfo[i - 1][0];
                        connectNum = cardInfo[i - 1][3];
                        i = n;
                    }
                }
            }
            //
            if (connectNum == -1) {
                connectNum = possibleMoves.get(num).items[0];
            }
//            }
        } else { //第一次出牌(即桌面上沒有骨牌)
            Gdx.app.log("yxk", "firstx");

            while (iterator.hasNext()) {
                ObjectMap.Entry<Integer, IntArray> map = iterator.next();
                cardInfo[n][0] = map.key;

                for (int m = 0; m < possibleMoves.get(map.key).size; m++) {

                    cardInfo[n][1] = aiNum(map.key, possibleMoves.get(map.key).items[m]);
                    cardInfo[n][3] = possibleMoves.get(map.key).items[m];
                    cardInfo[n][2] = 0;
                }

                n++;
            }
//            排序(按从小到大的顺序排序)
            for (int i = 1; i < n; i++) {
                for (int j = 0; j < n - i; j++) {
                    if (cardInfo[j][1] + cardInfo[j][2] > cardInfo[j + 1][1] + cardInfo[j + 1][2]) {
                        int[] ex = cardInfo[j];
                        cardInfo[j] = cardInfo[j + 1];
                        cardInfo[j + 1] = ex;
                    }
                }
            }
            //取赋值分最大的骨牌id
            num = cardInfo[n - 1][0];
            //该骨牌连接的端点
            connectNum = possibleMoves.get(num).items[0];
//            Gdx.app.log("yxk","firsty"+ num);
//            Gdx.app.log("yxk","firstz"+ connectNum);
        }
//        int connectidNum = possibleMoves.get(num).size;
        int sumNum = 0;
        if (possibleMoves != null) {
            for (IntArray a : possibleMoves.values()) {
                sumNum += a.size;
            }
        }
//        else {
//
//            if(iterator.hasNext())
//                num = iterator.next().key;
//
//            connectNum = possibleMoves.get(num).items[0];
//
//        }

//        float k1 = GameConfig.points[0] - GameConfig.points[1];
//        float k2 = pointsTarget - GameConfig.points[0] ;
//        float k3 = pointsTarget - GameConfig.points[1] ;
//        int aiLevel = calculateAi(k1,k2,k3);
//
//        Label.LabelStyle style = new Label.LabelStyle();
//        style.font  = Assets.instance.fonts[2];
//        style.fontColor = Color.WHITE;
//
//        if(abtest1!=null){
//            abtest1.remove();
//            abtest2.remove();
//            abtest3.remove();
//            abtest4.remove();
//            abtest5.remove();
//            abtest6.remove();
//            abtest7.remove();
//
//        }
//
//
//        abtest1 = new Label("k1:"+k1,style);
//        abtest2 = new Label("k2:"+k2,style);
//        abtest3 = new Label("k3:"+k3,style);
//        abtest4 = new Label("level:"+aiLevel,style);
//        abtest5 = new Label("1 = normal,2 = hard,3 = easy",style);
//        abtest6 = new Label("GameConfig:"+GameConfig.AiMode,style);
//        abtest7 = new Label("WinNum:"+FileUtil.getWinNum(GameConfig.gameType),style);
//
//        abtest1.setColor(Color.WHITE);
//        abtest1.setPosition(360,500);
//        abtest2.setColor(Color.WHITE);
//        abtest2.setPosition(360,460);
//        abtest3.setColor(Color.WHITE);
//        abtest3.setPosition(360,420);
//        abtest4.setColor(Color.WHITE);
//        abtest4.setPosition(360,540);
//        abtest5.setColor(Color.WHITE);
//        abtest5.setPosition(360,620,Align.center);
//        abtest6.setColor(Color.WHITE);
//        abtest6.setPosition(360,660,Align.center);
//        abtest7.setColor(Color.WHITE);
//        abtest7.setPosition(360,700,Align.center);
//
//        stage.addActor(abtest1);
//        stage.addActor(abtest2);
//        stage.addActor(abtest3);
//        stage.addActor(abtest4);
//        stage.addActor(abtest5);
//        stage.addActor(abtest6);
//        stage.addActor(abtest7);

//        if(!FileUtil.getIsTutorFinished(6) && FileUtil.getIsTutorFinished(5) && GameConfig.gameType == 0 && FileUtil.isFirstLogin){
//            num = 12;
//        }


//        if(PlayControler.isUse){
////            Gdx.app.log("yxk","usePC");
//
//            num = PlayControler.uiPlay[PlayControler.type][PlayControler.Turn-1];
//            connectNum =  PlayControler.uiConnect[PlayControler.type][PlayControler.Turn-1];
//
//
//            if(PlayControler.roundNum == 2){
//                PlayControler.Turn++;
//                FlurryManager.flurryLog_total_turn(PlayControler.roundNum,PlayControler.Turn);
//            }
////            Gdx.app.log("yxk","usePC"+PlayControler.type);
////            Gdx.app.log("yxk","usePC"+num);
//        }
//        else {
//            if (PlayControler.isStartUse && PlayControler.roundNum == 1){
//                FlurryManager.flurryLog_design_path(PlayControler.roundNum,3,num);
//            }
//            else if (PlayControler.isStartUse && PlayControler.roundNum == 2){
//                PlayControler.Turn++;
//                FlurryManager.flurryLog_total_turn(PlayControler.roundNum,PlayControler.Turn);
//            }
//        }

        //获得将要出牌的骨牌actor
//        num = 0;

        final Actor card = dominoObjects.get(num);
        card.clearActions();
        card.addAction(
                Actions.sequence(
                        Actions.moveBy(0, 100, 0.2f),
                        Actions.removeActor()
                )
        );

        Group g = card.getParent();

        final HandShowDomioCard dcard = new HandShowDomioCard(dominoManagers[num].values);
        dcard.setVisible(false);
        float sx = card.getWidth() / dcard.getHeight();
        float sy = card.getHeight() / dcard.getWidth();
        dcard.setOrigin(Align.center);
        dcard.setRotation(-90);
        dcard.setScale(sx, sy);
        dcard.setPosition(card.getX(Align.center), card.getY(Align.center) + 100, Align.center);
        g.addActor(dcard);

        dcard.clearActions();
        final int finalNum = num;
        final int finalConnectNum = connectNum;

        setPlayerHandGray(true);
        SequenceAction sequenceAction = Actions.sequence(
                Actions.delay(0.2f, Actions.show()),
                Actions.moveBy(0, -230, 0.2f),
                Actions.delay(0.2f),
                Actions.run(new Runnable() {
                    @Override
                    public void run() {
                        final Vector2 position = dcard.getParent().localToStageCoordinates(new Vector2(dcard.getX(Align.center), dcard.getY(Align.center)));
                        board.stageToLocalCoordinates(position);

                        dominoObjects.removeKey(finalNum);

                        if (dominoNumber != null) {
                            dominoNumber.updateDemoNumber(dominoManagers, finalNum);
                        }

                        Actor a = dominoManagers[finalNum].dominoBody;
                        float o1 = a.getOriginX();
                        float o2 = a.getOriginY();
                        a.setPosition(position.x, position.y, Align.center);
                        a.setOrigin(Align.center);
                        a.setRotation(-90);
                        a.setScale(dcard.getScaleX() / board.getScaleX(), dcard.getScaleY() / board.getScaleY());
                        a.setOrigin(o1, o2);
                        a.addAction(Actions.scaleTo(1, 1, 0.4f));

                        //实现出牌逻辑
                        layDomino(finalNum, finalConnectNum);
                        players[playerTurn].idsInHand.removeValue(finalNum);
                        players[playerTurn].dominoesInHand--;

                        dcard.setVisible(false);
                        layDominoOnBoard(true);
                        displayPlayerHands(true);
                    }
                })
        );

        sequenceAction.addAction(Actions.delay(0.6f, Actions.run(new Runnable() {
            @Override
            public void run() {
                if (GameConfig.gameType == GameConfig.ALL_FIVES_TYPE && calculateAllFivePoints(false, 0) > 0) {
            /*
             * 全部五玩法的一些规则
             * */
                    displayAllFivePoints(isShowTimeAddPoint || isSpinner);
                    isShowTimeAddPoint = false;
                    isSpinner = false;
                } else {
                    if (isSpinner) {
                        delayAnimation(new Runnable() {
                            @Override
                            public void run() {
                                nextTurn(true);
                            }
                        });
                    } else {
                        nextTurn(true);
                    }
                }
            }
        })));

        sequenceAction.addAction(Actions.removeActor());

        dcard.addAction(sequenceAction);
//        card.remove();


        //////////////////////////////////////// DNA /////////////////////////////////////////
        int scoreN = -1;
        if (GameConfig.gameType == GameConfig.ALL_FIVES_TYPE) {
            int k = calculateAllFivePoints(true, connectNum);
            if (k % 5 == 0) {
                scoreN = k;
            }
        }

        DeltaDNAManager.computerdominoNum++;
//        DeltaDNAManager.addTilesPlay("computer", GameConfig.gameType, FileUtil.getRPlayID() + "-" + DeltaDNAManager.roundNum, DeltaDNAManager.computerdominoNum, num,
//                connectNum, scoreN, connectidNum);
        dnaTilesPlay.addTitleDate(num, connectNum, scoreN, sumNum);
        //////////////////////////////////////////////////////////////////////////////////////
    }

    private void displayAllFivePoints(boolean isAnimation) {
        if (isAnimation) {
            delayAnimation(new Runnable() {
                @Override
                public void run() {
                    displayAllFivePoints();
                    Iterator<ObjectMap.Entry<Integer, IntArray>> iterator = possibleMoves.iterator();
                    while (iterator.hasNext()) {
                        ObjectMap.Entry<Integer, IntArray> map = iterator.next();
                        setPlayerHandGray(map.key, false);
                    }
                }
            });
        } else {
            displayAllFivePoints();
            Iterator<ObjectMap.Entry<Integer, IntArray>> iterator = possibleMoves.iterator();
            while (iterator.hasNext()) {
                ObjectMap.Entry<Integer, IntArray> map = iterator.next();
                setPlayerHandGray(map.key, false);
            }
        }
    }

    private void delayAnimation(Runnable runnable) {
        Actor b = new Actor();
        stage.addActor(b);
        b.clearActions();
        b.addAction(
                Actions.sequence(
                        Actions.delay(nextTurnDelayTime,
                                Actions.run(runnable)
                        ),
                        Actions.removeActor()
                )
        );
    }

    //全五模式出牌后处理逻辑
    private void displayAllFivePoints() {
        if (GameConfig.points[0] >= pointsTarget || GameConfig.points[1] >= pointsTarget) {
            gameEnd = true;
            isCanTouch = false;
            AnimationManager animationManagera = new AnimationManager();
            Actor a = animationManagera.getClickActor();
            a.clearListeners();
            a.addListener(new ClickListener() {
                @Override
                public void clicked(InputEvent event, float x, float y) {
                    int winner = getWinner(false);
                    GameConfig.points[winner] = GameConfig.toPoints[winner];
                    endOfHand(winner);
                }
            });
            stage.addActor(a);

            animationManagera.addAnimation(new FinishAnimation1(animationManagera, stage, FinishActor.FINISH_HINT) {
                @Override
                public void animationFinish() {
                    super.animationFinish();
//                    endOfGame();
                    int winner = getWinner(false);
                    GameConfig.points[winner] = GameConfig.toPoints[winner];
                    endOfHand(winner);
                }
            });
            animationManagera.startAnimation();
        } else {
            nextTurn(true);
            isCanTouch = true;
        }
    }

    //对手从剩余骨牌中抽取骨牌
    private void opponentPickFromBoneYard() {
        if (possibleMoves.size == 0 && boneYardDominoes.size > 0) {
            int pickedId = boneYardDominoes.get(MyRandom.getInstance().nextInt(boneYardDominoes.size));
            boneYardDominoes.removeValue(pickedId);
            players[playerTurn].distributeDomino(pickedId);
            Actor card = null;
            switch (playerTurn) {
                case 0:
                    card = new DominoCardPlayer2(pickedId, dominoManagers[pickedId].values, playerListener);
                    break;
                case 1:
                    card = new DominoCardHalf();
                    break;
            }
            if (card != null) {
                dominoObjects.put(pickedId, card);
                playerPanels[playerTurn].addActor(card);
                card.setVisible(false);

                final Actor finalCard = card;
                if (playerTurn == 1) {
                    displayComputerHands(true, new Runnable() {
                        @Override
                        public void run() {
                            setBoneYardAnimation(finalCard, new Runnable() {
                                @Override
                                public void run() {
                                    setComputerHandShowAnimation(finalCard, new Runnable() {
                                        @Override
                                        public void run() {
                                            buildListOfPossibleMoves();
                                            opponentPickFromBoneYard();
                                        }
                                    });
                                }
                            });
                        }
                    });
                } else {
                    displayPeopleHands(true, false, new Runnable() {
                        @Override
                        public void run() {
                            setBoneYardAnimation(finalCard, new Runnable() {
                                @Override
                                public void run() {
                                    setPeopleHandShowAnimation(finalCard, new Runnable() {
                                        @Override
                                        public void run() {
                                            buildListOfPossibleMoves();
                                            opponentPickFromBoneYard();
                                        }
                                    });
                                }
                            });
                        }
                    });
                }
//                playerPanels[playerTurn].findActor("shadow2").setZIndex(playerPanels[playerTurn].getChildren().size);
            }
            /////////////////////////// DNA ///////////////////////////////
            int[] a = dominoManagers[pickedId].values;
            boolean isConnect = false;
            for (int i = 0; i < useNum.length; ++i) {
                if (a[0] == useNum[i] || a[1] == useNum[i]) {
                    isConnect = true;
                    break;
                }
            }

            DeltaDNAManager.rankDraw++;
//                    DeltaDNAManager.addTilesDraw(FileUtil.getRPlayID() + "-" + DeltaDNAManager.roundNum,
//                            pickedId + "", DeltaDNAManager.rankDraw, "computer", isConnect);
            dnaTilesDraw.addDnaDraw(pickedId, "computer", isConnect);
            ///////////////////////////////////////////////////////////////
        } else {
            Actor a = new Actor();
            a.clearActions();
            a.addAction(
                    Actions.sequence(
                            Actions.delay(0.2f, Actions.run(new Runnable() {
                                @Override
                                public void run() {
                                    if (possibleMoves.size == 0) {
                                        players[playerTurn].hasPassed = true;
                                        nextTurn(true);
                                    } else {
                                        players[playerTurn].hasPassed = false;
                                        playOpponent();
                                    }
                                }
                            })),
                            Actions.removeActor()
                    )
            );
            stage.addActor(a);
        }
        showDominoes();
    }

//    private void opponentPickFromBoneYard() {
////        Timer.instance().scheduleTask(new Timer.Task() {
////            @Override
////            public void run() {
////                /*show message*/
//////                System.out.println("opponentPickFromYard");
////            }
////        }, 0.5F);
//        Timer.instance().scheduleTask(new Timer.Task() {
//            @Override
//            public void run() {
//                //如果没有能出的牌且牌池中有牌
//                step++;
//                if (step <= 3 || possibleMoves.size == 0 && boneYardDominoes.size > 0) {
//                    int pickedId = boneYardDominoes.get(MyRandom.getInstance().nextInt(boneYardDominoes.size));
//
////                    if(PlayControler.isUse){
////                        pickedId = PlayControler.uidraw[PlayControler.type][PlayControler.drawNum];
////                        PlayControler.drawNum ++;
////                    }
//                    boneYardDominoes.removeValue(pickedId);
//                    players[playerTurn].distributeDomino(pickedId);
//                    /*
//                     * 分牌操作
//                     *动画之类的
//                     *
//                     * */
//                    Actor card = null;
//                    switch (playerTurn) {
//                        case 0:
//                            card = new DominoCardPlayer2(pickedId, dominoManagers[pickedId].values, playerListener);
//                            break;
//                        case 1:
//                            card = new DominoCardHalf();
////                            card = new DominoCardPlayer(pickedId, dominoManagers[pickedId].values, playerListener);
//                            break;
//                    }
//                    if (card != null) {
//                        dominoObjects.put(pickedId, card);
//                        playerPanels[playerTurn].addActor(card);
//
//                        final Actor finalCard = card;
//                        if (playerTurn == 1) {
//                            displayComputerHands(true, new Runnable() {
//                                @Override
//                                public void run() {
//                                    setBoneYardAnimation(finalCard, new Runnable() {
//                                        @Override
//                                        public void run() {
//                                            setComputerHandShowAnimation(finalCard);
//                                        }
//                                    });
//                                }
//                            });
//                        } else {
//                            displayPeopleHands(true, new Runnable() {
//                                @Override
//                                public void run() {
//                                    setBoneYardAnimation(finalCard, new Runnable() {
//                                        @Override
//                                        public void run() {
//                                            setPeopleHandShowAnimation(finalCard);
//                                        }
//                                    });
//                                }
//                            });
//                        }
//
//                        buildListOfPossibleMoves();
////                        card.setVisible(false);
////                        playerPanels[playerTurn].findActor("shadow2").setZIndex(playerPanels[playerTurn].getChildren().size);
//                    }
//
//                    /////////////////////////// DNA ///////////////////////////////
//                    int[] a = dominoManagers[pickedId].values;
//                    boolean isConnect = false;
//                    for (int i = 0; i < useNum.length; ++i) {
//                        if (a[0] == useNum[i] || a[1] == useNum[i]) {
//                            isConnect = true;
//                            break;
//                        }
//                    }
//
//                    DeltaDNAManager.rankDraw++;
////                    DeltaDNAManager.addTilesDraw(FileUtil.getRPlayID() + "-" + DeltaDNAManager.roundNum,
////                            pickedId + "", DeltaDNAManager.rankDraw, "computer", isConnect);
//                    dnaTilesDraw.addDnaDraw(pickedId, "computer", isConnect);
//                    ///////////////////////////////////////////////////////////////
//
//                } else {
//                    this.cancel();
//                    Actor a = new Actor();
//                    a.clearActions();
//                    a.addAction(
//                            Actions.sequence(
//                                    Actions.delay(2, Actions.run(new Runnable() {
//                                        @Override
//                                        public void run() {
//                                            if (possibleMoves.size == 0) {
//                                                players[playerTurn].hasPassed = true;
//                                                nextTurn(true);
//                                            } else {
//                                                players[playerTurn].hasPassed = false;
//                                                playOpponent();
//                                            }
//                                        }
//                                    })),
//                                    Actions.removeActor()
//                            )
//                    );
////                    stage.addActor(a);
//                }
//                showDominoes();
//            }
//        }, 1.5f, 0.7F, boneYardDominoes.size + 1);
//    }

    private void setBoneYardAnimation(Actor card, Runnable runnable) {
        final Image actionCard = new Image(Assets.instance.dominoes.findRegion(DominoGame.dominoeName + "board-dominoes2"));
        Group computerPanels = playerPanels[playerTurn];
        computerPanels.addActor(actionCard);
        actionCard.setPosition(0, Configuration.height / 2 - computerPanels.getY(), Align.center);
        final float boundX = card.getX();
        final float boundY = card.getY();
        float scalex = card.getWidth() / actionCard.getWidth();
        float scaley = card.getHeight() / actionCard.getHeight();
        SequenceAction sequenceAction = Actions.sequence(
                Actions.parallel(
                        Actions.moveTo(boundX, boundY + 100, 0.2f),
                        Actions.scaleTo(scalex, scaley, 0.3f)
                )
        );
        if (runnable != null) {
            sequenceAction.addAction(Actions.run(runnable));
        }
        sequenceAction.addAction(Actions.fadeOut(0.01f));
        sequenceAction.addAction(Actions.removeActor());

        actionCard.addAction(sequenceAction);
    }

    private void setComputerHandShowAnimation(Actor card, Runnable runnable) {
        card.moveBy(0, 100);
        card.clearActions();
        card.addAction(
                Actions.sequence(
                        Actions.show(),
                        Actions.moveBy(0, -100, 0.2f),
                        Actions.run(runnable)
                )
        );
    }

    private void setPeopleHandShowAnimation(Actor card, Runnable runnable) {
        card.clearActions();
        card.addAction(
                Actions.sequence(
                        Actions.fadeOut(0.01f),
                        Actions.delay(0.3f),
                        Actions.fadeIn(0.01f),
                        Actions.delay(0.7f),
                        Actions.run(runnable)
                )
        );
    }


    //计算全五模式分数
    private int calculateAllFivePoints(boolean estimation, int connectedId) {
        int count = layedIds.size;
        if (count == 0)
            return 0;
        /*
         * 动画 todo
         * */

        int num = 0;
        ArrayList<DominoCard> cards = new ArrayList<>();
        DominoCard card;

        //遍历所有出过的牌id
        for (int i = 0; i < count; i++) {
            DominoManager dominoManager = dominoManagers[layedIds.get(i)];
            if (dominoManager.connectedCount == 0) {
                num = dominoManager.values[0] + dominoManager.values[1];
                card = dominoManager.dominoBody;
                cards.add(card);
            } else if (dominoManager.connectedCount <= 1 && (!estimation || dominoManager.dominoId != connectedId)) {
                card = dominoManager.dominoBody;
                cards.add(card);
                if (dominoManager.isDouble()) {
                    num += dominoManager.values[0] + dominoManager.values[1];
                } else {
                    if (!dominoManager.connectedDominoes.containsValue(dominoManager.values[0], true)) {
                        num += dominoManager.values[0];
                    } else {
                        num += dominoManager.values[1];
                    }
                    if (!estimation) {

                    }
                }

            }
        }
        if (estimation)
            return num;

        FlurryManager.flurryLog_allfive_add_score(num % 5 == 0 && num > 0);

        if (num % 5 == 0 && num > 0) {

            for (int i = 0; i < cards.size(); i++) {
                cards.get(i).addAllfiveAction();
            }

            addTutorAllfive();
            GameConfig.points[playerTurn] += num;
            scores[playerTurn] += num;

            addPointLabel.setText("+" + num);
            isShowTimeAddPoint = true;

            if (playerTurn == 0) {
                addPointLabel.setColor(true);
                GameConfig.AllfiveNum++;
                PlayerWordsShow("It's a multiple of 5. You score!");
            } else {
                addPointLabel.setColor(false);
                OpponentWordWordsShow("It's a multiple of 5. Your opponent scores!");
            }
            addPointLabel.setPosition(Configuration.width / 2 - Configuration.widthOffset / 2f, Configuration.height / 4 * 3, Align.center);

//            addPointLabel.setVisible(false);
//            addPointLabel.addAction(Actions.sequence(
//                    Actions.run(new Runnable() {
//                        @Override
//                        public void run() {
//                            addPointLabel.setVisible(true);
//                            AudioManager.PlaySound(AudioManager.AudioType.score);
//                        }
//                    }),
//                    Actions.moveBy(0, 100, 1F),
//                    Actions.hide()
//            ));
            float endX = processes[playerTurn].getX() + processes[playerTurn].getParent().getX();
            float endY = processes[playerTurn].getY() + processes[playerTurn].getParent().getY();
            final int finalNum = num;
            final int playerT = playerTurn;

            addPointLabel.animationStart(endX, endY, new Runnable() {
                @Override
                public void run() {
                    showPointAction(finalNum, playerT);
                }
            });
            return num;
        }
        return 0;
    }

    @Override
    public void pause() {
        super.pause();
        if (stage != null) {
            stage.cancelTouchFocus();
            for (int i = 0; i < layedIds.size; i++) {
                dominoManagers[layedIds.get(i)].dominoBody.highLight(-1);
            }
        }

        saveGame();
        saveGameTime();
//        if (tutorManager != null) {
//            tutorManager.hide();
//        }
    }

    @Override
    public void resize(int width, int height) {
        super.resize(width, height);
//        initPlayerBoards();
//        layDominoOnBoard();
//        adjustBoard();
    }

    @Override
    protected boolean back() {
        boolean flag = super.back();

        if (DominoGame.isShowEnd) {
            return false;
        }

        if (playerTurn == 1) {
            return false;
        }


        if (flag) {
            if (playerTurn == 1 || players[playerTurn].hasPassed) {
                return false;
            }
            saveGame();
            final SettingDialogNew dialog = showDialog(SettingDialogNew.class, "ui/objects/setting_gameNew.json");
//                PlayerWordsShow("The game is saved automatically.",true);
            dialog.setListener(new SettingDialogNew.SettingListener() {
                @Override
                public void startNew() {
                    GameConfig.refreshDataForNewGame();
                    game.gotoGameScreen();
//                    if(!ABTestUtil.isABTestA){
//                        FlurryManager.flurryLog_Clicknew();
//                    }
                }

                @Override
                public void home() {
                    if ((FileUtil.isFirstRound && GameConfig.handCount == 1) || (FileUtil.isSecondRound && GameConfig.handCount == 2)) {
                        FlurryManager.flurryLog_firstGameDetails_back(GameConfig.gameType, GameConfig.handCount);
                    }
                    saveGame();
                    game.gotoMenuScreen();

                }

                @Override
                public void openDesignDialog() {
                    showInfoDialog();
                }
            });
        }
        return false;
    }

    @Override
    public void render(float delta) {
        super.render(delta);

        if (isStartGame) {
            delaytime += delta;
            boneYarddelaytime += delta;

            if (dialogs.empty() && DominoGame.isBoneyard && !tutorSpinnerShow) {
                showBoneYard();
            }
        }

//        if (leagueGameEndDialogdialog != null) {
//            leagueGameEndDialogdialog.update();
//        }

        if (delaytime > 3 && playerTurn == 0) {
            delaytime = 0;
            if (noTouch && isStartGame) {
                displayPlayerHands(false);
            }
            if (!showYourTurn) {
                showYourTurn = true;
                PlayerWordsShow("It's your turn!");
            }
        }

        if (boneYarddelaytime > 10 && playerTurn == 0) {
            boneYarddelaytime = 0;
            if (possibleMoves.size == 0 && gameHasBoneYard && boneYardDominoes.size > 0 && !tutorSpinnerShow && FileUtil.getIsTutorFinished(6)) {
                showBoneYard();
            }
        }


        GameConfig.roundTime += delta;
        GameConfig.gameTime += delta;
        GameConfig.firstTime += delta;

        int numberOfSteps;


        numberOfSteps = 30;


        if (GameConfig.roundTime > numberOfSteps) {

            GameConfig.roundTime = 0;
            GameConfig.roundFLurry++;
            if (GameConfig.roundFLurry < 90) {
                FlurryManager.flurryLog_PlayTime_race(GameConfig.gameType, GameConfig.roundFLurry * numberOfSteps);
            } else {
                FlurryManager.flurryLog_PlayTime_race(GameConfig.gameType, 90 * numberOfSteps);
            }

        }

        if (GameConfig.gameTime > numberOfSteps) {

            GameConfig.gameTime = 0;
            GameConfig.gameFLurry++;

            if (GameConfig.gameFLurry < 90) {
                FlurryManager.flurryLog_PlayTime_subrace(GameConfig.gameType, GameConfig.gameFLurry * numberOfSteps);
            } else {
                FlurryManager.flurryLog_PlayTime_subrace(GameConfig.gameType, 90 * numberOfSteps);
            }
        }

        if (FileUtil.isFirstLogin) {
            if (GameConfig.firstTime > numberOfSteps) {
                GameConfig.firstFLurry++;
                GameConfig.firstTime = 0;
                FlurryManager.flurryLog_PlayTime_first(GameConfig.gameType, GameConfig.firstFLurry * numberOfSteps);
            }
        }

        GameConfig.uTime += delta;
        if (GameConfig.uTime > numberOfSteps) {
            GameConfig.uTimeFLurry++;
            GameConfig.uTime = 0;
            FlurryManager.flurryLog_PlayTime(GameConfig.gameType, GameConfig.uTimeFLurry * numberOfSteps);
        }
    }


    public void saveGameTime() {
        FileUtil.savePauseTime();
    }

    public void saveGame() {
        //如果是游戏结束
        if (gameEnd) {
            saveGameGameEnd();
            return;
        }

        try {
            PythonDict dict = new PythonDict();
            dict.put("started", System.currentTimeMillis());
            PythonArray laid = new PythonArray();
            dict.put("laid", laid);
            if (!handEnded) {
                for (int i = 0; i < layedIds.size; i++) {
                    int[] temp = new int[2];
                    temp[0] = layedIds.items[i];
                    temp[1] = dominoManagers[layedIds.items[i]].firstConnectedId;
                    laid.add(temp);
                }
                int[][] playArray = new int[players.length][];
                for (int i = 0; i < players.length; i++) {
                    playArray[i] = players[i].idsInHand.toArray();
                }
                dict.put("players", playArray);
                dict.put("handcount", GameConfig.handCount);
            } else {
                dict.put("handcount", GameConfig.handCount + 1);
            }
            dict.put("you", GameConfig.points[0]);
            dict.put("opponent", GameConfig.points[1]);
            dict.put("playercount", GameConfig.playerCount);
            dict.put("turn", playerTurn);
            dict.put("scoresSize", GameConfig.scores.size());
            for (int i = 0; i < GameConfig.scores.size(); i++) {
                dict.put("scores" + i, GameConfig.scores.get(i));
            }
            FileHandle file = Gdx.files.local("savegame_" + GameConfig.gameType);
            file.writeString(DominoGame.getJson().toJson(dict), false);

            FileUtil.saveData(GameConfig.gameType);
        } catch (Exception e) {
            FileUtil.clearSaveData(GameConfig.gameType);
        }

    }

    public void saveGameGameEnd() {
        FileUtil.clearSaveData(GameConfig.gameType);

        PythonDict dict = new PythonDict();
        FileHandle file = Gdx.files.local("savegame_" + GameConfig.gameType);
        file.writeString(DominoGame.getJson().toJson(dict), false);
    }

    //提示文字
    private void PlayerWordsShow(String str) {
        PlayerWordsShow(str, false);
    }

    private void PlayerWordsShow(String str, boolean isSpinner) {

        if (!dialogs.empty()) {
            showYourTurn = false;
            return;
        }

        if (showSpinner) {
            return;
        }
        DominoGame.isShowEnd = true;
        ClearWords();

        pWords.setText(str);
        float worldWidth = pWords.getPrefWidth();
        float worldHeight = pWords.getPrefHeight();

        pBg.setWidth(worldWidth + 54);
        pBg.setHeight(worldHeight + 20);
        if (str.contains("\n")) {
//            pBg.setHeight(100);
            pWords.setFontScale(0.6f);
        } else {
//            pBg.setHeight(70);
            pWords.setFontScale(0.6f);
        }
        playerWord.setHeight(pBg.getHeight());
        pWords.setPosition(playerWord.getWidth() / 2, playerWord.getHeight() / 2 + 1, Align.center);
        pBg.setPosition(playerWord.getWidth() / 2, playerWord.getHeight() / 2, Align.center);

        playerWord.addAction(
                Actions.sequence(
                        Actions.fadeIn(0.5f),
                        Actions.delay(1f),
                        Actions.fadeOut(0.5f),
                        Actions.run(new Runnable() {
                            @Override
                            public void run() {
                                DominoGame.isShowEnd = false;
                            }
                        })));

        if (isSpinner) {
            Timer.instance().scheduleTask(new Timer.Task() {
                @Override
                public void run() {
                    showSpinner = false;
                }
            }, 4f);
        }
    }

    //上提示文字
    private void OpponentWordWordsShow(String str) {

        if (!dialogs.empty()) {
            return;
        }
        if (showSpinner) {
            return;
        }

        ClearWords();

        oWords.setText(str);
        float worldWidth = oWords.getPrefWidth();
        float worldHeight = oWords.getPrefHeight();
        oBg.setWidth(worldWidth + 54);
        oBg.setHeight(worldHeight + 20);
//        if (str.contains("\n")) {
//            oBg.setHeight(100);
//        } else {
//            oBg.setHeight(70);
//        }
        playerWord.setHeight(pBg.getHeight());
        oWords.setPosition(opponentWord.getWidth() / 2, opponentWord.getHeight() / 2 + 2, Align.center);
        oBg.setPosition(opponentWord.getWidth() / 2, opponentWord.getHeight() / 2, Align.center);

        DominoGame.isShowEnd = true;
        opponentWord.addAction(
                Actions.sequence(
                        Actions.fadeIn(0.7f),
                        Actions.delay(1f),
                        Actions.fadeOut(0.7f),
                        Actions.run(new Runnable() {
                            @Override
                            public void run() {
                                DominoGame.isShowEnd = false;
                            }
                        })
                ));
    }

    private void ClearWords() {


        if (showSpinner) {
            return;
        }
        //上下两个提示标识
        opponentWord.clearActions();
        playerWord.clearActions();

        opponentWord.addAction(Actions.fadeOut(0.01f));
        playerWord.addAction(Actions.fadeOut(0.01f));

    }

    //更换皮肤
    public void showBg(int m) {
        for (int i = 0; i < board_id.length; i++) {
            if (m == board_id[i]) {
                topBgs[i].setVisible(true);
                middleBgs[i].setVisible(true);
                downBgs[i].setVisible(true);
            } else {
                topBgs[i].setVisible(false);
                middleBgs[i].setVisible(false);
                downBgs[i].setVisible(false);
            }
        }

        if (boneYard != null)
            boneYard.showBg(m);

    }

    //刷新骨牌显示
    public void showDominoes() {

        for (int i = 0; i < dominoManagers.length; i++) {
            dominoManagers[i].dominoBody.refreshShow();
        }

        for (int i = 0; i < players[0].dominoesInHand; i++) {
            Actor card = dominoObjects.get(players[0].idsInHand.get(i));
            ((DominoCardPlayer2) card).refresh();
        }

        for (int i = 0; i < players[1].dominoesInHand; i++) {
            Actor card = dominoObjects.get(players[1].idsInHand.get(i));
//            ( (DominoCardPlayer)card).refresh();
            ((DominoCardHalf) card).refresh();
        }

        boneYard.show(boneYardDominoes);

    }

    public void refreshDesignDialog() {
        if (designDialog != null) {
            designDialog.refresh();
        }
    }

    public void showUnlock(Design design) {
        UnlockDialog unlockDialog = showDialog(UnlockDialog.class, "ui/objects/unlockNew.json");
        unlockDialog.setDesign(design);
    }

    public void showInfoDialog() {
//        InfoDialog dialog = showDialog(InfoDialog.class, "ui/objects/tip_mainNew.json");
//        dialog.showPane();
        if (GameConfig.gameType == GameConfig.ALL_FIVES_TYPE) {
            showDialog(TipThreePageDialog.class, "ui/objects/tip_allfiveN.json");
        } else if (GameConfig.gameType == GameConfig.DRAW_TYPE) {
            showDialog(TipTwoPageDialog.class, "ui/objects/tip_drawN.json");
        } else {
            showDialog(TipTwoPageDialog.class, "ui/objects/tip_blockN.json");
        }
    }

    private int allfiveScore(int n) {
        int x;

        int a = n % 5;
        int b = n / 5;

        if (a >= 3) {
            b++;
        }
        x = b * 5;

        return x;

    }

    private int boneNum(int key, int connectId) {

        int x = dominoManagers[key].values[0];
        int y = dominoManagers[key].values[1];

        int[] use = new int[useNumCard.length];
        int[] useCard = new int[useNumCard.length];

        int score = 0;
        boolean isFind = false;

        if (connectId != -1) {
            int x1 = dominoManagers[connectId].values[0];
            int y1 = dominoManagers[connectId].values[1];
            for (int i = 0; i < useNumCard.length; i++) {

                if (isFind) {
                    use[i] = useNum[i];
                    useCard[i] = useNumCard[i];
                } else if (useNumCard[i] == connectId) {
                    useCard[i] = key;
                    if (x == x1 || x == y1)
                        use[i] = y;
                    else
                        use[i] = x;
                    isFind = true;
                } else {
                    use[i] = useNum[i];
                    useCard[i] = useNumCard[i];
                }

            }
        }

        if (useNum.length == 4) {
            if (useNum[2] == -1 && dominoManagers[key].isDouble()) {
                use[2] = dominoManagers[key].values[0];
                useCard[2] = key;
                use[3] = dominoManagers[key].values[0];
                useCard[3] = key;
            }
        }
//
        for (int j = 0; j < boneYardDominoes.size; j++) {
            for (int i = 0; i < useNum.length; i++) {

                if (dominoManagers[boneYardDominoes.get(j)].values[0] == use[i] || dominoManagers[boneYardDominoes.get(j)].values[1] == use[i]) {
                    score++;
                    i = useNum.length;
                }
            }
        }
        return score;
    }

    //赋值分的计算
    private int aiNum(int key, int connectId) {

        int x = dominoManagers[key].values[0];
        int y = dominoManagers[key].values[1];

        int[] use = new int[useNumCard.length];
        int[] useCard = new int[useNumCard.length];
        boolean isSpinner = false;

        int score = 0;
        int allfive = 0;

        boolean isFind = false;

        Gdx.app.log("yxk", "card id" + key);
        Gdx.app.log("yxk", "connect id" + connectId);

        if (connectId != -1) {
            for (int i = 0; i < useNumCard.length; i++) {

                if (isFind) {

                    use[i] = useNum[i];
                    useCard[i] = useNumCard[i];
                } else if (useNumCard[i] == connectId) {

                    if (x == useNum[i]) {
                        isFind = true;
                        use[i] = y;
                        useCard[i] = key;
                    } else if (y == useNum[i]) {
                        isFind = true;
                        use[i] = x;
                        useCard[i] = key;
                    } else {
                        use[i] = useNum[i];
                        useCard[i] = useNumCard[i];
                    }

                } else {
                    use[i] = useNum[i];
                    useCard[i] = useNumCard[i];
                }

//                Gdx.app.log("yxk","after useNumcard id"+ useCard[i]);
//                Gdx.app.log("yxk","after card useNum"+  use[i]);

            }
        } else {
            for (int i = 0; i < 2; i++) {
                use[i] = dominoManagers[key].values[i];
            }
            if (useNumCard.length > 2) {

                if (useNum[2] == -1 && dominoManagers[key].isDouble()) {
                    use[2] = dominoManagers[key].values[0];
                    use[3] = dominoManagers[key].values[0];
                } else {
                    use[2] = useNum[2];
                    use[3] = useNum[3];
                }


            }
        }

        //如果是allfive模式
        if (useNum.length == 4) {
            //如果前面没有double, 且当前输出的的骨牌值是double
            if (useNum[2] == -1 && dominoManagers[key].isDouble()) {
                use[2] = dominoManagers[key].values[0];
                useCard[2] = key;
                use[3] = dominoManagers[key].values[0];
                useCard[3] = key;
                isSpinner = true;
            }
        }

////
        //allfive的得分情况
        for (int i = 0; i < useNum.length; i++) {
            Gdx.app.log("yxk", "card useNum" + use[i]);
            if (GameConfig.gameType == GameConfig.ALL_FIVES_TYPE && useCard[i] != -1) {
                if (i > 1 && ((dominoManagers[useCard[i]].isSpinner) || isSpinner) || use[i] == -1) {
                    allfive += 0;
                } else {
                    allfive += use[i];
                    if (dominoManagers[useCard[i]].isDouble()) {
                        allfive += use[i];
                    }
                }
            }
            Gdx.app.log("yxk", "card allfiveNum" + i + "" + allfive);
        }

        //得分情况是5的倍数才得分
        if (allfive % 5 == 0) {
            score -= allfive / 5;
        }
//
        Gdx.app.log("yxk", "card allfiveNum" + allfive);
//        Gdx.app.log("yxk","card inhandNum"+ players[0].idsInHand.size);

        //
        ArrayList<Integer> allfiveList = new ArrayList<>();

        //遍历玩家手牌
        for (int j = 0; j < players[0].idsInHand.size; j++) {
            for (int i = 0; i < useNum.length; i++) {
                int pId = -1;
                //如果玩家可以接上
                if (dominoManagers[players[0].idsInHand.items[j]].values[0] == use[i] || dominoManagers[players[0].idsInHand.items[j]].values[1] == use[i]) {
                    score++;
                    i = useNum.length; //跳出循环
                    Gdx.app.log("yxk", "card idcanuse" + players[0].idsInHand.items[j]);
                    //玩家手牌id
                    pId = players[0].idsInHand.items[j];
                }

                if (pId != -1) {
                    //如该手牌是double类型
                    if (dominoManagers[pId].isDouble()) {
                        int dNum = 0;
                        //遍历出过的牌
                        for (int di = 0; di < layedIds.size; di++) {
                            if (dominoManagers[layedIds.get(di)].values[0] == dominoManagers[pId].values[0]
                                    || dominoManagers[layedIds.get(di)].values[1] == dominoManagers[pId].values[0]) {
                                dNum++;
                            }
                        }

                        if (connectId != -1) {
                            if (dNum > 3 && pId >= 18)
                                score++;
                            else if (dNum > 5 && pId >= 18)
                                score += 2;
                            else if (dNum > 5)
                                score++;
                        }
                    }

                }

                if (pId != -1 && GameConfig.gameType == GameConfig.ALL_FIVES_TYPE) {

                    x = dominoManagers[pId].values[0];
                    y = dominoManagers[pId].values[1];
                    Gdx.app.log("yxk", "allfive" + allfive);
                    int useallfive = allfive;
                    for (int p = 0; p < use.length; p++) {

                        if (x == y && x == use[p]) {
//                            if(p > 1 && dominoManagers[useCard[p]].isSpinner){
//                                useallfive += y*2;
//                            }
//                            else{
//                                useallfive -= x;
//                                if(dominoManagers[useCard[p]].isDouble()){
                            useallfive -= x;
//                                }
                            useallfive += 2 * y;
//                            }
                        } else if (x == use[p]) {
                            if (p > 1 && (dominoManagers[useCard[p]].isSpinner)) {
                                useallfive += y;
                            } else {
                                useallfive -= x;
                                if (dominoManagers[useCard[p]].isDouble()) {
                                    useallfive -= x;
                                }
                                useallfive += y;
                                if (x == y) {
                                    useallfive += y;
                                }
                            }
                        } else if (y == use[p]) {
                            if (p > 1 && dominoManagers[useCard[p]].isSpinner) {
                                useallfive += x;
                            } else {
                                useallfive -= y;
                                if (dominoManagers[useCard[p]].isDouble()) {
                                    useallfive -= y;
                                }
                                useallfive += x;
                                if (x == y) {
                                    useallfive += x;
                                }
                            }
                        }

//
                    }
                    Gdx.app.log("yxk", "useallfive" + useallfive);
                    if (useallfive % 5 == 0) {
                        allfiveList.add(useallfive);
                    }
                }
            }
        }
        int max = 0;
        if (allfiveList.size() > 0) {
            for (int i = 0; i < allfiveList.size(); i++) {
                if (allfiveList.get(i) > max) {
                    max = allfiveList.get(i);
                }
            }
        }

        if (GameConfig.gameType != GameConfig.ALL_FIVES_TYPE) {
            max = 0;
        }

        Gdx.app.log("yxk", "card allFivescore" + max);
        if (connectId != -1)
            score += max / 5;

        Gdx.app.log("yxk", "card score" + score);

        return score;

    }

    //ai的逻辑, 选择ai等级逻辑
    private int calculateAi(float k1, float k2, float k3) {
//        return 1;
        //如果是 A 版本
//        if (ABTestUtil.isABTestA) {
        if (GameConfig.hardLevel == GameConfig.HardLevel.Easy) {
            return 3;
        } else if (GameConfig.hardLevel == GameConfig.HardLevel.Normal) {
            return 1;
        } else {
            return 2;
        }
//        }

        //如果是 B 版本
//        if (GameConfig.AiMode == 1) {//基本难度
//            return 3;
//
//        } else if (GameConfig.AiMode == 2) {
//            if ((k1 / k2 >= 1.5 && k3 > 10 && k3 <= 30) || (k3 > 30 && (k1 / k2 >= 1 && k1 / k2 < 2.5))) {
//                return 1;
//            } else if (k3 > 30 && k1 / k2 >= 2.5) {
//                return 2;
//            } else {
//                return 3;
//            }
//        } else if (GameConfig.AiMode == 3) {//
//
//            if ((k1 / k2 >= 1.5 && k3 > 10 && k3 <= 30) || (k3 > 30 && k1 / k2 >= 1)) {
//                return 2;
//            } else if (k2 > 10 && -k1 / k3 >= 1.5) {
//                return 3;
//            } else {
//                return 1;
//            }
//        } else if (GameConfig.AiMode == 4) {//纯粹困难
//            return 2;
//        } else if (GameConfig.AiMode == 5) {
//            return GameConfig.RoundMode;
//        }

//
//
//        return 0;
    }

    @Override
    public void resume() {
        super.resume();

        if (isStartGame) {
            showDominoes();
            for (int j = 0; j < players[0].dominoesInHand; j++) {
                Actor card = dominoObjects.get(players[0].idsInHand.get(j));
                if (card != null) {
                    ((DominoCardPlayer2) card).resumePosition();
                }
            }
            layDominoOnBoard(false);
//        displayPlayerHands();
            if (FileUtil.isLongTimePause()) {
                GameConfig.loadData = true;
                game.gotoGameScreen();
            }
            if (GameConfig.PauseCount > 0) {
                GameConfig.isPause = false;
                GameConfig.PauseCount--;
                nextTurn(true);
            }
        }
    }

    //展示分数动画
    public void showPointAction(int num, int playerTurn) {

//        pointLabel[playerTurn] = findActor("point_" + playerTurn);
//        pointLabel[playerTurn].setText("" + GameConfig.points[playerTurn]);

        final float delay = 0.1f;
        final int startValue = GameConfig.points[playerTurn] - num;

        setProcess(true, true);
        if (num < 20) {
            pointLabel[playerTurn].setText(startValue + "");
            for (int m = 1; m <= num; m++) {
                final Label finalTemp = pointLabel[playerTurn];
                final int finalM = m;
                //游戏界面加分动画
                Timer.instance().scheduleTask(new Timer.Task() {
                    @Override
                    public void run() {
                        int x = startValue + finalM;
                        finalTemp.setText(x + "");
                    }
                }, delay * m);
            }
        } else {
            float[] delatTime = new float[num + 1];
            delatTime[0] = delay;
            pointLabel[playerTurn].setText(startValue + "");
            for (int m = 1; m <= num; m++) {
                final Label finalTemp = pointLabel[playerTurn];
                final int finalM = m;
                if (m > num - 5) {
                    delatTime[m] = delatTime[m - 1] + 0.15f;
                } else {
                    delatTime[m] = delatTime[m - 1] + 0.08f;
                }
                Timer.instance().scheduleTask(new Timer.Task() {
                    @Override
                    public void run() {
                        int x = startValue + finalM;
                        finalTemp.setText(x + "");
                    }
                }, delatTime[m]);
            }
        }


    }

    private void showHelp() {

//        if (!FileUtil.getHelp(GameConfig.gameType) && !ABTestUtil.isABTestA) {
//            showInfoDialog();
//            FileUtil.setHelp(GameConfig.gameType);
//        }
    }

    @Override
    public <T extends BaseDialog> T showDialog(Class<? extends BaseDialog> tClass, String name) {
        ClearWords();
        return super.showDialog(tClass, name);
    }

    public void addTutorFirstBone() {
//        if (FileUtil.getIsTutorFinished(5)) {
//            return;
//        }
//
//        tutorManager = new TutorManager(stage, 5);
//        Vector2 pos = tutorManager.showActor(playerPanels[0]);
//
//        Image hand = new Image(Assets.guide.findRegion("hand"));
//
//        tutorManager.addActorNoAction(hand, pos.x + 20, pos.y);
//
//        float startX = pos.x + 20;
//        float startY = pos.y;
//        hand.addAction(
//                Actions.forever(
//                        Actions.sequence(
//                                Actions.moveTo(startX + 200, startY + 400, 0.8f),
//                                Actions.fadeOut(0.01f),
//                                Actions.moveTo(startX, startY, 0.01f),
//                                Actions.delay(0.3f),
//                                Actions.fadeIn(0.01f)
//                        )
//                )
//        );
//
//        Image arrow = new Image(Assets.ui.findRegion("arrow"));
//        arrow.setRotation(-30);
//        tutorManager.addActorNoAction(arrow, startX + 30, startY + 250);
//
//        tutorManager.addWord(100, pos.y + 420, "Pick one tile to\nmatch the free ends.", 500, 160);
//        tutorManager.addoldMan(600, pos.y + 420);
    }

    public void addTutorDrawBone() {
        if (FileUtil.getIsTutorFinished(6)) {
            return;
        }

        Timer.instance().scheduleTask(new Timer.Task() {
            @Override
            public void run() {
//                tutorManager = new TutorManager(stage, 6);
//                Vector2 pos = tutorManager.showActor(boneYard);

                boneYard.TutorshowAction();

//                tutorManager.addWord(100, pos.y - 200, "No playable domino? Draw\none from the boneyard now.", 500, 160);
//                tutorManager.addoldMan(600, pos.y - 200);
            }
        }, 0.7f);


    }

    public void addTutorHelp() {
        if (FileUtil.getIsTutorFinished(7)) {
            return;
        }

//        tutorManager = new TutorManager(stage, 7);
//        Vector2 pos = tutorManager.showActionActor(scene.findActor("btn_info"));
//
//        tutorManager.addWord(100, pos.y - 300, "You can always review\nthe rules here.", 500, 160);
//        tutorManager.addoldMan(600, pos.y - 300);
//
//        tutorManager.bg.addListener(new ClickListener() {
//            @Override
//            public void clicked(InputEvent event, float x, float y) {
//                super.clicked(event, x, y);
//                tutorManager.hide();
//            }
//        });


    }

    public void addTutorBlock() {
        if (FileUtil.getIsTutorFinished(9)) {
            return;
        }

        showYourTurn = true;
//        tutorManager = new TutorManager(stage, 9);


//        tutorManager.addWord(100, Configuration.height - 600, "Boneyard is not available\nin Block", 500, 160);
//        tutorManager.addoldMan(600, Configuration.height - 600);

//        tutorManager.bg.addListener(new ClickListener() {
//            @Override
//            public void clicked(InputEvent event, float x, float y) {
//                super.clicked(event, x, y);
//                tutorManager.hide();
//                nextTurn(true);
//            }
//        });

    }

    public void addTutorSpinner() {
        if (FileUtil.getIsTutorFinished(10)) {
            return;
        }
//        tutorManager = new TutorManager(stage, 10);
//        tutorManager.showActor(board);

        tutorSpinnerShow = true;

//        tutorManager.addWord(50, Configuration.height - 550, "The first double played in each\nround is called \"Spinner\". \nIt can be connected from 4 sides.", 600, 220);
//        tutorManager.addoldMan(600, Configuration.height - 550);

//        tutorManager.bg.addListener(new ClickListener() {
//            @Override
//            public void clicked(InputEvent event, float x, float y) {
//                super.clicked(event, x, y);
//                tutorManager.hide();
//                tutorSpinnerShow = false;
//                addTutorFirstBone();
//                if (DominoGame.isBoneyard)
//                    showBoneYard();
//            }
//        });

    }

    public void addTutorScore() {
        if (FileUtil.getIsTutorFinished(11)) {
            return;
        }
//        tutorManager = new TutorManager(stage, false, 11);
//
//        tutorManager.addWord(100, Configuration.height / 2 + 480, "Here is the game target!", 500, 160);
//        tutorManager.addoldMan(600, Configuration.height / 2 + 480, 3);

    }

    public void addTutorAllfive() {
        if (FileUtil.getIsTutorFinished(12)) {
            return;
        }
//        tutorManager = new TutorManager(stage, 12);
//        tutorManager.showActor(board);
        GameConfig.isPause = true;

        tutorSpinnerShow = true;

//        Image bone = new Image(new Texture(Gdx.files.internal("image/bone.png")));
//
//        tutorManager.addActor(bone,200, Configuration.height-500);
//        tutorManager.addWord(100, Configuration.height - 400, "6+6+3=15\n15 is a multiple of 5.\nSo you get 15 points!", 500, 220);
//        tutorManager.addoldMan(600, Configuration.height - 400);
//
//        tutorManager.bg.addListener(new ClickListener() {
//            @Override
//            public void clicked(InputEvent event, float x, float y) {
//                super.clicked(event, x, y);
//                tutorManager.hide();
//                GameConfig.isPause = false;
//                if (GameConfig.PauseCount > 0) {
//                    GameConfig.PauseCount--;
//                    nextTurn(true);
//                }
//
//                tutorSpinnerShow = false;
//                if (DominoGame.isBoneyard)
//                    showBoneYard();
//            }
//        });

    }

//    public void showFanbeiDialog() {
//        fanbeiDialog = showDialog(FanbeiDialog.class, "ui/objects/scale.json");
//        fanbeiDialog.addListener(game);
//
//    }

    public void setPlayerHandGray(boolean gray) {
        for (int j = 0; j < players[0].dominoesInHand; j++) {
            //置灰操作
            ((DominoCardBase) dominoObjects.get(players[0].idsInHand.get(j))).gray(gray);
        }
    }

    public void setPlayerHandGray(int id, boolean gray) {
        Actor a = dominoObjects.get(id);
        if (a != null) {
            ((DominoCardBase) a).gray(gray);
        }
    }
}
